SystemOrganization addCategory: #Roassal!
SystemOrganization addCategory: #'Roassal-Actions'!
SystemOrganization addCategory: #'Roassal-Algorithm'!
SystemOrganization addCategory: #'Roassal-AttachPoint'!
SystemOrganization addCategory: #'Roassal-AttachPoint-Test'!
SystemOrganization addCategory: #'Roassal-Benchmarks'!
SystemOrganization addCategory: #'Roassal-Builder'!
SystemOrganization addCategory: #'Roassal-Builder-Tests'!
SystemOrganization addCategory: #'Roassal-Core'!
SystemOrganization addCategory: #'Roassal-Core-Tests'!
SystemOrganization addCategory: #'Roassal-Event'!
SystemOrganization addCategory: #'Roassal-Event-Tests'!
SystemOrganization addCategory: #'Roassal-Example'!
SystemOrganization addCategory: #'Roassal-Exporter'!
SystemOrganization addCategory: #'Roassal-Exporter-Tests'!
SystemOrganization addCategory: #'Roassal-Hooks'!
SystemOrganization addCategory: #'Roassal-Hooks-Tests'!
SystemOrganization addCategory: #'Roassal-Interaction'!
SystemOrganization addCategory: #'Roassal-Interaction-Tests'!
SystemOrganization addCategory: #'Roassal-Layout'!
SystemOrganization addCategory: #'Roassal-Layout-Tests'!
SystemOrganization addCategory: #'Roassal-Normalizers'!
SystemOrganization addCategory: #'Roassal-Normalizers-Tests'!
SystemOrganization addCategory: #'Roassal-PlatformIndependent'!
SystemOrganization addCategory: #'Roassal-Transformation'!
SystemOrganization addCategory: #'Roassal-Visitor'!
SystemOrganization addCategory: #'Roassal-Visitor-Tests'!
SystemOrganization addCategory: #'Roassal-Widgets'!
SystemOrganization addCategory: #'Roassal-Widgets-Tests'!

!Rectangle methodsFor: '*Roassal-Core' stamp: 'AlexandreBergel 8/27/2012 09:57'!
roCorner: aPoint
	"This method should not be. But the tree map layout works that way"
	corner := aPoint! !

!Rectangle methodsFor: '*Roassal-Core' stamp: 'AlexandreBergel 8/27/2012 09:57'!
roOrigin: aPoint
	"This method should not be. But the tree map layout works that way"
	origin := aPoint! !

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfSubclasses
	^ self allSubclasses size! !

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfVariables
	^ self instVarNames size! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: 'AlexandreBergel 5/3/2012 19:16'!
roSwapElement: u withElement: v
	| index1 index2 |
	index1 := self indexOf: u.
	index2 := self indexOf: v.
	self at: index2 put: u.
	self at: index1 put: v.! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: 'AlexandreBergel 1/2/2013 16:05'!
sortedAs: aSortBlockOrSymbol
	"Answer a SortedCollection whose elements are the elements of the 
	receiver. The sort order is defined by the argument, aSortBlock."

	| aSortedCollection aSortBlock |
	aSortedCollection := SortedCollection new: self size.
	aSortBlock := 
		aSortBlockOrSymbol isSymbol 
			ifTrue: [ [:a :b | |t1 t2|
							t1 := (a perform: aSortBlockOrSymbol).
							t2 := (b perform: aSortBlockOrSymbol).
							((t1 isKindOf: Boolean) and: [t2 isKindOf: Boolean])
								ifTrue: [ t1 ]
								ifFalse: [ t1 < t2 ] ] ]
			ifFalse: [ 
				(aSortBlockOrSymbol numArgs = 1)
					ifTrue: [ [ :v1 :v2 | (aSortBlockOrSymbol value: v1) < (aSortBlockOrSymbol value: v2) ] ]
					ifFalse: [ aSortBlockOrSymbol ] ].
	aSortedCollection sortBlock: aSortBlock.
	aSortedCollection addAll: self.
	^ aSortedCollection! !

!Number methodsFor: '*roassal-core' stamp: ''!
max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(20 max: 20 in: (0 to: 10)) == 10
	"
	^ self min: 0 max: max in: anInterval! !

!Number methodsFor: '*roassal-core' stamp: ''!
min: min max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(19 max: 20 in: (0 to: 10)) == 10
	"
	^ (self - min) / (max - min) * (anInterval last - anInterval first) + anInterval first
! !

TestCase subclass: #ROAddNameTest
	instanceVariableNames: 'element view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROAddNameTest methodsFor: 'running' stamp: 'AlexandreBergel 10/3/2012 17:47'!
setUp
	super setUp.
	element := ROElement on: 42.
	view := ROView new.
	view add: element! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:49'!
testAddThenRemove

	ROAddName toElement: element.
	ROAddName removeFrom: element.
	
	self assert: view numberOfElements = 1.
	self assert: view elements first == element! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 18:17'!
testAddTwice

	ROAddName toElement: element.
	ROAddName toElement: element.
	
	self assert: view numberOfElements = 2.
! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:46'!
testAddition

	self assert: element view numberOfElements = 1.
	ROAddName toElement: element.
	self assert: element view numberOfElements = 2.	 ! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:47'!
testRemoveFromEmpty

	self assert: element view numberOfElements = 1.
	ROAddName removeFrom: element.
	self assert: element view numberOfElements = 1.! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 18:17'!
testRemoveTwice

	ROAddName removeFrom: element.
	ROAddName removeFrom: element.
	
	self assert: view numberOfElements = 1.
! !

TestCase subclass: #ROAnimationTest
	instanceVariableNames: 'view element1 animation1 element2 animation2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROAnimationTest methodsFor: 'running' stamp: 'AlexandreBergel 11/30/2012 19:03'!
setUp

	view := ROView new.
	element1 := ROElement sprite.
	element2 := ROElement sprite.
	view add: element1.
	view add: element2.
		
	animation1 := ROLinearMove new.
	animation1 for: element1 to: (50 @ 40).
	
	animation2 := ROLinearMove new.
	animation2 for: element2 to: (150 @ 10).! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 21:24'!
testAnimation
	
	view := ROView new.
	self deny: view hasAnimation.
	view addAnimation: animation1.
	self assert: view hasAnimation.! !

!ROAnimationTest methodsFor: 'strategy' stamp: 'AlexandreBergel 5/2/2013 18:57'!
testDefaultStrategy

	self assert: (ROMotionMove new strategy isAppend)! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2012 19:12'!
testDoAnimationCycle

	view addAnimation: animation1.
	view addAnimation: animation2.

	self deny: animation1 hasCompleted.
	self deny: animation2 hasCompleted.
	
	self assert: element1 position = (0 @ 0).
	self assert: element2 position = (0 @ 0).
	
	animation1 nbCycles timesRepeat: [ view doAnimationCycle ].
	
	self assert: animation1 hasCompleted.
	self assert: animation2 hasCompleted.
	  
	self assert: element1 position = (50 @ 40).
	self assert: element2 position = (150 @ 10).
! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 21:21'!
testForBy

	| element |
	element := ROElement sprite.
	element translateTo: 50 @ 40.
	view add: element.
	
	ROLinearMove for: element by: 10 @ 5.
	view doAllAnimationCycles.
	self assert: element position = (60 @ 45)! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 10:26'!
testHasAnimationAfterDoAllAnimationCycles

	view addAnimation: animation1.
	view addAnimation: animation2.
	
	self assert: view hasAnimation.
	view doAllAnimationCycles.
	
	self deny: view hasAnimation.! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 21:25'!
testHasAnimationAfterDoAnimationCycle

	self assert: view hasAnimation.
	animation1 nbCycles timesRepeat: [ 
		self assert: view hasAnimation.
		view doAnimationCycle ].
	
	self assert: animation1 elapsedCycles = animation1 nbCycles.
	self deny: view hasAnimation.! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 16:17'!
testInitialize

	self assert: animation1 element == element1.
	self assert: animation1 elapsedCycles = 0! !

!ROAnimationTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2012 17:28'!
testNoAnimation

	self deny: ROView new hasAnimation.! !

!ROAnimationTest methodsFor: 'strategy' stamp: 'AlexandreBergel 5/2/2013 19:03'!
testSettingStrategy

	| animation mergingStrategy |
	animation := ROMotionMove new.
	mergingStrategy := ROAnimationExclusive instance.
	animation strategy: mergingStrategy.
	self assert: (animation strategy == mergingStrategy)! !

TestCase subclass: #RODynamicEdgeTest
	instanceVariableNames: 'view el1 el2 el3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RODynamicEdgeTest methodsFor: 'running' stamp: 'AlexandreBergel 4/7/2013 00:53'!
setUp

	view := ROView new.
	view add: (el1 := ROBox element).
	view add: (el2 := ROBox element).
	view add: (el3 := ROBox element).
	ROHorizontalLineLayout on: (Array with: el1 with: el2 with: el3).
	
	el1 @ (RODynamicEdge toAll: (Array with: el2 with: el3) using: (ROLine arrowed color: Color red))! !

!RODynamicEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/7/2013 07:21'!
testDefining

	el2 @ (RODynamicEdge 
			toAll: [ :el | (Array with: el1 with: el2 with: el3) copyWithout: el ] 
			using: (ROLine arrowed color: Color red)).
			
	el2 announce: ROMouseEnter.
	self assert: view numberOfElements = 5.! !

!RODynamicEdgeTest methodsFor: 'tests' stamp: 'miltonmamani 4/17/2013 15:24'!
testDefiningMultiple

	el2 @ (RODynamicEdge 
			toAll: [ :el | ((Array with: el1 with: el2 with: el3) copyWithout: el) copyFrom: 2 to: 2 ] 
			using: (ROLine arrowed color: Color red))
		@ (RODynamicEdge 
			toAll: [ :el | ((Array with: el1 with: el2 with: el3) copyWithout: el) copyFrom: 2 to: 2 ] 
			using: (ROLine arrowed color: Color blue)).
			
	el2 announce: ROMouseEnter.
	self assert: view numberOfElements = 5.! !

!RODynamicEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/7/2013 01:08'!
testEnteringAndExitingElement
	el1 announce: ROMouseEnter.
	el1 announce: ROMouseLeave.
	self assert: view numberOfElements = 3.
	self assert: (view elementsSuchThat: #isEdge) isEmpty! !

!RODynamicEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/7/2013 01:12'!
testEnteringElement
	el1 announce: ROMouseEnter.
	self assert: view numberOfElements = 5.
	self assert: (view elementsSuchThat: #isEdge) size = 2.
	self assert: (view elementsSuchThat: #isEdge) first from == el1.
	self assert: (view elementsSuchThat: #isEdge) first to == el2.
	
	self assert: (view elementsSuchThat: #isEdge) second from == el1.
	self assert: (view elementsSuchThat: #isEdge) second to == el3.
	
	self assert: (view elementsSuchThat: #isEdge) first shapes first color == Color red! !

!RODynamicEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/7/2013 00:51'!
testNoEdge

	self assert: view elements size = 3.! !

TestCase subclass: #ROKeyDownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event-Tests'!

!ROKeyDownTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/14/2013 11:43'!
testOnMondrianBuilder
	| pool raw view |
	pool := OrderedCollection new.
	view := ROMondrianViewBuilder new.
	view raw on: ROKeyDown do: [ :event | pool add: event ].
	
	self assert: pool size = 0.
	view raw announce: (ROKeyDown new).
	self assert: pool size = 1.
	
	view raw announce: (ROKeyDown new).
	self assert: pool size = 2.! !

!ROKeyDownTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/14/2013 11:50'!
testOnMondrianBuilder2

	| rawView view t |
	t := 0.
	rawView := ROView new.
	view := ROMondrianViewBuilder view: rawView.
	rawView on: ROKeyDown do: [ :event | t := t + 1 ].

	self assert: t = 0.
	rawView announce: ROKeyDown.
	self assert: t = 1.
	rawView announce: ROKeyDown.
	self assert: t = 2.! !

!ROKeyDownTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/14/2013 11:39'!
testOnView
	| pool raw view |
	pool := OrderedCollection new.
	view := ROView new.
	view on: ROKeyDown do: [ :event | pool add: event ].
	
	self assert: pool size = 0.
	view announce: (ROKeyDown new).
	self assert: pool size = 1.
	
	view announce: (ROKeyDown new).
	self assert: pool size = 2.! !

TestCase subclass: #RORemoveEdgeTest
	instanceVariableNames: 'el1 el2 el3 view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!RORemoveEdgeTest methodsFor: 'running' stamp: 'AlexandreBergel 11/21/2012 08:48'!
setUp

	el1 := ROElement on: 1.
	el2 := ROElement on: 2.
	el3 := ROElement on: 3.
	
	view := ROView new.
	view addAll: (Array with: el1 with: el2 with: el3).
	view add: (ROEdge from: el1 to: el2).
	view add: (ROEdge from: el1 to: el3).
	view add: (ROEdge from: el2 to: el3).! !

!RORemoveEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/21/2012 08:49'!
testEdges

	self assert: (view elements select: [ :el | el isEdge ]) size = 3.! !

!RORemoveEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/21/2012 08:49'!
testRemoveEdge

	RORemoveEdge edgesFrom: el1.
	self assert: (view elements select: [ :el | el isEdge ]) size = 1.! !

!RORemoveEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/21/2012 08:50'!
testRemoveEdge2

	RORemoveEdge edgesFrom: el3.
	self assert: (view elements select: [ :el | el isEdge ]) size = 3.! !

!RORemoveEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/21/2012 08:50'!
testRemoveEdgeTo

	RORemoveEdge edgesTo: el3.
	self assert: (view elements select: [ :el | el isEdge ]) size = 1.! !

TestCase subclass: #ROTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROTest subclass: #ROAbstractCanvasTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAbstractCanvasTest class methodsFor: 'testing' stamp: 'AlexandreBergel 4/19/2012 12:21'!
isAbstract
	^ self name == #ROAbstractCanvasTest ! !

!ROAbstractCanvasTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:20'!
canvasClass
	^ ROAbstractCanvas! !

!ROAbstractCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/19/2012 12:20'!
testTransformationBijection

	| canvas camera |
	camera := ROCamera new realExtent: 100@50; extent: 200@100.
	canvas := self canvasClass onCamera: camera.
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 0@0)) = (0 @ 0).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -100 @ -50)) = (-100 @ -50).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 100 @ 50)) = (100 @ 50).
	
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -10@ -6)) = (-10 @ -6).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 40 @ 50)) = (40 @ 50).
	self assert: (canvas realToVirtualRectangle: (canvas virtualToRealRectangle: (-10 @ -6 corner: 40 @ 50))) =
					 (-10 @ -6 corner: 40 @ 50).! !

ROTest subclass: #ROAbstractLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAbstractLabelTest class methodsFor: 'testing' stamp: 'AlexandreBergel 9/20/2012 12:00'!
isAbstract 
	^ self name == #ROAbstractLabelTest! !

!ROAbstractLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 11:58'!
classToTest
	self subclassResponsibility ! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testBounds
	| el |
	el := ROElement labelOn: 'hello world'.
	self assert: el bounds ~= ( 0@0 corner: 5@5).
	self assert: el extent = (self classToTest new preferedExtentFor: el).! !

!ROAbstractLabelTest methodsFor: 'colors' stamp: 'AlexandreBergel 10/14/2012 19:12'!
testColorFor

	 | rawView el1 shape |
	  rawView := ROView new.
	  el1 := ROElement on: 1.
	  el1 extent: 50@50.
	  el1 + (shape := self classToTest new color: [ :element | element model odd ifTrue: [ Color red ] ifFalse: [ Color blue ] ]). 

	  rawView add: el1.
	
	self assert: (shape colorFor: el1) = Color red.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testDynamicBounds
	| el extent shape extentFromShape bounds |
	el := ROElement on: 'hello'.
	el + self classToTest.
	
	shape := el getShape: self classToTest.
	bounds := el bounds.
	
	el model: 'hello world'.
	
	self assert: (shape preferedExtentFor: el) = el extent.
	
	self assert: el bounds origin = bounds origin.
	
	self assert: el bounds extent x > bounds extent x.
	self assert: el bounds extent y = bounds extent y.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testDynamicExtent
	| el extent shape extentFromShape |
	el := ROElement on: 'hello'.
	el + self classToTest.
	
	shape := el getShape: self classToTest.
	extent := el extent.
	extentFromShape := shape preferedExtentFor: el.
	
	self assert: extent = extentFromShape.
	
	el model: 'hello world'.
	
	self assert: (shape preferedExtentFor: el) x > extentFromShape x.
	self assert: (shape preferedExtentFor: el) y = extentFromShape y.
	
	self assert: (shape preferedExtentFor: el) = el extent.
	
	self assert: el extent x > extent x.
	self assert: el extent y = extent y.	! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOf

	| label |
	label := self classToTest new.
	self assert: (label linesOf: 'hello
world
	bravo') = #('hello' 'world' '	bravo')! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOfEmptyString

	| label |
	label := self classToTest new.
	self assert: (label linesOf: '') = #()! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOfWithTrailingCR

	| label |
	label := self classToTest new.
	self assert: (label linesOf: 'hello
world
	bravo
') = #('hello' 'world' '	bravo')! !

!ROAbstractLabelTest methodsFor: 'size minimum' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testMinimumSize

	| el |
	el := ROElement on: 'hello'.
	el extent: (90 @ 45).
	self assert: el extent = (90 @ 45).
	
	el + self classToTest.
	self assert: el extent = (90 @ 45).! !

!ROAbstractLabelTest methodsFor: 'size minimum' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testMinimumSize2

	| el |
	el := ROElement on: 'hello'.
	el extent: (3 @ 3).
	self assert: el extent = (3 @ 3).
	
	el + self classToTest.
	self assert: el extent > (3 @ 3).! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 6/10/2012 16:04'!
testMultilines
	"
	self debug: #testMultilines
	"
	| view elementWith2Lines elementWith1Line |
	view := ROView new.
	view add: (elementWith2Lines := ROElement  labelOn: 
'hello 
world').
	view add: (elementWith1Line := ROShape elementOn: 'bonjour le monde!!').
	"view openInWindow."
	
	self assert: (elementWith2Lines height >= (elementWith1Line height * 2))! !

!ROAbstractLabelTest methodsFor: 'white char' stamp: 'AlexandreBergel 10/17/2012 08:29'!
testReplaingWhiteCharacter

	| label element str |
	label := self classToTest new.
	element := ROElement on: (str := '	abc	def').
	self assert: (label textFor: element) = str.
	self assert: (label textAdaptedFor: element) =  '      abc      def'
! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testSize
	| el1 el2 |
	el1 := ROElement on: 'hello'.
	el2 := ROElement on: 'h'.
	
	self assert: el1 bounds = el2 bounds.
	self assert: el1 bounds = ( 0@0 corner: 5@5).
	
	el1 + self classToTest.
	el2 + self classToTest.
	
	self assert: el1 extent = (self classToTest new preferedExtentFor: el1).
	self assert: el2 extent = (self classToTest new preferedExtentFor: el2).
	
	self assert: el1 bounds ~= el2 bounds.
	self assert: el1 bounds height = el2 bounds height.
	self assert: el1 bounds width > el2 bounds width.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'JurajKubelka 4/30/2013 17:57'!
testSize2
	| el1 el2 label1 |
	el1 := ROElement on: 'hello'.
	el2 := ROElement on: 'hello'.
	label1 :=  self classToTest new fontSize: 50.
	el1 + label1.
	el2 + self classToTest.

	self assert: el1 extent = (label1 preferedExtentFor: el1).
	self assert: el2 extent = (self classToTest new preferedExtentFor: el2).
	
	self assert: el1 bounds ~= el2 bounds.
	self assert: el1 bounds height > el2 bounds height.
	self assert: el1 bounds width > el2 bounds width.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 5/6/2013 18:11'!
testSize3
	| el1 el2 el3 text1 text2 text3 |
	text1 := 'iiiiiiiiii'.
	text2 := 'WWWWW'.
	text3 := text1, ROPlatform current newLine, text2.
	el1 := ROElement on: text1.
	el2 := ROElement on: text2.
	el3 := ROElement on: text3.
	
	el1 + self classToTest.
	el2 + self classToTest.
	el3 + self classToTest.

	self assert: el1 extent = (self classToTest new preferedExtentFor: el1).
	self assert: el2 extent = (self classToTest new preferedExtentFor: el2).
	self assert: el3 extent = (self classToTest new preferedExtentFor: el3).
	
	self assert: el1 bounds ~= el2 bounds.
	self assert: el1 bounds height = el2 bounds height.
	self assert: el1 bounds width < el2 bounds width.
	
	self assert: el1 bounds ~= el3 bounds.
	self assert: el1 bounds height * 2 = el3 bounds height.
	self assert: el1 bounds width < el3 bounds width.

	self assert: el2 bounds ~= el3 bounds.
	self assert: el2 bounds height * 2 = el3 bounds height.
	self assert: el2 bounds width = el3 bounds width.! !

!ROAbstractLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testTextFor

	| label el |
	label := self classToTest new.
	label text: [ :e | e model + 1].
	el := ROElement on: 2.
	self assert: (label textFor: el) = '3'! !

!ROAbstractLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testWidthFor

	| label element1 element2 |
	label := self classToTest new.
	element1 := ROElement on: 'abcdefghijk
abc
def'.
	element2 := ROElement on: 'abcdefghijk'.
	
	self assert: (label longestTextLineFor: element1) = (label longestTextLineFor: element2).
	self assert: (label longestTextLineFor: element1) = element2 model.
	self assert: (label widthFor: element1) = (label widthFor: element2).! !

ROAbstractLabelTest subclass: #ROCenteredLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCenteredLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 12:02'!
classToTest
	^ ROCenteredLabel! !

ROAbstractLabelTest subclass: #ROLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 11:58'!
classToTest
	^ ROLabel! !

ROTest subclass: #ROAbstractPopupTest
	instanceVariableNames: 'view popup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROAbstractPopupTest class methodsFor: 'testing' stamp: 'AlexandreBergel 4/5/2013 14:43'!
isAbstract
	^ self name = #ROAbstractPopupTest! !

!ROAbstractPopupTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2013 14:42'!
classToTest
	self subclassResponsibility! !

!ROAbstractPopupTest methodsFor: 'running' stamp: 'AlexandreBergel 4/5/2013 14:23'!
setUp
	super setUp.
	view := ROView new.! !

!ROAbstractPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/5/2013 14:54'!
testDefaultReceivingView
	| el |
	view := ROView new.
	el := ROElement on: 123.
	el @ self classToTest.

	view add: el.
	
	self assert: view numberOfElements = 1.
	el announce: ROMouseEnter.
	self assert: view numberOfElements = 2.
	el announce: ROMouseLeave.
	self assert: view numberOfElements = 1.! !

!ROAbstractPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/5/2013 14:54'!
testReceivingView
	| el view2 |
	view := ROView new.
	view2 := ROView new.
	el := ROElement on: 123.
	el @ (ROPopup new receivingView: view2).

	view add: el.
	
	self assert: view numberOfElements = 1.
	self assert: view2 numberOfElements = 0.
	el announce: ROMouseEnter.
	self assert: view numberOfElements = 1.
	self assert: view2 numberOfElements = 1.
	el announce: ROMouseLeave.
	self assert: view numberOfElements = 1.
	self assert: view2 numberOfElements = 0.
! !

!ROAbstractPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/5/2013 14:54'!
testReceivingViewWithStack
	| el stack |
	view := ROView new.
	stack := ROViewStack new.
	el := ROElement on: 123.
	el @ (ROPopup new receivingView: stack).

	view add: el.
	stack addView: view.
		
	self assert: view numberOfElements = 1.
	self assert: stack numberOfElements = 0.
	el announce: ROMouseEnter.
	self assert: view numberOfElements = 1.
	self assert: stack numberOfElements = 1.
	el announce: ROMouseLeave.
	self assert: view numberOfElements = 1.
	self assert: stack numberOfElements = 0.
! !

ROAbstractPopupTest subclass: #ROPopupTest
	instanceVariableNames: 'el'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2013 14:42'!
classToTest
	^ ROPopup! !

!ROPopupTest methodsFor: 'running' stamp: 'AlexandreBergel 4/5/2013 14:23'!
setUp

	super setUp.
	el := ROElement new size: 50.
	el @ RODraggable.
	el @ (popup := ROPopup text: 'balh').
	view add: (el +  ROBox).
	
	view camera windowSize: 500 @ 500
	! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:12'!
testBottomLeft
	
	self assert: ((popup closestPositionOf: el from: 4 @ 504 in: view) = 
					((4 @ 504) + (popup popupOffset x @ popup popupOffset y negated) - (0 @ el height)))! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:13'!
testBottomRight
	
	self assert: ((popup closestPositionOf: el from: 504 @ 504 in: view) = 
					((504 @ 504) - popup popupOffset - (el width @ el height)))! !

!ROPopupTest methodsFor: 'tests' stamp: 'DR 1/15/2013 22:10'!
testMouseEnteringAndDragNode

	| popupElement |
	view := ROView new.
	el  := ROElement new.
	el @ ROPopup.
	view add: el.

	el announce: ROMouseEnter.
	self assert: view elements size = 2.
	popupElement := (view elements copyWithout: el) first.
	
	el announce: (ROMouseDragging step: 10 @ 10).
	self assert: view elements size = 1.! !

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/2/2013 09:14'!
testPositionInAStack
	| stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.
	view := ROView new.
	view
		add: element.
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	stack camera windowSize: 500 @ 500. 
	view camera windowSize: 500 @ 500. 
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :ell | ell ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new position: 45 @ 65; realPosition: 45 @ 65).
	popup := (view elementsSuchThat: [ :ell | ell ~~ element ]) first.
	self assert: popup position = ((45 @ 65) + ROPopup defaultPopupOffset).! !

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/2/2013 09:14'!
testPositionInAStack2
	|  stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	stack camera windowSize: 500 @ 500. 
	view camera windowSize: 500 @ 500. 
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :ell | ell ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :ell | ell ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:07'!
testTopLeft
	
	self assert: ((popup closestPositionOf: el from: 4 @ 4 in: view)= ((4 @ 4) + (popup popupOffset)))! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 4/6/2013 22:23'!
testTopLeftWithBigPopup
	| popupElement |
	popup := ROPopupView new view: (ROView new add: ((ROElement new extent: 800 @ 800) + ROBox)).
	popupElement := popup createPopupFor: el.
	self assert: ((popup closestPositionOf: popupElement from: 4 @ 4 in: view)= ((4 @ 4) + (popup popupOffset)))! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:06'!
testTopLeftWithEvents

	| popupElement |
	el announce: (ROMouseEnter new realPosition: 4 @ 4).
	popupElement := view elements second.
	
	self assert: (popupElement position = ((4 @ 4) + (popup popupOffset)))! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:11'!
testTopRight

	self assert: ((popup closestPositionOf: el from: 500 @ 4 in: view) = 
					((500 @ 4) + (popup popupOffset x negated @ popup popupOffset y) - (el width @ 0)))! !

!ROPopupTest methodsFor: 'positionning popup' stamp: 'AlexandreBergel 1/2/2013 09:15'!
testTopRightWithEvents

	| popupElement viewWidth |
	viewWidth := view camera windowSize x.
	el announce: (ROMouseEnter new realPosition: viewWidth @ 4).
	popupElement := view elements second.
	
	self assert: (popupElement position = ((viewWidth @ 4) + (popup popupOffset x negated @ popup popupOffset y) - (popupElement width @ 0)))! !

ROAbstractPopupTest subclass: #ROPopupViewTest
	instanceVariableNames: 'popupView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupViewTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/5/2013 14:43'!
classToTest
	^ ROPopupView! !

!ROPopupViewTest methodsFor: 'running' stamp: 'AlexandreBergel 4/5/2013 14:23'!
setUp
	| el |
	super setUp.
	popupView := ROView new.
	el := (ROElement new extent: 50@60)+ (ROBox new color: Color blue).
	popupView add: el.
	
! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 1/2/2013 09:16'!
testPositionInAStack
	| stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	stack camera windowSize: 500 @ 500.
	view camera windowSize: 500 @ 500.
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40 @ 60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = ((40 @ 60) + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 1/2/2013 09:16'!
testPositionInAStack2
	| stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	stack camera windowSize: 500 @ 500.
	view camera windowSize: 500 @ 500.

	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 1/2/2013 09:18'!
testPositionWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el translateTo: 50@25.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	view camera windowSize: 500 @ 500.
	receivingView camera windowSize: 500 @ 500.

	el announce: ROMouseEnter.
	popup := receivingView elements first.
	self assert: popup position =  (10@10).! !

!ROPopupViewTest methodsFor: 'size' stamp: 'AlexandreBergel 7/7/2012 07:48'!
testSize

	| v2 raw el |
	v2 := ROView new.
	v2 add: ((ROElement new extent: 90@20) + ROBox green).

	raw := ROView new.
	el := ROElement new extent: 150@ 60.
	el + (ROBox new).
	el @ RODraggable.
	el @ (ROPopupView view: v2). 
	raw add: el.
	
	self assert: v2 encompassingRectangle = ( (0@0) corner: (90@20))! !

!ROPopupViewTest methodsFor: 'subview' stamp: 'AlexandreBergel 8/19/2012 09:53'!
testSubview

	| canvas oldCamera viewDisplayerShape element |
	view := ROMondrianViewBuilder new.
	
	canvas := RONullCanvas new.
	oldCamera := canvas camera.

	viewDisplayerShape := ROViewDisplayer new view: view raw; yourself.
	element := ROElement new.
	element + viewDisplayerShape.
	
	element drawOn: canvas.
	
	self assert: canvas camera == view raw camera.
	
	
	
! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:26'!
testWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseEnter.
	self assert: view elements size = 1.
	self assert: receivingView elements size = 1.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:21'!
testWithoutReceivingView

	| el |
	view := ROView new.
	el := ROElement sprite.
	el @ ROPopup.
	view add: el.
	
	self assert: view elements size = 1.
	el announce: ROMouseEnter.
	self assert: view elements size = 2.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.! !

ROTest subclass: #ROAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAnnouncerTest methodsFor: 'running' stamp: ''!
setUp
	super setUp.
	announcer := ROAnnouncer new.! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder

	| t |
	self deny: announcer isForwarder.

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self assert: t isZero.

	announcer announce: ROEvent.
	self assert: t = 1.
	announcer announce: ROMouseClick.
	self assert: t = 2.
	
	announcer forward: ROMouseClick.
	announcer announce: ROMouseClick.
	self assert: t = 2. "No increase since it is forwarded."
	announcer announce: ROEvent.
	self assert: t = 3.

! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder2

	| t |

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self deny: (announcer isForwarded: ROMouseClick). 

	announcer forward: ROEvent.
	self assert: (announcer isForwarded: ROMouseClick).

	announcer announce: ROMouseClick.
	self assert: t = 0. "No increase since it is forwarded."

	announcer announce: ROEvent.
	self assert: t = 0.

! !

ROTest subclass: #ROArrowTest
	instanceVariableNames: 'arrow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROArrowTest methodsFor: 'running' stamp: 'AlexandreBergel 6/12/2012 15:01'!
setUp

	super setUp.
	arrow := ROArrow new.! !

!ROArrowTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/12/2012 15:02'!
testInitialization

	self assert: arrow offset = 0! !

!ROArrowTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/12/2012 16:54'!
testLine

	| line |
	line := ROLine new.
	self assert: line numberOfArrows = 0.
	self deny: line hasArrow.
	line add: arrow.
	self assert: line numberOfArrows = 1.
	self assert: line hasArrow.! !

ROTest subclass: #ROAttachPointTest
	instanceVariableNames: 'view el1 el2 edge shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint-Test'!

!ROAttachPointTest methodsFor: 'running' stamp: 'AlexandreBergel 6/1/2012 06:02'!
setUp
	
	view := ROView new.
	el1 := ROElement spriteOn: 1.
	el2 := ROElement spriteOn: 2.
	el1 @ ROPopup.
	el2 @ ROPopup.
	
	edge := ROEdge from: el1 to: el2.
	view addAll: (Array with: el1 with: el2 with: edge).
	shape := ROLine new color: Color black.
	edge + shape.
	ROHorizontalLineLayout on: (Array with: el1 with: el2)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:11'!
testHorizontalAttachPoint
	shape attachPoint: (ROHorizontalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)) asIntegerPoint ) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)) asIntegerPoint )  .! !

!ROAttachPointTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 12:13'!
testRenderingEmbeddedVerticalAttachPoint

	| canvas str spr embedding trace1 |
	
	view := ROView new.
	el1 := ROElement sprite.
	el2 := ROElement sprite.
	shape := ROLine new.
	shape attachPoint: (ROVerticalAttachPoint new).
	edge := (ROEdge from: el1 to: el2) + shape.
	embedding := ROElement sprite.
	embedding add: el1; add: el2; add: edge.
	ROHorizontalLineLayout on: (Array with: el1 with: el2).  
 
	embedding translateBy: 40 @ 30.

	canvas := ROTracingCanvas new.
	view add: embedding.
	view drawOn: canvas.
 
	self assert: canvas trace = #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') #(#line '(40@30)' '(160@30)' 1 'Color red') #(#line '(160@30)' '(160@90)' 1 'Color red') #(#line '(160@90)' '(40@90)' 1 'Color red') #(#line '(40@90)' '(40@30)' 1 'Color red') #(#line '(45@35)' '(95@35)' 1 'Color red') #(#line '(95@35)' '(95@85)' 1 'Color red') #(#line '(95@85)' '(45@85)' 1 'Color red') #(#line '(45@85)' '(45@35)' 1 'Color red') #(#line '(105@35)' '(155@35)' 1 'Color red') #(#line '(155@35)' '(155@85)' 1 'Color red') #(#line '(155@85)' '(105@85)' 1 'Color red') #(#line '(105@85)' '(105@35)' 1 'Color red') #(#line '(130@35)' '(70@85)' 1 'Color veryLightGray'))! !

!ROAttachPointTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 12:00'!
testRenderingVerticalAttachPoint

	| canvas |
	shape attachPoint: (ROVerticalAttachPoint new).
	canvas := ROTracingCanvas new.
	view drawOn: canvas.
	
	self assert: canvas trace = #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') #(#line '(5@5)' '(55@5)' 1 'Color red') #(#line '(55@5)' '(55@55)' 1 'Color red') #(#line '(55@55)' '(5@55)' 1 'Color red') #(#line '(5@55)' '(5@5)' 1 'Color red') #(#line '(65@5)' '(115@5)' 1 'Color red') #(#line '(115@5)' '(115@55)' 1 'Color red') #(#line '(115@55)' '(65@55)' 1 'Color red') #(#line '(65@55)' '(65@5)' 1 'Color red') #(#line '(90@5)' '(30@55)' 1 'Color black'))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:11'!
testShorterDistancePoint1
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el1 is on the left of el2"
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)) asIntegerPoint)  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)) asIntegerPoint)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint2
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateTo: el2 position.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + (0 @ (el1 bounds extent y / 2)) asIntegerPoint)  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topRight + (0 @ (el2 bounds extent y / 2)) asIntegerPoint)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint3
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateBy: 0 @ 80.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) asInteger @0)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ el2 bounds width))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint4
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same vertical line. el1 is above el2"
	el2 translateTo: el1 position.
	el2 translateBy: 0 @ 80.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) asInteger @ el1 bounds height)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ 0))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/9/2012 08:52'!
testShorterDistancePoint4WithOffset
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new offset: 5).
	
	"el1 and el2 are on the same vertical line. el1 is above el2"
	el2 translateTo: el1 position.
	el2 translateBy: 0 @ 80.
	
	self assert: (shape startingPointOf: edge) = ((el1 bounds topLeft + ((el1 bounds width / 2) asInteger @ el1 bounds height)) + (5 @ 0)) .
	self assert: (shape endingPointOf: edge) = ((el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ 0) + (5 @ 0)))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testVerticalAttachPoint
	shape attachPoint: (ROVerticalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds bottomLeft + ((el1 bounds extent x / 2) asInteger @ 0))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds extent x / 2) asInteger @ 0))  .! !

ROTest subclass: #ROBorderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBorderTest methodsFor: 'tests' stamp: ''!
testInitialization
	| border |
	border := ROBorder new.
	self assert: border color == ROBorder defaultColor! !

!ROBorderTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/10/2012 22:49'!
testSetting
	| border |
	border := ROBorder new.
	border color: Color green.
	self assert: border color = Color green! !

ROTest subclass: #ROBoxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBoxTest methodsFor: 'tests' stamp: 'DR 1/21/2013 20:24'!
testChangingBorderColor

	| box color |
	box := ROBox new.
	color := box borderColorFor: ROElement new.

	box borderColor: Color red.
	self assert: (box  borderColorFor: ROElement new) = Color red.
	self assert: (box  borderColorFor: ROElement new) ~= color! !

!ROBoxTest methodsFor: 'tests' stamp: ''!
testChangingWidthColor

	| box width |
	box := ROBox new.
	width := box borderWidthFor: ROElement new.

	box borderWidth: 4.
	self assert: (box  borderWidthFor: ROElement new) = 4.
	self assert: (box  borderWidthFor: ROElement new) ~= width! !

!ROBoxTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:11'!
testColorAndCache 

	| el box |
	el := ROElement on: (Array with: Color blue).
	box := ROBox new color: [ :element | element model first ].
	
	self assert: (box colorFor: el) = Color blue.

	"el model at: 1 put: Color red."
	box color: Color green.

	self assert: (box colorFor: el) = Color green.
	! !

!ROBoxTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:23'!
testComputingWidth

	| box width |
	box := ROBox new.
	width := box borderWidthFor: ROElement new.

	box borderWidth: 4.
	self assert: (box  borderWidthFor: ROElement new) = 4.
	self assert: (box  borderWidthFor: ROElement new) ~= width! !

!ROBoxTest methodsFor: 'tests' stamp: 'DR 1/21/2013 20:23'!
testInitialization 

	self assert: ROBox new color = ROBox defaultColor! !

ROTest subclass: #ROCameraTest
	instanceVariableNames: 'camera2 camera1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCameraTest methodsFor: 'running' stamp: 'AlexandreBergel 11/14/2012 11:57'!
setUp
	camera1 := ROCamera new.

	camera2 := ROCamera new.
	camera2 altitude: 20.! !

!ROCameraTest methodsFor: 'tests' stamp: ''!
testAngle

	self assert: camera1 angle = ROCamera defaultAngle! !

!ROCameraTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/14/2012 12:01'!
testDefaultSize

	self assert: camera1 extent = (500 @ 500).
	self assert: camera1 width = 500.
	self assert: camera1 height = 500.! !

!ROCameraTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/14/2012 13:42'!
testInitialization
	
	self assert: camera1 angle = ROCamera defaultAngle.
	self assert: camera1 position = ROCamera defaultPosition.
	self assert: camera1 windowSize = (0 @ 0)! !

!ROCameraTest methodsFor: 'initializing' stamp: ''!
testInitialize

	self assert: ROCamera new extent = ROCamera defaultExtent ! !

!ROCameraTest methodsFor: 'moving' stamp: ''!
testMovingUpAndDownCameraShouldBeCentered

	| view el b1 b2 |
	view := ROView new.
	view add: (el := ROElement sprite).
	"view open."

	self assert: (el bounds = ( 0@0 corner: 50@50)).

	b1 := (view camera virtualToRealRectangle: el bounds).

	"we move up"
	view camera moveDown.
	b2 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 extent < b2 extent.

	"check at the position of the element"
	self assert: b1 origin < b2 origin
! !

!ROCameraTest methodsFor: 'moving' stamp: 'DR 3/25/2013 21:55'!
testMovingUpAndDownCameraShouldBeCentered2

	| view el b1 b2 points |
	view := ROView new.
	view add: (el := ROElement sprite).
	el center: 250@250.
	self assert: el center = (250@250).
	"view open."

	b1 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 center = (250@250).
	
	"we move up"
	view camera moveUp.
	b2 := (view camera virtualToRealRectangle: el bounds).
	points := Array with: 230@230 with: 229@229.
	self assert: (points includes: b2 center).! !

!ROCameraTest methodsFor: 'resizing' stamp: 'AlexandreBergel 11/14/2012 12:02'!
testResizingHeight

	camera1 height: 30.
	self assert: camera1 height = 30.
	self assert: camera1 width = 500! !

!ROCameraTest methodsFor: 'resizing' stamp: 'AlexandreBergel 11/14/2012 13:50'!
testResizingView

	| view |
	view := ROView new.
	self assert: view camera windowSize = (0 @ 0).
	view windowSize: 40 @ 60.
	self assert: view camera windowSize = (40 @ 60)! !

!ROCameraTest methodsFor: 'resizing' stamp: 'AlexandreBergel 11/14/2012 12:02'!
testResizingWidth

	camera1 width: 30.
	self assert: camera1 width = 30.
	self assert: camera1 height = 500! !

!ROCameraTest methodsFor: 'resizing' stamp: 'AlexandreBergel 12/1/2012 17:33'!
testResizingWithMorph
	| cls view camera visualElement |
	view := ROView new.
	cls := ROPlatform current hostVisualElement.
	visualElement := cls on: view.
	camera := view camera.
	
	visualElement extent: (500 @ 500).
	self assert: visualElement extent = (500 @ 500).
	self assert: camera extent = (500 @ 500).
	self assert: camera windowSize = (500 @ 500).

	visualElement extent: (300 @ 200).
	self assert: camera extent = (500 @ 500).
	self assert: camera windowSize = (300 @ 200).
	! !

!ROCameraTest methodsFor: 'resizing' stamp: 'AlexandreBergel 12/1/2012 17:38'!
testResizingWithMorphAndStack
	| cls view1 view2 viewStack camera visualElement |
	view1 := ROView new.
	view2 := ROView new.
	viewStack := ROViewStack new.
	viewStack addView: view1; addView: view2.
	
	cls := ROPlatform current hostVisualElement.
	visualElement := cls on: viewStack.
	camera := viewStack camera.
	
	visualElement extent: (500 @ 500).
	self assert: visualElement extent = (500 @ 500).
	self assert: camera extent = (500 @ 500).
	self assert: camera windowSize = (500 @ 500).
	self assert: view1 camera windowSize = (500 @ 500).
	self assert: view1 camera windowSize = (500 @ 500).	
	
	visualElement extent: (300 @ 200).
	self assert: camera extent = (500 @ 500).
	self assert: camera windowSize = (300 @ 200).
	
	self assert: view1 camera windowSize = (300 @ 200).
	self assert: view1 camera windowSize = (300 @ 200).	! !

!ROCameraTest methodsFor: 'translating' stamp: ''!
testTranslating
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 250@500).
	camera1 translateBy: 50@30.
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 300@530).! !

ROTest subclass: #ROCanvasWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCanvasWrapperTest methodsFor: 'tests' stamp: 'VanessaPena 1/4/2013 10:21'!
testCreation

	|wrapper canvas|
	
	canvas := RONullCanvas new.	
	wrapper := ROCanvasWrapper onCanvas: canvas.
	
	self assert: (wrapper canvas = canvas)
	
	
! !

!ROCanvasWrapperTest methodsFor: 'tests' stamp: 'VanessaPena 1/4/2013 10:33'!
testDrawing

	|wrapper canvas view|
	
	canvas := ROTracingCanvas new.	
	wrapper := ROCanvasWrapper onCanvas: canvas.
	view := ROView new.
	view add: ROElement sprite.
	
	self assert: (wrapper canvas = canvas).
	
	view drawOn: wrapper.
	
	self assert: (wrapper canvas trace = #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') #(#line '(0@0)' '(50@0)' 1 'Color red') #(#line '(50@0)' '(50@50)' 1 'Color red') #(#line '(50@50)' '(0@50)' 1 'Color red') #(#line '(0@50)' '(0@0)' 1 'Color red')))
	
	
	
! !

ROCanvasWrapperTest subclass: #RONoTextCanvasWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!RONoTextCanvasWrapperTest methodsFor: 'tests' stamp: 'miltonmamani 4/19/2013 11:17'!
testLabelDrawing

	|wrapper view canvas|

	canvas := ROTracingCanvas new.
	wrapper := RONoTextCanvasWrapper onCanvas: canvas.
	view := ROView new.
	
	view add: ((ROElement new model: 'hola') + ROLabel).
	
	view drawOn:  canvas.
	self assert: (canvas trace size = 2).
	self assert: (canvas trace first = #(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white')).
	self assert: (canvas trace second copy at: 4 put: ''; yourself) = #(#drawStringColor 'hola' '(0@0)' '' 'Color black').
	
	canvas initialize.
	
	view drawOn:  wrapper.
	
	self assert: (canvas trace = #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white'))).! !

ROTest subclass: #ROCircleTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCircleTest methodsFor: 'running' stamp: 'VanessaPena 3/12/2013 15:30'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: (ROEllipse new color: Color green)
	! !

!ROCircleTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
testInitialization
	self assert: (ROEllipse new color = ROEllipse defaultColor)! !

ROTest subclass: #ROCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCollectionTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/18/2012 14:44'!
testAddInteraction

	| elements |
	elements := ROElement forCollection: (1 to: 20).
	self assert: (elements allSatisfy: [ :e | (e is: RODraggable) not ]).
	
	elements @ RODraggable.
	self assert: (elements allSatisfy: [ :e | e is: RODraggable ]).! !

ROTest subclass: #ROColorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:02'!
testAdjustBrightness

	self assert: (((Color gray: 0.7) adjustBrightness: -0.2) brightness - 0.5) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:03'!
testAdjustBrightnessNegativo

	self assert: (((Color gray: 0.7) adjustBrightness: -0.2) brightness - 0.5) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:03'!
testAdjustBrightnessPositivo

	self assert: (((Color gray: 0.5) adjustBrightness: 0.2) brightness - 0.7) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 17:25'!
testBrightness
	self assert: Color red brightness = 1.0.
	self assert: Color green brightness = 1.0.
	self assert: Color blue brightness = 1.0.
	
	self assert: ((Color gray: 0.7) brightness -  0.7) < 0.1! !

ROTest subclass: #ROConstraintTest
	instanceVariableNames: 'element1 element2 view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROConstraintTest methodsFor: 'running' stamp: 'AlexandreBergel 11/15/2012 16:30'!
setUp
	super setUp.
	view := ROView new.
	element1 := ROElement sprite.
	element1 extent: 50 @ 50.
	
	element2 := ROElement sprite.

	view add: element1.
	view add: element2.! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'DR 1/15/2013 21:05'!
testEvent

	| v outer inner innerLabel innerElement t |
	v := ROView new.
    
	outer := ROElement spriteOn: 'outter'.

	inner := ROElement spriteOn: 'inner'.
	innerLabel := ROElement labelOn: 'My sprite'.
	innerElement := ROElement spriteOn: 'Inner element'.
	outer add: inner; add: innerLabel.
	inner add: innerElement.

	"We layout the things"
	ROGridLayout on: inner elements.
	ROVerticalLineLayout on: outer elements.

	ROConstraint stick: innerLabel below: inner.
	v add: outer.
 
	"-------"
	t := 0.
	inner on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	innerElement translateBy: -1 @ 0.
	self assert: t = 0.
 
		
! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'DR 1/15/2013 21:05'!
testEvent2

	| v outer inner innerLabel innerElement t |
	v := ROView new.

	outer := ROElement spriteOn: 'outter'.

	inner := ROElement spriteOn: 'inner'.
	innerLabel := ROElement labelOn: 'My sprite'.
	innerElement := ROElement spriteOn: 'Inner element'.
	outer add: inner; add: innerLabel.
	inner add: innerElement.

	"We layout the things"
	ROGridLayout on: inner elements.
	ROVerticalLineLayout on: outer elements.

	ROConstraint stick: innerLabel below: inner.
	v add: outer.

	"-------"
	t := 0.
	inner on: ROElementEvent do: [ :event | t := t + 1 ].
	self assert: t = 0.

	innerElement translateBy: 5 @ 0.
	self assert: t = 1.
 ! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:23'!
testEventIfNoMoved

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementTranslated do: [ :event | t := t + 1 ].
	
	el translateBy: 0 @ 0.
	self assert: t = 0.! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:29'!
testEventIfNoResized

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementEvent do: [ :event | t := t + 1 ].
	
	el extent: el extent.
	self assert: t = 0.! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:28'!
testEventIfResized

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementEvent do: [ :event | t := t + 1 ].
	
	el extent: 10 @ 10.
	self assert: t = 1.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:07'!
testStickAbove

	ROConstraint 
		stick: element1 above: element2.
		
	self assert: (element2 position - (0 @ element1 height)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position - (0 @ element1 height)) = element1 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:06'!
testStickBelow

	ROConstraint 
		stick: element1 below: element2.
		
	self assert: (element2 position + (0 @ element2 height)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position + (0 @ element2 height)) = element1 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 12/18/2012 15:38'!
testStickToBottomLeft

	ROConstraint 
		stickToBottomLeft: element1 offset: 0.	
	
	element1 translateTo: 60 @ 30.
	self assert: element1 position = (60 @ 30).
	
	element1 view windowSize: 100 @ 80. 
	self assert: element1 position = (0 @ (80 - element1 height)).! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'VanessaPena 3/14/2013 17:11'!
testStickToTheCenter

	ROConstraint 
		stick: element1 onTheCenterOf: element2.
		
	self assert: (element1 position - (((element2 width - element1 width) / 2) @ ((element2 height - element1 height) / 2))) = element2 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element1 position - (((element2 width - element1 width) / 2) @ ((element2 height - element1 height) / 2))) = element2 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 20:35'!
testStickToTheLeft

	ROConstraint 
		stick: element1 onTheLeftOf: element2.
		
	self assert: (element1 position + (element1 width @ 0)) = element2 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element1 position + (element1 width @ 0)) = element2 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:01'!
testStickToTheRight

	ROConstraint 
		stick: element1 onTheRightOf: element2.
		
	self assert: (element2 position + (element2 width @ 0)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position + (element2 width @ 0)) = element1 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 12/18/2012 15:40'!
testStickToTopRight

	ROConstraint 
		stickToTopRight: element1 offset: 0.	
	
	element1 translateTo: 60 @ 30.
	self assert: element1 position = (60 @ 30).
	
	element1 view windowSize: 100 @ 80. 
	self assert: element1 position =  (50@0)! !

ROTest subclass: #RODecoratorTest
	instanceVariableNames: 'box label element box2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!RODecoratorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/14/2012 19:40'!
setUp

	box := ROBox new.
	box2 := ROBox new color: Color blue.
	label := ROLabel new.
	element := ROElement new.
! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 08:48'!
testAddLast

	box addLast: box2.
	box2 addLast: label.
	self assert: box next == box2.
	self assert: label next class == RONullShape.! !

!RODecoratorTest methodsFor: 'tests' stamp: 'DR 1/21/2013 20:19'!
testExample
	| el view | 
	view := ROView new.
	view add: ((el := ROElement on: 10) + (ROBox new color: Color red; borderColor: Color blue)+ ROLabel).
	"
	view open
	"
	self assert: el shapes second borderColor = Color blue.
	self assert: el numberOfShapes = 3.
	 ! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 12:18'!
testLinked
	"
	self debug: #testLinked
	"
				
	self assert: box next class == RONullShape.
	self assert: label next class == RONullShape.

	element 
		addShape: box;
		addShape: label.
	
	self assert: label next == box.
	self assert: box next class ==  RONullShape! !

ROTest subclass: #RODraggableTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RODraggableTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp
	node := ROElement new.
	node addShape: (ROBox new).

	draggableNode := ROElement new.
	draggableNode extent: 50@50.
	draggableNode + ROBox.
	draggableNode @ RODraggable.! !

!RODraggableTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:54'!
testAddition

	
	| bounds |
	node := ROElement new.
	node addShape: (ROBox new).
	node addInteraction: RODraggable.
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 5 @ 5).
	self assert: (bounds translateBy: 5 @ 5) = node bounds ! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWhileBeingRegistered

	| bounds |
	bounds := node bounds.
	node addInteraction: RODraggable.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: (bounds translateBy: 4@3) = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWithoutBeingRegistered

	| bounds |
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: bounds = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggable
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable new.
	self assert: (node is: RODraggable).
		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggableByClass
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable.
	self assert: (node is: RODraggable).

		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggingStep

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = (10 @ 6)).
	draggableNode announce: (ROMouseDragging step: -10 @ -6).
	self assert: (draggableNode position = (0 @ 0)).
	
	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = ( 5@3)).! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testElementToBeAdded

	| drag |
	self assert: (RODraggable elementToBeAdded class == RODraggable).
	drag := RODraggable new.
	self assert: (drag elementToBeAdded == drag)! !

!RODraggableTest methodsFor: 'nesting' stamp: 'AlexandreBergel 9/5/2012 08:42'!
testNesting

	| view node1 b innerNode |
	view := ROView new.
	node1 := ROElement spriteOn: 'hello'.
	node1 add: (innerNode := ROElement spriteOn: 'world').
	view add: node1.
	
	node1 translateBy: 10@20.
	
	b := node1 bounds.

	ROAdjustSizeOfNesting on: node1.
	ROAdjustSizeOfNesting on: node1.
	self assert: (b = node1 bounds).

	innerNode extent: 10@10.
	innerNode translateBy: 1 @ 1.
	self assert: (b = node1 bounds).
	
	innerNode translateBy: 5 @ 5.
	innerNode translateBy: 5 @ 5.
	self assert: (b = node1 bounds).
	
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	self assert: (b = node1 bounds).
	
	"
	view openInWindow 
	"! !

ROTest subclass: #ROElementTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROElementTest subclass: #ROContainingElementTest
	instanceVariableNames: 'node2 node3 node1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROContainingElementTest methodsFor: 'running' stamp: 'AlexandreBergel 4/19/2013 18:30'!
setUp

	node2 := ROElement on: 'world'.
	node2 extent: 40@30.
	node2 addShape: (ROBox new color: Color green).

	node3 := ROElement on: 'world'.
	node3 extent: 40@30.
	node3 addShape: (ROBox new color: Color yellow).
	node3 translateBy: 40@30.

	node1 := ROElement on: 'hello'.
	node1 extent: 100 @ 130.
	node1
		addShape: ROBox new;
		addShape: ROBorder new.! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 00:38'!
testAddingWithResize

	self assert: node3 extent < node1 extent.
	node3 add: node1.
	self assert: node3 extent > node1 extent! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 14:27'!
testAddingWithoutResize

	self assert: node3 extent < node1 extent.
	node3 resizeStrategy: ROFixedSizedParent instance.
	node3 add: node1.
	self assert: node3 extent < node1 extent! !

!ROContainingElementTest methodsFor: 'blocking and nesting' stamp: 'AlexandreBergel 4/29/2013 16:43'!
testBlockingAndNesting

	| outter inner |
	outter := ROBox element extent: 50 @ 50; yourself.
	inner := ROBox green element extent: 20 @ 20; yourself.
	outter resizeStrategy: (ROFixedSizedParent new).
	outter add: inner.
	
	self assert: outter extent = (50 @ 50).
	self assert: outter position = (0 @ 0).

	"Translating the inner node should not modify the outter node at all"
	inner translateBy: -15 @ -15.
	self assert: inner position = outter resizeStrategy padding.
	self assert: inner position = (5 @ 5).
		
	self assert: outter extent = (50 @ 50).
	self assert: outter position = (0 @ 0).
! !

!ROContainingElementTest methodsFor: 'blocking and nesting' stamp: 'AlexandreBergel 4/29/2013 16:15'!
testBlockingAndNesting2

	| outter inner |
	outter := ROBox element extent: 50 @ 50; yourself.
	inner := ROBox green element extent: 20 @ 20; yourself.
	outter resizeStrategy: (ROFixedSizedParent new).
	outter add: inner.
	
	self assert: outter extent = (50 @ 50).
	self assert: outter position = (0 @ 0).

	"Translating the inner node should not modify the outter node at all"
	inner translateBy: 150 @ 100.
	self assert: inner position = (25 @ 25).
	
	self assert: outter extent = (50 @ 50).
	self assert: outter position = (0 @ 0).

"
| view |
view := ROView new.
view add: outter.
view open
"! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/24/2013 16:53'!
testContainsEdge
	| view roView nodes edge |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 50.
	nodes := view nodes: #( 1 2 ).
	node1 := nodes first.
	node2 := nodes second.

	view shape line width: 4.	
	view interaction popupText: 'edge!!'.
	edge := view edgeFromAssociation: 1 -> 2.

	view applyLayout.
	roView := view raw.
	
	self assert: (edge contains: 60 @ 30).
	self assert: (roView elementAt: 60 @ 30) == edge.
	self assert: (roView elementAt: edge bounds center) == edge.
	
	self assert: (roView elementAt: node1 center) == node1.
	self assert: (roView elementAt: node2 center) == node2.	
! !

!ROContainingElementTest methodsFor: 'dragging' stamp: 'AlexandreBergel 4/23/2013 19:33'!
testDraggingNestedElement

	| b |
	"node1 bounds = 50@50 corner: 150@180 
	node3 bounds =  190@130 corner: 230@160 "
	node1 addInteraction: RODraggable.
	node3 addInteraction: RODraggable.
	node1 add: node3.

	node1 translateBy: 50 @ 50.
	
	"We move the inner node toward the bottom right corner"
	node3 translateBy: 150 @ 100.
	self assert: (node1 extent =  (240@170)).
	
	"We move the inner node toward the top left corner"
	b := node1 bounds.
	node3 translateBy: -200 @ -150.
	self assert: node1 topLeft ~= b topLeft.
	self assert: node1 topLeft  =  (45@35)
	"
	view open
	"! !

!ROContainingElementTest methodsFor: 'translation shape and inner nodes' stamp: 'AlexandreBergel 12/11/2012 12:55'!
testElementAt

	| el view |
	el := ROElement new + ROBox.
	el extent: 20 @ 20.
	
	view := ROView new.
	view add: el.
	el translateTo: 3 @ 3.
	
	self assert: (view elementAt: 3 @ 3) == el.
! !

!ROContainingElementTest methodsFor: 'view' stamp: 'AlexandreBergel 4/24/2013 08:46'!
testElementAtAfterDragging

	| view |
	view := ROView new.
	node1 add: node2.
	view add: node1.
	
	node1 translateTo: 50@50.

	self assert: (view elementAt: (node1 extent + node1 absolutePosition)) == view.
	self assert: (view elementAt: (50 @ 50)) == node1.
	self assert: (view elementAt: (55 @ 55)) == node2.

	self assert: (view elementAt: node1 topLeft + (5 @ 5)) == node2
	
! !

!ROContainingElementTest methodsFor: 'events' stamp: 'AlexandreBergel 4/24/2013 16:54'!
testEventForNested

	| view circle grid options choice t morph |
	t := 0.
	view := ROView new.
	circle := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'circle'). 
	circle on: ROMouseClick do: [:e | t := t + 1 ].

	grid := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'grid').
	grid on: ROMouseClick do: [:e | t := t + 10 ].
	options := (Array with: circle with: grid).

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	view add: choice.
	"
	view openInWindow.
	"
	
	"grid adjustSizeOfParent  " 
	morph := ROPlatform current widgetFactory forView: view.
	morph extent: 200@200.
	
	self assert: choice bounds = ( 0@0 corner: 225@55).
	
	"virtual position = 63@29"
	self assert: (choice contains: 63@29).
	
	"real position 32@15"
	self assert: (morph elementForRealPosition: 32@15) ~~ view.
! !

!ROContainingElementTest methodsFor: 'translating shape' stamp: 'AlexandreBergel 9/25/2012 17:51'!
testNoTranslationShape

	| el |
	el := ROElement new.
	el + ROBox.
	el extent: 50 @ 50.

	self assert: (el contains: 0 @ 0).
	self assert: (el contains: 25 @ 25).
	self deny: (el contains: 50 @ 50).! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/15/2012 10:46'!
testRemovingWithResize

	node3 add: node1.
	self assert: node3 extent > node1 extent.
	node3 removeAllElements.
	ROShrikingSize on: node3.
	self assert: node3 extent < node1 extent! !

!ROContainingElementTest methodsFor: 'view' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testSettingTheView

	| newNode view |
	newNode := ROElement new.
	self assert: (newNode view == ROView nullView).

	self assert: (node1 view == ROView nullView).
	view := ROView new.
	view add: node1.
	
	node1 add: newNode.
	
	self assert: (newNode view == view)! !

!ROContainingElementTest methodsFor: 'sizing' stamp: 'AlexandreBergel 4/23/2013 19:37'!
testSize

	| el el2 |
	el := ROElement new.
	self assert: (el extent = (5 @ 5)).
	el add: (el2 := ROElement sprite).
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el extent = (el2 extent + (10 @ 10)))
	! !

!ROContainingElementTest methodsFor: 'sizing' stamp: ''!
testSize2

	| bounds el |
	el := ROElement sprite.
	bounds := el bounds.
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el bounds = bounds)
	! !

ROElementTest subclass: #ROEdgeTest
	instanceVariableNames: 'view edge node1 node2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEdgeTest methodsFor: 'popup' stamp: 'AlexandreBergel 8/20/2012 11:06'!
doesNOTWORKtestPopup
	"Apparently this test run into concurency problems"

	| t |
	edge @ ROPopup.
	edge announce: ROMouseEnter.
	
	t := 0.
	10 timesRepeat: [ 
		(Delay forMilliseconds: 2) wait.
		t := t max: view raw elements size.
	].
	self assert: t = 4.! !

!ROEdgeTest methodsFor: 'running' stamp: 'AlexandreBergel 12/11/2012 14:30'!
setUp

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 30.
	view nodes: (1 to: 2).
	node1 := view raw elements first.
	node2 := view raw elements second.

	view interaction popupText: 'FooZork'.
	edge := view edgeFromAssociation: 1 -> 2.
	view applyLayout! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/18/2012 09:35'!
testArrowedEdge

	| n1 n2 line |
	n1 := ROElement new.
	n2 := ROElement new.

	edge := ROEdge arrowedLineFrom: n1 to: n2.
	self assert: edge from == n1.
	self assert: edge to == n2.
	
	line := edge getShape: ROLine.
	self assert: line numberOfArrows = 1! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/20/2012 10:03'!
testContains

	self deny: ((ROEdge from: ROElement new to: ROElement new) contains: 10@40)! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 14:46'!
testCreation

	self should: [ ROEdge from: Object new to: Object new ] raise: Exception! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 12:29'!
testEdgeBounds

	self assert: edge bounds = ( (5@5) corner: (75@35) ).
	
	
! !

!ROEdgeTest methodsFor: 'lookup' stamp: 'AlexandreBergel 12/5/2012 17:58'!
testElementFromModel

	edge model: 42.
	self assert: (edge elementFromModel: 42) isNil.
	self assert: (edge edgeFromModel: 42) == edge.
	self assert: (edge edgeFromModel: 43) isNil! !

!ROEdgeTest methodsFor: 'lookup' stamp: 'AlexandreBergel 8/19/2012 21:49'!
testGetFromView

	| roView |
	roView := view raw.
	self assert: (roView elementAtRealPosition: edge bounds center) == edge! !

!ROEdgeTest methodsFor: 'popup' stamp: 'AlexandreBergel 8/20/2012 11:07'!
testInteraction

	self assert: edge numberOfInteractions = 1.
	edge @ ROPopup.
	self assert: edge numberOfInteractions = 2.! !

!ROEdgeTest methodsFor: 'line segment' stamp: 'AlexandreBergel 12/11/2012 14:30'!
testLineSegment

	| shape segments |
	shape := edge getShape: ROShape.
	segments := shape lineSegmentsFor: edge.
	self assert: segments size = 2. 
	self assert: segments first = node1 rightCenter.
	self assert: segments second = node2 leftCenter! !

!ROEdgeTest methodsFor: 'line segment' stamp: 'AlexandreBergel 8/19/2012 21:05'!
testLineSegment2

	| shape segments |
	node2 translateBy: 80 @ 60.

	shape := edge getShape: ROShape.
	segments := shape lineSegmentsFor: edge.
	self assert: segments size = 2. 
	self assert: segments first = node1 rightCenter.
	self assert: segments second = node2 leftCenter! !

!ROEdgeTest methodsFor: 'orthoHorizontal' stamp: 'AlexandreBergel 8/19/2012 19:11'!
testOrthoHorizontalLineSegmentWithTranslation

	| lineShape segments |
	node2 translateBy: 50@80.
	edge + (lineShape := ROOrthoHorizontalLineShape new).
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: segments size = 4.
	self assert: segments = (Array 
								with: node1 topRight + (0 @ (node1 height / 2))
								with: (node2 topLeft x - node1 topRight x) / 2 + node1 topRight x @ (node1 position y + (node1 height / 2))
								with: (node2 topLeft x - node1 topRight x) / 2 + node1 topRight x @ (node2 position y + (node2 height / 2))
								with: node2 topLeft + (0 @ (node2 height / 2)) )! !

!ROEdgeTest methodsFor: 'orthoHorizontal' stamp: 'miltonmamani 4/16/2013 17:53'!
testOrthoHorizontalSamePosition

	|  el1 el2  |
	view := ROView new.

	el1 := ROElement sprite.
	el2 := ROElement sprite.

	edge := ROEdge from: el1 to: el2.
	edge + ROOrthoHorizontalLineShape new.
	view addAll: (Array with: el1 with: el2 with: edge).
	
	self shouldnt: [ edge contains: 40 @ 30 ] raise: Error.! !

!ROEdgeTest methodsFor: 'orthoVertical' stamp: 'AlexandreBergel 12/11/2012 14:31'!
testOrthoVerticalLineContainsPoint

	| lineShape segments |
	edge change: ROLine for: (lineShape := ROOrthoVerticalLineShape new).
	view raw on: ROMouseClick do: [ :ann | Transcript show: ann position printString ;cr ].
	"view open."
	node2 translateBy: 50@100.
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: (edge contains: (21 @ 52)).
	self assert: (edge contains: (111 @ 88)).
	self assert: (edge contains: (64 @ 70)).! !

!ROEdgeTest methodsFor: 'orthoVertical' stamp: 'AlexandreBergel 8/19/2012 21:38'!
testOrthoVerticalLineSegmentWithTranslation

	| lineShape segments |
	node2 translateBy: 50@100.
	edge + (lineShape := ROOrthoVerticalLineShape new).
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: segments size = 4.
	self assert: segments = (Array 
								with: node1 bottomCenter
								with: node1 bottomCenter x @ ((node2 topCenter y - node1 bottomCenter y) / 2 + node1 bottomCenter y)
								with: node2 bottomCenter x @ ((node2 topCenter y - node1 bottomCenter y) / 2 + node1 bottomCenter y)
								with: node2 topCenter) ! !

!ROEdgeTest methodsFor: 'orthoVertical' stamp: 'miltonmamani 4/16/2013 17:54'!
testOrthoVerticalSamePosition

	|  el1 el2  |
	view := ROView new.

	el1 := ROElement sprite.
	el2 := ROElement sprite.

	edge := ROEdge from: el1 to: el2.
	edge + ROOrthoVerticalLineShape new.
	view addAll: (Array with: el1 with: el2 with: edge).
	
	self shouldnt: [ edge contains: 40 @ 30 ] raise: Error.! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/19/2012 12:12'!
testPopupFixture

	self assert: view raw elements size = 3.
! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/26/2013 19:13'!
testTopLeftAndContaint

	edge := ROEdge from: ROElement new to: ROElement new.
	self assert: edge topLeft = (0 @ 0).
	self deny: (edge contains: 5 @ 5)! !

!ROElementTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: ROBox new;
		addShape: ROBorder new.
	
	draggableNode := ROElement new.
	draggableNode @ RODraggable.
	draggableNode extent: 50@50.
	draggableNode + ROBorder red.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 12/11/2012 12:22'!
testAddShape

	| el shape1 shape2 |
	el := ROElement new.
	self assert: el numberOfShapes = 1.
 
	shape1 := ROBox new.
	shape2 := ROLabel new.
	shape1 next: shape2.
	el addShape: shape1.
	
	self assert: el numberOfShapes = 3! !

!ROElementTest methodsFor: 'event' stamp: 'TudorGirba 9/9/2012 21:41'!
testAllElementsDo

	| node1 node2 node21 edge root traversed |
	root := ROElement new.
	node1 := ROElement new.
	node2 := ROElement new.
	edge := ROEdge from: node1 to: node2.
	node21 := ROElement new.

	root add: node1.
	root add: node2.
	root add: edge.
	node2 add: node21.
	
	traversed := OrderedCollection new.
	root allElementsDo: [:each | traversed add: each].
	self assert: traversed size = 4.
	self assert: traversed first = node1.
	self assert: traversed second = node2.
	self assert: (traversed at: 3) = node21.
	self assert: traversed last = edge! !

!ROElementTest methodsFor: 'event' stamp: ''!
testAnnounce

	| node1 node2 bounds |
	node1 := ROElement new.
	node2 := ROElement new.
	
	node1 on: ROMouseClick do: [ ROGrow on: node2 by: 1 ].
	bounds := node2 bounds.

	node1 announce: ROMouseClick.
	self assert: (bounds extent < node2 bounds extent)! !

!ROElementTest methodsFor: 'attributes' stamp: 'AlexandreBergel 6/18/2012 14:11'!
testAttributes
	self deny: node hasAttributes.
	node attributes at: #oldColor put: Color black.
	self assert: node hasAttributes.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 17:02'!
testChangeShape
	"
	self debug: #testChangeShape
	"
	| element |
	element := ROEdge new.
	self deny: (element isShapedAs: ROLine).
	element + ROLine.
	element change: ROShape for: ROLine.
	self assert: (element isShapedAs: ROLine).
	self assert: (element isShapedAs: ROShape).
	
	element change: ROShape for: ROOrthoVerticalLineShape.
	self assert: (element isShapedAs: ROShape).
	self assert: (element isShapedAs: ROOrthoVerticalLineShape).
! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testContains

	self assert: (node contains: node position).
	self deny: (node contains: node position - (1 @ 1)).! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testCornerRadius

	node := ROElement new center: 10@8 radius: 5.
	self assert: node bounds = (5@3 corner: 15@13)! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:24'!
testDecoration
	| el |
	
	el := ROElement bare.
	self deny: (el isShapedAs: ROShape).
	self deny: (el isShapedAs: ROLabel).
	
	el addShape: ROLabel.
	self assert: (el isShapedAs: ROShape).
	self assert: (el isShapedAs: ROLabel).! !

!ROElementTest methodsFor: 'margin' stamp: 'AlexandreBergel 4/24/2013 09:23'!
testDefaultMargin

	self assert: ROElement new padding = (5 @ 5)! !

!ROElementTest methodsFor: 'depth' stamp: 'AlexandreBergel 12/4/2012 08:43'!
testDepth

	self assert: ROElement new depth = 1.! !

!ROElementTest methodsFor: 'depth' stamp: 'AlexandreBergel 12/4/2012 08:44'!
testDepthOfElementInView

	| view el |
	view := ROView new.
	view add: (el := ROElement new).
	self assert: el depth = 1.! !

!ROElementTest methodsFor: 'depth' stamp: 'AlexandreBergel 12/4/2012 08:44'!
testDepthOfElementInViewWithNesting

	| view el1 el2 |
	view := ROView new.
	view add: (el1 := ROElement new).
	el1 add: (el2 := ROElement new).
	self assert: el1 depth = 1.
	self assert: el2 depth = 2.! !

!ROElementTest methodsFor: 'depth' stamp: 'AlexandreBergel 12/4/2012 08:45'!
testDepthOfView

	self assert: ROView new depth = 0! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 4/23/2013 19:38'!
testDragAndDropWithInner

	| view outter inner |
	view := ROView new.
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	outter add: inner.
	view add: outter.
	
	self assert: outter bounds = (0@0 corner: 60 @ 60).
	self assert: inner bounds = ( (5@5) corner: (55@55)).
	
	inner translateBy: -10 @ -10.
	self assert: outter bounds = ( (-5@ -5) corner: (60@60)).
	self assert: inner bounds = (0@0 corner: 50@50).
! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 9/30/2012 18:43'!
testEventTranslation

	| t el |
	t := 0.
	el := ROElement new.
	el on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	el translateTo: 50 @ 50.
	self assert: t = 1.
	
	el translateBy: 50 @ 50.
	self assert: t = 2.! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 10/1/2012 09:10'!
testEventTranslation2

	| t outter inner1 inner2 |
	t := 0.
	outter := ROElement on: 'outter'.
	inner1 := ROElement on: 'inner1'.
	inner2 := ROElement on: 'inner1'.
	
	inner1 on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	inner1 translateTo: 50 @ 50.
	self assert: t = 1.
	
	inner2 translateBy: 50 @ 50.
	self assert: t = 1.
	
	outter translateBy: 50 @ 50.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 6/18/2012 13:53'!
testForShapeDo

	| border |
	border := node getShape: ROBorder.
	self assert: border color = ROBorder defaultColor.
	node forShape: ROBorder do: [ :s | s color: Color blue ].

	self assert: border color = Color blue! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwarding

	| inner view outter bInner bOutter |
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: inner bounds = bInner.
	self assert: outter bounds = (bOutter translateBy: (10@10)).! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/30/2012 18:48'!
testForwardingEvent

	| inner view outter bInner bOutter t |
	t := 0.
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.

	outter on: ROMouseDragging do: [ :evt | t := t + 1 ].
	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwardingEventWithView

	| inner view outter bInner bOutter t |
	t := 0.
	view := ROView new.
	view on: ROEvent do: [ :evt | t := t + 1 ].

	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	
	outter add: inner. 
	view add: outter.

	inner forward.
	outter forward.
	
	self assert: outter parent == view.
	self assert: inner parent == outter.

	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:48'!
testGetShape
	| el deco |
	
	el := ROElement new.
	deco := ROBox new.
	deco color: Color red.
	el addShape: deco.
	
	self assert: (el getShape: ROBox) == deco.! !

!ROElementTest methodsFor: 'group of nodes' stamp: 'DR 1/21/2013 21:05'!
testGroupOfNodes

	| nodes |
	nodes := ROElement forCollection: (1 to: 20).
	self assert: (nodes size = 20).
	self assert: (nodes collect: #model) = (1 to: 20) asArray! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 13:55'!
testHeightAndWidth

	draggableNode width: 100.
	self assert: ((draggableNode getShape: ROBorder) width = 100).
	
	draggableNode height: 59.
	self assert: ((draggableNode getShape: ROBorder) height = 59).! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 14:01'!
testHeightAndWidthWithBlock

	draggableNode model: 42.
	draggableNode width: [ :element | element model + 10 ].
	draggableNode height: [ :element | element model + 20 ].
	self assert: (((draggableNode getShape: ROBorder) extentFor: draggableNode) = (52 @ 62)).! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 12:23'!
testInitialization
	| aNode |
	aNode := ROElement new.
	self assert: aNode bounds = ROElement defaultBounds.
	self assert: aNode extent = aNode bounds extent.
	
	self assert: aNode numberOfShapes = 1! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:10'!
testInitialization2
	self assert: ROElement new view camera notNil.! !

!ROElementTest methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/25/2012 20:25'!
testInitializationBare
	| aNode |
	aNode := ROElement bare.
	self assert: aNode bounds = ROElement defaultBounds.
	self assert: aNode extent = aNode bounds extent.
	
	"Just the null shape"
	self assert: aNode numberOfShapes = 1! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testInteraction 

	| int int2 |

	self deny: (node is: ROMenuActivable).
	node @ (int := ROMenuActivable new item: 'act' action: #inspect).
	self assert: (node is: ROMenuActivable).
	
	self assert: int == (node getInteraction: ROMenuActivable).
	self assert: int numberOfEntries = 1.
	
	"We add a new action. We should fill the first interaction only"
	node @ (int2 := ROMenuActivable new item: 'act2' action: #inspect).
	self assert: int numberOfEntries = 2.
	self assert: int == (node getInteraction: ROMenuActivable).! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/27/2012 21:00'!
testIsNotEdge

	self assert: node isNotEdge.
	self deny: node isEdge.
	self assert: node isElement! !

!ROElementTest methodsFor: 'iteration' stamp: ''!
testIteratingOnEmptyCollections

	self shouldnt: [ ROElement new interactionsDo: [ :el | ] ]  raise: Error! !

!ROElementTest methodsFor: 'margin' stamp: 'AlexandreBergel 4/24/2013 09:21'!
testMargin

	| el1 el2 |
	el1 := ROBox blue element.
	el2 := ROBox red element.
	el2 extent: 20 @ 20.
	
	self assert: el1 extent = (5 @ 5).

	el1 resizeStrategy: (ROShrinkingParent new paddingGap: 0).
	el1 add: el2.
	self assert: el1 extent = (20 @ 20).	
	! !

!ROElementTest methodsFor: 'margin' stamp: 'AlexandreBergel 4/24/2013 09:23'!
testMargin2

	| el1 el2 |
	el1 := ROBox blue element.
	el2 := ROBox red element.
	el2 extent: 20 @ 20.
	
	self assert: el1 extent = (5 @ 5).

	el1 resizeStrategy: (ROShrinkingParent new paddingGap: 10).
	el1 add: el2.
	self assert: el1 extent = (30 @ 30).	
	! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testModel
	| aNode object |
	aNode := ROElement new.
	self assert: aNode model isNil.

	aNode := ROElement on: (object := Object new).
	self assert: (aNode model == object)! !

!ROElementTest methodsFor: 'nesting' stamp: 'AlexandreBergel 9/29/2012 16:12'!
testMostSpecificParentCommonWith

	| view el1 el11 el111 el12 el2 el21 |
	view := ROView new.
	el1 := ROElement sprite @ ROPopup .
	el11 := ROElement sprite @ ROPopup .
	el111 := ROElement sprite @ ROPopup .
	el12 := ROElement sprite @ ROPopup .
	el2 := ROElement sprite @ ROPopup .
	el21 := ROElement sprite @ ROPopup .
	
	el1 add: el11; add: el12.
	el11 add: el111.
	el2 add: el21.
	
	view add: el1; add: el2. 
	
	self assert: (el1 mostSpecificParentCommonWith: el2) == view.
	self assert: (el1 mostSpecificParentCommonWith: el21) == view.
	
	self assert: (el1 mostSpecificParentCommonWith: el11) == view.
	self assert: (el12 mostSpecificParentCommonWith: el111) == el1.

	self assert: (el11 mostSpecificParentCommonWith: el111) == el1.! !

!ROElementTest methodsFor: 'event' stamp: 'VanessaPena 12/2/2012 19:20'!
testOnDoOnce

	| element t |
	element := ROElement new.
	t := 0.

	self assert: element numberOfInteractions = 0.
	element on: ROMouseClick doOnce: [ :ann | t := t + 1 ].

	"self assert: element numberOfInteractions = 1."
	self assert: t = 0.
	
	element announce: ROMouseClick.
	self assert: t = 1.
	"self assert: element numberOfInteractions = 0."
	
	element announce: ROMouseClick.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 11/25/2012 10:57'!
testOnDoOnce2

	| element t |
	element := ROElement new.
	t := 0.

	self assert: element numberOfInteractions = 0.
	element on: ROMouseLeave doOnce: [ :ann | t := t + 1 ].

	"self assert: element numberOfInteractions = 1."
	self assert: t = 0.
	
	element announce: ROMouseLeave.
	self assert: t = 1.
	"self assert: element numberOfInteractions = 0."
	
	element announce: ROMouseLeave.
	self assert: t = 1.
	
	element announce: ROMouseClick.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 8/2/2012 18:10'!
testOverridingIteraction

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	"Two subscription, one for entering and another for leaving"

	node @ ROPopup.
	self assert: eventHandler numberOfSubscriptions = 3.
	
	node changeInteraction: ROAbstractPopup for: (ROPopupView new view: ROView new).
	self assert: eventHandler numberOfSubscriptions = 3.	
! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testParentAndNesting

	| inner outter |
	inner := ROElement new.
	outter := ROElement new.
	
	self assert: inner parent == ROView nullView.
	self assert: outter parent == ROView nullView.
	
	outter add: inner. 

	self assert: inner parent == outter.
	self assert: outter parent == ROView nullView! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testParentAndView

	| element view |
	element := ROElement new.
	self assert: element parent == ROView nullView.

	view := ROView new.
	view add: element.

	self assert: element parent == view.! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 4/22/2013 19:30'!
testParentBehavior

	| element outterElement |
	element := ROElement new.
	self assert: element resizeStrategy isExtensible.
	
	outterElement := ROElement new.
	outterElement add: element.
	self assert: element resizeStrategy isExtensible! !

!ROElementTest methodsFor: 'printing' stamp: 'AlexandreBergel 5/10/2012 16:39'!
testPrinting

	self assert: (#('a ROElement' 'a Roassal.ROElement') includes: ROElement new printString).
	self assert: (#( 'a ROElement<10>'  'a Roassal.ROElement<10>') includes: (ROElement on: 10) printString).

! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/5/2012 08:47'!
testReducingSize

	| el |
	el := (ROElement new extent: 90@20) + ROBox green.
	el extent: 10 @ 12.
	self assert: el extent = (10 @ 12)! !

!ROElementTest methodsFor: 'actions' stamp: ''!
testRemoveElements

	| elements |

	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.
	
	node addAll: (ROElement forCollection: (1 to: 20)).
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements notEmpty.
	
	node removeAllElements.
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 6/16/2012 00:48'!
testRemoveElementsAndError

	self shouldnt:  [ node remove ] raise: Error! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:57'!
testRemoveInteraction

	| el |
	el := ROElement new.
	self deny: (el is: RODraggable).
	
	el @ RODraggable.
	self assert: (el is: RODraggable).

	el removeInteraction: RODraggable.
	self deny: (el is: RODraggable).! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 09:43'!
testRemoveInteraction2

	self shouldnt: [ ROElement new removeInteraction: ROAbstractPopup ] raise: Error ! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 6/5/2012 10:31'!
testRemoveOnElement

	| view |
	view := ROView new.
	view add: node.
	self assert: (view elements includes: node).
	
	node remove.
	self deny: (view elements includes: node).! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 12/11/2012 12:23'!
testRemoveShape

	self assert: (node numberOfShapes = 3).
	node - ROBox.
	self assert: (node shapes size = 2).
	node + ROBox.
	self assert: (node shapes size = 3).
	
	"No error should happen here"
	self shouldnt: [ node - ROLine ] raise: Error.
	
	node - ROBorder.
	node - ROBox.
	self assert: (node shapes size = 1).
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testRemoveShapeOnEdges

	| edge |
	edge := ROEdge new.
	self assert: (edge shapes size = 1).
	edge - ROLine.
	self assert: (edge shapes size = 1).
	edge + ROLine.
	self assert: (edge shapes size = 2).
	
	"No error should happen here"
	self shouldnt: [ edge - ROBox] raise: Error.
	
! !

!ROElementTest methodsFor: 'shapes' stamp: 'DR 1/15/2013 20:47'!
testRemoveSubscription

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler aPopup |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	aPopup := ROPopup new.
	node @ aPopup.
	self assert: eventHandler numberOfSubscriptions = 3.

	eventHandler unsubscribe: aPopup.
	self assert: eventHandler numberOfSubscriptions = 0.! !

!ROElementTest methodsFor: 'removing' stamp: 'AlexandreBergel 10/18/2012 16:52'!
testRemoving

	| view |
	view := ROView new.
	view add: node.
	node remove.
	self assert: view numberOfElements = 0.! !

!ROElementTest methodsFor: 'removing' stamp: 'AlexandreBergel 10/18/2012 18:14'!
testRemovingNestedNode

	| innerNode |
	
	innerNode := ROElement new.
	node add: innerNode.
	self assert: node numberOfElements = 1.
	innerNode remove.
	self assert: node numberOfElements = 0.! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testRendering
	
	| nullCanvas |
	nullCanvas := ROCountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles isZero.
	node drawOn: nullCanvas.

	self assert: nullCanvas numberOfRectangles = 1.
	self assert: nullCanvas numberOfLines = 4.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:54'!
testResizing

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node extent: 20 @ 10.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:54'!
testResizing2

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node extent: node extent.
	self assert: t = 0.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:55'!
testResizing3

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node width: 60.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:55'!
testResizing4

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node height: 60.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:23'!
testSize

	| el |
	el := (ROElement new extent: 90@20) + ROBox green.
	self assert: el extent = ( 90 @ 20 )! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/13/2012 12:26'!
testSize2

	| el |
	el := (ROElement new) + ROBox green.
	el extent: 90@20.
	self assert: el extent = ( 90 @ 20 )! !

!ROElementTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
testSize3

	| el |
	el := ROElement new + ROEllipse.
	el extent: 30 @ 30.
	self assert: el extent = ( 30 @ 30 )! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 7/23/2012 11:56'!
testTranslatingByAFloatPoint

	| el |
	el := ROElement new.
	self assert: el position = (0 @ 0).
	
	el translateBy: 0.4 @ 0.3.
	self assert: el position = (0.4 @ 0.3).
	! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByFloats

	
	self assert: draggableNode position = (0@0).
	draggableNode translateBy: 4.5 @ 1.3.
	self assert: draggableNode position = (4.5 @ 1.3).
	
	node translateTo: 2.4 @ 6.4.
	self assert: node position = ( 2.4@6.4).
	
	node translateBy: 2.4 @ 6.4.
	self assert: node position = ( 4.8@12.8)! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByRealPoint

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 10 @ 6)).
	draggableNode translateByRealPoint: -10 @ -6.
	self assert: (draggableNode position = ( 0 @ 0)).

	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 5@3)).! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 9/16/2012 22:19'!
testTranslation

	| elOutter elInner view |
	elOutter := ROElement new + ROBorder.
	elOutter @ RODraggable.

	elInner := ROElement new + ROBorder.
	elInner @ RODraggable.
	elOutter add: elInner .
	 
	"elInner is now centered"
	ROHorizontalLineLayout on: (Array with: elInner).
	
	"view := ROView new.
	view add: elOutter.
	view open."
	
	self assert: elInner position = (5 @ 5).

	elInner translateBy: -5 @ -5.
	self assert: elInner position = (0 @ 0).! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testView

	self assert: node view == ROView nullView.

	ROView new add: node.
	self assert: node view notNil.	  ! !

!ROElementTest methodsFor: 'event' stamp: 'TudorGirba 9/9/2012 21:42'!
testWithAllElementsDo

	| node1 node2 node21 edge root traversed |
	root := ROElement new.
	node1 := ROElement new.
	node2 := ROElement new.
	edge := ROEdge from: node1 to: node2.
	node21 := ROElement new.

	root add: node1.
	root add: node2.
	root add: edge.
	node2 add: node21.
	
	traversed := OrderedCollection new.
	root withAllElementsDo: [:each | traversed add: each].
	self assert: traversed size = 5.
	self assert: traversed first = root.
	self assert: (traversed at: 2) = node1.
	self assert: (traversed at: 3) = node2.
	self assert: (traversed at: 4) = node21.
	self assert: traversed last = edge! !

ROTest subclass: #ROEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEventTest methodsFor: 'layout' stamp: 'AlexandreBergel 11/16/2012 09:10'!
assertLayout: layout
	| element1 element2 view events |
	element1 := ROElement sprite.
	element2 := ROElement sprite.
	
	view := ROView new.
	view add: element1; add: element2.
	
	self assert: view elements size = 2.

	events := OrderedCollection new.
	layout on: ROLayoutBegin do: [ :event | events add: event ].
	layout on: ROLayoutEnd do: [ :event | events add: event ].
	
	self assert: events isEmpty.
	
	"------- We do the layout"
	layout on: view elements.
	
	self assert: events size = 2.
	self assert: events first class == ROLayoutBegin.
	self assert: events second class == ROLayoutEnd.! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 20:47'!
testEmitToParent
	| t spr sprInner |
	t := 0.
	spr := ROElement new.
	spr on: ROMouseEnter do: [ :evt | t := t + 10 ].
	
	sprInner := ROElement new.
	sprInner on: ROMouseEnter do: [ :evt | t := t + 1. evt emitToParent ].
	spr add: sprInner.
	
	sprInner announce: ROMouseEnter.
	self assert: t = 11.
	
	! !

!ROEventTest methodsFor: 'layout' stamp: 'AlexandreBergel 12/1/2012 17:35'!
testLayoutEvent
	| classesToExclude |
	classesToExclude := OrderedCollection new.
	classesToExclude add: ROTreeMapLayout.
	
	(ROLayout withAllSubclasses reject: [ :cls | classesToExclude includes: cls ] ) do: [ :cls | 
		cls isNotAbstract ifTrue: [ self assertLayout: cls new ] ]
! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 20:42'!
testNoSentToParent
	| t spr sprInner |
	t := 0.
	spr := ROElement new.
	spr on: ROMouseEnter do: [ :evt | t := t + 10 ].
	
	sprInner := ROElement new.
	sprInner on: ROMouseEnter do: [ :evt | t := t + 1.  ].
	spr add: sprInner.
	
	sprInner announce: ROMouseEnter.
	self assert: t = 1.
	
	! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/18/2013 10:46'!
testPositionNotNil

	| event |
	ROComponentEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self assert: event position = (0@0)
		 ]! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/30/2013 12:01'!
testProperlyInitialized 
	

	| event |
	ROEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self shouldnt: [ (event class selectors select: [ :k | (k includes: ':' first) not]) do: [ :k | event perform: k ] ] raise: Error.
		 ]! !

ROTest subclass: #ROExpandChildrenOnClickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 12:26'!
testChildrenForModel

	| expandChildren children elements |
	expandChildren := ROExpandChildrenOnClick childrenForModel: [ :v | Array with: v with: v + 1 with: v + 2 ].
	elements := expandChildren computeChildrenFor: (ROElement on: 10).
	
	self assert: elements size = 3.
	self assert: elements first numberOfShapes = 3.
	self assert: (elements first shapes collect: #class) asArray =  
					((Array with: ROBox with: ROLabel with: RONullShape))! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:35'!
testClickOnAddedNode

	| view el elements |
	view := ROView new.
	el := (ROElement on: 'hello') + ROLabel.
	el @ (ROExpandChildrenOnClick childrenBlock: [ :element | 
		Array with: ((ROElement on: (element model, ' world')) + ROBox) ]).
	view add: el. 
	
	el announce: ROMouseClick.
	elements := view elementsSuchThat: [ :e | e model = 'hello world' ].
	self assert: elements notEmpty.
	elements first announce: ROMouseClick.
	self assert: view numberOfElements = 3.! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:35'!
testClickOnRecursiveAddedNode

	| view el elements |
	view := ROView new.
	el := (ROElement on: 'hello') + ROLabel.
	el @ (RORecursiveExpandOnClick childrenBlock: [ :element | 
		Array with: ((ROElement on: (element model, ' world')) + ROBox) ]).
	view add: el. 
	
	el announce: ROMouseClick.
	elements := view elementsSuchThat: [ :e | e model = 'hello world' ].
	self assert: elements notEmpty.
	elements first announce: ROMouseClick.
	self assert: view numberOfElements = 5.! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:34'!
testClickOnRoot

	| view el |
	view := ROView new.
	el := (ROElement on: 'world') + ROLabel.
	el @ (ROExpandChildrenOnClick childrenBlock: [ :element | 
		Array with: (ROElement on: (element model, ' World')) ]).
	view add: el. 
	
	self assert: view numberOfElements = 1.
	el announce: ROMouseClick.
	self assert: view numberOfElements = 3.
	el announce: ROMouseClick.
	self assert: view numberOfElements = 5.! !

ROTest subclass: #ROFixedSizedParentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROFixedSizedParentTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/24/2013 09:24'!
testMoveInner
	| outter inner rawView |
	rawView := ROView new.
	outter := ROBox element extent: 100 @ 80.
	inner := (ROEllipse color: Color gray) element size: 20. 
	outter resizeStrategy: (ROFixedSizedParent new paddingGap: 0).
	outter add: inner.
	self assert: (inner position = (0 @ 0)).

	rawView add: outter.
	"rawView add: inner."
	
	outter translateTo: 80 @ 20.
	ROConstraint constraintInItsParent: inner.
	
	self assert: (inner position = (0 @ 0)).
	
	inner translateTo: (-20 @ -5).
	
	self assert: (outter extent = (100 @ 80)).
	self assert: (inner position = (0 @ 0)).! !

ROTest subclass: #ROFocusViewTest
	instanceVariableNames: 'view camera el1 el2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROFocusViewTest methodsFor: 'running' stamp: 'AlexandreBergel 11/19/2012 15:05'!
setUp

	view := ROView new.
	camera := view camera.

	view add: (el1 := ROElement sprite).
	view add: (el2 := ROElement sprite translateBy: 200 @ 20).
	
	view @ RODraggable 
! !

!ROFocusViewTest methodsFor: 'corner' stamp: 'AlexandreBergel 11/21/2012 14:15'!
testBottomLeft

	| focus |
	self assert: view camera position = (0 @ 0).
	view windowSize: 500 @ 500.
	ROFocusView bottomLeftOn: el2.
	self assert: view camera position =  (200@ -430)! !

!ROFocusViewTest methodsFor: 'corner' stamp: 'AlexandreBergel 11/21/2012 14:15'!
testBottomRight

	| focus |
	self assert: view camera position = (0 @ 0).
	view windowSize: 500 @ 500.
	ROFocusView bottomRightOn: el2.
	self assert: view camera position = (-250@ -430)! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 5/6/2012 10:13'!
testCamera
	self assert: camera position = (0 @ 0).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 11/21/2012 14:15'!
testOnView

	"
	self debug: #testOnView
	"
	| focus |
	view windowSize: 500 @ 500.
	ROFocusView on: el2.
	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 11/21/2012 14:14'!
testOnViewWithInitialTranslation

	"
	self debug: #testOnView
	"
	| focus |
	view windowSize: 500 @ 500.
	camera translateTo: 10@30.
	
	focus := ROFocusView new.
	focus on: el2.

	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 11/21/2012 14:14'!
testOnViewWithoutProcess

	"
	self debug: #testOnView
	"
	| focus |
	view windowSize: 500 @ 500.
	focus := ROFocusView new.
	focus on: el2.
	
	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 11/21/2012 14:14'!
testPosition
	view windowSize: 500 @ 500.

	el1 translateTo:  (1650.5@134.0).
	
	camera translateTo:  (-14656.5@ -72.0).
	self assert: (camera position = (-14656.5@ -72.0)).
	
	self assert: camera == el1 view camera.
	
	ROFocusView new on: el1.
	
	self assert: (camera centerPosition - (1651@134)) abs <= (2 @ 2)! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 11/21/2012 14:17'!
testToPositionView

	"
	self debug: #testToPositionView
	"
	| focus |
	view windowSize: 500 @ 500.
	self assert: camera position =  (0@ 0).
	ROFocusView new view: view toPosition: 500@20.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ -230).
	
	ROFocusView new view: view toPosition: 500@250.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ 0).! !

!ROFocusViewTest methodsFor: 'corner' stamp: 'AlexandreBergel 11/21/2012 14:19'!
testTwice

	| focus |
	view windowSize: 500 @ 500.
	ROFocusView bottomLeftOn: el2.

	self assert: view camera position =  (200@ -430).

	ROFocusView bottomLeftOn: el2.
	self assert: view camera position =  (200@ -430)
	! !

ROTest subclass: #ROGraphTransformationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 11:11'!
OLDtestCheckCycleNoCycle

	| view nodes edges newNode transformation node1 node2 node3 |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).
		
	transformation := ROGraphTransformation new.

	"self assert: (transformation containsCycleIn: nodes with: edges)"
	"self deny: (transformation containsCycleIn: nodes first with: edges passedNodes: OrderedCollection new)"
	self deny: (transformation hasCycleIn: nodes with: edges)! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 10:10'!
testFromEdgesToNesting

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2).
	edges := view edgesFromAssociations: (Array with: 1 -> 2).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) = (Array with: nodes second).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode == nodes first! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/9/2012 15:20'!
testFromEdgesToNesting2

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second with: nodes third).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 2.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	self assert: newNode elements second model = 3.	
	
	"We make sure that the nodes that have been moved are removed from the view"
	self assert: (view raw elements includes: newNode).
	self deny: (view raw elements includes: nodes second).
	self deny: (view raw elements includes: nodes third).! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 15:05'!
testFromEdgesToNesting3

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second).

	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode elements first numberOfElements = 1.
	self assert: newNode elements first elements first model = 3.	! !

ROTest subclass: #ROHighlightElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROHighlightElementTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
testColor

	"el1 and el2 are the same, except el2 is lightly highlightable"
	| el1 el2 view |
	el1 := (ROElement on: 1) height: 50; width: 50.
	el1 + (ROEllipse color: Color green).

	el2 := (ROElement on: 1) height: 50; width: 50.
	el2 + (ROEllipse color: Color green) @ ROLightlyHighlightable.

	view := ROView new @ RODraggable.
	view add: el1.
	view add: el2.
	ROHorizontalLineLayout on: view elements.
	"view open."
	
	self assert: (el1 getShape: ROShape) color = Color green.
	self assert: (el2 getShape: ROShape) color = Color green.
	
	el2 announce: ROMouseEnter.
	self assert: (el2 getShape: ROShape) color = ROLightlyHighlightable new defaultHighlightColor.
	self assert: el2 hasAttributes.
	self assert: (el2 attributes at: #oldColor) = Color green.

	el2 announce: ROMouseLeave.
	self assert: (el2 getShape: ROShape) color = Color green.
	self deny: el2 hasAttributes.
! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/29/2012 15:20'!
testHighlightAndUnlight

	| element shape |
	element := ROElement new + ROBorder yellow.
	shape := (element getShape: ROShape).
	self assert: shape color = Color yellow.
	self deny: (ROHighlightElement isHighlighted: element).
	
	ROHighlightElement on: element.
	self assert: shape color = Color red.
	self assert: (ROHighlightElement isHighlighted: element).
	
	ROUnhighlightElement on: element.
	self assert: shape color = Color yellow.
	self deny: (ROHighlightElement isHighlighted: element).
! !

!ROHighlightElementTest methodsFor: 'highlight edges' stamp: 'AlexandreBergel 10/2/2012 19:53'!
testHighlightEdge

	| rawView node1 node2 edge lineShape |
	rawView := ROView new.
	node1 := ROBox elementOn: 'node1'. 
	node2 := ROBox elementOn: 'node2'.

	edge := ROEdge from: node1 to: node2.
	edge + (ROLine red).
	
	edge @ ROLightlyHighlightable.

	rawView add: edge; add: node1; add: node2.
	node2 translateBy: 100 @ 0.

	lineShape := edge getShape: ROLine.
	self assert: (lineShape colorFor: edge) = Color red.

	self shouldnt: [ edge announce: ROMouseEnter ] raise: Error.
	self assert: (lineShape colorFor: edge) = ROLightlyHighlightable highlightedColor.
	
	self shouldnt: [ edge announce: ROMouseLeave ] raise: Error.
	self assert: (lineShape colorFor: edge) = Color red.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 12:49'!
testHighlightingShape

	| shape1 shape2 el |
	shape1 := ROBox white.
	shape2 := ROBorder new.
	el := ROElement new.
	el + shape1 + shape2.
		
	el @ ROLightlyHighlightable.
	
	el announce: ROMouseEnter.
	
	self assert: el shapes asArray = (Array with: shape2 with: shape1 with: (el getShape: RONullShape)).
	self assert: (shape1 colorFor: el) = Color white.
	self assert: (shape2 colorFor: el) = ROLightlyHighlightable highlightedColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/6/2012 12:59'!
testLeavingWithoutEntering

	| el shape |
	el := ROElement new + (shape := ROBox new).
	self assert: (shape colorFor: el) = ROBox defaultColor.
	
	self deny: (ROHighlightElement isHighlighted: el).
		
	ROUnhighlightElement on: el.
	self assert: (shape colorFor: el) = ROBox defaultColor.
	self deny: (ROHighlightElement isHighlighted: el).! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/4/2012 16:15'!
testMultipleHighlight

	| el shape |
	el := ROElement new + (shape := ROBox new).
	self assert: (shape colorFor: el) = ROBox defaultColor.
	
	self deny: (ROHighlightElement isHighlighted: el).
	
	ROHighlightElement on: el.
	self assert: (shape colorFor: el) = Color red.
	self assert: (ROHighlightElement isHighlighted: el).
	
	ROHighlightElement on: el.
	self assert: (shape colorFor: el) = Color red.
	self assert: (ROHighlightElement isHighlighted: el).
	
	ROUnhighlightElement on: el.
	self assert: (shape colorFor: el) = ROBox defaultColor.
	self deny: (ROHighlightElement isHighlighted: el).! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
testOnBox

	| el |
	el := ROElement on: 'hello'.
	el + ROBox.
	
	self assert: (el getShape: ROBox) color =  ROBox defaultColor.
	ROHighlightElement on: el.
	self assert: (el getShape: ROBox) color =  Color red.
	
	ROUnhighlightElement on: el.
	self assert: (el getShape: ROBox) color = ROEllipse defaultColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
testOnCircle

	| el |
	el := ROElement on: 'hello'.
	el + ROEllipse.
	
	self assert: (el getShape: ROEllipse) color = ROEllipse defaultColor.
	ROHighlightElement on: el.
	self assert: (el getShape: ROEllipse) color = Color red.

	ROUnhighlightElement on: el.
	self assert: (el getShape: ROEllipse) color = ROEllipse defaultColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/24/2012 12:08'!
testUnhighlightingShape

	| shape el |
	shape := ROBox white.
	el := ROElement new.
	el + shape.
		
	el @ ROLightlyHighlightable.
	
	el announce: ROMouseLeave.
	self assert: (shape colorFor: el) = Color white.
	! !

ROTest subclass: #ROImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROImageTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/23/2013 19:39'!
testBasic

	| view el elInner canvas |
	view := ROView new.
	el := ROElement new.
	elInner := ROElement new + (ROImage new form: ((4 @ 6) extent: (10 @ 30))).
	el add: elInner.
	view add: el.
	el translateTo: 50 @ 40.
	elInner translateBy: 5 @ 4.
	
	canvas := ROTracingCanvas new.
	view drawOn: canvas.
	
	self assert: canvas trace =  #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') #(#paintImage '(60@49)'))! !

ROTest subclass: #ROLayoutSteppingTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROLayoutSteppingTest methodsFor: 'converting' stamp: 'AlexandreBergel 11/15/2012 17:30'!
assertLayout: layout

	| events |
	events := OrderedCollection new.
	layout on: ROLayoutStep do: [ :evt | events add: evt ].
	self assert: events size = 0.
	layout on: elements.
	self assert: events size = (elements size // layout iterationsToSendEvent).
	self assert: events size > 0.
	self assert: (events allSatisfy: [ :evt | evt maxInterations = elements size ]).
	self assert: (events collect: #currentIteration) asArray = #(100 200 300)! !

!ROLayoutSteppingTest methodsFor: 'running' stamp: 'AlexandreBergel 11/15/2012 17:10'!
setUp

	elements := ROElement forCollection: (1 to: ROLayout new iterationsToSendEvent * 3).
	view := ROView new.
	view addAll: elements.
	! !

!ROLayoutSteppingTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2013 09:09'!
testLayout

	| classesToExclude |
	classesToExclude := OrderedCollection new.
	classesToExclude 
		add: ROTreeMapLayout;
		add: RONullLayout;
		add: RONarrowRadialTreeLayout;
		add: ROForceBasedLayout;
		add: ROHorizontalCompactTree;
		add: ROVerticalCompactTree;
		add: ROSugiyamaLayout.
	
	(ROLayout withAllSubclasses copyWithoutAll: classesToExclude) do: [ :cls | 
		cls isNotAbstract ifTrue: [ self assertLayout: cls new ] ]
! !

ROTest subclass: #ROLayoutTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTest subclass: #ROAbstractLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROAbstractLayout methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/15/2012 13:29'!
testAbstract
	ROLayout withAllSubclasses do: [ :cls | 
		cls subclasses notEmpty ifTrue: [ 
			self assert: cls isAbstract ] ]! !

!ROAbstractLayout methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/15/2012 13:28'!
testNotAbstract
	ROLayout withAllSubclasses do: [ :cls | 
		cls subclasses isNil ifTrue: [ 
			self deny: cls isAbstract ] ]! !

ROLayoutTest subclass: #ROCircleLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 1/23/2013 15:44'!
assertArrayOfPoint: computedArray isCloseTo: result
	"utility method useful to compare two set of points that are close to each other."
	
	self assert: computedArray size = result size.
	self assert: (computedArray allSatisfy: [ :p | p class = Point ]).
	computedArray with: result do: [ :e1 :e2 | 
		self assert: ((e1 x - e2 x) abs <= 1 and: [ (e1 y - e2 y) abs <= 1 ]) ]
	
! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 16:26'!
testAssertArrayOfPoint

	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 2@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@2).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 3@2).! !

!ROCircleLayoutTest methodsFor: 'test radius' stamp: 'AlexandreBergel 1/23/2013 15:56'!
testComputeRadius
	self assert: (ROCircleLayout new computeRadiusFor: (Array new: 10)) = (10 * ROCircleLayout new scaleFactor).! !

!ROCircleLayoutTest methodsFor: 'test radius' stamp: 'AlexandreBergel 1/23/2013 15:56'!
testComputeRadius2
	self assert: (ROCircleLayout new initialRadius: 45; computeRadiusFor: (Array new: 10)) = 45! !

!ROCircleLayoutTest methodsFor: 'test initial angle' stamp: 'AlexandreBergel 1/23/2013 15:04'!
testInitialAngleInitialization

	self assert: ROCircleLayout new initialAngle = 0.
	self assert: ROCircleLayout new initialAngleInDegree = 0.! !

!ROCircleLayoutTest methodsFor: 'test initial angle' stamp: 'AlexandreBergel 1/23/2013 15:07'!
testInitialAngleInitialization2

	| layout |
	layout := ROCircleLayout new.
	layout initialAngle: (Float pi / 2).
	self assert:  (layout initialAngleInDegree - 90) abs <= 0.1! !

!ROCircleLayoutTest methodsFor: 'test initial angle' stamp: 'AlexandreBergel 1/23/2013 15:08'!
testInitialAngleInitialization3

	| layout |
	layout := ROCircleLayout new.
	layout initialAngleInDegree: 90.
	self assert:  (layout initialAngleInDegree - 90) abs <= 0.1.
	self assert:  (layout initialAngle - (Float pi / 2)) abs <= 0.1. ! !

!ROCircleLayoutTest methodsFor: 'test incremental angle' stamp: 'AlexandreBergel 1/23/2013 15:59'!
testInitialIncrementalAngle

	self assert: ((ROCircleLayout new computeIncrementalAngleFor: elements) - (2 * Float pi / elements size)) abs <= 0.2! !

!ROCircleLayoutTest methodsFor: 'test radius' stamp: 'AlexandreBergel 1/23/2013 15:54'!
testInitialRadius
	self assert: (ROCircleLayout new initialRadius = 0)! !

!ROCircleLayoutTest methodsFor: 'test radius' stamp: 'AlexandreBergel 1/23/2013 15:55'!
testInitialRadiusSet
	self assert: (ROCircleLayout new computeRadiusFor: (Array new: 10)) = (10 * ROCircleLayout new scaleFactor).! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 14:29'!
testLayout
	| result computedArray |
	ROCircleLayout on: elements.
	
	computedArray := elements collect: #positionAsInteger.
	result := ((Array new: 20) at: 1 put: ((440@220)); at: 2 put: ((429@287)); at: 3 put: ((397@349)); at: 4 put: ((349@397)); at: 5 put: ((287@429)); at: 6 put: ((220@440)); at: 7 put: ((152@429)); at: 8 put: ((90@397)); at: 9 put: ((42@349)); at: 10 put: ((10@287)); at: 11 put: ((0@220)); at: 12 put: ((10@152)); at: 13 put: ((42@90)); at: 14 put: ((90@42)); at: 15 put: ((152@10)); at: 16 put: ((219@0)); at: 17 put: ((287@10)); at: 18 put: ((349@42)); at: 19 put: ((397@90)); at: 20 put: ((429@152)); yourself).
	
	self assertArrayOfPoint: computedArray isCloseTo: result.
"
view openInWindow
" ! !

!ROCircleLayoutTest methodsFor: 'test initial angle' stamp: 'AlexandreBergel 1/23/2013 15:46'!
testLayoutWithInitialAngle
	| result computedArray |
	ROCircleLayout new
		initialAngle: Float pi;
		on: elements.
	
	computedArray := elements collect: #positionAsInteger.
	result := ((Array new: 20) at: 1 put: ((0@220)); at: 2 put: ((10@152)); at: 3 put: ((42@90)); at: 4 put: ((90@42)); at: 5 put: ((152@10)); at: 6 put: ((219@0)); at: 7 put: ((287@10)); at: 8 put: ((349@42)); at: 9 put: ((397@90)); at: 10 put: ((429@152)); at: 11 put: ((440@219)); at: 12 put: ((429@287)); at: 13 put: ((397@349)); at: 14 put: ((349@397)); at: 15 put: ((287@429)); at: 16 put: ((220@440)); at: 17 put: ((152@429)); at: 18 put: ((90@397)); at: 19 put: ((42@349)); at: 20 put: ((10@287)); yourself).
	
	self assertArrayOfPoint: computedArray isCloseTo: result.
! !

!ROCircleLayoutTest methodsFor: 'test initial angle' stamp: 'AlexandreBergel 1/23/2013 15:47'!
testLayoutWithInitialAngleInDegree
	| result computedArray |
	ROCircleLayout new
		initialAngleInDegree: 90;
		on: elements.
	
	computedArray := elements collect: #positionAsInteger.
	result :=  ((Array new: 20) at: 1 put: ((220@440)); at: 2 put: ((152@429)); at: 3 put: ((90@397)); at: 4 put: ((42@349)); at: 5 put: ((10@287)); at: 6 put: ((0@220)); at: 7 put: ((10@152)); at: 8 put: ((42@90)); at: 9 put: ((90@42)); at: 10 put: ((152@10)); at: 11 put: ((219@0)); at: 12 put: ((287@10)); at: 13 put: ((349@42)); at: 14 put: ((397@90)); at: 15 put: ((429@152)); at: 16 put: ((440@219)); at: 17 put: ((429@287)); at: 18 put: ((397@349)); at: 19 put: ((349@397)); at: 20 put: ((287@429)); yourself).
	
	self assertArrayOfPoint: computedArray isCloseTo: result.
"
view openInWindow
" ! !

ROLayoutTest subclass: #ROFlowLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROFlowLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/20/2012 18:08'!
testLayout
	| result resultVW computed |
	ROFlowLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((5@65)); at: 4 put: ((65@65)); at: 5 put: ((5@125)); at: 6 put: ((65@125)); at: 7 put: ((5@185)); at: 8 put: ((65@185)); at: 9 put: ((5@245)); at: 10 put: ((65@245)); at: 11 put: ((5@305)); at: 12 put: ((65@305)); at: 13 put: ((5@365)); at: 14 put: ((65@365)); at: 15 put: ((5@425)); at: 16 put: ((65@425)); at: 17 put: ((5@485)); at: 18 put: ((65@485)); at: 19 put: ((5@545)); at: 20 put: ((65@545)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROFlowLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/20/2012 18:16'!
testLayoutASet
	| set |
	set := Set new. 
	set addAll: elements.
	ROFlowLayout on: set! !

ROLayoutTest subclass: #ROForceBasedLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROForceBasedLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 3/31/2013 21:55'!
testLayout
	| result |
	ROForceBasedLayout new 
		layoutInitial: ROGridLayout;
		on: elements.
	
	result := (elements collect: #position) collect: #asIntegerPoint.

	ROForceBasedLayout new 
		on: elements.

	self assert: (result ~= ((elements collect: #position) collect: #asIntegerPoint))! !

ROLayoutTest subclass: #ROGridLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:06'!
testLayout
	| result |
	ROGridLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((185@5)); at: 5 put: ((245@5)); at: 6 put: ((5@65)); at: 7 put: ((65@65)); at: 8 put: ((125@65)); at: 9 put: ((185@65)); at: 10 put: ((245@65)); at: 11 put: ((5@125)); at: 12 put: ((65@125)); at: 13 put: ((125@125)); at: 14 put: ((185@125)); at: 15 put: ((245@125)); at: 16 put: ((5@185)); at: 17 put: ((65@185)); at: 18 put: ((125@185)); at: 19 put: ((185@185)); at: 20 put: ((245@185)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 6/30/2012 01:23'!
testLayoutLineItemCount
	| result |
	ROGridLayout on: elements withLineItemsCount: 5.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((185@5)); at: 5 put: ((245@5)); at: 6 put: ((5@65)); at: 7 put: ((65@65)); at: 8 put: ((125@65)); at: 9 put: ((185@65)); at: 10 put: ((245@65)); at: 11 put: ((5@125)); at: 12 put: ((65@125)); at: 13 put: ((125@125)); at: 14 put: ((185@125)); at: 15 put: ((245@125)); at: 16 put: ((5@185)); at: 17 put: ((65@185)); at: 18 put: ((125@185)); at: 19 put: ((185@185)); at: 20 put: ((245@185)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 6/30/2012 01:23'!
testLayoutLineItemCount2
	| result |
	ROGridLayout on: elements withLineItemsCount: 3.
	
	result := (((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((5@65)); at: 5 put: ((65@65)); at: 6 put: ((125@65)); at: 7 put: ((5@125)); at: 8 put: ((65@125)); at: 9 put: ((125@125)); at: 10 put: ((5@185)); at: 11 put: ((65@185)); at: 12 put: ((125@185)); at: 13 put: ((5@245)); at: 14 put: ((65@245)); at: 15 put: ((125@245)); at: 16 put: ((5@305)); at: 17 put: ((65@305)); at: 18 put: ((125@305)); at: 19 put: ((5@365)); at: 20 put: ((65@365)); yourself)).
	
	self assert: (elements collect: #position) = result! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/23/2013 14:56'!
testLayoutOnEmptyList

	self shouldnt: [ ROGridLayout on: #() ] raise: Error! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/24/2013 09:24'!
testLayoutWithMargin

	| element result |
	element := ROBox blue element.
	element resizeStrategy: (ROExtensibleParent new paddingGap: 25).
	element addAll: elements.
	ROGridLayout on: elements.
	
	view := ROView new.
	view add: element.
	
	result := ((Array new: 20) at: 1 put: ((25@25)); at: 2 put: ((85@25)); at: 3 put: ((145@25)); at: 4 put: ((205@25)); at: 5 put: ((265@25)); at: 6 put: ((25@85)); at: 7 put: ((85@85)); at: 8 put: ((145@85)); at: 9 put: ((205@85)); at: 10 put: ((265@85)); at: 11 put: ((25@145)); at: 12 put: ((85@145)); at: 13 put: ((145@145)); at: 14 put: ((205@145)); at: 15 put: ((265@145)); at: 16 put: ((25@205)); at: 17 put: ((85@205)); at: 18 put: ((145@205)); at: 19 put: ((205@205)); at: 20 put: ((265@205)); yourself).
	
	self assert: (elements collect: #position) = result! !

ROLayoutTest subclass: #ROHorizontalLineLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/22/2013 11:36'!
testLayout

	| previous |
	ROHorizontalLineLayout on: elements.
	previous := nil.
	elements do: [ :el |
		previous notNil ifTrue: [ self assert: el position x > previous position x ].
		previous := el ]! !

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/23/2013 15:41'!
testLayoutOnEmptyCollection

	self shouldnt: [ ROHorizontalLineLayout on: #() ] raise: Error.
	self shouldnt: [ ROHorizontalLineLayout on: #() edges: #() ] raise: Error.
	self shouldnt: [ ROHorizontalLineLayout new on: #() edges: #() ] raise: Error! !

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/8/2013 12:20'!
testLayoutWithAlignment

	| previous |
	ROHorizontalLineLayout new alignment: #bottom; on: elements.
	previous := nil.
	elements do: [ :el |
		previous notNil ifTrue: [ self assert: el position x > previous position x ].
		previous := el ].
	
! !

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/24/2013 09:24'!
testLayoutWithMargin
	| element result |
	element := ROBox blue element.
	element resizeStrategy: (ROExtensibleParent new paddingGap: 25).
	element addAll: elements.
	ROHorizontalLineLayout on: elements.
	
	view := ROView new.
	view add: element.
	
	result := (((Array new: 20) at: 1 put: ((25@25)); at: 2 put: ((85@25)); at: 3 put: ((145@25)); at: 4 put: ((205@25)); at: 5 put: ((265@25)); at: 6 put: ((325@25)); at: 7 put: ((385@25)); at: 8 put: ((445@25)); at: 9 put: ((505@25)); at: 10 put: ((565@25)); at: 11 put: ((625@25)); at: 12 put: ((685@25)); at: 13 put: ((745@25)); at: 14 put: ((805@25)); at: 15 put: ((865@25)); at: 16 put: ((925@25)); at: 17 put: ((985@25)); at: 18 put: ((1045@25)); at: 19 put: ((1105@25)); at: 20 put: ((1165@25)); yourself)).
	
	self assert: (elements collect: #position) = result! !

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/22/2013 13:57'!
testStretch

	 | previous |
	 ROHorizontalLineLayout new stretch; on: elements.
	 previous := nil.
	 elements do: [ :el |
		 previous notNil ifTrue: [ self assert: el position x > previous position x ].
		 previous := el ].! !

!ROHorizontalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/6/2013 18:04'!
testStretchInsideElement

	 | previous random rootElement |
	
	elements := ROElement forCollection: (1 to: 10).
	random := #(23 53 60 50).
	elements do: [ :n | n 
						extent: (random anyOne) @ (random anyOne); 
						addShape: (ROBox new); addShape: (ROBorder new) ].
	rootElement := ROElement on: 11.
	rootElement size: (11 * 55).
	rootElement addShape: ROBorder black.
	rootElement addAll: elements.
	view := ROView new.
	view add: rootElement.
	
	 ROHorizontalLineLayout new stretch; on: elements.
	 previous := nil.
	 elements do: [ :el |
		 previous notNil ifTrue: [ 
			self assert: el position x > previous position x.
			self assert: el height = previous height.
			 ].
		 previous := el ].! !

ROLayoutTest subclass: #ROHorizontalNarrowTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROHorizontalNarrowTreeLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/2/2013 11:27'!
testLayout
	| result |
	ROHorizontalNarrowTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((3.0@480.0)); at: 2 put: ((73.0@3.0)); at: 3 put: ((73.0@56.0)); at: 4 put: ((73.0@109.0)); at: 5 put: ((73.0@162.0)); at: 6 put: ((73.0@215.0)); at: 7 put: ((73.0@268.0)); at: 8 put: ((73.0@321.0)); at: 9 put: ((73.0@374.0)); at: 10 put: ((73.0@427.0)); at: 11 put: ((73.0@480.0)); at: 12 put: ((73.0@533.0)); at: 13 put: ((73.0@586.0)); at: 14 put: ((73.0@639.0)); at: 15 put: ((73.0@692.0)); at: 16 put: ((73.0@745.0)); at: 17 put: ((73.0@798.0)); at: 18 put: ((73.0@851.0)); at: 19 put: ((73.0@904.0)); at: 20 put: ((73.0@957.0)); yourself).
	self assert: (elements collect: #position) = result.! !

ROLayoutTest subclass: #ROHorizontalTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROHorizontalTreeLayoutTest methodsFor: 'test layout' stamp: 'DR 1/15/2013 21:20'!
testLayout
	| result edges firstEdge shape |
	ROHorizontalTreeLayout on: elements.
	
	result := (((Array new: 20) at: 1 put: ((5@482.0)); at: 2 put: ((75@747.0)); at: 3 put: ((75@800.0)); at: 4 put: ((75@429.0)); at: 5 put: ((75@482.0)); at: 6 put: ((75@111.0)); at: 7 put: ((75@164.0)); at: 8 put: ((75@853.0)); at: 9 put: ((75@906.0)); at: 10 put: ((75@535.0)); at: 11 put: ((75@588.0)); at: 12 put: ((75@217.0)); at: 13 put: ((75@270.0)); at: 14 put: ((75@959.0)); at: 15 put: ((75@5.0)); at: 16 put: ((75@641.0)); at: 17 put: ((75@694.0)); at: 18 put: ((75@323.0)); at: 19 put: ((75@376.0)); at: 20 put: ((75@58.0)); yourself)).
	self assert: ((elements collect: #position) includesAll: result).
	
	edges := view elements select: #isEdge.
	edges do: [ :e | (e getShape: ROLine) attachPoint: ROHorizontalAttachPoint new ].
	
	firstEdge := edges first.
	shape := firstEdge getShape: ROLine.
	self assert: (shape startingPointOf: firstEdge) = (firstEdge from bounds topRight + (0 @ (firstEdge from bounds height / 2))).
	self assert: (shape endingPointOf: firstEdge) = (firstEdge to bounds topLeft + (0 @ (firstEdge to bounds height / 2))).! !

!ROLayoutTest class methodsFor: 'testing' stamp: ''!
isAbstract 
	^ self name == #ROLayoutTest  ! !

!ROLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/22/2012 21:01'!
setUp

	elements := ROElement forCollection: (1 to: 20).
	elements do: [ :n | n extent: 50@50; addShape: (ROBox new) ].
	view := ROView new.
	view addAll: elements.
	elements allButFirst do: [:e | 
	 	view add: (ROEdge lineFrom: elements first to: e) ]! !

!ROLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 11/19/2012 15:15'!
testLayout
! !

ROLayoutTest subclass: #RORadialTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!RORadialTreeLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/18/2013 09:39'!
testLayout
	| result |
	RORadialTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((0@0)); at: 2 put: ((46.0@0.0)); at: 3 put: ((43.57594222755657@14.73557799954425)); at: 4 put: ((36.55924960953685@27.918117199904074)); at: 5 put: ((25.689438158008553@38.1582594876372)); at: 6 put: ((12.112118783148706@44.376757188678134)); at: 7 put: ((-2.741743012452414@45.918219099325576)); at: 8 put: ((-17.306642048950174@42.62018466629995)); at: 9 put: ((-30.0475280344195@34.83024632443438)); at: 10 put: ((-39.621590373169404@23.36941540348773)); at: 11 put: ((-45.019782098847514@9.445592610963525)); at: 12 put: ((-45.6731671849421@ -5.473737233036325)); at: 13 put: ((-41.51288288378593@ -19.81616902120773)); at: 14 put: ((-32.977397434326505@ -32.070099133904726)); at: 15 put: ((-20.96629822114379@ -40.94403911318548)); at: 16 put: ((-6.7454808269901845@ -45.502730559964284)); at: 17 put: ((8.186268533577934@ -45.26571558581784)); at: 18 put: ((22.255235813010025@ -40.25797410336636)); at: 19 put: ((33.978638859829566@ -31.007291097954365)); at: 20 put: ((42.12090348816135@ -18.488631353915743)); yourself).
	
	(elements collect: #position) with: result do: [ :e1 :e2 | 
		self assert: (e1 closeTo: e2) ]! !

ROLayoutTest subclass: #ROSugiyamaLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSugiyamaLayoutTest methodsFor: 'test layout' stamp: 'DR 3/25/2013 21:52'!
testLayout
	| result |
	ROSugiyamaLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((497.0@3.0)); at: 2 put: ((974.0@73.0)); at: 3 put: ((921.0@73.0)); at: 4 put: ((868.0@73.0)); at: 5 put: ((815.0@73.0)); at: 6 put: ((762.0@73.0)); at: 7 put: ((709.0@73.0)); at: 8 put: ((656.0@73.0)); at: 9 put: ((603.0@73.0)); at: 10 put: ((550.0@73.0)); at: 11 put: ((497.0@73.0)); at: 12 put: ((444.0@73.0)); at: 13 put: ((391.0@73.0)); at: 14 put: ((338.0@73.0)); at: 15 put: ((285.0@73.0)); at: 16 put: ((232.0@73.0)); at: 17 put: ((179.0@73.0)); at: 18 put: ((126.0@73.0)); at: 19 put: ((73.0@73.0)); at: 20 put: ((20.0@73.0)); yourself).
	self assert: (result includesAll: (elements collect: #position))! !

ROLayoutTest subclass: #ROTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROTreeLayoutTest methodsFor: 'test layout' stamp: 'DR 1/15/2013 21:20'!
testLayout
	| result |
	ROTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((482@5)); at: 2 put: ((5@75)); at: 3 put: ((58@75)); at: 4 put: ((111@75)); at: 5 put: ((164@75)); at: 6 put: ((217@75)); at: 7 put: ((270@75)); at: 8 put: ((323@75)); at: 9 put: ((376@75)); at: 10 put: ((429@75)); at: 11 put: ((482@75)); at: 12 put: ((535@75)); at: 13 put: ((588@75)); at: 14 put: ((641@75)); at: 15 put: ((694@75)); at: 16 put: ((747@75)); at: 17 put: ((800@75)); at: 18 put: ((853@75)); at: 19 put: ((906@75)); at: 20 put: ((959@75)); yourself).
	self assert:  (result includesAll: (elements collect: #positionAsInteger))! !

ROLayoutTest subclass: #ROVerticalLineLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/22/2013 17:50'!
testLayout

	| previous |
	ROVerticalLineLayout on: elements.
	previous := nil.
	elements do: [ :el |
		previous notNil ifTrue: [ self assert: el position y > previous position y ].
		previous := el ]! !

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/23/2013 15:43'!
testLayoutOnEmptyCollection

	self shouldnt: [ ROVerticalLineLayout on: #() ] raise: Error.
	self shouldnt: [ ROVerticalLineLayout on: #() edges: #() ] raise: Error.
	self shouldnt: [ ROVerticalLineLayout new on: #() edges: #() ] raise: Error! !

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/22/2013 17:50'!
testLayoutWithAlignment

	| previous |
	ROVerticalLineLayout new alignment: #bottom; on: elements.
	previous := nil.
	elements do: [ :el |
		previous notNil ifTrue: [ self assert: el position y > previous position y ].
		previous := el ].
	
! !

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/24/2013 09:24'!
testLayoutWithMargin
	| element result |
	element := ROBox blue element.
	element resizeStrategy: (ROExtensibleParent new paddingGap: 25).
	element addAll: elements.
	ROVerticalLineLayout on: elements.
	
	view := ROView new.
	view add: element.
	
	result := (((Array new: 20) at: 1 put: ((25@25)); at: 2 put: ((25@85)); at: 3 put: ((25@145)); at: 4 put: ((25@205)); at: 5 put: ((25@265)); at: 6 put: ((25@325)); at: 7 put: ((25@385)); at: 8 put: ((25@445)); at: 9 put: ((25@505)); at: 10 put: ((25@565)); at: 11 put: ((25@625)); at: 12 put: ((25@685)); at: 13 put: ((25@745)); at: 14 put: ((25@805)); at: 15 put: ((25@865)); at: 16 put: ((25@925)); at: 17 put: ((25@985)); at: 18 put: ((25@1045)); at: 19 put: ((25@1105)); at: 20 put: ((25@1165)); yourself)).
	
	self assert: (elements collect: #position) = result! !

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/22/2013 17:50'!
testStretch

	 | previous |
	 ROVerticalLineLayout new stretch; on: elements.
	 previous := nil.
	 elements do: [ :el |
		 previous notNil ifTrue: [ self assert: el position y > previous position y ].
		 previous := el ].! !

!ROVerticalLineLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/6/2013 18:03'!
testStretchInsideElement

	 | previous random rootElement |
	
	elements := ROElement forCollection: (1 to: 10).
	random := #(23 53 60 50).
	elements do: [ :n | n 
						extent: (random anyOne) @ (random anyOne); 
						addShape: (ROBox new); addShape: (ROBorder new) ].
	rootElement := ROElement on: 11.
	rootElement size: (11 * 55).
	rootElement addShape: ROBorder black.
	rootElement addAll: elements.
	view := ROView new.
	view add: rootElement.
	
	 ROVerticalLineLayout new stretch; on: elements.
	 previous := nil.
	 elements do: [ :el |
		 previous notNil ifTrue: [ 
			self assert: el position y > previous position y.
			self assert: el width = previous width.
			 ].
		 previous := el ].! !

ROLayoutTest subclass: #ROVerticalNarrowTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROVerticalNarrowTreeLayoutTest methodsFor: 'test layout' stamp: 'JurajKubelka 4/2/2013 12:02'!
testLayout
	| result |
	ROVerticalNarrowTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((480.0@3.0)); at: 2 put: ((3.0@73.0)); at: 3 put: ((56.0@73.0)); at: 4 put: ((109.0@73.0)); at: 5 put: ((162.0@73.0)); at: 6 put: ((215.0@73.0)); at: 7 put: ((268.0@73.0)); at: 8 put: ((321.0@73.0)); at: 9 put: ((374.0@73.0)); at: 10 put: ((427.0@73.0)); at: 11 put: ((480.0@73.0)); at: 12 put: ((533.0@73.0)); at: 13 put: ((586.0@73.0)); at: 14 put: ((639.0@73.0)); at: 15 put: ((692.0@73.0)); at: 16 put: ((745.0@73.0)); at: 17 put: ((798.0@73.0)); at: 18 put: ((851.0@73.0)); at: 19 put: ((904.0@73.0)); at: 20 put: ((957.0@73.0)); yourself).
	self assert: (elements collect: #position) = result.! !

ROTest subclass: #ROLayoutTranslatorTest
	instanceVariableNames: 'elements layout view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTranslatorTest subclass: #ROAbsorbLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROAbsorbLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/17/2012 17:28'!
testLayout
	layout translator: ROAbsorbLayoutTranslator new.
	layout applyOn: elements.
	self assert: ((elements collect: #position) asSet asArray first = (0@0))! !

ROLayoutTranslatorTest subclass: #RODirectLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!RODirectLayoutTranslatorTest methodsFor: 'tests' stamp: 'DR 3/25/2013 22:03'!
testLayout
	| result |
	layout translator: RODirectLayoutTranslator new.
	layout applyOn: elements.
	result := ((Array new: 7) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (111@5); at: 5 put: (5@145); at: 6 put: (32@5); at: 7 put: (32@75); yourself).
	self assert: (result includesAll: (elements collect: #positionAsInteger))! !

!ROLayoutTranslatorTest methodsFor: 'running' stamp: 'AlexandreBergel 12/1/2012 10:14'!
setUp

	| edges |
	view := ROView new.
	elements := ROElement spritesOn: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	layout := ROTreeLayout new! !

!ROLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:33'!
testDefault
	"
	Commented out because isAbstractClass is not in VW
	self assert: ROLayoutTranslator isAbstractClass.
	self assert: ROLayoutTranslator defaultClass isAbstractClass not.
	"
	
	self assert: (ROLayoutTranslator withAllSubclasses select: #isDefault) size = 1.
	
	self assert: ROLayoutTranslator default class ==  ROLayoutTranslator defaultClass! !

ROLayoutTranslatorTest subclass: #ROSmoothLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSmoothLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 17:42'!
testLayout
	| result |
	layout translator: ROSmoothLayoutTranslator new.

	self deny: view hasAnimation.
	layout applyOn: elements.
	self assert: view hasAnimation.

	self assert: ((elements collect: #positionAsInteger) asSet asArray first = (0@0)).
	self assert: layout translator hasCompleted not.
	
	view doAllAnimationCycles.
	self assert: layout translator hasCompleted.

	result := ((Array new: 5) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (110@5); at: 5 put: (4@145); yourself).
	self assert: ((result with: (elements collect: #positionAsInteger) collect: [ :v1 :v2 | v1 - v2 ]) allSatisfy: [ :v | v <= (1 @ 1) ])! !

ROTest subclass: #ROLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLineTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:14'!
testColorBlockTakesTheElement
	| edge line |
	line := ROLine new 
		color: #model.
	edge := ROEdge on: 42.
	self assert: (line colorFor: edge) = 42! !

!ROLineTest methodsFor: 'tests creation' stamp: 'AlexandreBergel 4/7/2013 01:02'!
testCreation

	| shape |
	shape := ROLine arrowed color: Color blue.
	self assert: (shape elementOn: 123) model = 123.
	self assert: (shape elementOn: 123) class == ROEdge.
	
! !

!ROLineTest methodsFor: 'tests creation' stamp: 'AlexandreBergel 4/7/2013 01:02'!
testCreation2

	| el1 el2 edge shape |
	shape := ROLine arrowed color: Color blue.
	el1 := ROBox element.
	el2 := ROBox element.
	edge := shape elementFrom: el1 to: el2.
	self assert: edge class == ROEdge.
	self assert: edge from == el1.
	self assert: edge to == el2.! !

!ROLineTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:15'!
testWidthBlockTakesTheElement
	| edge line |
	line := ROLine new 
		width: #model.
	edge := ROEdge on: 42.
	self assert: (line widthFor: edge) = 42! !

ROTest subclass: #ROMenuElementTest
	instanceVariableNames: 'emptyMenu menu counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets-Tests'!

!ROMenuElementTest methodsFor: 'running' stamp: 'AlexandreBergel 9/1/2012 19:54'!
setUp

	emptyMenu := ROMenuElement new.
	
	menu := ROMenuElement new.
	menu item: 'reset' action: [ :v | counter := 0. ].
	menu item: 'increase' action: [ :v | counter := counter + 1 ].! !

!ROMenuElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/1/2012 19:55'!
testEvaluateCallback

	self assert: counter isNil.
	menu evaluate: 'reset'.
	self assert: counter = 0.
	
	menu evaluate: 'increase'.
	self assert: counter = 1.

	menu evaluate: 'increase'.
	menu evaluate: 'increase'.
	self assert: counter = 3.
! !

!ROMenuElementTest methodsFor: 'test-initialization' stamp: 'AlexandreBergel 9/1/2012 23:35'!
testInitialization

	self assert: emptyMenu targetObject == emptyMenu.
	! !

!ROMenuElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/1/2012 19:49'!
testNumberOfActions

	self assert: emptyMenu numberOfActions = 0.
	self assert: menu numberOfActions = 2.
! !

!ROMenuElementTest methodsFor: 'test-rendering' stamp: 'AlexandreBergel 10/2/2012 08:40'!
testRendering

	self assert: menu numberOfElements = 0.
	self assert: menu extent = (5@5).
	
	menu create.
	
	self assert: menu numberOfElements = menu numberOfActions.
	self assert: menu extent >=  (50@50).
	
	"ROView new add: menu; open "! !

!ROMenuElementTest methodsFor: 'test-rendering' stamp: 'AlexandreBergel 9/1/2012 23:58'!
testRenderingEmpty

	self assert: emptyMenu numberOfElements = 0.
	self assert: emptyMenu extent = (5@5).
	
	emptyMenu create.
	
	self assert: emptyMenu numberOfElements = 0.
	self assert: emptyMenu extent = (5@5)! !

ROTest subclass: #ROMiniMapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:15'!
testCameraTranslation

	|view miniMap|
	view := ROView new.
	view @ROMiniMap.
	
	miniMap := (view attributes at: #miniMap).

	self assert: (miniMap lupa position = (0@0)).	
	self assert: (view camera position = (0@0)).
	view camera translateBy: 100@100.
	view announce: (ROCameraTranslated new step: 100@100).
	self assert: (view camera position = (100@100)).	
	self assert: (miniMap lupa position =  (500@500)).
! !

!ROMiniMapTest methodsFor: 'creation' stamp: 'VanessaPena 1/5/2013 21:15'!
testCreation

	|view miniMap|
	view := ROView new.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.
	
	self assert: (miniMap lupa position = (0@0)).
	self assert: (miniMap lupa extent = (5@5)).
	self assert: (miniMap camera position = (0@0)).
	self assert: (miniMap miniMap extent = (200@200) )
	
	! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:14'!
testLupaCreation

	|view miniMap|
	view := ROView new.
	view @ROMiniMap.
	view windowSize: (300@300).
	
	miniMap := (view attributes at: #miniMap).

	self assert: (miniMap lupa extent =   (1500@1500)).	! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:14'!
testLupaTranslation

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view @ROMiniMap.
	
	miniMap := (view attributes at: #miniMap).

	self assert: (miniMap lupa position = (0@0)).	
	self assert: (view camera position = (0@0)).
	miniMap lupa announce: (ROMouseDragging new step: 10@10).
	self assert: (miniMap lupa position = (10@10)).
	self assert: (view camera position =  (100@100)).! !

!ROMiniMapTest methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:13'!
testMiniMapCameraAfterContainerResize

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.

	self assert: (miniMap miniMap extent = (200@200)).
	self assert: (miniMap camera realExtent =  (50@50)).
	miniMap container windowSize: (300@300).
	self assert: (miniMap miniMap extent = (300@300)).
	self assert: (miniMap camera realExtent = (3000@3000)).! !

!ROMiniMapTest methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:13'!
testMiniMapContainerResize

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.

	self assert: (miniMap containerSize = (200@200)).
	self assert: (miniMap miniMap extent = (200@200)).
	miniMap container windowSize: (300@300).
	self assert: (miniMap containerSize = (300@300)).
	self assert: (miniMap miniMap extent = (300@300)).
	! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:12'!
testMiniMapOnClik

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view @ROMiniMap.
	
	miniMap := (view attributes at: #miniMap).

	self assert: (miniMap lupa position = (0@0)).	
	self assert: (view camera position = (0@0)).
	miniMap container announce: (ROMouseLeftClick new position: 10@10).
	self assert: (miniMap lupa position = (10@10)).
	self assert: (view camera position =  (100@100)).! !

!ROMiniMapTest methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:12'!
testMiniMapPosition

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view add: ROElement sprite.
	ROVerticalLineLayout new on: view elements.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.
	
	self assert: (miniMap miniMap extent =  (80@200)).
	self assert: (miniMap miniMap position =  (60@0) ).



	
	! !

!ROMiniMapTest methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:11'!
testMiniMapPositionAfterContainerResize

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view add: ROElement sprite.
	ROVerticalLineLayout new on: view elements.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.

	self assert: (miniMap miniMap extent =  (80@200)).
	self assert: (miniMap miniMap position =  (60@0) ).
	miniMap container windowSize: (300@300).
	self assert: (miniMap miniMap extent =   (120@300)).
	self assert: (miniMap miniMap position =  (90@0)).
	! !

!ROMiniMapTest methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:10'!
testMiniMapSizeAdjustment

	|view miniMap|
	view := ROView new.
	view add: ROElement sprite.
	view @ROMiniMap.
	miniMap := (view attributes at: #miniMap).
	self assert: miniMap isNil not.
	
	self assert: (miniMap containerSize = (200@200)).
	self assert: (miniMap miniMap extent = (200@200)).
	self assert: (miniMap miniMap position = (0@0) ).
	self assert: (miniMap camera realExtent =  (50@50)).


	
	! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:09'!
testViewZoomIn

	|view miniMap incrementX1Y1 incrementX2Y2 topLeft bottomRight bounds|
	view := ROView new.
	view @ROMiniMap.
	
	view windowSize: 500@500.
	
	miniMap := (view attributes at: #miniMap).
	
	self assert: (miniMap lupa position = (0@0)).
	self assert: (miniMap lupa extent =  (2500@2500)).
	
	ROZoomInMove new on: view.
	view doAllAnimationCycles.
	
	self assert: (miniMap lupa position = (200@200)).
	self assert: (miniMap lupa extent =  (2100@2100)).! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:09'!
testViewZoomOut

	|view miniMap incrementX1Y1 incrementX2Y2 topLeft bottomRight bounds|
	view := ROView new.
	view @ROMiniMap.
	
	view windowSize: 500@500.
	
	miniMap := (view attributes at: #miniMap).
	
	self assert: (miniMap lupa position = (0@0)).
	self assert: (miniMap lupa extent =  (2500@2500) ).
	
	ROZoomOutMove new on: view.
	view doAllAnimationCycles.
	
	self assert: (miniMap lupa position =  (-200@ -200)).
	self assert: (miniMap lupa extent =  (2900@2900)).! !

!ROMiniMapTest methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 12:51'!
testWindowResize

	|view miniMap|
	view := ROView new.
	view @ROMiniMap.
	
	miniMap := (view attributes at: #miniMap).
	
	self assert: (miniMap miniMap extent = (200@200) ).
	view windowSize: 1000@1000.
	self assert: (miniMap miniMap extent = (1000@1000) ).
	! !

ROTest subclass: #ROMondrianCacheTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianCacheTest methodsFor: 'running' stamp: 'AlexandreBergel 12/11/2012 15:48'!
setUp
	super setUp.
	view := ROMondrianViewBuilder new! !

!ROMondrianCacheTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 18:48'!
testCache
	| t |
	t := OrderedCollection new.
	view shape rectangle 
		height: [ :v | t add: (Array with: v with: #height). 10 ];
		width: [ :v | t add: (Array with: v with: #width). 20 ];
		fillColor: [ :v | t add: (Array with: v with: #width). Color blue ].
	view nodes: #(1 2).
	view raw drawOn: RONullCanvas new.
	
	self assert: t size = 6.
	view raw drawOn: RONullCanvas new.
	view raw drawOn: RONullCanvas new.
	self assert: t size = 6.
! !

!ROMondrianCacheTest methodsFor: 'test cache shapes' stamp: 'AlexandreBergel 4/11/2013 15:54'!
testCacheShapeAndInnerElements
	| element canvas |
	view := ROMondrianViewBuilder new.
	element := view node: 'hello' forIt: [ view nodes: (1 to: 20) ].
	element translateBy: -200 @ 0.
	view noLayout.

	self assert: view raw numberOfElementsToRender = 21.

	view raw windowSize: 500 @ 500.
	
	canvas := ROTracingCanvas new.
	view raw drawOn: canvas.

	self assert: view raw numberOfElementsToRender = 1.
	self assert: canvas trace =  #(#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white'))! !

!ROMondrianCacheTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 19:22'!
testCacheWithInner
	| t |
	t := OrderedCollection new.
	view node: 'foo' forIt: [
		view shape rectangle 
			height: [ :v | t add: (Array with: v with: #height). 10 ];
			width: [ :v | t add: (Array with: v with: #width). 20 ];
			fillColor: [ :v | t add: (Array with: v with: #color). Color blue ].
		view nodes: #(1 2) ].
	view raw drawOn: RONullCanvas new.
	
	self assert: t size = 6.
	view raw drawOn: RONullCanvas new.
	view raw drawOn: RONullCanvas new.
	self assert: t size = 6.
! !

ROTest subclass: #ROMondrianScatterLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianScatterLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:41'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayout
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
	view layout: (ROScatterplotLayout new 
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayoutBounds
	"
	self debug: #testScatterplotLayoutBounds
	"
	| nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:45'!
testScatterplotLayoutOffset
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
		
	view layout: (ROScatterplotLayout new 
						offset: 2;
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 12.
	self assert: nodes first bounds topLeft y = 22.

	self assert: nodes last bounds topLeft x = 32.
	self assert: nodes last bounds topLeft y = 42.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'DR 3/25/2013 21:58'!
testScatterplotLayoutScalled

	|  nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last
							;
							scaledToWidth: 20;
							scaledToHeight: 15 ).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x >= 6.
	self assert: nodes first bounds topLeft x <= 7.
	self assert: nodes first bounds topLeft y >= 7.
	self assert: nodes first bounds topLeft y <= 8.
	
	self assert: nodes last bounds topLeft x = 20.
	self assert: nodes last bounds topLeft y = 15.

! !

ROTest subclass: #ROMondrianViewBuilderLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/25/2012 17:19'!
buildScenario

	view := ROMondrianViewBuilder new.
	view nodes: #(1 2) forEach: [ :each |
		view nodes: (Array with: each * 10 with: (each * 100)). 
		view treeLayout.
	].
	view edgesFromAssociations: (Array with: 10 -> 100 with: 20 -> 200).
	view applyLayout.
	! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 7/25/2012 11:24'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:36'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/24/2012 15:00'!
testEdgesDefinedOutside

	| firstNode secondNode |
	self buildScenario.
	
	firstNode := view raw elements first.
	secondNode := view raw elements second.
	
	"We check who has the edge"
	self assert: (firstNode elements size = 3).
	self assert: (secondNode elements size = 3).
	self assert: view raw elements size = 2.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 12/10/2012 20:12'!
testEdgesDefinedOutsideLayout

	| firstNode secondNode |
	self buildScenario.
	
	firstNode := view raw elements first.
	secondNode := view raw elements second.
	
	"We check the layout" 
	self assert: (firstNode elementsNotEdge collect: #position) asArray reverse = (Array with: 5 @ 30 with: 5 @ 5).
	self assert: (secondNode elementsNotEdge collect: #position) asArray reverse = (Array with: 5 @ 30 with: 5 @ 5).
	
! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/25/2012 11:02'!
testEdgesDefinedOutsideLayoutStructure
	| firstInnerFrame secondInnerFrame |
	self buildScenario.
	
	self assert: view numberOfFrames = 3.
	
	"Outter frame"
	self assert: view structureTree elements size = 2.
	self assert: view structureTree nodes size = 2.
	
	"First inner frame"
	firstInnerFrame := view structureTree children first.
	self assert: firstInnerFrame elements size = 3. 
	self assert: firstInnerFrame nodes size = 2.
	self assert: firstInnerFrame edges size = 1.
	
	"Second inner frame"
	secondInnerFrame := view structureTree children second.
	self assert: secondInnerFrame elements size = 3. 
	self assert: secondInnerFrame nodes size = 2.
	self assert: secondInnerFrame edges size = 1.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:26'!
testEdgesFrom

	| outterFrame firstInnerFrame secondInnerFrame |
	view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2 with: v + 3).
		view shape line.
		view edgesFrom: [ :el | v + 1 ].
		view treeLayout ].

	view horizontalLineLayout.
	view applyLayout.
	
	self assert: view structureTree numberOfFrames = 3.

	outterFrame := view structureTree .
	firstInnerFrame := outterFrame children first.
	secondInnerFrame := outterFrame children second.
	
	self assert: (outterFrame nodes size = 2).
	self assert: (outterFrame edges size = 0).
	
	self assert: (firstInnerFrame nodes size = 3).
	self assert: (firstInnerFrame edges size = 2).
	
	self assert: (secondInnerFrame nodes size = 3).
	self assert: (secondInnerFrame edges size = 2).! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:23'!
testLayouts

	| l |
	l := OrderedCollection new.
	l add: #treeLayout.
	l add: #gridLayout.
	l add: #forceBasedLayout.
	l add: #circleLayout.
	l add: #verticalLineLayout.
	l add: #horizontalLineLayout.
	l add: #sugiyamaLayout.
	l add: #bottomFlowLayout.
	l add: #flowLayout.
	l add: #radialTreeLayout.
	l add: #scatterPlotLayout.
	l add: #noLayout.

	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.

	l do: [ :sel | 
		self shouldnt:  [ view perform: sel. view applyLayout ] raise: Error ]! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:23'!
testTreeLayoutAndColor
	"Strange bug http://code.google.com/p/objectprofile/issues/detail?id=86&thanks=86&ts=1341240917"
	| edges |
	
	view shape rectangle size: 50.
	view nodes: (1 to: 5).
	view shape line color: Color blue.
	edges := view edgesFromAssociations: (Array with: 1 -> 5 with: 1 -> 2 with: 3 -> 4).
	self assert: (edges allSatisfy: [ :edge | (edge getShape: ROLine) color = Color blue ]).
	
	view treeLayout .	 
	"view open"
	
	self assert: (edges allSatisfy: [ :edge | (edge getShape: ROLine) color = Color blue ])! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'user defined edges' stamp: 'AlexandreBergel 12/11/2012 12:31'!
testUserDefinedEdges
	" to address: http://code.google.com/p/moose-technology/issues/detail?id=834 "

	| edges layout |
	view nodes: #(1 2 3).
	edges := view edgesFrom: [ :each  | each - 1 ].
	view shape line color: Color red.
	view edges: #(3) from: [ :each | each - 2 ] to: #yourself.
	layout := view treeLayout userDefinedEdges: edges; yourself.
	
	"We check the user defined edges before doing the layout"
	self assert: (layout userDefinedEdges = edges).
	
	"We do the layout"
	view applyLayout.

	"We first check whether the edges have been well defined."
	self assert: edges size = 2.
	self assert: (edges last from model = 2).
	self assert: (edges last to model = 3).
	
	self assert: (edges first from model = 1).
	self assert: (edges first to model = 2).

	"We then checked if the edges are defined in the layout"
	self assert: (layout userDefinedEdges = edges).
	self assert: (layout edges = edges).
	
 ! !

ROTest subclass: #ROMondrianViewBuilderTest
	instanceVariableNames: 'view window node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderTest commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilderTest is a test class for testing the behavior of ROMondrianViewBuilder!

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
setUp
	view := ROMondrianViewBuilder new! !

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
tearDown
	super tearDown.
	window ifNotNil: [window delete. window := nil]! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePosition
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePositionAfterTranslation
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.
	outter translateBy: 10@3.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5 + (10@3)).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10 + (10@3)).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15 + (10@3)).! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testAddingNode

	view node: 123.
	self assert: (view raw numberOfElements = 1)! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testAddingNodes

	view nodes: (1 to: 20).
	self assert: (view raw numberOfElements = 20)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 12:18'!
testBorderColor

	| nodes b |
	view shape rectangle borderColor: (b := [ :model | model + 1]).
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 13:11'!
testBorderColorWithNormalizer

	view shape rectangle borderColor: (RONIdentityNormalizer new).
	view nodes: (1 to: 10).
	self shouldnt: [view raw drawOn: RONullCanvas new]  raise: Error! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 12:14'!
testBorderWidth

	| nodes b |
	view := ROMondrianViewBuilder new.
	view shape rectangle borderWidth: (b := [ :model | model + 1 ]).
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderWidthFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROPopupView for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction2

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROAbstractPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROAbstractPopup for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'VanessaPena 3/12/2013 15:30'!
testCircle

	| element |
	view shape circle.
	element := view node: 'hello'.
	self assert: (element isShapedAs: ROEllipse).
	"view raw bitmap."! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'VanessaPena 3/12/2013 15:30'!
testCircleWithBorderedColor

	| element |
	view shape circle borderColor: [ :v | Color r: 255 g: 255 b: v].
	element := view node: 255.
	self assert: (element isShapedAs: ROEllipse).
	! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testColoredEdges

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.
	
	view treeLayout.
	self assert: (edge1 numberOfShapes = 2).
	self assert: (edge2 numberOfShapes = 2)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/3/2012 00:03'!
testColoredEdges2

	| edges |
	view shape rectangle size: 50.
	view nodes: (1 to: 5).
	view shape line color: [:edge | (edge from model + edge to model) odd ifTrue: [ Color red ] ifFalse: [ Color black ]].

	edges := view edgesFromAssociations: (Array with: 1 -> 5 with: 1 -> 2 with: 3 -> 4).
	view treeLayout .	 

	self assert: ((edges first getShape: ROLine) color roValue: edges first) = Color black.
	self assert: ((edges second getShape: ROLine) color roValue: edges second) = Color red.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testColoredEdgesWithoutLayout

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.

	self assert: (edge1 numberOfShapes = 2).
	self assert: (edge2 numberOfShapes = 2)! !

!ROMondrianViewBuilderTest methodsFor: 'constraining inner nodes' stamp: 'AlexandreBergel 4/29/2013 16:50'!
testConstrainingInnerNodes

	node := view node: 1 forIt: [  
		view nodes: (1 to: 9).
		view gridLayout ].
	
	view horizontalLineLayout 
		on: ROLayoutEnd 
		do: [ :event |  view raw elementsDo: [ :el | el resizeStrategy: (ROFixedSizedParent instance) ] ].
	
	view applyLayout.
	
	self assert: node extent =  (33@33).
	node elements first translateBy: 100 @ 100.
	
	"The size does not change"
	 self assert: node extent =  (33@33).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testDefaultShapeForEdge

	| edge |
	view nodes: #(1 2 3).
	edge := view edgeFromAssociation: 1 -> 2.	
	self assert: (edge isShapedAs: ROLine)
! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:52'!
testDefaultTitle
	| builder |
	builder := ROMondrianViewBuilder new.
	window := builder open.
	
	[
		self assert: window labelString = ROView defaultWindowTitle.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'dynamic edges' stamp: 'AlexandreBergel 4/7/2013 07:07'!
testDynamicEdges

	| firstNode |
	view interaction 
		dynamicEdge: [ :model | (Array with: 10 with: 20 with: 30) copyWithout: model ]
		using: (ROLine arrowed color: Color red).
	view shape rectangle size: 20.
	view nodes: (Array with: 10 with: 20 with: 30).
	view circleLayout.
	view applyLayout.
	
	self assert: view raw numberOfElements = 3.
	self assert: (view raw elementsSuchThat: #isEdge) isEmpty.
	
	firstNode := view raw elements first.
	self assert: firstNode numberOfInteractions = 3.
	self assert: (firstNode is: RODynamicEdge).
	
	firstNode announce: ROMouseEnter.
	self assert: view raw numberOfElements = 5.
	self assert: (view raw elementsSuchThat: #isEdge) size = 2.
! !

!ROMondrianViewBuilderTest methodsFor: 'dynamic edges' stamp: 'AlexandreBergel 4/10/2013 16:38'!
testDynamicEdgesMultiple

	| firstNode |
	view interaction 
		dynamicEdge: [ :model | ((Array with: 10 with: 20 with: 30) copyWithout: model) allButFirst ] using: (ROLine arrowed color: Color red);
		dynamicEdge: [ :model | ((Array with: 30 with: 20 with: 10) copyWithout: model) allButFirst ] using: (ROLine arrowed color: Color blue).
	view shape rectangle size: 20.
	view nodes: (Array with: 10 with: 20 with: 30).
	view circleLayout.
	view applyLayout.
	
	self assert: view raw numberOfElements = 3.
	self assert: (view raw elementsSuchThat: #isEdge) isEmpty.
	
	firstNode := view raw elements first.
	self assert: firstNode numberOfInteractions = 3.
	self assert: (firstNode is: RODynamicEdge).
	
	firstNode announce: ROMouseEnter.
	self assert: view raw numberOfElements = 5.
	self assert: (view raw elementsSuchThat: #isEdge) size = 2.
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 8/19/2012 21:52'!
testEdgeAndInteraction

	|  edge |
	view := ROMondrianViewBuilder new.
	view shape rectangle size: 30.
	view nodes: (1 to: 2).
	view interaction on: ROMouseEnter do: [:ann | Transcript show: ann printString ; cr ].
	edge := view edgeFromAssociation: 1 -> 2.

	self assert: edge numberOfInteractions = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 8/20/2012 09:16'!
testEdgeAndInteraction2LowLevel

	|  edge |
	view := ROMondrianViewBuilder new.
	view shape line.
	view interaction on: ROMouseEnter do: [:ann | Transcript show: ann printString ; cr ].
	edge := view buildEdgeFrom: (ROElement on: 1) to: (ROElement on: 2) for: 'zork'.

	self assert: edge numberOfInteractions = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'TudorGirba 11/29/2012 13:33'!
testEdgeFromAllTo
	
	view nodes: #(1 2).
	view edges: #(1 2) fromAll: [ :v | Array with: 1 ] to: #yourself.

	self assert: (view raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testEdgeFromAndToItself
	"
	self debug: #testEdgeFromAndToItself
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 2 with: 1 -> 1).

	self assert: (view raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testEdgeFromAndToItself2
	"
	self debug: #testEdgeFromAndToItself2
	"
	
	view nodes: #(1 2).
	view edges: #(1 2) from: #yourself toAll: [ :v | Array with: 1 ].

	self assert: (view raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:40'!
testEdgeFromAssociation
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	 view edge: (1 -> 2) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:42'!
testEdgeFromAssociation2
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	 view edge: (1 -> 20) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges isEmpty
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 12/11/2012 12:32'!
testEdgesAndInnerNodes
	"Node extremities should be looked up with the nesting"
	
	| outterNode1 edges innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: [ innerNode1 := view node: 1 ].
	view node: 'outter2' forIt: [ innerNode2 := view node: 2 ].
	view node: 'outter3' forIt: [ innerNode3 := view node: 3 ].
	
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).

	self assert: (view nestedLookup: 1 in: outterNode1) = innerNode1.
	self assert: (view nestedLookup: 2 in: outterNode1) isNil.
		
	self assert: (view lookup: 1) == innerNode1.
	self assert: (view lookup: 2) == innerNode2.
	self assert: (view lookup: 3) == innerNode3.
	
	edges := view root edges.
	self assert: edges size = 3.
	self assert: (edges last from == innerNode1).
	self assert: (edges last to == innerNode3).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:42'!
testEdgesFromAssociation
	| nodes edges  m |

	nodes := view nodes: #(1 2 3 4).
	 view edges: (Array with: 1 -> 2 with: 2 -> 10 with: 10 -> 3) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 11/27/2012 21:02'!
testEdgesFromTo

	| edges |
	view nodes: (1 to: 5).
	edges := view edgesFrom: 1 to: 2. 
	self assert: edges size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 12/11/2012 12:32'!
testEdgesFromTo2

	| edges |
	view nodes: (1 to: 5).
	edges := view edgesFrom: #yourself to: 1. 
	self assert: edges size = 4.
	self assert: (edges collect: [ :edge | edge from model ]) asArray = #(2 3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:07'!
testEdgesFromToHaveNonNilModel
	| edges |
	view nodes: #(4 2).
	edges := view edges: (Array with: 42) from: 4 to: 2.
	
	self assert: edges first model = 42! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 11/28/2012 22:58'!
testEdgesFromToWithSameModelsAsTheNodes
	| edges |
	view nodes: (Array with: 4 with: 2).

	self shouldnt: [edges := view edges: (Array with: 4 with: 2) from: 4 to: 2] raise: Error.
	self assert: edges size = 1! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/6/2013 18:00'!
testEdgesToAll

	view shape rectangle.
	view nodes: #(1 2 3).
	self assert: view edges size = 0.
	
	view shape arrowedLine.
	view edgesToAll: #(2).
	self assert: view edges size = 3. "Is it correct? I didn't expect edge 2->2."
	(view edges collect: #target) do: [ :eachTarget |
		self assert: eachTarget model = 2 ].
	"(view edges collect: #source) do: [ :eachSource |
		self deny: eachSource model = 2 ]."! !

!ROMondrianViewBuilderTest methodsFor: 'accessing' stamp: 'AlexandreBergel 12/5/2012 17:20'!
testElementFromModel

	| nodes edges |
	view shape rectangle size: 30.
	nodes := view nodes: (Array with: Collection with: Collection superclass).
	edges := view edgesFrom: #superclass.

	self assert: edges size = 1.
	self assert: nodes size = 2.
	
	self assert: (view raw elementFromModel: Collection) == nodes first.
	self assert: (view raw elementFromModel: Collection superclass) == nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'accessing' stamp: 'AlexandreBergel 12/5/2012 09:35'!
testElementsFromModels
	"
	self debug: #testElementsFromModels
	"

	| container node1To6 node7 nodeInner10To20 node8 nodeInner1To6 |
	node1To6 := view nodes: (1 to: 6).
	node7 := view node: 7 forIt: [ nodeInner10To20 := view nodes: (10 to: 20) ].
	node8 := view node: 8 forIt: [ nodeInner1To6 := view nodes: (100 to: 106) ].
	
	container := view raw.

	"Looking up individual nodes"
	self assert: (container elementFromModel: 1) == node1To6 first.
	self assert: (container elementFromModel: 7) == node7.
	self assert: (container elementFromModel: 8) == node8.

	self assert: (node7 elementFromModel: 7) == node7.
	self assert: (node7 elementFromModel: 70) isNil.
	
	"------"
	"Group of nodes"
	"Checking the outter nodes"
	self assert: (container elementsFromModels: (1 to: 6)) asArray = node1To6.
	self assert: (container elementsFromModels: (Array with: 7)) asArray first == node7.
	self assert: (container elementsFromModels: (Array with: 8)) asArray first == node8.

	"Looking up the inner nodes"
	self assert: (container elementsFromModels: (10 to: 20)) asArray = nodeInner10To20. 
	
	"Looking up unexisting nodes"
	self assert: (container elementsFromModels: (Array with: 2000)) isEmpty
	
! !

!ROMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 5/6/2013 18:05'!
testExtensibleSizeWithPaddingGap

	| element1 element2 |
	view extensibleSizeWithPaddingGap: 0.
	element1 := view node: 100 forIt: [ 
		view shape rectangle size: 50.
		element2 := view node: 10.
	].

	self assert: element1 padding = (0 @ 0).
	self assert: element1 width = element2 width.
	self assert: element1 height = element2 height.! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:41'!
testFillColor

	| nodes |
	view shape rectangle fillColor: [ :model | model + 1].
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 4/22/2013 19:22'!
testFixedSize

	| variableNode fixedSizedNode |
	view shape rectangle width: 50; height: 50.
	variableNode := view node: 'Variable size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	view shape rectangle width: 50; height: 50; fixedSize.
	fixedSizedNode := view node: 'Fixed size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	self assert: fixedSizedNode resizeStrategy isFixed.
	self assert: variableNode extent >= (50 @ 50).
	self assert: fixedSizedNode extent = (50 @ 50).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:19'!
testFontSize
	
	| node |
	view shape label 
		text: [ :o | o name, ' class'];
		fontSize: 10.
	node := view node: Object.
	self assert: ((node getShape: ROLabel) fontSizeFor: node) = 10.! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testForItAndShape
	| node |
	
	view shape rectangle width: [ :v | v ].
	view node: 50.
	
	view shape withoutBorder.
	node := view node: Object new.
	
	self assert: node width = view defaultWidth.
	self assert: node height = view defaultHeight.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 1/18/2013 14:05'!
testForwarding

	| t outterNode innerNode |
	
	t := 0.
	"Only the outter node should be a forwarder"
	view interaction forwarder.
	outterNode := view node: 'outter' forIt: [ 
		innerNode := view node: 'inner'.
	].
	view raw on: ROEvent do: [ :e | t := t + 1 ].

	self assert: t = 0.
	outterNode announce: ROComponentEvent.
	self assert: t = 1.

	"Since the inner node is not declared has a forwarder, it should not forward"
	innerNode announce: ROComponentEvent.
	self assert: t = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/23/2013 15:54'!
testFromInsideToOutside

	| node1 node2 edge attachPoint points |
	node1 := view node: 'zork'.
	view node: 'foo' forIt: [ 
		node2 := view node: 'bar'. 
		view raw add: (edge := ROEdge lineFrom: node1 to: node2). ].
	view applyLayout.
	
	attachPoint := edge shapes first attachPoint.
	points := Array with: (10@7) with: (25@12).
	self assert: (points includes: (attachPoint startingPointOf: edge)).
	self assert: (points includes: (attachPoint endingPointOf: edge)).
	
	node2 translateTo: 100 @ 50.
	points := Array with:  (10@7) with: 5@3.
	self assert: (points includes: (attachPoint startingPointOf: edge)).
	points := Array with: 100@52 with: (120@57).
	self assert: (points includes: (attachPoint endingPointOf: edge)).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/23/2013 15:56'!
testFromInsideToOutside2

	| edge attachPoint edges points |
	view node: 'foo' forIt: [
		view node: 'bar' forIt: [
			view nodes: #(1 2).
			edges := view edgesFrom: 1 to: 2.
		 ]
	].
	view applyLayout.
	edge := edges first.

	attachPoint := edge shapes first attachPoint.
	points := Array with:   (20@17) with:  (30@17).
	self assert: (points includes: (attachPoint startingPointOf: edge)).
	self assert: (points includes: (attachPoint endingPointOf: edge)).
	
	view applyLayout.
	

	points := Array with: 20@17 with: 20@18.
	self assert: (points includes: (attachPoint startingPointOf: edge)).
	points := Array with: 30@17 with: 30@18.
	self assert: (points includes: (attachPoint endingPointOf: edge)).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: ''!
testGraph

	"No error should be raised"
	
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 09:34'!
testHeight

	| nodes heightBlock secondNode |
	heightBlock := [ :model | model + 1].
	view shape rectangle height: heightBlock.
	"self assert: view height == heightBlock."
	nodes := view nodes: #(2 30 40).
	
	secondNode := nodes second.
	self assert: ((secondNode getShape: ROBox) height roValue: secondNode) = 31.
	self assert: (nodes collect: [ :n | n height ]) =  #(5 31 41)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:45'!
testIfBorderColor

	| nodes |
	view shape rectangle 
		if: #odd borderColor: [ :model | model + 1];
		if: #even borderColor: [ :model | model + 10].
	nodes := view nodes: #(2 3 4 5 6).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = #(12 4 14 6 16)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 10:05'!
testIfFillColor

	| nodes |
	view shape rectangle 
		if: #odd fillColor: [ :model | model + 1];
		if: #even fillColor: [ :model | model + 10].
	nodes := view nodes: #(2 3 4 5 6).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(12 4 14 6 16)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:49'!
testIfborderColor

	| nodes result |
	view shape rectangle 
		if: #odd borderColor: Color red;
		if: #even borderColor: Color blue.
	nodes := view nodes: #(1 2 3 4).
	
	result :=  ((Array new: 4) at: 1 put: Color red; at: 2 put: Color blue; at: 3 put: Color red; at: 4 put: Color blue; yourself).
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = result! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testInitialization

	| builder |
	builder := ROMondrianViewBuilder new.
	self assert: (builder raw class == ROView)! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testInitializationWithView

	| builder v |
	v := ROView new.
	builder := ROMondrianViewBuilder titled: 'hello' view: v .
	
	self assert: (builder raw == v).
	self assert: (builder raw class == ROView).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 12/11/2012 12:34'!
testInnerNodesAndEvents

	| outter inner inner2 |
	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: (view raw elementAt: outter absolutePosition) == outter.
	self assert: (view raw elementAt: inner absolutePosition) == inner.
	self assert: (view raw elementAt: inner2 absolutePosition) == inner2.


	self assert: (view raw elementAtRealPosition: outter absolutePosition) == outter.
	self assert: (view raw elementAtRealPosition: inner absolutePosition) == inner.
	self assert: (view raw elementAtRealPosition: inner2 absolutePosition) == inner2.
	
	self assert: (view raw elementAtRealPosition: 18@18) == inner2.

	"We simulate a drag and drop"
	outter translateTo: 67@32.
	self assert: (view raw elementAtRealPosition: 80@45) == inner2.	
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 12/11/2012 12:35'!
testInnerNodesAndLayout
	| nodes |
	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2) ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (45@5 corner: 75@20)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))

! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 12/11/2012 12:37'!
testInnerNodesAndLayout2
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2).
		view verticalLineLayout ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 20@35) with: (30@5 corner: 45@35)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 12/11/2012 12:37'!
testInnerNodesAndLayout3
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v+ 1 with: v +2).
	 ].
	view verticalLineLayout.
	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (5@30 corner: 35@45)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'DR 1/15/2013 21:21'!
testInnerNodesAndLayout4
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2 with: v + 3).
		view shape line.
		view edgesFrom: [ :el | v + 1 ].
		view treeLayout ].

	view horizontalLineLayout.
	view applyLayout.
	
	"Sanity check begin"
	self deny: ((nodes second elementFromModel: 13) isShapedAs: ROLine).
	self assert: (nodes first elementsSuchThat: #isEdge) size = 2.
	"Sanity check end"
	
	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 28.0@45) with: (38.0@5 corner: 61.0@45)).
	
	self assert: (((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself) includesAll: (nodes first elementsNotEdge collect: #bounds) asArray).
	self assert: (((((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself))) includesAll: (nodes second elementsNotEdge collect: #bounds) asArray)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testInteraction
	
	| t nodes |
	t := OrderedCollection new.
	view interaction 
		item: 'act' action: [ :v |  t add: t ].
	
	nodes := view nodes: #(1 2).
	! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 4/11/2013 14:08'!
testInteraction1
	"
	self debug: #testInteraction1
	"

	
	| nodes firstNode |
	view interaction highlightWhenOver: [ :e | (Array with: 123) ].
	view shape rectangle size: 60; fillColor: Color green.
	nodes := view nodes: #(123 456 789).

	firstNode := nodes first.
	self assert: ((firstNode getShape: ROBox) colorFor: firstNode) = Color green.
	nodes first announce: ROMouseEnter.
	self assert: ((firstNode getShape: ROBox) colorFor: firstNode) = Color red.
	nodes first announce: ROMouseLeave.
	self assert: ((firstNode getShape: ROBox) colorFor: firstNode) = Color green.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 10/15/2012 10:03'!
testInteraction2
	"
	self debug: #testInteraction2
	"

	
	| nodes firstNode |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | (Array with: 123) ].
		view shape rectangle size: 60; fillColor: Color green.
		nodes := view nodes: #(123 456 789) ].

	firstNode := nodes first.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.
	nodes first announce: ROMouseEnter.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color red.
	nodes first announce: ROMouseLeave.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.
	! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'TudorGirba 10/18/2012 09:36'!
testInteraction2HighlightWhenOver
	"
	self debug: #testInteraction2HighlightWhenOver
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
	view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
	view shape rectangle 
		width: 40;
		height: 30.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	nodes first announce: (ROMouseEnter new).
	
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 color = Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) color = Color red).
	self assert: ((node5 getShape: ROBox) color = Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | ((n getShape: ROBox) colorFor: n) = Color white ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'TudorGirba 10/18/2012 09:36'!
testInteraction2HighlightWhenOverOnInnerNodes
	"
	self debug: #testInteraction2HighlightWhenOverOnInnerNodes
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view node: 'outterNode' forIt: [
		view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
		view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
		view shape rectangle 
			width: 40;
			height: 30.
		nodes := view nodes: (1 to: 16).
		view gridLayout gapSize: 2
	].
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	
	nodes first announce: (ROMouseEnter new).
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 color = Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) color = Color red).
	self assert: ((node5 getShape: ROBox) color = Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | ((n getShape: ROBox) colorFor: n) == Color white ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/4/2012 00:10'!
testInteraction3
	"
	self debug: #testInteraction2
	"

	
	| nodes firstNode shape secondNode |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | (Array with: 123) ].
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes := view nodes: #(123 456 789) ].

	firstNode := nodes first .
	secondNode := nodes second .
	shape := firstNode getShape: ROShape.
	
	self assert: (shape color roValue: firstNode) = Color green.
	firstNode announce: ROMouseEnter.
	self assert: (shape color roValue: firstNode) = Color red.
	firstNode announce: ROMouseLeave.
	self assert: (shape color roValue: firstNode) = Color green.

	"----"
	self assert: (shape color roValue: firstNode) = Color green.
	secondNode announce: ROMouseEnter.
	self assert: (shape color roValue: firstNode) = Color red.
	secondNode announce: ROMouseLeave.
	self assert: (shape color roValue: firstNode) = Color green.
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 4/11/2013 12:56'!
testInteraction4
	"
	self debug: #testInteraction4
	"

	
	| firstNode shape secondNode nodes1 nodes2 firstShape secondShape |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | Array with: 123 with: 123  ].
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes1 := view nodes: #(456 789) ].

	view node: 'bar' forIt: [
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes2 := view nodes: #(123) ].
	
	firstNode := nodes1 first .
	secondNode := nodes2 first .
	firstShape := firstNode getShape: ROBox.
	secondShape := secondNode getShape: ROBox.
	
	"----"
	self assert: (secondShape color roValue: secondNode) = Color green.
	firstNode announce: ROMouseEnter.
	self assert: (secondShape color roValue: secondNode) = Color red.
	firstNode announce: ROMouseLeave.
	self assert: (secondShape color roValue: secondNode) = Color green.
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 1/1/2013 13:12'!
testItemAction
	| t nodes menuActivable block |
	
	t := OrderedCollection new.
	view interaction item: 'foo' action: [ :aModelObject | t add: aModelObject ].
	nodes := view nodes: (1 to: 5).
	
	menuActivable := nodes first getInteraction: ROMenuActivable.
	block := (menuActivable actionNamed: 'foo').
	block value value: nodes first.
	self assert: t size = 1.
	self assert: t first == nodes first model
	! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/6/2013 17:57'!
testLabel

	| builder element | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	
	builder shape label.
	node := builder node: 'hello'.

	self assert: ((node getShape: ROLabel) textFor: node) = 'hello'.
	
	view := builder raw.
	self assert: view numberOfElements = 1.
	
	element := view elementDetect: [ :el | true ].
	self assert: (element isShapedAs: ROLabel).
	
	self assert: node bounds extent = (ROLabel new preferedExtentFor: node)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'JurajKubelka 4/2/2013 16:15'!
testLabelLinearFontSize

	"MOViewRendererTest>>testLabel1"
	| nodes |
	
	view shape label
		linearFontSize: #yourself within: (1 to: 40).
	nodes := view nodes: (1 to: 40).
	
	window := view open.
	
	self assert: (((nodes at: 10) getShape: ROLabel) fontSizeFor: (nodes at: 10)) = 14.
	self assert: (((nodes at: 20) getShape: ROLabel) fontSizeFor: (nodes at: 20)) = 24.	
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'TudorGirba 10/18/2012 09:34'!
testLabelText
	
	| node |
	view shape label text: [:o | o name, ' class'].
	node := view node: Object.

	self assert: ((node getShape: ROLabel) textFor: node) = 'Object class'.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 12/11/2012 12:37'!
testLabelWithTwoNodes
	"Just to make sure that the view does not initialize a shape that later stays one"
	
	| node1 node2 |
	view shape label text: #printString.
	node1 := view node: Object.
	self assert: (node1 shapes size = 2).
	
	view shape label text: #printString.
	node2 := view node: Object.
	self assert: (node1 shapes size = 2)! !

!ROMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 4/23/2013 15:14'!
testLayoutAfterRemoveAndAddNode

	|result|	
	
	view nodes: (1 to: 4).
	view gridLayout.
	view applyLayout .
	result := ((Array new: 4) at: 1 put: ((5@5)); at: 2 put: ((14@5)); at: 3 put: ((5@14)); at: 4 put: ((14@14)); yourself).
	self assert: ((view raw elements collect: #position) = result).
		
	view removeNodes: (2 to: 4).
	
	view nodes: (2 to: 4).
	view gridLayout.
	view applyLayout.
	self assert: ((view raw elements collect: #position) = result).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/28/2012 11:24'!
testLinearFillColor

	self shouldnt:  
		[view shape rectangle 
			linearFillColor: #foo within: #().
		view nodes: #()]
	raise: Error.! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/18/2012 09:48'!
testLogHeight

	| nodes |
	view shape rectangle logHeight: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	(nodes do: [ :n | self assert: n height class == Float ]) 
	 ! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/18/2012 09:49'!
testLogWidth

	| nodes |
	view shape rectangle logWidth: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	(nodes do: [ :n | self assert: n width class == Float ]) 
	 ! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testMenu

	| nodes |
	
	view node: 30 forIt: [ 
		view interaction action: #inspect; action: #foo; action: #bar.
		nodes := view nodes: (1 to: 20) ].

	self assert: (nodes first getInteraction: ROMenuActivable) numberOfEntries = 3! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/23/2013 15:25'!
testMouseEvent
	| nodes thirdNode secondNode |

	nodes := view nodes: (1 to: 3) forEach: [ :v |
		view nodes: (1 to: 30).
		view gridLayout.
	].

	"For debugging purpose"
	view raw on: ROMouseClick do: [ :event | event inspect  ].
"
view open
"
	view applyLayout.
	thirdNode := nodes third.
	secondNode := nodes second.
	self assert: (thirdNode model = 3).
	self assert: (thirdNode bounds = ( (145@5) corner: (205@56))).
	self assert: (thirdNode bounds containsPoint: (166@49)).
	self assert: (thirdNode contains: 166 @ 49).
	
	self assert: (secondNode bounds = ( (75@5) corner: (135@56))).
	self deny: (secondNode bounds containsPoint: (166@49)).

	self assert: (91@44) = (166@49 - secondNode topLeft).
	self deny: (secondNode shapes first boundsFor: secondNode containsPoint: 94@44).
	self deny: (secondNode shapes second boundsFor: secondNode containsPoint: 94@44).

	self deny: (secondNode contains: (166 @ 49)).
				
	self assert: (view raw elementAt: (166@49)) == nodes third.
	! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 9/10/2012 09:09'!
testNesting
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2) ].	
	view applyLayout.
	firstNode := (view raw elementsSuchThat: [:el | el model = 1]) first.	
	self assert: firstNode extent = (30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 7/25/2012 10:08'!
testNestingForIt
	| firstNode |
	view node: 123 forIt: [ view nodes: (1 to: 2). ].
	view applyLayout.
	
	firstNode := (view raw elementsSuchThat: [:el | el model = 123]) first.	
	self assert: firstNode extent = ( 30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testNestingWithExplicitLayout
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2) . view treeLayout ].
	view applyLayout.
	
	self assert: (view raw numberOfElements = 20).
	
	firstNode := (view raw elementsSuchThat: [:el | el model = 1]) first.
	self assert: firstNode numberOfElements = 2.
	
	self assert: firstNode extent = ( 23@15).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testNilKeyOrValue

	"
	self debug: #testNilKeyOrValue
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: nil -> 2 with: 1 -> nil).
	view edgeFromAssociation: nil -> nil.
	view edges: #(1 2) from: #yourself to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: #yourself.

	self assert: (view root raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view root raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:58'!
testNoDraggable

	| el b |
	view interaction nodraggable.
	el := view node: 123.
	b := el position.
	
	self deny: (el is: RODraggable).
	
	el announce: (ROMouseDragging step: 40@50).
	self assert: el position = b! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/6/2012 14:15'!
testNoPopup

	| el1 el2 el3 |
	view interaction noPopup.
	el1 := view node: 1.
	
	el2 := view node: 2.

	view interaction noPopup.
	el3 := view node: 3.

	self deny: (el1 is: ROPopupView).
	self assert: (el2 is: ROPopupView).
	self deny: (el3 is: ROPopupView).! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions

	
	self assert: view numberOfDefinedInteractions = 1! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions2

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions3
	view interaction action: #inspect.
	self assert: view numberOfDefinedInteractions = 2.

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:48'!
testNumberOfDefinedInteractions4
	view interaction 
		if: #odd popupText: 'hello';
		if: #even popupText: 'world'.
	self assert: view numberOfDefinedInteractions = 3.

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testOddLine

	view node: 4.
	view edges: (Array with: 4) from: #yourself toAll: [ :m | #() ].

	self assert: view root raw numberOfElements = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'open' stamp: 'AlexandreBergel 11/30/2012 16:17'!
testOpenInWindowSized
	[ window := view openInWindowSized: 400@30.
	 self assert: window extent >= (400@30).]
		ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 15:17'!
testOverlappingObjects

	| canvas |
	view shape rectangle size: 30.
	view node: 'foo'.

	view shape circle size: 30; fillColor: Color blue.
	view node: 'bar'.

	view noLayout.
	
	canvas := ROTracingCanvas new.
	view raw drawOn: canvas.
	
	self assert: canvas trace =
	 #(	#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') 
		#(#frameAndFillRectangle: '(0@0) corner: (30@30)' 'Color white' 1 'Color black') 
		#(#fillOval: '(0@0) corner: (30@30)' 1 'Color blue'))
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/6/2012 14:15'!
testPopupOnInnerInnerNodes
	| node1 node2 node3 |
	node1 := view node: 1 forIt: [ node2 := view node: 2 forIt: [ node3 := view node: 3 forIt: [  ] ] ].
	
	self assert: (node1 is: ROPopupView).
	self assert: (node2 is: ROPopupView).
	self assert: (node3 is: ROPopupView).! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 6/2/2012 17:42'!
testPopupView
	| t el |
	t := false.

	view interaction popupView: [ :myView :ell |  t := true ] delay: 0. 
	el := view node: 'hello'.
	
	el announce: ROMouseEnter.
	self assert: t! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 09:49'!
testPopupViewSize
	| el popup elRef |
	

	view interaction popupView: [ :ell :myView | 
		
		myView shape rectangle fillColor: Color blue.
		myView node: '' forIt: [  myView node: 'world' ] ] delay: 0. 
	el := view node: 'hello'.
	
	elRef := view node: 'h' forIt: [ view node: 'w' ].
	
	view applyLayout.
	
	self assert: view stack numberOfElements = 0.
	el announce: ROMouseEnter.
	self assert: view stack numberOfElements = 1.
	
	popup := view stack elements first.
	self assert: popup extent = (21 @ 21).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 12/6/2012 16:53'!
testPopupWithEdges2
	| rawView nodes firstNode secondNode virtualPoint outterNode edge |
	 
	outterNode := view node: 'foo' forIt: [ 
		nodes := view nodes: #(1 2).
		edge := view edge: 1 from: 1 to: 2.
		view treeLayout.
	].

	view applyLayout.
"
	view open.
"	
	self assert: (view raw elementAt: 14 @ 39) == nodes second.
! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testPositionRelativeTo

	| outterNode1 innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: 
		[ innerNode1 := view node: 1 forIt: [ innerNode2 := view node: 2] ].
	view applyLayout.
	
	self assert: innerNode2 bounds = ( (5@5) corner: (10@10) ).
	self assert: (innerNode2 positionRelativeTo: innerNode2) = (0 @ 0).
	self assert: (innerNode2 positionRelativeTo: innerNode1) = innerNode2 topLeft.
	self assert: (innerNode2 positionRelativeTo: outterNode1) = (innerNode2 topLeft + innerNode1 topLeft).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/6/2013 18:12'!
testRawEdgesFromTo

	view := ROMondrianViewBuilder new.
	view interaction on: ROMouseClick do: [ :event |
		view shape rectangle.
		view interaction on: ROMouseClick do: [ :otherEvent |
			view shape rectangle.
			view nodes: otherEvent model subclasses.
			view edgesFrom: #superclass.
			view treeLayout.
			view applyLayout ].
		view nodes: event model subclasses.
		view edgesFrom: #superclass.
		view treeLayout.
		view applyLayout ].

	node := view node: Collection.
	view applyLayout.

	node announce: ROMouseClick.
	self shouldnt: [ view raw elements first announce: ROMouseClick ] raise: Exception.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 18:43'!
testRectangleWithText

	view shape rectangle withText: [ :v | v ].
	view node: Object.
	! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:15'!
testRemoveAllEdgesFromNode

	
	view nodes: (1 to: 2).
	view edgesFromAssociations: (Array with: 1->2).
	self assert: (view raw numberOfElements = 3).
	
	view removeAllEdgesFrom: 1.
	self assert: (view raw numberOfElements = 2).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:37'!
testRemoveAllEdgesFromNodes

	
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 2->1 with: 3->2).
	self assert: (view raw numberOfElements = 5).
	view removeAllEdgesFromNodes: (2 to: 3).
	self assert: (view raw numberOfElements = 3).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:30'!
testRemoveAllEdgesToNode

	
	view nodes: (1 to: 2).
	view edgesFromAssociations: (Array with: 2->1).
	self assert: (view raw numberOfElements = 3).
	
	view removeAllEdgesTo: 1.
	self assert: (view raw numberOfElements = 2).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:36'!
testRemoveAllEdgesToNodes

	
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 2->1 with: 3->2).
	self assert: (view raw numberOfElements = 5).
	view removeAllEdgesToNodes: (1 to: 2).
	self assert: (view raw numberOfElements = 3).
! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 12:47'!
testRemoveAndAddNode

	view nodes: (1 to: 4).
	self assert: view raw numberOfElements = 4.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 4.		

	view removeNodes: (2 to: 4).
	self assert: view raw numberOfElements = 1.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 1.
	
	view nodes: (2 to: 4).
	self assert: view raw numberOfElements = 4.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 4.		
! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 10:49'!
testRemoveNode

	|node|	
	
	node := view node: 1.
	self assert: (view raw numberOfElements = 1).
	self assert: ((view elementFromModel: 1) = node).
	
	view removeNode: 1.
	self assert: (view raw numberOfElements = 0).
! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 10:53'!
testRemoveNodes

	view nodes: (1 to: 3).
	self assert: (view raw numberOfElements = 3).
	
	view removeNodes: (1 to: 3).
	self assert: (view raw numberOfElements = 0).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/17/2012 20:39'!
testShapeAndEdges

	| edges |
	view nodes: (1 to: 5).
	view shape line color: Color blue.
	edges := view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
		
	self assert: edges size = 5.
	edges do: [ :edge | 
		self assert: (edge getShape: ROLine) color = Color blue. 
	]
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: ''!
testShapeAreProperlyInitialized
	| node1 node2 |
	
	view shape rectangle width: 20.
	node1 := view node: 123.
	self assert: node1 bounds width = 20.
	node2 := view node: 1234.
	
	self assert: node1 bounds width = 20.
	self assert: node2 bounds width = 5.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 13:46'!
testSize

	| element |
	view shape rectangle size: 30.
	element := view node: 'hello'.
	
	self assert: element extent = (30 @ 30)! !

!ROMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testSugiyamaLayout 

	| nodes result |
	view node: 'foo' forIt: [
		view node: 'foo' forIt: [
			nodes := view nodes: (1 to: 5).
			view edgesFromAssociations: (Array with: 1 -> 2 with: 3 -> 5 with: 2-> 5).
			view sugiyamaLayout 
		]
	].
	view applyLayout.
	
	result := ((Array new: 5) at: 1 put: ((24.0@3.0) corner: (29.0@8.0)); at: 2 put: ((20.0@28.0) corner: (25.0@33.0)); at: 3 put: ((28.0@28.0) corner: (33.0@33.0)); at: 4 put: ((28.0@53.0) corner: (33.0@58.0)); at: 5 put: ((20.0@53.0) corner: (25.0@58.0)); yourself).
	self assert: (nodes collect: #bounds) = result.! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:53'!
testTitle
	| builder |
	builder := ROMondrianViewBuilder titled: 'hello world'.
	window := builder open.
	
	[
		self assert: window labelString = 'hello world'.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:43'!
testWidth

	| nodes |
	view shape rectangle width: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	self assert: (nodes collect: [ :n | n width ]) =  #(5 31 41)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/23/2012 09:00'!
testWithBorderWidth
	"Related to http://code.google.com/p/objectprofile/issues/detail?id=198"
	| classesToDraw |
	
	classesToDraw := Collection withAllSubclasses.
	view shape rectangle 
		borderWidth: 1; 
		borderColor: Color blue.
	view nodes: classesToDraw.
	view gridLayout.
	self shouldnt: [ view raw drawOn: RONullCanvas new ]  raise: Error ! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 10:12'!
testWithText

	| nodes |
	view shape rectangle withText: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	self assert: (nodes collect: [ :n | (n getShape: ROLabel) textFor: n]) =  #('3' '31' '41')! !

!ROMondrianViewBuilderTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/10/2012 19:11'!
testZOrderingAndNesting
"(ROZOrdering new
						at: [:edge | ((edge source depth * 2) max: (edge target depth * 2)) - 1 ] put: #isEdge;
						at: [ :element | element depth * 2 ] put: #isNotEdge)."
	
	| map |
	view node: 1 forIt: [ view node: 11 ].
	view node: 2 forIt: [ view node: 22 ].
	view node: 3 forIt: [ view node: 33 ].
	view edgeFromAssociation: 11 -> 33.
	
	map := OrderedCollection new
		add: 1 -> 2;
		add: 11 -> 4;
		add: 2 -> 2;
		add: 22 -> 4;
		add: 3 -> 2;
		add: 33 -> 4;
		yourself.
		
	self assert: (view elementFromModel: 11) parent == (view raw elementFromModel: 1).
	self assert: view zOrdering numberOfEntries = 2.
	
	map do: [ :assoc | 
		self assert: (view elementFromModel: assoc key) zIndex = assoc value ].
	
	self assert: (view edgeFromModel: (11 -> 33)) zIndex = 3
	
! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testlookup

	| nodes |
	nodes := view nodes: #(1 2 3 4).
	self assert: (view lookup: 1) == nodes first.
	self assert: (view lookup: 4) == nodes fourth.
	self assert: (view lookup: 6) == nil! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testrawEdgesFrom
	| nodes edges ass m assoc |

	nodes := view nodes: #(1 2 3 4).
	self assert: view raw numberOfElements = 4.
	assoc := 1 -> 2.

	edges := view rawEdges: (Array with: assoc) from: #key to: #value.
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

ROTest subclass: #ROMotionMoveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROMotionMoveTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 15:30'!
test

	| view element |
	view := ROView new.

	element := ROElement new.
	element extent: 20@20;
				+ ROEllipse blue;
				@ RODraggable;
				@ RODraggableWithVelocity.
	view add: element.

	self deny: view hasAnimation.
	ROMotionMove new for: element initialSpeed: 40 @ 30.	
	self assert: view hasAnimation.
	! !

ROTest subclass: #RONativeExampleUtilityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks-Tests'!

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:00'!
current
	^ RONativeExampleUtility current ! !

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:06'!
testGetMethods

	self assert: (self current getMethodsForClass: Object) isCollection! !

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:05'!
testSubstrings

	self assert: (self current substringsFor: 'ab cd ef') = #('ab' 'cd' 'ef')! !

ROTest subclass: #RONormalizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers-Tests'!

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/14/2012 10:43'!
testBeginingAtBlue

	| n |
	n := RONIdentityNormalizer beginingAtBlue.
	self assert: n nextColor = Color blue! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/14/2012 10:40'!
testBeginingAtRed

	| n |
	n := RONIdentityNormalizer beginingAtRed.
	self assert: n nextColor = Color red! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'DR 1/15/2013 21:12'!
testExplicitIdentity
	| normalizer colorOne colorTwo |
	
	normalizer := RONExplicitIdentityNormalizer 
						withCommand: #last 
						withColors: (Array with: Color blue with: Color white with: Color red) 
						withDefaultColor: Color green.
						
	colorOne := normalizer roValue: 'alex'.
	colorTwo := normalizer roValue: 'suffix'.
	self assert: (colorOne = colorTwo)

! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'DR 1/15/2013 21:12'!
testExplicitIdentity2
	| normalizer colorOne colorTwo |
	
	normalizer := RONExplicitIdentityNormalizer
					withCommand: #yourself
					withColors: (Array with: Color blue with: Color white with: Color red) 
					withDefaultColor: Color green.						

	self assert: (normalizer roValue: 1) = Color blue.
	self assert: (normalizer roValue: 2) = Color white.
	self assert: (normalizer roValue: 3) = Color red.
	self assert: (normalizer roValue: -1) = Color green.
	self assert: (normalizer roValue: 1000) = Color green.! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'DR 1/15/2013 21:11'!
testExplicitIdentity3Initialization
	| normalizer colorOne colorTwo colors |
	
	colors := Array with: Color blue with: Color white with: Color red.
	normalizer := RONExplicitIdentityNormalizer
					withCommand: #yourself
					withColors: colors
					withDefaultColor: Color green.						
											
	self assert: (normalizer roValue: 1) = Color blue.
	self assert: (normalizer roValue: 2) = Color white.
	self assert: (normalizer roValue: 3) = Color red.
	self assert: (normalizer roValue: 4) = Color green.! !

!RONormalizerTest methodsFor: 'linear' stamp: 'AlexandreBergel 7/4/2012 00:49'!
testGradient
	| normalizer |

	normalizer := RONColorLinearNormalizer inContext: #(0 1 2 3 4 5 6 7 8 9 10) lowColor: Color yellow highColor: Color red.
	self assert: (normalizer maximumValue: nil) = 10.
	self assert: (normalizer roValue: 10) =  (Color r: 1.0 g: 0.0 b: 0.0). 
	self assert: (normalizer roValue: 1) = (Color r: 1.0 g: 0.900012 b: 0.0).
	self assert: (normalizer roValue: 0) =  (Color r: 1.0 g: 1.0 b: 0.0)! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentity
	| colorOne colorTwo normalizer |
	
	normalizer := RONIdentityNormalizer new.
	colorOne := normalizer roValue: 1.
	colorTwo := normalizer roValue: 2.
	self deny: colorOne = colorTwo.

	colorOne := normalizer roValue: 12.
	colorTwo := normalizer roValue: 12.
	self assert: colorOne = colorTwo.! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentityModulo
	"This checks that there is no exception if there are more identities than colors"

	1 to: 150 do: [:index | RONIdentityNormalizer new roValue: index]! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentityWithCommand
	| colorOne colorTwo normalizer |
	
	normalizer := RONIdentityNormalizer withCommand: #last.
	colorOne := normalizer roValue: 'bob'.
	colorTwo := normalizer roValue: 'tom'.
	self deny: colorOne = colorTwo.

	colorOne := normalizer roValue: 'anna'.
	colorTwo := normalizer roValue: 'maria'.
	self assert: colorOne = colorTwo.! !

!RONormalizerTest methodsFor: 'multiple' stamp: 'AlexandreBergel 7/4/2012 00:54'!
testMultipleLinearNormalizer
	| normalizer |

	normalizer := ROMultipleColorLinearNormalizer 
					valueRange: #(5 10 15) colorRange: (Array with: Color blue with: Color white with: Color red) .
	
	self assert: (normalizer roValue: 5) =   (Color r: 0.0 g: 0.0 b: 1.0).
	self assert: (normalizer roValue: 6) =  ( (Color r: 0.2 g: 0.2 b: 1.0)). 
	self assert: (normalizer roValue: 15) =  (Color r: 1.0 g: 0.0 b: 0.0)! !

!RONormalizerTest methodsFor: 'linear' stamp: 'AlexandreBergel 7/2/2012 16:16'!
testNumberLinearNormalizer
	| normalizer |
	normalizer := RONumberLinearNormalizer inContext: (1 to: 10) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer roValue: 100) = 10.
	
	normalizer := RONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer roValue: 100) = 1.
	
	normalizer := RONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity ].
	self assert: (normalizer roValue: 100) = 1.
! !

!RONormalizerTest methodsFor: 'linear' stamp: 'AlejandroInfante 1/11/2013 15:01'!
testValueLinearNormalizer

	| normalizer |
	normalizer := ROValueLinearNormalizer inContext: (0 to: 10) withCommand: [:entity | entity ].
	self assert: (normalizer roValue: 10) = 1.
	
	normalizer := ROValueLinearNormalizer inContext: (0 to: 10) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer roValue: 100) = 10.
	
	normalizer := ROValueLinearNormalizer inContext: (99 to: 100) withCommand: [:entity | entity ].
	self assert: (normalizer roValue: 101) = 2.! !

ROTest subclass: #ROOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROOrderedCollection methodsFor: 'tests' stamp: 'AlexandreBergel 1/2/2013 16:06'!
testBasic

	self assert: ((#(5 4 1 5 2) sortedAs: #squared) asArray =  #(1 2 4 5 5) )! !

ROTest subclass: #ROParentElementResizeStrategyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROParentElementResizeStrategyTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/23/2013 19:39'!
testFixedSized

	| view el1 el2 |
	view := ROView new.
	el1 := ROElement new.
	el1 resizeStrategy: ROFixedSizedParent instance.
	el1 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	el2 := ROElement new.
	el2 resizeStrategy: ROExtensibleParent instance.
	el2 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	self assert: el1 bounds = ( (0@0) corner: (5 @ 5)).
	self assert: el2 bounds = ( (0@0) corner: (50 @ 35)).! !

ROTest subclass: #ROPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-PlatformIndependent'!

!ROPlatformTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 18:01'!
testAddingAPlatform

	| platform s |
	platform := ROPlatform new.
	platform name: 'test'.
	platform canvasClass: ROAbstractCanvas subclasses anyOne.
	platform fontOrganizerClass: ROFontOrganizer subclasses anyOne.
	platform widgetFactory: RONativeWidgetFactory subclasses anyOne.
	platform timeOrganizerClass: ROTimeOrganizer subclasses anyOne.
	platform hostVisualElement: Object. "We pick any class"

	ROPlatform removeNamed: 'test' ifAbsent: [].
	s := ROPlatform numberOfPlatforms.
	ROPlatform add: platform.
	self assert: (s + 1) = ROPlatform numberOfPlatforms.

	platform remove.
	self assert: s = ROPlatform numberOfPlatforms.! !

!ROPlatformTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 15:19'!
testCurrent
	self assert: ROPlatform current notNil.
	self assert: (ROPlatform current isKindOf: ROPlatform).! !

ROTest subclass: #ROPopupMondrianTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROPopupMondrianTest methodsFor: 'running' stamp: 'AlexandreBergel 7/3/2012 13:28'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/9/2012 07:57'!
testIfPopupText

	| nodes targetView |
	view interaction 
		if: #odd popupText: 'hello';
		if: #even popupText: 'world'.
	nodes := view nodes: #(1 2 3).
	
	targetView := view stack.
	
	self assert: (nodes allSatisfy: [ :node | node is: ROPopupView ]).
	
	self assert: targetView numberOfElements isZero.
	 
	nodes first announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes first announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.

	nodes third announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes third announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.
	
	
	nodes second announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes second announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/14/2012 09:36'!
testInteractionAndPopup

	| nodes node |
	view interaction action: #browse.
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self assert: (node is: ROMenuActivable).
	self assert: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:37'!
testInteractionAndPopup2

	| nodes node |
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self deny: (node is: ROMenuActivable).
	self assert: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:38'!
testInteractionAndPopup3

	| nodes node |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self assert: (node is: ROMenuActivable).
	self deny: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:46'!
testInteractionAndPopup4

	| nodes node node1 node2 |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	node1 := view node: 10.
	node2 := view node: 20.
	
	self assert: (node1 is: RODraggable).
	self assert: (node1 is: ROMenuActivable).
	self deny: (node1 is: ROPopupView).

	self assert: (node2 is: RODraggable).
	self deny: (node2 is: ROMenuActivable).
	self assert: (node2 is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/16/2012 20:03'!
testInteractionAndPopup5

	| node1 node2 |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	node1 := view node: 10 forIt: [
		node2 := view node: 20 ].
	
	self assert: (node1 is: RODraggable).
	self assert: (node1 is: ROMenuActivable).
	self deny: (node1 is: ROPopupView).

	self assert: (node2 is: RODraggable).
	self deny: (node2 is: ROMenuActivable).
	self assert: (node2 is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/3/2012 13:28'!
testNoTwoPopupAtTheSameTime

	| nodes |
	nodes := view nodes: #(1 2).
	
	"We have done nothing so far, so there is only two nodes"
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 0.

	
	"We enter one node, a popup appears in the stack"
	nodes first announce: ROMouseEnter.
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
	
	"We enter the second node, a popup appears, but the first popup should diseapear"
	nodes second announce: ROMouseEnter.
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
! !

ROTest subclass: #RORemoveNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RORemoveNodeTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/18/2012 15:55'!
testBasic

	| view el1 el2 el3 el4 el | 
	view := ROView new.
	view add: (el1 := ROElement on: 1).
	view add: (el2 := ROElement on: 2).
	view add: (el3 := ROElement on: 3).
	view add: (el4 := ROElement on: 4).
	
	view addAll: (ROEdge linesFor: (Array with: el1 -> el2 with: el1 -> el1 with: el3 -> el1)).
	self assert: view numberOfElements = 7.
	RORemoveNode suchThat: [ :e | e == el1 ] in: view.
	self assert: view numberOfElements = 3.! !

ROTest subclass: #ROScrollbableTest
	instanceVariableNames: 'view stack horizontalScrollbar verticalScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROScrollbableTest methodsFor: 'running' stamp: 'AlexandreBergel 6/9/2012 18:42'!
setUp

	view := ROView new.
	view add: ROElement sprite.

	view addAll: (ROHorizontalLineLayout on: (ROElement spritesOn: (1 to: 50))).
	"view @ RODraggable ."

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	"stack open."

	"Get the scrollbars"	
	horizontalScrollbar := stack elements first.
	verticalScrollbar := stack elements second.
! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testMovingScrollbar

	ROGridLayout on: view elements .

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 250).
	self assert: verticalScrollbar position = (0 @ 250).
	
	self assert: view encompassingRectangle height =  350.
	self assert: view camera position =  (0 @ 175) " ((2995-  view camera width) @0).".
	
	
	horizontalScrollbar announce: (ROMouseDragging step: 250 @ 0).
	self assert: horizontalScrollbar position = (250 @ 0).
	
	self assert: view encompassingRectangle width =   530.
	self assert: view camera position =  (265 @ 175) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 18:02'!
testScrollbar

	self assert: horizontalScrollbar position = (0 @ 0).
	self assert: view camera position = (0 @ 0)! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testScrollbarBottomMost

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 10000).
	self assert: verticalScrollbar position = (0 @ 420).
	
	self assert: view encompassingRectangle height =  55.
	self assert: view camera position =   (0@46) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'DR 3/25/2013 21:53'!
testScrollbarRightMost

	| points |
	horizontalScrollbar announce: (ROMouseDragging step: 10000 @ 0).
	self assert: horizontalScrollbar position = (420 @ 0).
	
	points := Array with: 2515@0 with: 2516@0.
	self assert: (points includes: view camera position).	! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 17:59'!
testStack
	"Only one element in the stack so far. Soon we will have two!!"
	self assert: stack numberOfElements = 2.
! !

ROTest subclass: #ROShapeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 10/17/2012 09:42'!
testAddingShape
	| el shape b |
	el := ROElement on: 30.
	shape := ROBox new.
	shape height: (b := [ :e | e model + 1 ]).
	self assert: (shape extentFor: el) = (5 @ 31).
	
	el + shape.
	self assert: (shape extentFor: el) = (5 @ 31).
	
	self assert: shape height == b! !

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 9/27/2012 19:00'!
testAdjustingShapeChain

	| shape1 shape2 el |
	shape1 := ROBox blue.
	shape2 := ROBox green.
	el := ROElement new.
	el + shape1 + shape2.
	
	el extent: 50 @ 50.
	
	self assert: el extent = (50 @ 50).
	self assert: shape1 extent = (50 @ 50).	
	self assert: shape2 extent = (50 @ 50).! !

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 9/27/2012 19:12'!
testAdjustingShapeChain4

	| shape1 shape2 el |
	shape1 := ROBox blue.
	shape2 := ROBox green.
	el := ROElement new.
	el + shape1 + shape2.
	
	el extent: 50 @ 50.
	shape1 extent: 70 @ 70.
	
	self assert: el extent = (70 @ 70).
	self assert: shape1 extent = (70 @ 70).	
	self assert: shape2 extent = (50 @ 50).! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:42'!
testCompose
	| shape1 shape2 shape3 |

	shape1 := ROBox new.
	shape2 := ROLabel.
	shape3 := shape1 compose: shape2.
	
	self assert: shape3 == shape1.
	self deny: shape3 next == shape2.
	self assert: (shape1 next isKindOf: shape2).
! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:42'!
testCompose2
	| shape1 shape2 shape3 |

	shape1 := ROBox.
	shape2 := ROLabel new.
	shape3 := shape1 compose: shape2.
	
	self deny: shape3 == shape1.
	self assert: (shape3 isKindOf: shape1).
	self assert: shape3 next == shape2.! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:42'!
testCompose3
	| shape1 shape2 shape3 |

	shape1 := ROBox.
	shape2 := ROLabel.
	shape3 := shape1 compose: shape2.
	
	self deny: shape3 == shape1.
	self assert: (shape3 isKindOf: shape1).
	self deny: shape3 next == shape2.
	self assert: (shape3 next isKindOf: shape2).
! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:43'!
testCompose4
	| shape1 shape2 shape3 |

	shape1 := ROBox new.
	shape2 := ROLabel new.
	shape3 := shape1 compose: shape2.
	
	self assert: shape3 == shape1.
	self assert: shape3 next == shape2.! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'AlexandreBergel 5/6/2013 18:08'!
testComposeAllElementShapes
	| elementShapes composition element view excludedShapes |

	view := ROView new.
	excludedShapes := Array with: ROMiniMapDisplayer with: ROImage with: ROViewDisplayer.
	elementShapes := ROShape withAllSubclasses reject: [: e |
			(e isAbstract or: [ e isEdgeShape ]) or: [ excludedShapes anySatisfy: [ :ee | ee == e ] ] ].
	composition := elementShapes first.
	composition := elementShapes inject: composition into: [ :subComposition :shape |
		subComposition + shape + shape new ].
	composition := composition.

	element := ROElement new.
	element + composition.
	view add: element.
	view drawOn: ROTracingCanvas new.
	
	self assert: ((element shapes collect: #class) includesAll: elementShapes).! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:45'!
testPlus
	| shape1 shape2 shape3 |

	shape1 := ROBox new.
	shape2 := ROLabel.
	shape3 := shape1 + shape2.
	
	self assert: shape3 == shape1.
	self deny: shape3 next == shape2.
	self assert: (shape1 next isKindOf: shape2).
! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:45'!
testPlus2
	| shape1 shape2 shape3 |

	shape1 := ROBox.
	shape2 := ROLabel new.
	shape3 := shape1 + shape2.
	
	self deny: shape3 == shape1.
	self assert: (shape3 isKindOf: shape1).
	self assert: shape3 next == shape2.! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:45'!
testPlus3
	| shape1 shape2 shape3 |

	shape1 := ROBox.
	shape2 := ROLabel.
	shape3 := shape1 + shape2.
	
	self deny: shape3 == shape1.
	self assert: (shape3 isKindOf: shape1).
	self deny: shape3 next == shape2.
	self assert: (shape3 next isKindOf: shape2).
! !

!ROShapeTest methodsFor: 'compose shapes' stamp: 'JurajKubelka 4/19/2013 12:45'!
testPlus4
	| shape1 shape2 shape3 |

	shape1 := ROBox new.
	shape2 := ROLabel new.
	shape3 := shape1 + shape2.
	
	self assert: shape3 == shape1.
	self assert: shape3 next == shape2.! !

!ROShapeTest methodsFor: 'remove shape' stamp: 'VanessaPena 3/12/2013 15:30'!
testRemoveShape
	| b c removedElement |
	b := ROBox new.
	c := ROEllipse new.
	b addLast: c.

	self assert: b next == c.
	removedElement := b removeShape: ROEllipse.
	
	self assert: removedElement == c.
	self assert: (b next isKindOf: RONullShape) ! !

!ROShapeTest methodsFor: 'remove shape' stamp: 'VanessaPena 3/12/2013 15:30'!
testRemoveShape2
	| b c b2 |
	b := ROBox new.
	c := ROEllipse new.
	b addLast: c.
	b2 := b removeShape: ROBox.
	
	self assert: b2 == c.
	self assert: (b2 next isKindOf: RONullShape)! !

ROTest subclass: #ROTracingCanvasTest
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROTracingCanvasTest methodsFor: 'running' stamp: 'AlexandreBergel 12/14/2012 13:31'!
setUp

	canvas := ROTracingCanvas new.! !

!ROTracingCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/14/2012 16:24'!
testColToString

	self assert: (canvas colToStr: Color white) = 'Color white'.
	self assert: (canvas colToStr: Color red) = 'Color red'! !

!ROTracingCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/14/2012 13:32'!
testRecToString

	self assert: (canvas recToStr: ((3 @ 6) corner: (10 @ 30))) = '(3@6) corner: (10@30)'! !

ROTest subclass: #ROTranslationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROTranslationTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/24/2013 08:54'!
testDraggingOnTheTopLeftCorner
	| view outterNode innerNode1 innerNode2 |
	view := ROView new.
	view @ RODraggable.
	
	outterNode := ROElement new.
	outterNode + (ROBox new extent: 50 @ 50).
	
	innerNode1 := ROElement new.
	innerNode1 + (ROBox blue extent: 10 @ 10).
	
	innerNode2 := ROElement new.
	innerNode2 + (ROBox green extent: 10 @ 10).

	outterNode add: innerNode1.
	outterNode add: innerNode2.
	
	view add: outterNode.
	" view open "	

	"Witout dragging"
	self assert: innerNode1 position = (5 @ 5).
	self assert: innerNode2 position = (5 @ 5).

	"Dragging innerNode"
	innerNode1 translateBy: -10 @ -10.
	self assert: innerNode1 position = (0 @ 0).
	self assert: innerNode2 position = (10 @ 10).! !

ROTest subclass: #ROViewStructureTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROViewStructureTest methodsFor: 'running' stamp: 'AlexandreBergel 7/24/2012 17:35'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROViewStructureTest methodsFor: 'frame' stamp: 'VanessaPena 4/12/2013 11:48'!
testAddFrame

	|parent child|
	parent := ROMondrianFrame new.
	child := ROMondrianFrame new.
	self assert: parent children size = 0.
	parent addChild: child.
	child parent: parent.
	self assert: parent children size = 1.
	self assert: parent children first = child.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:37'!
testBasic

	view nodes: (1 to: 4).
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 4.
	
	view nodes: (5 to: 10).
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 10.! !

!ROViewStructureTest methodsFor: 'looking up' stamp: 'AlexandreBergel 7/25/2012 10:29'!
testFrameOfElement

	| outterNodes outterFrame firstInnerFrame secondInnerFrame |
	outterNodes := view nodes: #(10 11) forEach: [ :e | view nodes: (1 to: 5) ].
	
	outterFrame := view structureTree.
	outterNodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == outterFrame ].
	
	firstInnerFrame := outterFrame children first.
	firstInnerFrame nodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == firstInnerFrame ].

	secondInnerFrame := outterFrame children second.
	secondInnerFrame nodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == secondInnerFrame ].
! !

!ROViewStructureTest methodsFor: 'looking up' stamp: 'AlexandreBergel 7/25/2012 16:44'!
testFrameOfElementNotFound

	self assert: (view structureTree frameOfElement: ROElement new) == view structureTree
! !

!ROViewStructureTest methodsFor: 'initialization' stamp: 'AlexandreBergel 7/24/2012 17:54'!
testInitialization

	self assert: view numberOfFrames = 1.
	! !

!ROViewStructureTest methodsFor: 'initialization' stamp: 'AlexandreBergel 7/24/2012 17:44'!
testInitializationFrame

	self assert:  ROMondrianFrame new parent isNil! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 10:06'!
testLayout

	| node innerNodes outerFrame innerFrame |
	view nodes: #(10 11) forEach: [ :each | view nodes: (1 to: 5) ].
	view treeLayout.
	
	outerFrame := view structureTree.
	self assert: outerFrame layout class == ROTreeLayout.
	
	innerFrame := outerFrame children anyOne.
	self assert: innerFrame layout class == ROHorizontalLineLayout ! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:46'!
testNesting

	view node: 10 forIt: [ view nodes: (1 to: 5) ].

	self assert: view numberOfFrames = 2.
	self assert: view structureTree numberOfElements = 1.
	
	self assert: (view structureTree numberOfChildren = 1).
	self assert: (view structureTree children first numberOfElements = 5).
! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:48'!
testNesting2

	| node innerNodes |
	node := view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5) ].

	self assert: view structureTree elements first == node.
	self assert: (view structureTree children first elements = innerNodes).
! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 10:07'!
testNesting3

	view nodes: #(1 2) forEach: [ :e | view nodes: (1to: 3)].
	
	self assert: view structureTree numberOfElements = 2.
	self assert: view structureTree numberOfFrames = 3.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 10:45'!
testNestingWithEdges

	| innerNodes edge innerFrame |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). edge := view edgeFromAssociation: 1->3  ].

	innerFrame := view structureTree children first.
	self assert: (innerFrame numberOfElements = 6).
	self assert: (innerFrame edges size = 1).
	self assert: (innerFrame edges anyOne == edge).
	
	self assert: (innerFrame nodes = innerNodes).
	self assert: (innerFrame edges first == edge).! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 4/24/2013 08:33'!
testNoLayout

	| innerNodes |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). view horizontalLineLayout ].
	
	"We haven't done a layout still"
	self assert: (view structureTree children first layout class == ROHorizontalLineLayout).
	self assert: (innerNodes allSatisfy: [ :n | n position = (5 @ 5)]) ! !

!ROViewStructureTest methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:36'!
testPoping

	view push.
	view pop.
	self assert: view currentFrame == view structureTree.
	! !

!ROViewStructureTest methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:36'!
testPushing

	self assert: view currentFrame == view structureTree. 
	
	view push.
	self assert: view currentFrame ~~ view structureTree.
	self assert: view currentFrame parent == view structureTree.! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 09:53'!
testRecursiveLayout

	| innerNodes positions |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). view horizontalLineLayout ].
	
	view applyLayout.
	 
	positions := OrderedCollection new.
	positions add: (5@5); add: (20@5); add: (35@5); add: (50@5); add: (65@5).
	self assert: (innerNodes collect: #position) = positions asArray.! !

!ROViewStructureTest methodsFor: 'frame' stamp: 'VanessaPena 4/12/2013 11:48'!
testRemoveFrame

	|parent child|
	parent := ROMondrianFrame new.
	child := ROMondrianFrame new.
	parent addChild: child.
	child parent: parent.
	self assert: parent children size = 1.
	self assert: parent children first = child.
	parent removeChild: child.
	self assert: parent children size = 0.	! !

!ROViewStructureTest methodsFor: 'frame' stamp: 'VanessaPena 4/12/2013 11:48'!
testRemoveFrameFromParent

	|parent child|
	parent := ROMondrianFrame new.
	child := ROMondrianFrame new.
	parent addChild: child.
	child parent: parent.
	self assert: parent children size = 1.
	self assert: parent children first = child.
	child removeFromParent.
	self assert: parent children size = 0.	! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'VanessaPena 4/12/2013 11:18'!
testRemoveNestedNode

	view node: 1forIt: [ view nodes: (1 to: 4)].
	self assert: view numberOfFrames = 2.
	self assert: view currentFrame numberOfElements = 1.
	self assert: view currentFrame children first numberOfElements = 4.
	
	view removeNode: 1.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 0.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'VanessaPena 4/12/2013 12:00'!
testRemoveNestedNodes

	view nodes: (1 to: 3)forEach: [ view nodes: (1 to: 4)].
	self assert: view numberOfFrames = 4.
	self assert: view currentFrame numberOfElements = 3.
	self assert: view currentFrame children first numberOfElements = 4.
	
	view removeNodes: (2 to: 3).
	self assert: view numberOfFrames = 2.
	self assert: view currentFrame numberOfElements = 1.
	self assert: view currentFrame children first numberOfElements = 4.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'VanessaPena 4/12/2013 11:11'!
testRemoveNode

	view node: 1.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 1.
	
	view removeNode: 1.
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 0.! !

ROTest subclass: #ROViewTest
	instanceVariableNames: 'node1 view emptyView node2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROViewTest subclass: #ROViewStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/1/2012 11:33'!
testNestingView

	| newView el mouseClickPosition |
	newView := ROView new.
	newView add: (el := ROElement sprite translateTo: 0@60).

	view := ROViewStack new.
	view addFirst: newView.
	
	self assert: (view elementAtRealPosition: 23@85) == el.
	self assert: (newView elementAtRealPosition: 23@85) == el.

	(ROZoomOutMove new on: newView).
	self assert: newView hasAnimation.
	newView doAllAnimationCycles.


	self assert: (view elementAtRealPosition: (53@103)) == el.
	self assert: (newView elementAtRealPosition: (53@103)) == el.
	
	ROZoomOutMove new on: newView.
	newView doAllAnimationCycles.
	ROZoomOutMove new on: newView.	
	newView doAllAnimationCycles.

	self assert: (view elementAtRealPosition: (109@131)) == el.

"	view openInWindow"! !

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 23:18'!
testOpening

	|  window |
	view := ROViewStack new.
	view add: (ROElement on: 'hello').
	window := view open.
	window delete! !

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 17:17'!
testZoomInAndDragAndDrop

	| newView el originalCameraBounds step |
	newView := ROView new.
	el := ROElement new extent: (5 @ 5).
	el + (ROBox new color: Color red).
	el @ RODraggable.
	newView add: el.
	el translateTo: 150 @ 100.

	view := ROViewStack new.
	view addFirst: newView.


	self assert: (el bounds = ( (150@100) corner: (155@105))).
	self assert: newView camera bounds = ( (0@0) corner: (500@500)).
	self assert: (newView camera virtualToRealPointNoTrunc: el position ) = (150 @ 100).
	
	
	"We simulate the zoom in"
	originalCameraBounds := newView camera bounds.
	step := 100 @ 100.
	newView camera bounds: ((originalCameraBounds topLeft + step) corner: (originalCameraBounds bottomRight - step)).
	newView signalUpdate.
	self assert: (el bounds = ( (150@100) corner: (155@105))).
	
	self assert: (((newView camera virtualToRealPointNoTrunc: el position ) -  (83.33333333333333@0.0)) < (0.1 @ 0.1)).
	self assert: newView camera bounds = ( (100@100) corner: (400@400)).
	
	
	el announce: (ROMouseDragging step: 20 @ 20 ).
	self assert: (el bounds = ( (162.0@112.0) corner: (167.0@117.0))).
	self assert: ((newView camera virtualToRealPointNoTrunc: el position ) - (103.33333333333333@20.0)) < (0.1 @ 0.1)! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 9/25/2012 15:01'!
setUp

	node1 := ROElement on: 'hello'.
	node1 extent: 40 @ 30.
	node1
		addShape: (ROBox new color: Color yellow);
		addShape: ROBorder new.
	node1 addInteraction: RODraggable.

	node2 := ROElement on: 'world'.
	node2 extent: 40 @ 30.
	node2
		addShape: (ROBox new color: Color green).
	node2 translateBy: 100@30.
	
	view := self viewClass new.
	view add: node1.
	view add: node2.
	
	emptyView := ROView new.! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/3/2012 22:34'!
testAddingNode

	self assert: emptyView numberOfElements isZero.
	emptyView add: ROElement new.
	self assert: emptyView numberOfElements = 1.
	
	emptyView add: ROElement new.
	self assert: emptyView numberOfElements = 2! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 15:21'!
testAddingNodes

	| element |
	element := ROElement new.
	self assert: emptyView elements isEmpty.
	3 timesRepeat: [ emptyView add: element ].
	self assert: emptyView elements size = 1.
! !

!ROViewTest methodsFor: 'animations' stamp: 'AlexandreBergel 5/2/2013 19:06'!
testAnimationWithDefaultStrategy

	| animation1 animation2 |
	animation1 := ROMotionMove new.
	animation2 := ROMotionMove new.
	view := ROView new.
	view addAnimation: animation1.
	view addAnimation: animation2.
	self assert: view numberOfAnimations = 2! !

!ROViewTest methodsFor: 'animations' stamp: 'AlexandreBergel 5/3/2013 08:37'!
testAnimationWithExclusiveStrategy

	| animation |
	view := ROView new.
	ROMotionMove new for: view initialSpeed: 5 @ 5.

	animation := ROMotionMove new.
	animation strategy: (ROAnimationExclusive instance).
	animation for: view initialSpeed: 15 @ 15.

	self assert: view numberOfAnimations = 1.
	self assert: view animations asArray = (Array with: animation)! !

!ROViewTest methodsFor: 'events' stamp: 'AlexandreBergel 6/9/2012 15:15'!
testAnnouncerInView

	self assert: (view instVarNamed: 'eventHandler') class == ROAnnouncer! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testCamera
	self assert: (view camera class == ROCamera)! !

!ROViewTest methodsFor: 'camera' stamp: 'DR 3/25/2013 21:58'!
testCameraHeight
	| camera alts |
	camera := view camera.
	self assert: camera position = (0@0).
	self assert: camera altitude asInteger = 229.
	
	"Due to the rounding"
	camera altitude: 230.
	alts := Array with: 229 with: 230.
	self assert: (alts includes: camera altitude asInteger).
	
	
	! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 3/20/2013 10:28'!
testChangingToBasicOrdering

	view zOrdering: (ROBasicZOrdering new).
	self assert: node1 zIndex = 0.
	self assert: node2 zIndex = 0.
	
	view zOrdering: (ROZOrdering new
							setZIndex: 1 if: [ :el | el == node1 ];
							setZIndex: 2 if: [ :el | el == node2 ];
							yourself).
	self assert: node1 zIndex = 1.
	self assert: node2 zIndex = 2.! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 18:12'!
testChangingZOrdering

	view zOrdering: (ROZOrdering new
							setZIndex: 1 if: [ :el | el == node1 ];
							setZIndex: 2 if: [ :el | el == node2 ];
							yourself).
	self assert: node1 zIndex = 1.
	self assert: node2 zIndex = 2.
	
	view zOrdering: (ROZOrdering new
							setZIndex: 1 if: [ :el | el == node2 ];
							setZIndex: 2 if: [ :el | el == node1 ];
							yourself).
	self assert: node1 zIndex = 2.
	self assert: node2 zIndex = 1.! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 15:25'!
testDefaultWindowSize

	self assert: (self viewClass new defaultWindowSize class == Point)! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/11/2012 21:08'!
testDefaultZOrdering

	self assert: node1 zIndex = 0. 
	self assert: node2 zIndex = 0.! !

!ROViewTest methodsFor: 'dragging' stamp: ''!
testDraggingElement
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	view on: RORefreshNeeded do: [ :event | t := true. ].
	self deny: t.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 9/4/2012 15:30'!
testDraggingElement2
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	"view := self viewClass new.
	view add: node1; add: node2."
	view on: RORefreshNeeded do: [ :event | t := true ].
	self deny: t.
	
	"Check signalUpdate, since this is what is used to update the view"
	self assert: el view == node1 view.
	el signalUpdate.
	self assert: t.
	t := false.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testDraggingView
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateByRealStep: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	"camera translateByRealStep: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500)."! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 1/2/2013 09:19'!
testDraggingViewAndPopupOnElement
	"
	self debug: #testDraggingViewAndPopupOnElement
	"
	
	| el popup |
	view := ROView new.
	el := ROElement spriteOn: 12.
	el @ ROPopup.
	view add: el.
	view 
			@ RODraggable;
			@ RODraggableWithVelocity.

	view camera windowSize: 500 @ 500.
	
	el announce: (ROMouseEnter new position: 0@0).
	self assert: view elements size = 2.
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	"We do a drag and drop of the view, and we mouse enter again"
	view translateBy: 50@60.
	el announce: (ROMouseEnter new realPosition: 50@60).
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	
	"
	view open
	"! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt

	self assert: (view elementAt: node1 bounds center) == node1.
	self assert: (view elementAt: node2 bounds center) == node2.
	self assert: (view elementAt: node2 bounds bottomRight + (1 @ 1)) == view ! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 21:07'!
testElementAt2

	node1 translateBy: (-20 @ -20).
	self assert: (view elementAt: (node1 bottomRight - (5@5))) == node1.
	! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 21:07'!
testElementAt3

	| node aPoint |
	node := ROElement sprite 
				extent: (100@100);
				add: (ROElement sprite).
	view add: node.
	self assert: (view elementAt: (node bottomRight - (5@5))) == node.
	
	node translateBy: -20 @ -20.
	aPoint := node bottomRight - (5@5).
	self assert: (node contains: aPoint).
	self assert: (view elementAt: aPoint) == node.
! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 14:28'!
testElementsToRenderDo
	| t |
	t := OrderedCollection new.
	view elementsToRenderDo: [ :el | t add: el ].
	
	self assert: t asArray = view elements.! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 14:28'!
testElementsToRenderReverseDo
	| t |
	t := OrderedCollection new.
	view elementsToRenderReverseDo: [ :el | t add: el ].
	
	self assert: t asArray = view elements reverse! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/3/2012 15:13'!
testEncompassingRectangle

	self assert: view encompassingRectangle = ((0@0) corner: (140@60)).
	
	node1 translateBy: 6@9.
	self assert: view encompassingRectangle = ((6@9) corner: (140@60)).! !

!ROViewTest methodsFor: 'events' stamp: ''!
testEvents

	| t |
	t := 0.
	view announce: RORefreshNeeded.
	self assert: t isZero.
	
	view on: RORefreshNeeded do: [ :event | t := t + 1 ].
	view announce: RORefreshNeeded.
	self assert: t = 1.
! !

!ROViewTest methodsFor: 'mondrian' stamp: 'AlexandreBergel 12/10/2012 20:00'!
testMondrian
	| rawView |
	view := ROMondrianViewBuilder new.
	view node: 'foo' forIt: [ 
		view nodes: (1 to: 2).
		view edgeFromAssociation: 1 -> 2.
	].
	view applyLayout.
	
	rawView := view raw.
	self assert: rawView numberOfElementsToRender = 4.! !

!ROViewTest methodsFor: 'animations' stamp: 'AlexandreBergel 5/2/2013 19:05'!
testNumberOfAnimation

	self assert: ROView new numberOfAnimations = 0.
	self assert: (ROView new addAnimation: ROMotionMove new; numberOfAnimations) = 1.
	! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 11/23/2012 08:35'!
testOpenInWindow
	| window |
	window := view open.
	window delete! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/10/2012 16:41'!
testOpenInWindowSized
	| window |
	[ window := view openInWindowSized: 400@30.
	 self assert: window extent >= (400@30).]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'overlapping' stamp: 'AlexandreBergel 9/28/2012 08:30'!
testOverlapping
	| greenNode |

	"greenNode is overlapping node1"
	greenNode := ROElement spriteOn: 'green node'.
	greenNode setBounds: (node1 bounds translateBy: 5@6 ).

	view add: greenNode.
	 
	"-----"
	self assert: (view elementAt: node1 bounds topLeft) == node1. 
	self assert: (view elementAt: greenNode bounds topLeft) == greenNode

	! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 2/23/2013 20:09'!
testRemovingAllElementToRender

	emptyView add: ROElement sprite.
	emptyView add: ROElement sprite.
	self assert: emptyView numberOfElementsToRender = 2.
	self assert: emptyView numberOfElements = 2.
	emptyView removeAllElementsToRender.
	self assert: emptyView numberOfElementsToRender = 0.
	self assert: emptyView numberOfElements = 2! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 06:40'!
testRemovingNestedRenderingElements
	| spr spr2 |
	spr := ROElement sprite.
	spr2 := ROElement sprite.
	spr add: spr2.
	emptyView add: spr.
	
	self assert: emptyView numberOfElementsToRender = 2.
	self assert: emptyView numberOfElements = 1.
	
	spr remove.
	self assert: emptyView numberOfElementsToRender = 0.
	self assert: emptyView numberOfElements = 0.
! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 06:27'!
testRemovingRenderingElements
	| spr |
	spr := ROElement sprite.
	emptyView add: spr.
	
	self assert: emptyView numberOfElementsToRender = 1.
	self assert: emptyView numberOfElements = 1.
	
	spr remove.
	self assert: emptyView numberOfElementsToRender = 0.
	self assert: emptyView numberOfElements = 0.
! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 11:49'!
testRemovingRenderingElementsAndPopup
	| spr |
	spr := ROElement sprite.
	spr @ ROPopup.
	self assert: emptyView numberOfElements = 0.
	emptyView add: spr.
	
	spr announce: ROMouseEnter.
	"Because the popup has two elements"
	self assert: emptyView numberOfElementsToRender = 3.
	self assert: emptyView numberOfElements = 2.
	
	spr announce: ROMouseLeave.
	self assert: emptyView numberOfElementsToRender = 1.
	self assert: emptyView numberOfElements = 1.
! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'VanessaPena 3/12/2013 15:30'!
testRendering

	| el1 el2 canvas |
	view := ROView new.
	el1 := ROElement new + ROBox.
	el1 extent: 30 @ 30.
	el2 := ROElement new + ROEllipse blue.
	el2 extent: 30 @ 30.
	
	view add: el1; add: el2.

	canvas := ROTracingCanvas new.
	view drawOn: canvas.
	
	self assert: canvas trace =   #(
			#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') 
			#(#frameAndFillRectangle: '(0@0) corner: (30@30)' 'Color veryLightGray' 0 'Color black') 
			#(#fillOval: '(0@0) corner: (30@30)' 0 'Color blue'))! !

!ROViewTest methodsFor: 'running' stamp: 'miltonmamani 4/17/2013 15:41'!
testRenderingElementAndDraggingView

	| el |
	view := ROView new.
	view add: (el := ROElement sprite).
	view windowSize: 500 @ 500.

	view @ RODraggable.
	view drawOn: RONullCanvas new.	
	self assert:  el isRendered.
	
	view announce: (ROMouseDragging step: -100 @ -100).

	view drawOn: RONullCanvas new.	
	self assert:  el isRendered.

	view announce: (ROMouseDragging step: 100 @ 100).
	view drawOn: RONullCanvas new.	
	self assert:  el isRendered.! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/10/2012 19:31'!
testRenderingElements
	emptyView add: ROElement sprite.
	self assert: emptyView numberOfElementsToRender = 1! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/10/2012 19:31'!
testRenderingElements2
	emptyView add: (ROElement sprite add: ROElement sprite).
	self assert: emptyView numberOfElementsToRender = 2! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:17'!
testRenderingElements3
	| spr |
	spr := ROElement sprite.
	emptyView add: spr.
	spr add: ROElement sprite.
	self assert: emptyView numberOfElementsToRender = 2.
! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:17'!
testRenderingElements4
	self deny: (ROElement sprite isRendered)! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:18'!
testRenderingElements5
	| spr |
	spr := ROElement sprite.
	emptyView add: spr.
	self assert: emptyView numberOfElementsToRender = 1.

	spr setAsNotRendered.
	self assert: emptyView numberOfElementsToRender = 0.
	self deny: spr isRendered.
	
	spr setAsRendered.
	self assert: emptyView numberOfElementsToRender = 1.
	self assert: spr isRendered.
	
! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:37'!
testRenderingElements6
	| spr1 spr2 edge |
	spr1 := ROElement sprite.
	spr2 := ROElement sprite.
	edge := ROEdge lineFrom: spr1 to:  spr2.
	emptyView add: spr1; add: spr2; add: edge.
	self assert: emptyView numberOfElementsToRender = 3.

	edge setAsNotRendered.
	self assert: emptyView numberOfElementsToRender = 2.
	self deny: edge isRendered.
	
	edge setAsRendered.
	self assert: emptyView numberOfElementsToRender = 3.
	self assert: edge isRendered.
	
! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:17'!
testRenderingElementsTesting
	| el |
	emptyView add: (el := ROElement sprite).
	self assert: (emptyView numberOfElementsToRender = 1).
	self assert: (emptyView isRendered: el).
	self assert: (el isRendered)! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/10/2012 19:43'!
testRenderingEmptyViewOnCanvas

	| canvas |
	canvas := ROTracingCanvas new.
	ROView new drawOn: canvas.
	self assert: canvas trace size = 1.
	self assert: canvas trace first  = #(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white')! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 4/24/2013 08:29'!
testRenderingNestedElementOnCanvas

	| canvas |
	canvas := ROTracingCanvas new.

	view := ROView new.
	view add: (ROElement sprite add: ROElement sprite).
	
	view drawOn: canvas.
	self assert: canvas trace size = 9.
	self assert: canvas trace asArray = 
	 #(
		#(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white') 
		#(#line '(0@0)' '(60@0)' 1 'Color red') 
		#(#line '(60@0)' '(60@60)' 1 'Color red') 
		#(#line '(60@60)' '(0@60)' 1 'Color red') 
		#(#line '(0@60)' '(0@0)' 1 'Color red') 
		#(#line '(5@5)' '(55@5)' 1 'Color red') 
		#(#line '(55@5)' '(55@55)' 1 'Color red') 
		#(#line '(55@55)' '(5@55)' 1 'Color red') 
		#(#line '(5@55)' '(5@5)' 1 'Color red')
	)
	! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 06:23'!
testRenderingOnCanvas

	| canvas |
	canvas := ROTracingCanvas new.
	view := ROView new.
	view add: ROElement sprite.
	view drawOn: canvas.
	self assert: canvas trace size = 5.
	self assert: canvas trace first  = #(#frameAndFillRectangle: '(0@0) corner: (40@30)' 'Color white' 0 'Color white').
	self assert: canvas trace second  = #(#line '(0@0)' '(50@0)' 1 'Color red').
	self assert: canvas trace third  = #(#line '(50@0)' '(50@50)' 1 'Color red').
	self assert: canvas trace fourth  = #(#line '(50@50)' '(0@50)' 1 'Color red').
	self assert: canvas trace fifth  =  #(#line '(0@50)' '(0@0)' 1 'Color red').! !

!ROViewTest methodsFor: 'rendering' stamp: 'AlexandreBergel 12/10/2012 19:15'!
testRenderingWithoutElement

	self assert: emptyView numberOfElementsToRender = 0.
	self assert: emptyView elementsToRender = #()! !

!ROViewTest methodsFor: 'events' stamp: 'AlexandreBergel 11/15/2012 16:25'!
testResizingViewAndEvent

	|  e oldExtent |
	view := ROView new.
	view on: ROWindowResized do: [ :event | e := event ].
	self assert: e isNil.
	
	oldExtent := view camera windowSize.
	view windowSize: 40 @ 60.
	self assert: e notNil.
	self assert: e class == ROWindowResized.
	self assert: e oldExtent = oldExtent.
	self assert: e extent = (40 @ 60)! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 13:26'!
testSortedCollection

	"We are just testing a property of the sorted collection. This is useful when migrating to other platform to see whether this important invariant is preserved or not"
	
	| col el1 el2 el3 |
	col := SortedCollection sortBlock: [ :a :b | a model < b model ].
	col add: (el1 := ROElement on: 1).
	col add: (el2 := ROElement on: 2).

	self assert: (col indexOf: el1) = 1.
	self assert: (col indexOf: el2) = 2.	
	
	col add: (el3 := ROElement on: 2).

	self assert: (col indexOf: el1) = 1.
	self assert: (col indexOf: el3) = 2.	
	self assert: (col indexOf: el2) = 3.	
! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 13:55'!
testSortingElements

	| nodes nodes2 |
	
	nodes := ROElement forCollection: #(1 2 3).
	emptyView addAll: nodes.
	
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(1 2 3).
	
	emptyView sortElementsWith: [ :a :b | a model > b model ].
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(3 2 1).
! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testTranslatingCamera
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateBy: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	camera translateBy: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500).! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testVisibleBounds
	| window |
	self assert: view camera bounds = ( 0@0 corner: 500@500).
	window := view open.
	window delete.
	self assert: view camera bounds = ( 0@0 corner: 500@500).

	! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 4/30/2012 15:26'!
testWindowTitle

	| window |
	window := (view := self viewClass titled: 'Hello World') open.
	[ self assert: window labelString = 'Hello World'.
	  self assert: view title = 'Hello World' ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testWindowTitleDefault

	| window |
	window := self viewClass new open.
	[ self assert: window labelString = ROView defaultWindowTitle ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/11/2012 21:07'!
testzOrderingError

	self assert: (view numberOfElements > 0).
	self shouldnt: [ view zOrdering: ROZOrdering new ] raise: Error! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 4/30/2012 15:25'!
viewClass
	^ ROView! !

ROTest subclass: #ROVisitorTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

ROVisitorTest subclass: #ROCountingVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

!ROCountingVisitorTest methodsFor: 'tests' stamp: ''!
test

	| visitor |
	visitor := ROCountingVisitor new.
	self assert: visitor nbOfEdges isZero.
	self assert: visitor nbOfNodes isZero.
	
	visitor runOn: view.
	
	self assert: visitor nbOfEdges = 3.
	self assert: visitor nbOfNodes = 5.
! !

!ROVisitorTest class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self name == #ROVisitorTest! !

!ROVisitorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/17/2012 17:02'!
setUp

	| elements |
	view := ROView new.
	elements := ROElement forCollection: (1 to: 5).
	elements do: [ :el | el + ROBox ].
	view addAll: elements.
	view addAll: (ROEdge linesFor: 
		(Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third ))! !

!ROVisitorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/21/2012 08:52'!
test

	| visitor |
	visitor := ROVisitor new.	
	visitor runOn: view.! !

ROTest subclass: #ROZOrderingTest
	instanceVariableNames: 'zordering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROZOrderingTest methodsFor: 'running' stamp: 'AlexandreBergel 12/3/2012 21:05'!
setUp
	super setUp.
	zordering := ROZOrdering new! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/13/2012 18:14'!
test

	| view c1 c2 c3 c4 |
	zordering setZIndex: 10 if: #isEdge.
	zordering setZIndex: 20 if: #isNotEdge.
	view := ROView new.
	view zOrdering: zordering.

	view add: (c1 := ROEdge new). 
	view add: (c2 := ROElement new).
	view add: (c3 := ROEdge new).
	view add: (c4 := ROElement new).
	
	self assert: c1 zIndex = 10.
	self assert: c2 zIndex = 20.
	self assert: c3 zIndex = 10.
	self assert: c4 zIndex = 20.
	
	self assert: view zOrdering == zordering.
	
	self assert: view numberOfElementsToRender = 4.
	self assert: view elementsToRender = (Array with: c1 with: c3 with: c2 with: c4)! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/3/2012 21:06'!
testDefault
	self assert: (zordering zIndexOf: ROElement new) = 0! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/13/2012 18:14'!
testDefaultValue
	zordering setZIndex: 10 if: true.
	self assert: zordering numberOfEntries = 1.
	self assert: (zordering zIndexOf: ROElement new) = 10! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/25/2013 08:31'!
testDefaultValueWithoutIf
	zordering setZIndex: 10.
	self assert: zordering numberOfEntries = 1.
	self assert: (zordering zIndexOf: ROElement new) = 10! !

!ROZOrderingTest methodsFor: 'dynamic' stamp: 'AlexandreBergel 12/13/2012 18:14'!
testDynamic

	| el1 el2 |
	zordering setZIndex: [ :element | element depth + 1 ] if: true.
	
	el1 := ROElement new.
	el2 := ROElement new.
	el1 add: el2.
	
	self assert: (zordering zIndexOf: el1) = 2.
	self assert: (zordering zIndexOf: el2) = 3.! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/3/2012 21:05'!
testInitialization
	self assert: zordering numberOfEntries = 0! !

!ROZOrderingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/10/2012 20:09'!
testView

	self assert: ROView new zOrdering notNil! !

ROTest subclass: #ROZoomIntoElementOnClickTest
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 10:32'!
setUp

	stack := ROViewStack new.! !

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 11:13'!
testAddView

	|view viewToAdd zoom|
	view := ROView new.
	viewToAdd := ROView new.
	zoom := ROZoomIntoElementOnClick new stack: stack; view: viewToAdd.
	view add: (ROElement sprite @zoom).
	stack addView: view.
	
	view elements first announce: ROMouseLeftClick.
	view doAllAnimationCycles.
		
	self assert: (stack viewsSize = 2).
	self assert: (stack firstView = viewToAdd )
	! !

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 11:13'!
testAddViewAsBlock

	|view zoom|
	view := ROView new.
	zoom := ROZoomIntoElementOnClick new.
	zoom 
		stack: stack; 
		view: [:el | |v|
			v := ROView new.
			v			
			].
	view add: (ROElement sprite @zoom).
	stack addView: view.
	
	view elements first announce: ROMouseLeftClick.
	view doAllAnimationCycles.
		
	self assert: (stack viewsSize = 2).
	self assert: (stack firstView elements size = 0)
	! !

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 12:39'!
testRecursive

	|view zoom|
	view := ROView new.
	zoom := ROZoomIntoElementOnClick new.
	zoom 
		stack: stack; 
		view: [:el | 
			|v| 
			v := ROView new.
			v add: ROElement sprite.		
			v];
		recursive: true.
	view add: (ROElement sprite @zoom).
	stack addView: view.
	
	(1 to: 2) do: [:n | 
			stack firstView elements first announce: ROMouseLeftClick.
			stack firstView doAllAnimationCycles.
			self assert: (stack viewsSize = (n +1)).
		].
	(1 to: 2) do: [:n | 
			stack firstView announce: ROMouseRightClick.
			stack firstView doAllAnimationCycles.
			self assert: (stack viewsSize = (3 - n)).
		].! !

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 11:28'!
testRemoveView

	|view zoom viewToAdd|
	view := ROView new.
	zoom := ROZoomIntoElementOnClick new.
	zoom 
		stack: stack; 
		view: (viewToAdd := ROView new).
	viewToAdd add: ROElement sprite.
	view add: (ROElement sprite @zoom).
	stack addView: view.
	
	view elements first announce: ROMouseLeftClick.
	view doAllAnimationCycles.
		
	self assert: (stack viewsSize = 2).
	self assert: (stack firstView = viewToAdd).
	
	viewToAdd announce: ROMouseRightClick.
	viewToAdd doAllAnimationCycles.
			
	self assert: (stack viewsSize = 1).
	self assert: (stack firstView = view).
	! !

!ROZoomIntoElementOnClickTest methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/8/2013 13:07'!
testZoomMove

	|view move|
	view := ROView new.
	view camera bounds: (0@0 corner: 200@200).
	move := ROZoomMove new.
	move nbCycles: 10.
	move on: view to: (0@0 corner: 50@50).

	
	(1 to: 10) do: [:n | move doStep].
	
	self assert: (view camera bounds = (0@0 corner: 50@50)).
	! !

ROTest subclass: #ROZoomOnClickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROZoomOnClickTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:11'!
testZoomOnClick

	| view |
	view := ROView new.
	view add: (ROElement sprite @ ROZoomOnClick ).
	
	view elements first announce: ROMouseClick! !

ROTest subclass: #RoassalExporterHTMLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter-Tests'!

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 16:13'!
testCircle

	|view element visitor|
	view := ROView new.
	element := (ROElement new on: 'My Model') + (ROEllipse new color: Color green).
	view add: element.
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents = ' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "My Model", nodeWidth: 5, nodeHeight: 5, x: 0, y: 0, nodeParentID: 0, draggable: "false"},
{ nodeID: 2, nodeParentID: 1, nodeShape: "ROEllipse", nodeWidth: 5, nodeHeight: 5, x: 0, y: 0, nodeFillColor: "#00FF00", nodeBorderColor: "#000000", nodeBorderWidth: "0", draggable: "false"}, ], ').
	self assert: (visitor linksStream contents = ' links:[  ] ')
	! !

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'VanessaPena 1/31/2013 18:22'!
testLabel

	|view element visitor w|
	view := ROView new.
	element := (ROElement spriteOn: 'My Model') + ROLabel.
	view add: element.
	w := element width.
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents = (' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "My Model", nodeWidth: ', w printString ,', nodeHeight: 50, x: 0, y: 0, nodeParentID: 0, draggable: "true"},
{ nodeID: 2, nodeParentID: 1, nodeModel: "My Model", nodeShape: "ROLabel", nodeWidth: ', w printString ,', nodeHeight: 50, x: 0, y: 10, nodeFillColor: "none", nodeBorderColor: "#000000", draggable: "true"},{ nodeID: 3, nodeParentID: 1, nodeShape: "ROBorder", nodeWidth: ', w printString ,', nodeHeight: 50, x: 0, y: 0, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"}, ], ')).

	self assert: (visitor linksStream contents = ' links:[  ] ')
	! !

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'miltonmamani 4/17/2013 14:56'!
testLinks

	|view node1 node2 visitor edge|
	view := ROView new.
	node1 := (ROElement spriteOn: 'node1') + (ROBox new color: (Color r: 0 g: 0 b: 1)).
	node2 := (ROElement spriteOn: 'node2') + (ROBox new color: (Color r: 0 g: 0 b: 1)).
	node2 translateBy: 200@200.
	edge := ROEdge  from: node1 to: node2.
	edge + (ROLine new color: Color black).
	view add: node1; add: node2; add: edge.
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents = ' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "node1", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeParentID: 0, draggable: "true"},
{ nodeID: 2, nodeParentID: 1, nodeShape: "ROBox", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeFillColor: "#0000FF", nodeBorderColor: "#000000", nodeBorderWidth: "0", draggable: "true"},{ nodeID: 3, nodeParentID: 1, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 5, nodeShape: "ROElement", nodeModel: "node2", nodeWidth: 50, nodeHeight: 50, x: 200, y: 200, nodeParentID: 0, draggable: "true"},
{ nodeID: 6, nodeParentID: 5, nodeShape: "ROBox", nodeWidth: 50, nodeHeight: 50, x: 200, y: 200, nodeFillColor: "#0000FF", nodeBorderColor: "#000000", nodeBorderWidth: "0", draggable: "true"},{ nodeID: 7, nodeParentID: 5, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 200, y: 200, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"}, ], ').
	self assert: (visitor linksStream contents = ' links:[ { sourceID: "1", targetID: "5", edgeColor: "#000000", edgeWidth: "1"}, ] ')! !

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'VanessaPena 1/31/2013 18:16'!
testNestedNodes

	|view element visitor children|
	view := ROView new.
	element := (ROElement on: 'parent') + ROBorder new.
	children := ROElement spritesOn: (1 to: 6).
	element addAll: children.
	ROGridLayout new on: element elements .
	view add: element .
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents = ' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "parent", nodeWidth: 180, nodeHeight: 120, x: 0, y: 0, nodeParentID: 0, draggable: "false"},
{ nodeID: 2, nodeParentID: 1, nodeShape: "ROBorder", nodeWidth: 180, nodeHeight: 120, x: 0, y: 0, nodeFillColor: "none", nodeBorderColor: "#000000", draggable: "false"},{ nodeID: 4, nodeShape: "ROElement", nodeModel: "1", nodeWidth: 50, nodeHeight: 50, x: 5, y: 5, nodeParentID: 1, draggable: "true"},
{ nodeID: 5, nodeParentID: 4, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 5, y: 5, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 7, nodeShape: "ROElement", nodeModel: "2", nodeWidth: 50, nodeHeight: 50, x: 65, y: 5, nodeParentID: 1, draggable: "true"},
{ nodeID: 8, nodeParentID: 7, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 65, y: 5, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 10, nodeShape: "ROElement", nodeModel: "3", nodeWidth: 50, nodeHeight: 50, x: 125, y: 5, nodeParentID: 1, draggable: "true"},
{ nodeID: 11, nodeParentID: 10, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 125, y: 5, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 13, nodeShape: "ROElement", nodeModel: "4", nodeWidth: 50, nodeHeight: 50, x: 5, y: 65, nodeParentID: 1, draggable: "true"},
{ nodeID: 14, nodeParentID: 13, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 5, y: 65, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 16, nodeShape: "ROElement", nodeModel: "5", nodeWidth: 50, nodeHeight: 50, x: 65, y: 65, nodeParentID: 1, draggable: "true"},
{ nodeID: 17, nodeParentID: 16, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 65, y: 65, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 19, nodeShape: "ROElement", nodeModel: "6", nodeWidth: 50, nodeHeight: 50, x: 125, y: 65, nodeParentID: 1, draggable: "true"},
{ nodeID: 20, nodeParentID: 19, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 125, y: 65, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"}, ], ').
	self assert: (visitor linksStream contents = ' links:[  ] ')! !

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'VanessaPena 1/31/2013 18:18'!
testNestedNodes2

	|view element visitor children|
	view := ROView new.
	element := (ROElement on: 'parent') + ROBorder new.
	children := ROElement spritesOn: (1 to: 2).
	element addAll: children.
	children do: [:node | 
		node addAll: (ROElement spritesOn: (1 to: 3)).
		ROGridLayout new on: node elements.
	].
	ROGridLayout new on: element elements.
	view add: element .
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents = ' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "parent", nodeWidth: 260, nodeHeight: 130, x: 0, y: 0, nodeParentID: 0, draggable: "false"},
{ nodeID: 2, nodeParentID: 1, nodeShape: "ROBorder", nodeWidth: 260, nodeHeight: 130, x: 0, y: 0, nodeFillColor: "none", nodeBorderColor: "#000000", draggable: "false"},{ nodeID: 4, nodeShape: "ROElement", nodeModel: "1", nodeWidth: 120, nodeHeight: 120, x: 5, y: 5, nodeParentID: 1, draggable: "true"},
{ nodeID: 5, nodeParentID: 4, nodeShape: "ROBorder", nodeWidth: 120, nodeHeight: 120, x: 5, y: 5, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 7, nodeShape: "ROElement", nodeModel: "1", nodeWidth: 50, nodeHeight: 50, x: 10, y: 10, nodeParentID: 4, draggable: "true"},
{ nodeID: 8, nodeParentID: 7, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 10, y: 10, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 10, nodeShape: "ROElement", nodeModel: "2", nodeWidth: 50, nodeHeight: 50, x: 70, y: 10, nodeParentID: 4, draggable: "true"},
{ nodeID: 11, nodeParentID: 10, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 70, y: 10, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 13, nodeShape: "ROElement", nodeModel: "3", nodeWidth: 50, nodeHeight: 50, x: 10, y: 70, nodeParentID: 4, draggable: "true"},
{ nodeID: 14, nodeParentID: 13, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 10, y: 70, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 16, nodeShape: "ROElement", nodeModel: "2", nodeWidth: 120, nodeHeight: 120, x: 135, y: 5, nodeParentID: 1, draggable: "true"},
{ nodeID: 17, nodeParentID: 16, nodeShape: "ROBorder", nodeWidth: 120, nodeHeight: 120, x: 135, y: 5, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 19, nodeShape: "ROElement", nodeModel: "1", nodeWidth: 50, nodeHeight: 50, x: 140, y: 10, nodeParentID: 16, draggable: "true"},
{ nodeID: 20, nodeParentID: 19, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 140, y: 10, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 22, nodeShape: "ROElement", nodeModel: "2", nodeWidth: 50, nodeHeight: 50, x: 200, y: 10, nodeParentID: 16, draggable: "true"},
{ nodeID: 23, nodeParentID: 22, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 200, y: 10, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"},{ nodeID: 25, nodeShape: "ROElement", nodeModel: "3", nodeWidth: 50, nodeHeight: 50, x: 140, y: 70, nodeParentID: 16, draggable: "true"},
{ nodeID: 26, nodeParentID: 25, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 140, y: 70, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"}, ], ').
	self assert: (visitor linksStream contents = ' links:[  ] ')! !

!RoassalExporterHTMLTest methodsFor: 'tests' stamp: 'VanessaPena 3/12/2013 16:13'!
testShapeComposition

	|view element visitor|
	view := ROView new.
	element := (ROElement spriteOn: 'My Model') + (ROEllipse new color: Color green).
	view add: element.
	visitor := ROHTMLVisitor new runOn: view.
	self assert: (visitor nodesStream contents =' nodes:[ { nodeID: 1, nodeShape: "ROElement", nodeModel: "My Model", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeParentID: 0, draggable: "true"},
{ nodeID: 2, nodeParentID: 1, nodeShape: "ROEllipse", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeFillColor: "#00FF00", nodeBorderColor: "#000000", nodeBorderWidth: "0", draggable: "true"},{ nodeID: 3, nodeParentID: 1, nodeShape: "ROBorder", nodeWidth: 50, nodeHeight: 50, x: 0, y: 0, nodeFillColor: "none", nodeBorderColor: "#FF0000", draggable: "true"}, ], ').
	self assert: (visitor linksStream contents = ' links:[  ] ')
	! !

ROTest subclass: #RoassalExporterSVGTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter-Tests'!

!RoassalExporterSVGTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/4/2013 08:45'!
testBasic

	|view edges n1 n2 n3 canvas|
	view := ROView new.
	n1 := ROElement spriteOn: 1.
	n2 := ROElement spriteOn: 2.
	n3 := ROElement spriteOn: 3.
	edges := ROEdge linesFor: (Array with: (n1 -> n2) with: (n1 -> n3)).
	edges do: [:e | (e getShape: ROLine) color: Color blue].
	view add: n1; add: n2; add: n3; addAll: edges.
	ROTreeLayout on: view elements.	

	canvas := ROSVGCanvas onCamera: view camera.
	canvas view: view.
	canvas addStart.
	view drawOn: canvas.
	canvas addEnd.
	
	self assert:  canvas stream contents = '<svg  xmlns="http://www.w3.org/2000/svg" width="110.0px" height="127px" 
	xmlns:xlink="http://www.w3.org/1999/xlink">
<rect x="5" y="5" height="120" width="103" style="fill:rgb(256,256,256)"/>
<line x1="31" y1="5" x2="81" y2="5" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="81" y1="5" x2="81" y2="55" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="81" y1="55" x2="31" y2="55" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="31" y1="55" x2="31" y2="5" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="5" y1="75" x2="55" y2="75" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="55" y1="75" x2="55" y2="125" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="55" y1="125" x2="5" y2="125" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="5" y1="125" x2="5" y2="75" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="58" y1="75" x2="108" y2="75" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="108" y1="75" x2="108" y2="125" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="108" y1="125" x2="58" y2="125" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="58" y1="125" x2="58" y2="75" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="55" y1="100" x2="56" y2="55" style="stroke:rgb(0,0,256);stroke-width:1"/>
<line x1="83" y1="75" x2="56" y2="55" style="stroke:rgb(0,0,256);stroke-width:1"/>
</svg>'! !

!RoassalExporterSVGTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/4/2013 08:45'!
testLine

	|view n1 n2 canvas edge|
	view := ROView new.
	n1 := (ROElement on: 'n1') + (ROBox new color: Color red).
	n2 := (ROElement on: 'n2') + (ROBox new color: Color red).
	n2 translateBy: 100@100.
	edge := ROEdge from: n1 to: n2.
	edge + (ROLine red).
	view add: n1; add: n2; add: edge.
	
	canvas := ROSVGCanvas onCamera: view camera.
	canvas view: view.
	canvas addStart.
	view drawOn: canvas.
	canvas addEnd.
	
	self assert: canvas stream contents = '<svg  xmlns="http://www.w3.org/2000/svg" width="107px" height="107px" 
	xmlns:xlink="http://www.w3.org/1999/xlink">
<rect x="0" y="0" height="105" width="105" style="fill:rgb(256,256,256)"/>
<rect x="0" y="0" height="5" width="5" style="fill:rgb(256,0,0)"/>
<rect x="100" y="100" height="5" width="5" style="fill:rgb(256,0,0)"/>
<line x1="100" y1="102" x2="2" y2="5" style="stroke:rgb(256,0,0);stroke-width:1"/>
</svg>'! !

!RoassalExporterSVGTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/4/2013 08:45'!
testNesting

	|view node ch1 ch2 ch3 canvas|
	view := ROView new.
	node := ROElement spriteOn: 'node'.
	ch1 := (ROElement on: 'ch1') + (ROBox new color: Color green).
	ch2 := (ROElement on: 'ch2') + (ROBox new color: Color green).
	ch3 := (ROElement on: 'ch3') + (ROBox new color: Color green).
	node add: ch1; add: ch2; add: ch3.
	ROGridLayout on: node elements.
	view add: node.

	canvas := ROSVGCanvas onCamera: view camera.
	canvas view: view.
	canvas addStart.
	view drawOn: canvas.
	canvas addEnd.

	
	self assert: canvas stream contents = '<svg  xmlns="http://www.w3.org/2000/svg" width="52px" height="52px" 
	xmlns:xlink="http://www.w3.org/1999/xlink">
<rect x="0" y="0" height="50" width="50" style="fill:rgb(256,256,256)"/>
<line x1="0" y1="0" x2="50" y2="0" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="50" y1="0" x2="50" y2="50" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="50" y1="50" x2="0" y2="50" style="stroke:rgb(256,0,0);stroke-width:1"/>
<line x1="0" y1="50" x2="0" y2="0" style="stroke:rgb(256,0,0);stroke-width:1"/>
<rect x="5" y="5" height="5" width="5" style="fill:rgb(0,256,0)"/>
<rect x="20" y="5" height="5" width="5" style="fill:rgb(0,256,0)"/>
<rect x="5" y="20" height="5" width="5" style="fill:rgb(0,256,0)"/>
</svg>'! !

!RoassalExporterSVGTest methodsFor: 'tests' stamp: 'miltonmamani 4/17/2013 14:57'!
testOval

	|view n1 canvas |
	view := ROView new.
	n1 := (ROElement on: 1) + (ROEllipse new color: (Color r: 0 g: 0.5 b: 0.5)); yourself .
	n1 size: 200.
	view add: n1.
	
	canvas := ROSVGCanvas onCamera: view camera.
	canvas view: view.
	canvas addStart.
	view drawOn: canvas.
	canvas addEnd.

	self assert: canvas stream contents = '<svg  xmlns="http://www.w3.org/2000/svg" width="202px" height="202px" 
	xmlns:xlink="http://www.w3.org/1999/xlink">
<rect x="0" y="0" height="200" width="200" style="fill:rgb(256,256,256)"/>
<ellipse cx= "100" cy="100" rx="100" ry="100" style="fill:rgb(0,128,128);stroke: rgb(0,0,0);stroke-width: 0"/>
</svg>'! !

TestCase subclass: #ROTreeMapLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/4/2012 15:23'!
testBasicNodePositioning
	| layout view nodes edges root |
	
	"Setting up..."
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 400; height: 400.
	view nodes: (0 to: 76).
	edges := view edgesFrom: [ :each | each // 10 ].
	view layout: layout.	
	nodes := view nodes.
	root := nodes first.
	view applyLayout.
	nodes := layout recursiveChildrenSortedFor: root.
	
	"Check dimensions and position of root node."
      self assert: root extent = (400 @ 400).
	self assert: root bounds = ((5@5) corner: (405@405)).
	
	"These are relative bounds (to containment nodes bounds)."
	self assert: (nodes at: 1) bounds = ((5@5) corner: (44@91)).
	self assert: (nodes at: 2) bounds = ((43@5) corner: (122@91)).
	self assert: (nodes at: 3) bounds = ((121@5) corner: (238@91)).
	self assert: (nodes at: 8) bounds = ((126@177) corner: (252@395)).
	self assert: (nodes at: 33) bounds = ((5@46) corner: (29@81)).
	self assert: (nodes at: 49) bounds = ((102@53) corner: (153@81)).
	self assert: (nodes at: 67) bounds = ((47@79) corner: (117@106)).
	self assert: (nodes at: 76) bounds = ((223@5) corner: (264@83)).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/11/2012 14:39'!
testDeepNesting
	| layout view nodes interval o |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	layout inset: 5.
	layout minInset: 3.
	interval := 1 to: 30.
	view := ROMondrianViewBuilder new.
	view shape size: 240.
	view nodes: interval.
	o := OrderedCollection new.
	interval do: [ :each | o add: each -> (each+1)].
	view edgesFromAssociations: o.
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	
	self assert: (nodes at: 1) extent = (240@240).
	self assert: (nodes at: 1) position = (5@5).
	self assert: (nodes at: 2) extent = (230@230).
	self assert: (nodes at: 2) position = (5@5).
	self assert: (nodes at: 4) extent = (210@210).
	self assert: (nodes at: 4) position = (5@5).
	self assert: (nodes at: 7) extent = (182@182).
	self assert: (nodes at: 7) position = (4@4).
	self assert: (nodes at: 11) extent = (150@150).
	self assert: (nodes at: 11) position = (4@4).
	self assert: (nodes at: 16) extent = (120@120).
	self assert: (nodes at: 16) position = (3@3).
	self assert: (nodes at: 22) extent = (84@84).
	self assert: (nodes at: 22) position = (3@3).
	self assert: (nodes at: 29) extent = (42@42).
	self assert: (nodes at: 29) position = (3@3).
	self assert: (nodes at: 30) extent = (36@36).
	self assert: (nodes at: 30) position = (3@3).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'miltonmamani 4/17/2013 15:39'!
testEdgeDrivenLayouting
	| view nodes rawEdges edges |
	
	view := ROMondrianViewBuilder new.
	view shape width: 200; height: 200.
	"view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass."
	nodes := view nodes: (1 to: 9).
	rawEdges := OrderedCollection new.
	rawEdges add: 1 -> 2; add: 1 -> 3; add: 2 -> 4; add: 3 -> 5; add: 5 -> 6; add: 6 -> 7; add: 7 -> 8; add: 8 -> 9.
	edges := view edgesFromAssociations: rawEdges.
	
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view applyLayout.
	
	"Testing right number of objects and ordering"
	self assert: nodes size = 9.
	self assert: edges size = 8.
	self assert: nodes first model = 1.
	
	"Testing  bounds"
	self assert: (nodes first bounds = ((5@5) corner: (205@205))).
	self assert: (nodes second bounds = ((5@5) corner: (195@81))).
	self assert: (nodes third bounds = ((5@80) corner: (195@195))).
	self assert: ((nodes at: 8) bounds = ((5@5) corner: (155@80))).
	self assert: ((nodes at: 9) bounds = ((4@4) corner: (146@71))).
	
	"Testing z-index"
	self assert: nodes first zIndex = 1.
	self assert: nodes second zIndex = 2.
	self assert: nodes third zIndex = 2.
	self assert: nodes fourth zIndex = 3.
	self assert: nodes fifth zIndex = 3.
	self assert: (nodes at: 6) zIndex = 4.
	self assert: (nodes at: 7) zIndex = 5.
	self assert: (nodes at: 8) zIndex = 6.
	self assert: (nodes at: 9) zIndex = 7.! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/24/2013 17:01'!
testLayoutEmbedding
	| layout view outerModel outerNodes node1 node2 node3 |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	outerModel := (OrderedCollection with: 1).
	outerNodes := view nodes: outerModel forEach: [ :node |
		
		"Testing setting the size of the node that has the treemap layout."
		view shape rectangle size: 150.
		
		view nodes: (2 to: 3).
		view edgesFromAssociations: (Array with: 2 -> 3).
		view layout: layout.
	].

	view applyLayout.

	node1 := outerNodes at: 1.
	node2 := node1 elements at: 1.
	node3 := node2 elements at: 1.

	"Make sure outer node has grown corecctly."
	self assert: node1 extent = (165 @ 165).
	
	"Make sure the inner nodes have according sizes."
	self assert: node2 extent = (150@150).
	self assert: node3 extent = (140@140).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/19/2012 12:16'!
testLayoutEmbedding2
	| layout view outerModel outerNodes innerNodes node1 node2 node3 |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	outerModel := (OrderedCollection with: 1).
	
	"Testing setting the size of the node that is outside of the treemap layout."
	view shape rectangle size: 160.
	
	outerNodes := view nodes: outerModel forEach: [ :node |
		innerNodes := view nodes: (2 to: 3).
		view edgesFromAssociations: (Array with: 2 -> 3).
		view layout: layout.
	].

	view applyLayout.

	node1 := outerNodes at: 1.
	node2 := node1 elements at: 1.
	node3 := node2 elements at: 1.

	self assert: node1 extent = (160@160).
	self assert: node2 extent = (150@150).
	self assert: node3 extent = (140@140).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 2/26/2013 16:22'!
testMinAreaOptimizations
	| layout view nodes |

	layout := ROTreeMapLayout withWeightBlock: [ :e | e model ].
	layout minAreaPerNode: 25.
	
	view := ROMondrianViewBuilder new.
	view shape rectangle size: 15.
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	view layout: layout.

	view applyLayout.
	
	nodes := view nodes.
	
	"The node has lost its relation to its children... :("
	self assert: nodes first elements isEmpty.
	
	"Make sure we only render the first node, and none of its children"
	self assert: view raw elementsToRender size = 1.
	
	"Also check for correct sizing"
	self assert: nodes first extent = (15@15).
	self assert: nodes first bounds = ((5@5) corner: (20@20)).

! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 2/26/2013 16:23'!
testMinAreaOptimizations2
	| layout view minAreaPerNode minAreaBreakPoint sizeBreakpoint inset numberOfNodes nodes o |

	minAreaPerNode := 25.
	inset := 3.
	numberOfNodes := 6.
	
	layout := ROTreeMapLayout withWeightBlock: [ :e | e model ].
	layout inset: inset.
	layout minAreaPerNode: minAreaPerNode.
	
	minAreaBreakPoint := layout minAreaNeededFor: (2 to: (numberOfNodes - 1)).
	sizeBreakpoint := minAreaBreakPoint sqrt.

	view := ROMondrianViewBuilder new.
	view shape rectangle size: sizeBreakpoint.
	
	view nodes: (1 to: numberOfNodes).
	
	o := OrderedCollection new.
	o add: 1->2; add: 1->3; add: 1->4; add: 1->5; add: 1->6.
	view edgesFromAssociations: o.
	
	view layout: layout.

	view applyLayout.
	
	nodes := view nodes.
	
	"The node has lost its relation to its children... :("
	self assert: nodes first elements isEmpty.
	
	"Make sure we only render the first node, and none of its children"
	self assert: view raw elementsToRender size = 1.
	
	"Also check for correct sizing"
	self assert: nodes first extent = (sizeBreakpoint@sizeBreakpoint).
	self assert: nodes first bounds = ((inset@inset) corner: ((sizeBreakpoint + inset)@(sizeBreakpoint + inset))).
! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 2/26/2013 16:24'!
testMinAreaOptimizations3
	| layout view minAreaPerNode minAreaBreakPoint sizeBreakpoint inset numberOfNodes nodes o |

	minAreaPerNode := 25.
	inset := 3.
	numberOfNodes := 10.
	
	layout := ROTreeMapLayout withWeightBlock: [ :e | e model ].
	layout inset: inset.
	layout minAreaPerNode: minAreaPerNode.
	
	minAreaBreakPoint := layout minAreaNeededFor: (2 to: (numberOfNodes - 1)).
	sizeBreakpoint := minAreaBreakPoint sqrt.

	view := ROMondrianViewBuilder new.
	view shape rectangle size: sizeBreakpoint + 40.
	
	view nodes: (1 to: numberOfNodes).
	
	o := OrderedCollection new.
	o add: 1->2; add: 1->3; add: 2->4; add: 1->5; add: 1->6; add: 4->7; add: 7->8; add: 7->9; add: 7->10.
	view edgesFromAssociations: o.
	
	view layout: layout.

	view applyLayout.
	
	nodes := view nodes.

	"In this confgration, exactly 7 nodes should be visible"
	self assert: view raw elementsToRender size = 7.
! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/24/2013 17:00'!
testNestedNodePositioning
	| layout view nodes edges root |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 100.
	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			((Array new: 6)
				at: 1 put: (each*10) -> (each*10+each*5*1);
				at: 2 put: (each*10) -> (each*10+each*5*2);
				at: 3 put: (each*10) -> (each*10+each*5*3);
				at: 4 put: (each*10) -> (each*10+each*5*4);
				at: 5 put: (each*10) -> (each*10+each*5*5);
				at: 6 put: (each*10) -> (each*10+each*5*6);
			 	yourself).
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].	
	nodes := view nodes.

	view applyLayout.
	"view open."
	
	"Make sure outer nodes have the size we specified."
	self assert: (nodes at: 1) extent = (100 @ 100).
	self assert: (nodes at: 2) extent = (100 @ 100).
	self assert: (nodes at: 3) extent = (100 @ 100).
	self assert: (nodes at: 4) extent = (100 @ 100).

	"Make sure the standard layout - because we have none set for the outer nodes - positions them correctly."
	self assert: (nodes at: 1) bounds = ((5@5) corner: (105@105)).
	self assert: (nodes at: 2) bounds = ((115@5) corner: (215@105)).
	self assert: (nodes at: 3) bounds = ((225@5) corner: (325@105)).
	self assert: (nodes at: 4) bounds = ((335@5) corner: (435@105)).
	
	"Test first (inner) nodes..."
	self assert: ((nodes at: 1) elements at: 2) bounds = ((24@5) corner: (54@28)).
	self assert: ((nodes at: 1) elements at: 3) bounds = ((53@5) corner: (95@28)).
	self assert: ((nodes at: 1) elements at: 5) bounds = ((5@56) corner: (43@95)).
	self assert: ((nodes at: 1) elements at: 7) bounds = ((42@57) corner: (95@95)).
	
	"Test third (inner) nodes..."
	self assert: ((nodes at: 3) elements at: 1) bounds = ((5@5) corner: (25@28)).
	self assert: ((nodes at: 3) elements at: 3) bounds = ((53@5) corner: (95@28)).
	self assert: ((nodes at: 3) elements at: 4) bounds = ((5@27) corner: (43@57)).
	self assert: ((nodes at: 3) elements at: 6) bounds = ((42@27) corner: (95@58)) ! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 1/8/2013 09:59'!
testSimpleEdgeDrivenLayouting
	| layout view nodes edges node1 node2 node3 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	node3 := (nodes at: 3).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@105))).
	self assert: (node2 bounds = ((5@5) corner: (95@41))).
	self assert: (node3 bounds = ((5@40) corner: (95@95))).
	

	
! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DR 1/15/2013 21:23'!
testSimpleNestedDrivenLayouting
	| layout view nodes root mergedBounds node1 node2 node3 |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 100.
	view nodes: (OrderedCollection with: 1) forEach: [ :each |
		| innerNodes innerEdges |
		innerNodes := (view nodes: (2 to: 3)) reverse.
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].
	nodes := view nodes.
	view applyLayout.

	nodes := nodes reverse.
	
	node1 := (nodes at: 1).
	node2 := ((nodes at: 1) elements at: 1).
	node3 := ((nodes at: 1) elements at: 2).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@105))).
	self assert: (node2 bounds = ((5@5) corner: (95@41))).
	self assert: (node3 bounds = ((5@40) corner: (95@95))).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/4/2012 16:47'!
testSingleNodeLayouting
	| layout view nodes edges root |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (OrderedCollection with: 1).
	view layout: layout.	
	nodes := view nodes.
	root := nodes first.	
	"view open."	
	view applyLayout.

	"Make sure the node has the dimension we specified."
	self assert: (nodes at: 1) extent = (100 @ 100).

	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 12/18/2012 15:51'!
testThreeNodesLayouting
	| layout view nodes node1 node2 node3 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 3).
	view layout: layout.	
	nodes := view nodes.

	view applyLayout.
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	node3 := (nodes at: 3).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@21))).
	self assert: (node2 bounds = ((5@20) corner: (45@105))).
	self assert: (node3 bounds = ((44@20) corner: (105@105))).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 12/18/2012 15:51'!
testTwoNodeslayouting
	| layout view nodes node1 node2 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 2).
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	mergedBounds := node1 bounds merge: node2 bounds.

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).

	"Make sure the nodes have the right dimensions based on their weight: node2 should be double the size as node1."
	"We have to substract the area that node2 has additionally because of the border overlapping. See the splitRectangle 
	methods in ROTreeMapLayout"
	self assert: (node1 bounds area) * 2 = (node2 bounds area - (2 * node2 bounds width)).

	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@38))).
	self assert: (node2 bounds = ((5@37) corner: (105@105))).
! !

!Array methodsFor: '*roassal-core' stamp: ''!
@ interactionClassOrObject
	| obj |
	obj := interactionClassOrObject elementToBeAdded.
	self do: [ :el | el addInteraction: obj ].
	^ self! !

!Point class methodsFor: '*roassal-core' stamp: ''!
radius: radius theta: angle
	^ (radius * angle cos) @ (radius * angle sin)! !

Announcement subclass: #ROEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROCameraEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROCameraEvent subclass: #ROCameraResized
	instanceVariableNames: 'oldBounds newBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROCameraResized methodsFor: 'accessing' stamp: 'VanessaPena 12/23/2012 20:21'!
newBounds
	^ newBounds! !

!ROCameraResized methodsFor: 'accessing' stamp: 'VanessaPena 12/23/2012 20:21'!
newBounds: anObject
	newBounds := anObject! !

!ROCameraResized methodsFor: 'accessing' stamp: 'VanessaPena 12/23/2012 20:21'!
oldBounds
	^ oldBounds! !

!ROCameraResized methodsFor: 'accessing' stamp: 'VanessaPena 12/23/2012 20:21'!
oldBounds: anObject
	oldBounds := anObject! !

ROCameraEvent subclass: #ROCameraTranslated
	instanceVariableNames: 'step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROCameraTranslated methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/5/2013 17:33'!
step

	^step ! !

!ROCameraTranslated methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/5/2013 17:33'!
step: aPoint

	step := aPoint! !

ROEvent subclass: #ROComponentEvent
	instanceVariableNames: 'position element realPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROComponentEvent subclass: #ROAbstractMouseDragging
	instanceVariableNames: 'step commandKeyPressed controlKeyPressed shiftKeyPressed buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 18:05'!
buttons
	^ buttons! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 18:05'!
buttons: anObject
	buttons := anObject! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
commandKeyPressed

	^commandKeyPressed! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
commandKeyPressed: anObject
	commandKeyPressed := anObject! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
controlKeyPressed
	^ controlKeyPressed! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
controlKeyPressed: anObject
	controlKeyPressed := anObject! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
shiftKeyPressed
	^ shiftKeyPressed! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 17:38'!
shiftKeyPressed: anObject
	shiftKeyPressed := anObject! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step
	^ step! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step: anObject
	step := anObject! !

ROAbstractMouseDragging subclass: #ROMouseDragged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROAbstractMouseDragging subclass: #ROMouseDragging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROMouseDragging class methodsFor: 'as yet unclassified' stamp: ''!
step: value
	^ self new step: value! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:39'!
element
	^ element! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:39'!
element: anObject
	element := anObject! !

!ROComponentEvent methodsFor: 'action' stamp: 'AlexandreBergel 1/18/2013 10:40'!
emitToParent
	element ifNil: [ ^ self ].
	element parent announce: self! !

!ROComponentEvent methodsFor: 'testing' stamp: 'AlexandreBergel 1/18/2013 10:41'!
hasElement
	^ element notNil! !

!ROComponentEvent methodsFor: 'initialize-release' stamp: 'AlexandreBergel 1/18/2013 11:15'!
initialize
	super initialize.
	position := 0 @ 0.
	realPosition := 0 @ 0! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:40'!
model 
	^ element isNil
		ifTrue: [ nil ]
		ifFalse: [ self element model ]
 ! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 14:04'!
position
	^ position! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:40'!
position: aPoint
	"Set the position of the even in the view.  The position does not necessary correspond to the position on the screen"
	position := aPoint
	! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:40'!
realPosition
	^ realPosition! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 1/18/2013 10:40'!
realPosition: aPoint
	"aPoint corresponds to the position on the screen. This is useful to process later on"
	realPosition := aPoint! !

!ROComponentEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 4/8/2013 18:08'!
view
	self element ifNil: [ ^ nil ].
	^ self element view! !

ROComponentEvent subclass: #ROElementEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROElementEvent subclass: #ROElementResized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROElementEvent subclass: #ROElementTranslated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROComponentEvent subclass: #ROKeyDown
	instanceVariableNames: 'keyValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROKeyDown methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2013 00:04'!
character
	^ Character value: self keyValue! !

!ROKeyDown methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/14/2013 12:07'!
initialize
	super initialize.
	keyValue := 0! !

!ROKeyDown methodsFor: 'accessing' stamp: 'VanessaPena 8/26/2012 12:26'!
keyValue 
	^keyValue ! !

!ROKeyDown methodsFor: 'accessing' stamp: 'VanessaPena 8/26/2012 12:26'!
keyValue: aValue
	
		keyValue := aValue ! !

ROComponentEvent subclass: #ROMouseClick
	instanceVariableNames: 'commandKeyPressed controlKeyPressed shiftKeyPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
commandKeyPressed
	^ commandKeyPressed! !

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
commandKeyPressed: anObject
	commandKeyPressed := anObject! !

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
controlKeyPressed
	^ controlKeyPressed! !

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
controlKeyPressed: anObject
	controlKeyPressed := anObject! !

!ROMouseClick methodsFor: 'accessing' stamp: 'AlexandreBergel 12/16/2012 18:31'!
initialize 
	super initialize.
	commandKeyPressed := false.
	controlKeyPressed := false.
	shiftKeyPressed := false.! !

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
shiftKeyPressed
	^ shiftKeyPressed! !

!ROMouseClick methodsFor: 'accessing' stamp: 'BenComan 12/16/2012 14:29'!
shiftKeyPressed: anObject
	shiftKeyPressed := anObject! !

ROMouseClick subclass: #ROMouseLeftClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROMouseClick subclass: #ROMouseRightClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROComponentEvent subclass: #ROMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROComponentEvent subclass: #ROMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROComponentEvent subclass: #ROMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROEvent class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/17/2012 20:19'!
new
	^ self basicNew initialize! !

ROEvent subclass: #ROLayoutEvent
	instanceVariableNames: 'layout elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROLayoutEvent subclass: #ROLayoutBegin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROLayoutEvent subclass: #ROLayoutEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROLayoutEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 13:16'!
elements
	^ elements! !

!ROLayoutEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 13:16'!
elements: anObject
	elements := anObject! !

!ROLayoutEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 13:17'!
layout
	^ layout! !

!ROLayoutEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 13:17'!
layout: anObject
	layout := anObject! !

ROLayoutEvent subclass: #ROLayoutStep
	instanceVariableNames: 'currentIteration maxInterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROLayoutStep methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 16:45'!
currentIteration
	^ currentIteration! !

!ROLayoutStep methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 17:03'!
currentIteration: number
	currentIteration := number! !

!ROLayoutStep methodsFor: 'initialize-release' stamp: 'AlexandreBergel 11/15/2012 16:45'!
initialize
	super initialize.
	currentIteration := 0.
	maxInterations := 0.! !

!ROLayoutStep methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 16:45'!
maxInterations
	^ maxInterations! !

!ROLayoutStep methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 16:45'!
maxInterations: anObject
	maxInterations := anObject! !

ROEvent subclass: #RORefreshNeeded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROViewChanged
	instanceVariableNames: 'newView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView 
	^ newView! !

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView: aView
	newView := aView! !

ROEvent subclass: #ROWindowResized
	instanceVariableNames: 'oldExtent extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROWindowResized methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 15:05'!
extent
	^ extent! !

!ROWindowResized methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 15:05'!
extent: anObject
	extent := anObject! !

!ROWindowResized methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 15:06'!
oldExtent
	^ oldExtent! !

!ROWindowResized methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 15:06'!
oldExtent: anObject
	oldExtent := anObject! !

Announcer subclass: #ROAnnouncer
	instanceVariableNames: 'forwarding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAnnouncer commentStamp: '<historical>' prior: 0!
A ROAnnouncer is an object that receive and emit events. Each roassal element has an roannouncer. !

!ROAnnouncer methodsFor: 'announce' stamp: 'AlexandreBergel 9/2/2012 20:25'!
announce: event
	(self isForwarded: event) 
		ifTrue: [ self sendToParent: event ]
		ifFalse: [ super announce: event ]
! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward
	self forward: ROEvent! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward: anEventClass

	forwarding ifNil: [ forwarding := IdentitySet new ].
	forwarding add: anEventClass! !

!ROAnnouncer methodsFor: 'testing' stamp: 'AlexandreBergel 9/2/2012 20:24'!
isForwarded: anEventClass
	anEventClass isBehavior ifFalse: [ ^ self isForwarded: anEventClass class ].
	 
	forwarding ifNil: [ ^ false ].
	^ forwarding anySatisfy: [ :c | (c == anEventClass) or: [ anEventClass inheritsFrom: c ] ] ! !

!ROAnnouncer methodsFor: 'testing' stamp: ''!
isForwarder
	^ forwarding notNil and: [ forwarding notEmpty ]! !

!ROAnnouncer methodsFor: 'announce' stamp: ''!
sendToParent: event
	"Do nothing if an event class"
	event isBehavior ifTrue: [ ^ self ].
	
	event hasElement ifTrue: [ event element parentAnnounce: event ]! !

!ClassDescription methodsFor: '*roassal-core' stamp: 'AlexandreBergel 7/16/2012 07:56'!
numberOfLinesOfCode 
	"Return the amount of lines of code"
	
	^ 5 + ((RONativeExampleUtility current getMethodsForClass: self)  inject: 0 into: [:sum :el | sum + el linesOfCode ])! !

!Object methodsFor: '*roassal-core' stamp: ''!
roValue: anArgument 
	^ self! !

Object subclass: #ROAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

ROAction subclass: #ROAbstractAdjustSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAbstractAdjustSize class methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:42'!
getNewRectangleFor: element
	self subclassResponsibility ! !

!ROAbstractAdjustSize class methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:57'!
on: element
	| rec topLeft border |
	self assert: [ element isKindOf: ROElement ].
	topLeft := element bounds topLeft.
	rec := self getNewRectangleFor: element.
	element extent: rec extent.
	element translateTo: (rec topLeft).	"Check if I was extended on the topLeft corner"
	element elementsNotEdge do: [ :el | el translateWithoutUpdatingContainedElementsBy: topLeft - rec topLeft ]! !

ROAbstractAdjustSize subclass: #ROAdjustSizeOfNesting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAdjustSizeOfNesting class methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:31'!
getNewRectangleFor: element
	^ element encompassingRectangle! !

ROAbstractAdjustSize subclass: #ROShrikingSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROShrikingSize class methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:33'!
getNewRectangleFor: element
	^ element encompassingNestedRectangle! !

!ROAction class methodsFor: 'public' stamp: ''!
on: element
	self subclassResponsibility! !

ROAction subclass: #ROFocusView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROFocusView class methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 14:53'!
bottomLeftOn: element
	^ self new bottomLeftOn: element! !

!ROFocusView class methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 14:53'!
bottomRightOn: element
	^ self new bottomRightOn: element! !

!ROFocusView class methodsFor: 'public' stamp: 'AlexandreBergel 9/29/2012 14:50'!
on: element
	^ self new on: element! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 11/21/2012 14:14'!
bottomLeftOn: element
	"Public method"
	self on: element offset: (0 @ (element view camera windowSize y - element height))! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 11/21/2012 14:14'!
bottomRightOn: element
	"Public method"

	self 
		on: element 
		offset: (((element view camera windowSize x - element width)) @ (element view camera windowSize y - element height))! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 12/1/2012 16:02'!
highlightElement: element
	| sequence |
	ROHighlightElement on: element. 
	RONopAnimation new
		nbCycles: 20;
		after: [ ROUnhighlightElement on: element ];
		on: element view.

	RONopAnimation new
		nbCycles: 40;
		after: [ ROHighlightElement on: element ];
		on: element view.

	RONopAnimation new
		nbCycles: 60;
		after: [ ROUnhighlightElement on: element ];
		on: element view.
! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 11/21/2012 14:14'!
on: element
	"Public method"

	self on: element offset: (element view camera windowSize / 2).! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 15:55'!
on: element offset: offset

	element view camera translateTo: (element absolutePosition - offset).
	self highlightElement: element.
	element signalUpdate.! !

!ROFocusView methodsFor: 'public deprecated' stamp: 'AlexandreBergel 9/29/2012 14:55'!
on: element view: aView 
	"Public method"
	"There is some duplication with ROLinearMove. Need to check!!!!!!"
	
	"Deprecated method"

	self on: element! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 11/21/2012 14:18'!
view: view toPosition: pointToFocusOn
	view camera translateTo: (pointToFocusOn - (view camera windowSize / 2))! !

ROAction subclass: #ROGrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROGrow class methodsFor: 'public' stamp: ''!
on: element by: integer
	element setBounds: (element bounds extendBy: ((integer * 2) @ (integer * 2))).
	element translateBy: integer @ integer! !

ROAction subclass: #ROHighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:17'!
defaultColor
	^ Color red! !

!ROHighlightElement class methodsFor: 'testing' stamp: 'AlexandreBergel 7/4/2012 16:16'!
isHighlighted: element
	^ element attributes includesKey: #oldColor! !

!ROHighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:17'!
on: element
	self on: element color: self defaultColor! !

!ROHighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:19'!
on: element color: aColor
	element forShape: ROShape do: [ :d | 
		
		(element attributes includesKey: #oldColor)
			ifFalse: 
				[ element attributes at: #oldColor put: d color.
				d color: aColor.
				element signalUpdate ]]. 
	! !

ROAction subclass: #ROHighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElements class methodsFor: 'public' stamp: ''!
on: elements
	elements do: [ :el | ROHighlightElement on: el ]! !

!ROHighlightElements class methodsFor: 'public' stamp: ''!
on: elements color: aColor
	elements do: [ :el | ROHighlightElement on: el color: aColor ]! !

ROAction subclass: #RORemoveEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!RORemoveEdge class methodsFor: 'public' stamp: 'AlexandreBergel 11/20/2012 18:50'!
edgesFrom: anElement 
	anElement view elementsDo: [ :el |
		el isEdge ifTrue: [ (el from == anElement) ifTrue: [ el remove ] ] ].
	anElement view signalUpdate ! !

!RORemoveEdge class methodsFor: 'public' stamp: 'AlexandreBergel 11/20/2012 18:50'!
edgesTo: anElement 
	anElement view elementsDo: [ :el |
		el isEdge ifTrue: [ (el to == anElement) ifTrue: [ el remove ] ] ].
	anElement view signalUpdate ! !

ROAction subclass: #RORemoveNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!RORemoveNode class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/18/2012 15:49'!
suchThat: aBlock in: view
	view elementsDo: [ :el | 
		el isEdge
			ifTrue: [ ((aBlock value: el from) or: [ (aBlock value: el to) ]) ifTrue: [ el remove ] ] 
			ifFalse: [ (aBlock value: el) ifTrue: [ el remove ] ] ].
	view signalUpdate ! !

ROAction subclass: #ROUnhighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 9/29/2012 14:58'!
on: element

	(ROHighlightElement isHighlighted: element) ifFalse: [ ^ self ].
	
	element forShape: ROShape do: [ :d | 
		d color: (element attributes at: #oldColor).
		element attributes removeKey: #oldColor ]. 
	element signalUpdate ! !

ROAction subclass: #ROUnhighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElements class methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2012 18:36'!
on: elements
	elements do: [ :el | ROUnhighlightElement on: el ]! !

Object subclass: #ROBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Benchmarks'!

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:31'!
cleanMemory

	10 timesRepeat: [ Smalltalk garbageCollect ].
	Object new; new; new.
	10 timesRepeat: [ Smalltalk garbageCollect ].! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:33'!
elementAtFor: nbIterations
	"
	self new elementAtFor: 50000 
	=> 320 (AlexandreBergel 9/28/2012 08:33)
	=> 329 (Macbook air AlexandreBergel 9/27/2012 17:09)
	"


	| view node center |
	self cleanMemory.
	view := ROMondrianViewBuilder new.
	view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ node := view node: #a ] ] ] ].
	"
	view open.
	"
	
	center := node bounds center.
	^ [ nbIterations timesRepeat: [(view raw elementAt: center )] ] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:33'!
interaction1
	"
	self new interaction1 
	331 (AlexandreBergel 9/28/2012 08:33)
	518 AlexandreBergel 9/26/2012 09:21 
	920 AlexandreBergel 2/11/2012 17:02
	"
	| element |
	self cleanMemory.
	element := ROElement new.
	^ [20000 timesRepeat: [element @ RODraggable @ ROGrowable @ ROPopup]] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 12/17/2012 21:29'!
interaction2WithMenuActivable
	"
	self new interaction2WithMenuActivable
	
	=> 77 (AlexandreBergel 9/28/2012 08:32)
	79 AlexandreBergel 9/26/2012 09:21
	 793 AlexandreBergel 2/11/2012 17:04
	"
	| element |
	self cleanMemory.
	element := ROElement new.
	^ [ 100000 timesRepeat: [element @ ROMenuActivable ] ] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:32'!
layout

"
[self new layout ] timeToRun 

=> 8177 (AlexandreBergel 9/28/2012 08:32)
=> 7309 
=> 6845  (Pharo)
"

| view |
self cleanMemory.
view := ROMondrianViewBuilder new.
view nodes: (1 to: 800).
view edgesFrom: [ :v | v // 5].
"==="
view treeLayout.
view applyLayout.
"==="
view sugiyamaLayout.
view applyLayout
! !

Object subclass: #RODummyNode
	instanceVariableNames: 'edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODummyNode commentStamp: '<historical>' prior: 0!
A RODummyNode is used by the sugiyama layout!

!RODummyNode class methodsFor: 'instance creation' stamp: 'AlexandreBergel 5/3/2012 19:18'!
on: anEdge slot: anIndex
	
	^(self new)
		edge: anEdge;
		slot: anIndex;
		yourself! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge
	
	^edge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge: anEdge
	
	edge := anEdge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
height
	
	^0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:15'!
position
	^ 0 @ 0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
signalUpdate
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
slot: anIndex
	! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
translateBy: apoint
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
translateTo: aPoint
	
	"edge index: index point: aPoint"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/13/2013 22:14'!
view
	^ ROView new! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
width
	
	^0! !

Object subclass: #ROExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROExample commentStamp: '<historical>' prior: 0!
A ROExample contains a list of example of Roassal. It does not contains examples on the builder. !

!ROExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:48'!
postScript
	^ '
"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
ROEaselMorphic new populateMenuOn: view.
view noLayout.
view open'! !

!ROExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:43'!
preamble
	^ 'rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.'! !

!ROExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:43'!
preambleVariables
	^ #('view' 'rawView')! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 12/1/2012 21:41'!
animationOn: rawView
| elements b helpLabel |

"Define 10 blue rectangles, align them, and move them away from the corner"
elements := ROElement forCollection: (1 to: 10).
elements do: [ :el | el + ROBox blue; extent: 40 @ 80 ].
rawView addAll: elements.

ROHorizontalLineLayout new 
	horizontalGap: 0;
	on: elements.
	
elements do: [ :el | 
	el translateBy: 40 @ 40 ].

"We define the animation in a block to be repeatable"
b := [ elements do: [ :el | 
	el model odd ifTrue: [
		ROLinearMove new
			nbCycles: 30;
			for: el by: 0 @ 40;
			after: [ ROLinearMove new
						nbCycles: 30;
						for: el by: 0 @ -40 ] ] ] ]. 

"We first do the animation"
b value.

"Help message"
RONopAnimation new
	nbCycles: 70;
	after: [ rawView add: (helpLabel := (ROElement on: 'Click here!!') + ROLabel). 
			helpLabel translateTo: 20 @ 150.];
	on: rawView.
RONopAnimation new
	nbCycles: 120;
	after: [ helpLabel remove ];
	on: rawView.
		
rawView on: ROMouseClick do: [ :event | b value ].! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/13/2013 23:15'!
arrayOfObjects

	| view |
	view := ROView new.
	self arrayOfObjectsOn: view.
	view open! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/13/2013 23:43'!
arrayOfObjectsOn: rawView
	| module unit b |
	
	"Inspired from Processing code, ArrayObjects"
	unit := 40.
	
	1 to: (500 / unit) asInteger do: [ :x | 
		1 to: (500 / unit) asInteger do: [ :y |
			module := ROElement new + (ROEllipse size: 8).
			module translateTo:  (x * unit + ( unit / 2)) @ (y * unit + ( unit / 2)).
			module attributesAt: #speed put: (200 atRandom / 100) asFloat.
			module attributesAt: #direction put: (1 @ 1).
			module attributesAt: #originalPosition put: ((x * unit) @ (y * unit)).
			rawView add: module. 
			] ].
	
	b := [
		rawView elementsDo: [ :element | 
			| px dx |
			px := (element attributesAt: #originalPosition) x.
			dx :=  (module attributesAt: #direction) x.
			element translateBy: ((element attributesAt: #speed) *dx) @ 0.
			
			(((element position x - px) >= unit) or: [ 
				(element position x - px) <= 0 ]) ifTrue: [
					module attributesAt: #direction put: (dx negated @ 0 ) ].
		]
	].
	ROPluggableAnimation new
		nbCycles: 20000;
		block: b;
		on: rawView.
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 15:05'!
arrowedLine

	"
	self new arrowedLine
	"
	| view n1 n2|
	view := ROView new.
	self arrowedLineOn: view.
	view open! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:12'!
arrowedLineOn: rawView 
	| n1 n2 |
	
	n1 := ROElement sprite.
	n2 := ROElement sprite.
	n2 translateBy: 20@60.

	rawView 
		add: n1; 
		add: n2; 
		add: (ROEdge arrowedLineFrom: n1 to: n2).
	! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:48'!
bouncingBall

"
	self new bouncingBall

"

	| rawView |
	rawView := ROView new.
	self bouncingBallOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'VanessaPena 3/12/2013 15:30'!
bouncingBallOn: rawView
| x y dy ball b |

x := 0.
y := 50.
dy := 0.

ball := ROElement new + ROEllipse.
ball extent: 30 @ 30.
rawView add: ball. 

b := [ 
	x := x + 4.
	y := y + dy.
	( y > 185) 
		ifTrue: [ 
			dy := dy negated. 
			ball extent: 30 @ 25.
			ball translateTo: x @ 190 ]
		ifFalse: [
			dy := dy * 0.98 + 3.
			ball extent: 30 @ 30.
			ball translateTo: x @ y ].
].

ROPluggableAnimation new
	nbCycles: 100;
	block: b;
	on: rawView.
! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 9/11/2012 17:19'!
brightness 
"
	Brightness 
	by Rusty Robison. 
	from Processing
	
	self new brightness 	
	
"
	
	| view barWidth elements windowExtent cantBars layout |
	
	view := ROView new.
	windowExtent := 500.
	self brightnessOn: view.	
	view openInWindowSized: windowExtent @windowExtent .
	
! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 12/4/2012 10:06'!
brightnessOn: rawView
	| barWidth elements windowExtent cantBars layout |
	windowExtent := 250.
	barWidth := 5.	
	cantBars := windowExtent / barWidth .
	elements := ROElement forCollection: (1 to: cantBars).
	elements do: [:e |
			e extent: barWidth@windowExtent.
			e + (ROBox new color: Color black).
			e on: ROMouseMove do:[:event | 
				(e getShape: ROBox) color: (Color h: e position x s: 100 v: (event position y / 250) ).
				e signalUpdate.
			].
			
		].
	layout := ROHorizontalLineLayout  withGap: 0.
	layout applyOn: elements.
	rawView addAll: elements.
	
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 11/23/2012 08:33'!
centeredLabel

	"
	self new centeredLabel
	"
	
	| rawView |
	rawView := ROView new.
	self centeredLabelOn: rawView.
	rawView open .
	! !

!ROExample methodsFor: 'basic' stamp: 'VanessaPena 3/12/2013 15:30'!
centeredLabelOn: rawView
	| el |
	
el := (ROElement spriteOn: 
'x
x
x
x
x
x x x x x x x x x x x x x x x x x x
x
x
x
x
x' ) width: 200; height:200.

el + ROCenteredLabel + (ROEllipse color: Color green).
rawView add: el.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 11/23/2012 08:34'!
choice
	"
	self new choice
	"

	| view circle grid options choice container elementsToLayout |
	view := ROView new.
	circle := ROButtonElement named: 'circle' do: [:e | ROCircleLayout on: elementsToLayout. view signalUpdate  ].

	grid := ROButtonElement named: 'grid' do:  [:e | ROGridLayout on: elementsToLayout. view signalUpdate  ].
	
	options := Array with: circle with: grid.

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	container := ROElement new.
	elementsToLayout := ROElement labelsOn: (1 to: 20).
	elementsToLayout do: [ :v | 
		v + ROBorder red @RODraggable.
		v extent: 50@50 ].
	container addAll: (ROCircleLayout on: elementsToLayout).
	elementsToLayout do: [:l | l addShape: ROLabel].

	view addAll: (ROVerticalLineLayout on: (Array with: choice with: container)).
	view open.
	! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 7/14/2012 18:40'!
choiceOn: rawView
	| circle grid options choice container elementsToLayout |
	circle := ROButtonElement named: 'circle' do: [:e | ROCircleLayout on: elementsToLayout. rawView signalUpdate  ].
	grid := ROButtonElement named: 'grid' do:  [:e | ROGridLayout on: elementsToLayout. rawView signalUpdate  ].
	options := Array with: circle with: grid.
	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	container := ROElement new.
	elementsToLayout := ROElement labelsOn: (1 to: 20).
	elementsToLayout do: [ :v | 
		v + ROBorder red @RODraggable.
		v extent: 50@50 ].
	container addAll: (ROCircleLayout on: elementsToLayout).
	elementsToLayout do: [:l | l addShape: ROLabel].

	rawView addAll: (ROVerticalLineLayout on: (Array with: choice with: container)).
	
	! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 1/23/2013 16:29'!
circle
	| view |
	view := ROView new.
	self circleOn: view.
	view open! !

!ROExample methodsFor: 'animation' stamp: 'VanessaPena 3/12/2013 15:30'!
circleOn: rawView
	| outterElements innerElements b angle |
	
	outterElements := ROElement forCollection: (1 to: 20).
	outterElements do: [ :el | el + (ROEllipse blue extent: 20 @ 20) @ RODraggable ].
	
	innerElements := ROElement forCollection: (21 to: 41).
	innerElements do: [ :el | el + (ROEllipse green extent: 20 @ 20) @ RODraggable ].
	
	rawView addAll: outterElements.
	rawView addAll: innerElements.	
	angle := 0.

	b := [ 
		ROCircleLayout new 
			initialAngleInDegree: angle;
			initialRadius: 130;
			initialIncrementalAngleInDegree: 10;
			on: innerElements.
			
		ROCircleLayout new 
			initialAngleInDegree: angle;
			initialRadius: 250;
			initialIncrementalAngleInDegree: 10;
			on: outterElements.
		angle := angle + 1.
		angle >= 360 ifTrue: [ angle := 0 ].
	].

	ROPluggableAnimation new
		nbCycles: 5000;
		nbIterationsBeforeRefresh: 2;
		block: b;
		on: rawView.
		! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 15:19'!
clickAndMove
	"
	self new clickAndMove
	
	Click to make the element go to where you have clicked
	"

	| rawView |
	rawView := ROView new.
	self clickAndMoveOn: rawView.
	rawView open.
	
! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 11/30/2012 17:36'!
clickAndMoveOn: rawView
	| el |
	"
	Click to make the element go to where you have clicked
	"
	el := ROElement sprite.
	rawView add: el.
	rawView on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el to: event position.
	].
	! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 12:42'!
clock
	"
	self new clock
	"
	| view |
	view := ROView new.
	self clockOn: view.
	view open! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 13:32'!
clockOn: rawView
	| radius secondsRadius minutesRadius hoursRadius clockDiameter cx cy now s m h center secondElement minuteElement hourElement b |
	radius := 250.
	secondsRadius := radius * 0.72.
	minutesRadius := radius * 0.60.
	hoursRadius := radius * 0.50.
	clockDiameter := radius * 1.8.
	
	cx := 250.
	cy := 250.
	
	center := ROElement new. 
	center translateTo: (cx @ cy). 
 
	secondElement := ROElement new zIndex: 2.
	rawView add: ((ROLine gray width: 2) elementFrom: center to: secondElement).

	minuteElement := ROElement new zIndex: 2.
	rawView add: ((ROLine gray width: 3) elementFrom: center to: minuteElement).

	hourElement := ROElement new zIndex: 2.
	rawView add: ((ROLine gray width: 5) elementFrom: center to: hourElement).

	"Points"
	
	1 to: 360 by: (360 / 12) do: [ :a | 
		| ra el |
		ra := (a * 3.1415 / 180) asFloat.
		el := ROBox red element translateTo: (cx + (ra cos * secondsRadius)) @ (cy + (ra sin * secondsRadius)).
		rawView add: el.
	].

	b := 
	[
		now := Time now.
		s := now second / 60 * (3.1415 * 2) - (3.1415 / 2).
		m := (now minute + (now second / 60)) / 60  * (3.1415 * 2) - (3.1415 / 2).
		h := (now hour + (now minute / 60)) / 60  * (3.1415 * 2) - (3.1415 / 2).
		minuteElement translateTo: (cx + (m cos * minutesRadius)) @ (cy + (m sin * minutesRadius)).
		secondElement translateTo: (cx + (s cos * secondsRadius)) @ (cy + (s sin * secondsRadius)).
	 	hourElement translateTo: (cx + (h cos * hoursRadius)) @ (cy + (h sin * hoursRadius)).
	 	rawView signalUpdate ].

	b value.
	ROPluggableAnimation new
		nbCycles: 2000;
		block: b;
		on: rawView.! !

!ROExample methodsFor: 'colors' stamp: 'VanessaPena 12/20/2012 17:50'!
colors
	"
	self new colors
	"
	| view els |
	view := ROView new.
	view @RODraggable .
	self colorsOn: view.
	view open. view inspect ! !

!ROExample methodsFor: 'colors' stamp: 'VanessaPena 3/12/2013 15:30'!
colorsOn: rawView
	| els |
	
	els := ROElement forCollection: (1 to: 20). 
	els with: (Color red mix: Color green shades: 20) do: [:el :c | (el size: 20) + (ROEllipse color: c )].
	
	"We make the circle draggable"
	els do: [ :e | e @ RODraggable ].
	
	rawView addAll: els.
	ROCircleLayout new scaleBy: 4; on: els.
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 12/11/2012 20:32'!
composingOn: rawView 
| outer inner innerLabel |

outer := ROElement new + ROBorder white.
outer @ RODraggable.

inner := ROElement sprite.
innerLabel := ROElement labelOn: 'My sprite'.

outer add: inner; add: innerLabel.

"We make the inner and innerLabel forwarder of events"
inner forward.
innerLabel forward.

"We layout the things"
ROVerticalLineLayout on: outer elements.

rawView add: outer.


! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 13:37'!
constraint

	"
	self new constraint
	"
	| view |
	view := ROView new.
	self constraintOn: view.
	view open ! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 14:13'!
constraintOn: rawView

	| outter inner |
	outter := ROBox element extent: 100 @ 80.
	inner := (ROEllipse color: Color gray) element size: 20. 
	outter add: inner.
	outter resizeStrategy: (ROFixedSizedParent new).
	ROConstraint constraintInItsParent: inner.
	
	rawView add: outter.
	rawView add: inner.
	
	outter translateTo: 80 @ 20.
	
	inner @ RODraggable ! !

!ROExample methodsFor: 'basic' stamp: 'VanessaPena 3/14/2013 17:18'!
constraintsOn: rawView
| outer inner innerLabel |

outer := ROElement sprite.
outer @ ROLightlyHighlightable .

inner := ROElement sprite .
innerLabel := ROElement labelOn: 'My sprite'.
outer add: inner; add: innerLabel.
inner add: ROElement sprite.

rawView add: outer.

ROConstraint stick: innerLabel onTheRightOf: inner.
"ROConstraint stick: innerLabel below: inner."
"ROConstraint stick: innerLabel above: inner."
"ROConstraint stick: innerLabel onTheLeftOf: inner."
"ROConstraint stick: innerLabel onTheCenterOf: inner."! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 8/22/2012 21:38'!
continuousLinearMove

"
	From Processing
	
	self new continuousLinearMove

"

	|view line1 line2|
	view := ROView new.
	line1 := (ROElement new model: 'line1') extent:1@100; yourself.
	line1 + (ROBorder new color: Color red).
	line2 := (ROElement new model: 'line1') extent:1@100; yourself.
	line2 + (ROBorder new color: Color green).
	line2 translateBy: 0@100.
	view add: line1.
	view add: line2.
	ROMotionMove new for: line1 initialSpeed: 60@0.
	ROMotionMove new for: line2 initialSpeed: 30@0.
	view openInWindowSized: 200@200.
	! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 3/12/2013 15:30'!
drawCircle: view x: x radius: radius level: level
	| tt |
	tt := 126 * level / 4.
	view  add: ((ROElement new center: x asInteger @100 radius: radius asInteger )
						addShape: (ROEllipse new color: (Color gray256: tt) )).
	(level > 1) ifTrue: 
		[
			self drawCircle: view x: (x - (radius / 2)) radius: radius / 2 level: level - 1.
			self drawCircle: view x: (x + (radius / 2)) radius: radius / 2 level: level - 1.
		]
! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 4/6/2013 23:59'!
drawing

	| rawView p newEl |
	rawView := ROView new.
	rawView add: (ROLabel elementOn: 'Drawing!!').

	rawView on: ROMouseRightClick do: [ :event | rawView removeAllElements ].
	rawView on: ROMouseDragging do: [ :event | 
		p ifNil: [ p := ROBox element size: 1 . p translateTo: event position. rawView add: p ].
		newEl := (ROBox element size: 1) translateTo: event position.
		rawView add: newEl.
		rawView add: ((ROEdge from: p to: newEl) + ROLine).
		p := newEl.
		rawView signalUpdate ].
	rawView on: ROMouseDragged do: [ :event | p := nil ].

	rawView open ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 4/7/2013 01:21'!
dynamicEdgeOn: rawView
	| el1 el2 el3 |

	rawView add: (el1 := ROBox element size: 20).
	rawView add: (el2 := ROBox element size: 20).
	rawView add: (el3 := ROBox element size: 20).
	ROCircleLayout on: (Array with: el1 with: el2 with: el3).
	
	el1 @ RODraggable.
	el2 @ RODraggable.
	el3 @ RODraggable.
	
	el1 @ (RODynamicEdge toAll: (Array with: el2 with: el3) using: (ROLine arrowed color: Color red)).! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 9/11/2012 15:48'!
embeddedIteration

"
	From Processing

	self new embeddedIteration

"

	| view boxSize elements tmpEltos windowExtent cantBoxes layout height gap originalBoxSize |
	originalBoxSize := 10.
	boxSize := 10.
	windowExtent := 200.
	view := ROView new.
	elements := OrderedCollection new.
	cantBoxes := windowExtent / boxSize .
	height  := 0.
	[ boxSize > 0 ] whileTrue: [
		gap := (originalBoxSize - boxSize) / 2.	
		tmpEltos := ROElement forCollection: (1 to: cantBoxes).
		tmpEltos do: [ :e |
			e + ROBox .
			e size: boxSize ].
		
		layout := ROHorizontalLineLayout withGap: gap.
		layout applyOn: tmpEltos.
		tmpEltos do: [ :e | e translateBy: 0 @ height ].

		elements addAll: tmpEltos .
		height := height + boxSize + 1.
		boxSize := boxSize - 0.5.	

	].

	view addAll: elements .	
	view openInWindowSized: windowExtent @ windowExtent .! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 00:03'!
enteringCharacter
	"
	self new enteringCharacter
	"
	| rawView |
	rawView := ROView new.
	self enteringCharacterOn: rawView.
	rawView open! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 12:11'!
enteringCharacterOn: rawView
	| label labelElement |
	label := 'Press keys :'.
	labelElement := ROLabel elementOn: label.
	labelElement @RODraggable .
	rawView add: labelElement.
 
	rawView on: ROKeyDown do: [ :event | 
		label := label, event character asString. 
		labelElement model: label.
		rawView signalUpdate ].! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:28'!
expandableNodes

	"
	ROExample new expandableNodes
	"
	
	| view initialNodes |
	view := ROView new.
	self expandableNodesOn: view.
	view @RODraggable @ RODraggableWithVelocity.
	view open! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:28'!
expandableNodesOn: rawView
	| initialNodes |
	
	initialNodes := (ROElement labelsOn: (Array with: Integer)) asOrderedCollection.
	initialNodes do: [:n |
		n + ROLabel + ROBorder red.
		n @ (RORecursiveExpandOnClick childrenForModel: [ :model | model subclasses])].
	rawView addAll: initialNodes.
	ROTreeLayout new 
		translator: (ROSmoothLayoutTranslator new);
		applyOn: initialNodes.
! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 11/23/2012 08:35'!
grid
	"
	self new grid
	"

	| view elements |
	view := ROView new.
	view addAll: ((elements := ROElement spritesOn: (1 to: 20)) do: [:n | n addShape: ROLabel]).
	ROGridLayout on: elements.
	view open ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 11/23/2012 08:34'!
growOnClick

	"
	self new growOnClick
	"
	| view greenNode blueNode |
	view := ROView new.
	self growOnClickOn: view.
	view open ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:31'!
growOnClickOn: rawView 
	| greenNode blueNode |
	
	greenNode := ROElement on: 'green node'.
	greenNode addShape: (ROBox new color: Color green).
	greenNode setBounds: (5 @ 10 corner: (180 @ 170)).
	greenNode @ RODraggable.
	greenNode @ ROGrowable.

	blueNode := ROElement on: 'blue node'.
	blueNode addShape: (ROBox new color: Color blue).
	blueNode setBounds: (5 @ 10 corner: (180 @ 170)).
	blueNode translateBy: 50@30.
	blueNode @ RODraggable.
	blueNode @ ROGrowable.

	rawView add: greenNode; add: blueNode.
	! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/22/2012 21:01'!
innerNodeAndZoom


	"
	self new innerNodeAndZoom
	"
	| view els |
	view := ROView new.
	els := ROElement forCollection: (1 to: 200).
	els do: [:spr |
		| innerNodes |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable.
		
		innerNodes := ROElement forCollection: (1 to: 10).
		innerNodes do: [:s | s + ROBox green @ RODraggable ].
		spr addAll: (ROGridLayout on: innerNodes).
		].
	view addAll: els.
	view @ RODraggable.
	ROGridLayout on: els.
	view open.
	! !

!ROExample methodsFor: 'keypressing' stamp: 'VanessaPena 8/27/2012 10:06'!
keyPressing

"

	self new keyPressing

"

	|view elto elements|
	view := ROView new.
	view on: ROKeyDown  do: [:evt |
		|keyValue|
		keyValue  := evt keyValue.
		keyValue = 30 "up arrow"
			ifTrue: [view  translateBy: 0@1].
		keyValue = 31 "down arrow"
			ifTrue: [view  translateBy: 0@(-1)].
		keyValue = 29 "right arrow"
			ifTrue: [view  translateBy: (-1)@0].
		keyValue = 28 "left arrow"
			ifTrue: [view  translateBy: 1@0]
	].
	elements := ROElement spritesOn: (1 to: 100).
	ROGridLayout new applyOn: elements.
	view  addAll: elements .
	view open.! !

!ROExample methodsFor: 'keypressing' stamp: 'AlexandreBergel 4/14/2013 00:03'!
keyPressing2

"

	self new keyPressing2

"

	|view elto element|
	view := ROView new.
	element := ROElement spriteOn: 'me'.
	view on: ROKeyDown  do: [:evt |
		| keyValue |
		keyValue  := evt keyValue.
		keyValue = 30 "up arrow"
			ifTrue: [element  translateBy: 0@(-2)].
		keyValue = 31 "down arrow"
			ifTrue: [element  translateBy: 0@(2)].
		keyValue = 29 "right arrow"
			ifTrue: [element  translateBy: (2)@0].
		keyValue = 28 "left arrow"
			ifTrue: [element  translateBy: (-2)@0].
		element signalUpdate.
	].
	view add: element.
	view open.! !

!ROExample methodsFor: 'basic' stamp: 'VanessaPena 12/23/2012 20:53'!
label

	"
	self new label
	"
	
	| rawView |
	rawView := ROView new.
	self labelOn: rawView.
	rawView open.
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:13'!
labelOn: rawView

	rawView add: (ROLabel elementOn: 'hello world').
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 11/23/2012 08:35'!
labelWithCRCharacter

	"
	self new labelWithCRCharacter
	"
	
	| view |
	view := ROView new.
	view add: (ROLabel elementOn: 
'hello 
world').
	view open! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:21'!
labelWithCRCharacterOn: rawView
	rawView add: (ROLabel elementOn: 
'hello 
world').
	
	! !

!ROExample methodsFor: 'software' stamp: 'VanessaPena 3/12/2013 15:30'!
latentSemanticIndexing
	"
	self new latentSemanticIndexing
	"

	| documentsToProcess matrix words v elements view tIndexing elementsGraphical nativeUtil stack miniView |
	documentsToProcess := OrderedCollection new.
	nativeUtil := RONativeExampleUtility current.
	ROElement withAllSubclasses do: [ :cls | documentsToProcess addAll: ((nativeUtil getMethodsForClass: cls) collect: #getSource) ].
	
	"Matrix is a dictionary of dictionaries. The outter key is a word of the documents. The value is a dictionary is a method source code. In this dictionary of method source code, the value is the number of occurence of the word in the source code.
    | w1 | w2 | w3 | w4|
s0| 
s1|
s2|

(w1, s0) occurence of the word w1 in the source code s0.
...
	"
	matrix := Dictionary new.
	documentsToProcess do: [ :source | 
		words := nativeUtil substringsFor: source .
		words do: [ :w |  
			matrix at: w ifAbsentPut: [ Dictionary new ].
			v := (matrix at: w) at: source ifAbsentPut: [ 0 ].
			(matrix at: w) at: source put: (v + 1) ] ].
	elements := OrderedCollection new.
	matrix associationsDo: [ :assoc|
		| wordToConsider sourceAndOccurrences |
		wordToConsider := assoc key.
		sourceAndOccurrences := assoc value.
		
		sourceAndOccurrences associationsDo: [ :assoc2|
			| sourceCodeForWord wordOccurrence|
			sourceCodeForWord := assoc2 key.
			wordOccurrence := assoc2 value.
			elements add: (Array 
							with: wordToConsider
							with: (documentsToProcess indexOf: sourceCodeForWord) 
							with: wordOccurrence
							with: sourceCodeForWord) ] ].

	tIndexing := (elements collect: #first) asSet asSortedCollection.
	elements := elements collect: [ :tupple |
			Array 
				with: (tIndexing indexOf: tupple first) 
				with: tupple second 
				with: tupple third
				with: tupple fourth
				with: tupple first ].
	

	"We build the view"	
	stack := ROViewStack new.
	view := ROView new backgroundColor: Color black.
	elementsGraphical := ROElement forCollection: elements.
	elementsGraphical do: [:el | 
					
					el 
						addShape: (ROEllipse green);
						addInteraction: (ROPopup new 
											text:  [:e | 
												'Word: ', e fifth, Character cr,
												'Occurrence: ', e third printString, Character cr,
												'Source Code: ', Character cr, e fourth printString] ;
											receivingView: stack);
						size: (el model third) ].
						
	view addAll: elementsGraphical.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elementsGraphical.
	

	view 
		on: ROMouseLeftClick
		do: [ :event | 
			ROZoomInMove new on: view ].
	view 
		on: ROMouseRightClick
		do: [ :event | 
			ROZoomOutMove new on: view ].
		
	view @ RODraggable @ RODraggableWithVelocity.
	
	stack addView: view.
	stack open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 11/23/2012 08:35'!
leftAndRightClick
	" 
	self new leftAndRightClick
	"
	| view |
	view := ROView new.
	self leftAndRightClickOn: view.
	view open  ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/29/2012 09:40'!
leftAndRightClickOn: rawView
	| counter add sub els |
	
	els := OrderedCollection new.
	
	add := ROElement sprite 
				addShape: (ROLabel new text: '+ / --');
				addShape: (ROBorder yellow).

	add on: ROMouseLeftClick do: [ :ev | 
		| el |
		el := ROElement sprite translateTo: (200 atRandom @ 200 atRandom ).
		els add: el.
		rawView add: el.
		rawView signalUpdate ].

	add on: ROMouseRightClick do: [ :ev | 
		| el |
		els ifNotEmpty: [
			rawView remove: els removeLast.
			rawView signalUpdate ] ].

	rawView add: add.
	! !

!ROExample methodsFor: 'basic' stamp: 'VanessaPena 12/23/2012 20:52'!
lines

	"
	self new lines
	"
	
	| view node1 node2 edge |
	view := ROView new.
	self linesOn: view.
	view open.
	view camera inspect.! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 10/3/2012 09:02'!
linesOn: rawView
	| node1 node2 edge |
	node1 := ROLabel elementOn: 'node1'. 
	node2 := ROLabel elementOn: 'node2'.
	node1 @ RODraggable.
	node2 @ RODraggable.
	edge := ROEdge from: node1 to: node2.
	edge + (ROLine red).
	rawView add: edge; add: node1; add: node2.
	ROHorizontalLineLayout on: (Array with: node1 with: node2).
	! !

!ROExample methodsFor: 'software' stamp: ''!
memoryProfiling
	"
	self new memoryProfiling
	"
	"| spaceItems builder |
	spaceItems := SpaceTally new spaceTally: (Array with: ByteString with: Process with: RPackage with: Bitmap).
	
	builder := ROMondrianViewBuilder new.
	builder shape rectangle logWidth: #instanceCount; logHeight: #spaceForInstances.
	builder nodes: (spaceItems asSorted: #spaceForInstances).
	builder open	.
	"! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 3/11/2013 10:37'!
miniMap

"	
	self new miniMap
"

	| view eltos |
	view := ROView new.
	view @ RODraggable.
	view on: ROMouseRightClick 
		do: [ :event | ROZoomInMove new on: view ].
	view on: ROMouseLeftClick	
		do: [ :event | ROZoomOutMove new on: view ].
		
	eltos := ROElement spritesOn: (1 to: 400).
	eltos do:  [:el | el + ROLabel  ].
	view addAll: eltos.
	ROGridLayout new on: eltos.
	
	"Mini map opens by pressing m"
	view @ ROMiniMap.
	view open.

	! !

!ROExample methodsFor: 'util' stamp: 'AlexandreBergel 12/13/2012 17:20'!
monsterFrom: string color: aColor 
	"Check spaceInvaderOn: for example of usage"

	^ self monsterFrom: string color: aColor size: 10! !

!ROExample methodsFor: 'util' stamp: 'AlexandreBergel 1/30/2013 12:04'!
monsterFrom: string color: aColor size: sizeAsInteger
	"Check spaceInvaderOn: for example of usage"
	
	| monster x y cr |
	cr := '
' first.
	monster := ROElement new.
	monster @ RODraggable.
	x := 0.
	y := 0.
	string do: [ :char | 
		char = 'X' first ifTrue: [
			| el |
			el := ROElement new + (ROBox new color: aColor).
			el extent: sizeAsInteger @ sizeAsInteger.
			el translateBy: (x * sizeAsInteger) @ (y * sizeAsInteger).
			monster add: el.
			el forward.
		].
		char = cr ifTrue: [ 
			y := y + 1.
			x := -1.
		].
		x := x + 1
	].
	^ monster! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 14:19'!
moose1D
	"
	self new moose1D
	"
	| rawView |
	rawView := ROView new.
	self moose1DOn: rawView.
	rawView open! !

!ROExample methodsFor: 'Processing' stamp: 'AlexandreBergel 4/14/2013 20:33'!
moose1DOn: rawView
	| el1 el2 |
	el1 := ROBox element.
	el2 := ROBox element.
	el1 forward.
	el2 forward.
	rawView add: el1; add: el2.
	
	rawView on: ROMouseMove do: [ :event |
		el1 translateTo: ( 250 + (event position x / 2)) @ (event position x / 2).
		el2 translateTo: ( 250 - (500 - (event position x))) @ (event position x / 2).
		
		el1 extent: (event position x @ event position x).
		el2 extent: ((500 @ 500) - (event position x @ event position x)).

		rawView signalUpdate
	].! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:34'!
motion

	"
	self new motion
	"
	|view sprs |
	view := ROView new.
	self motionOn: view.
	view open.
! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 3/12/2013 15:30'!
motionOn: rawView
	| sprs |
	
	sprs := (ROElement forCollection: (1 to: 20)).
	sprs do: [:s | 
		s extent: 20@20.
		s + ROEllipse blue.
		s @ RODraggable.
		s @ RODraggableWithVelocity ].
	rawView addAll: sprs.

	sprs do: [ :spr | ROMotionMove new for: spr initialSpeed: 60 atRandom @ 60 atRandom ].

	sprs last @ (ROPopup text: 'Press me!!' ).
	(sprs last getShape: ROEllipse) color: Color red.
	sprs last on: ROMouseClick do: [ 
		sprs do: [ :spr | ROMotionMove new for: spr initialSpeed: (60 atRandom - 30) @ (60 atRandom - 30 ) ] ].! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 8/28/2012 09:52'!
mouse1D

"
	From Processing

	self new mouse1D
"

	|view lElto rElto w h|
	w := 200.
	h := 200.
	view := ROView new.
	lElto := ROElement new model: 'left element'.
	lElto width: 100; height: 200.
	lElto + (ROBox new color: Color green).
	rElto := ROElement new model: 'right element'.
	rElto width: 100; height: 200.
	rElto + (ROBox new color: Color blue).
	
	rElto translateBy: 100@0.
	
	view add: lElto ; add: rElto .
	
	view openInWindowSized: w@h.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:48'!
moveLikeCircle

"
	self new moveLikeCircle

"

	| rawView |
	rawView := ROView new.
	self moveLikeCircleOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'VanessaPena 3/12/2013 15:30'!
moveLikeCircleOn: rawView
	| elto mov |
	
	elto := ROElement new.
	elto size: 10.
	elto + (ROEllipse color: Color green).
	rawView add: elto.
	elto translateBy: 250@250.

	ROFuncionMove new
		nbCycles: 360;
		blockX: [ :elapseCycle | (elapseCycle * 3.14 / 180) cos * 40  + 100 ]; 
		blockY: [ :elapseCycle | (elapseCycle * 3.14 / 180) sin * 40 + 100 ];
		on: elto.
		
"	mov := ROTranslation new nbCycles: 200.
	mov for: elto functionX: [:t | 10* (t cos)] Y: [:t | 10* (t sin)] intervalIni: 0 IntervalEnd: 2 * Float pi.
	"! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:47'!
moveLikeCurve

"
	self new moveLikeCurve

"
	| rawView |
	rawView := ROView new.
	self moveLikeCurveOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'VanessaPena 3/12/2013 15:30'!
moveLikeCurveOn: rawView
	| elto mov |
	
	elto := ROElement new.
	elto size: 10.
	elto + (ROEllipse color: Color green).
	rawView add: elto.
	elto translateBy: 30@20.

	ROFuncionMove new
		nbCycles: 360;
		blockY: [ :x | (x * 3.1415 / 180) sin * 80 + 50 ];
		on: elto.
		
"	mov := ROTranslation new nbCycles: 100.
	mov for: elto function:  [:x | x ] intervalIni: 0 IntervalEnd: 100.
"! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 6/13/2012 00:25'!
multipleArrow

	| view el1 el2 edge line  |
	view := ROView new.
	el1 := ROElement new.
	el1 @RODraggable.
	el1 extent: 50@50.
	el1 + ROBox blue.

	el2 := ROElement new.
	el2 @RODraggable.
	el2 extent: 50@50.
	el2 + ROBox green.

	el1 translateTo: 0 @ 100.
	 
	edge := ROEdge from: el1 to: el2.
	line := ROLine new.
	line add: ROArrow new offset: 0.1.
	line add: ROArrow new offset: 0.5.
	edge + line.

	view add: el1; add: el2; add: edge.
	view open 
	 ! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:23'!
multipleArrowOn: rawView
	| el1 el2 edge line  |
	
	"A line shape can have several arrows on it."
	el1 := ROElement new.
	el1 @RODraggable.
	el1 extent: 50@50.
	el1 + ROBox blue.

	el2 := ROElement new.
	el2 @RODraggable.
	el2 extent: 50@50.
	el2 + ROBox green.

	el1 translateTo: 0 @ 100.
	 
	edge := ROEdge from: el1 to: el2.
	line := ROLine new.
	line add: ROArrow new offset: 0.1.
	line add: ROArrow new offset: 0.5.
	edge + line.

	rawView add: el1; add: el2; add: edge.
	 
	 ! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/7/2012 13:46'!
nestedLayoutOn: rawView
	| elements edges outterNode |
	
	outterNode := ROElement new + ROBorder blue.
	elements := ROElement spritesOn: (1 to: 5).
	outterNode addAll: elements.
	
	rawView add: outterNode.
	rawView addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.
! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 11/23/2012 08:35'!
nesting
	"
	self new nesting
	"

	| view innerNode outterNode |
	view := ROView new.
	
	innerNode := ROElement new 
					extent: 40@30; 
					+ (ROBox new color: Color green);
					@ RODraggable.
	
	outterNode := 
		ROElement new 
			addInteraction: RODraggable;
			extent: 190@190;
			translateBy: 20@20;
			+ (ROBorder new color: Color red).

	view add: outterNode.
	outterNode add: innerNode.	
	
	view open.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 11/23/2012 08:34'!
nesting2
	"
	self new nesting2
	"

	| view nodes |
	view := ROView new.
	view add: (ROElement sprite
				addAll: (nodes := ROElement spritesOn: (1 to: 20))).
	nodes do: [:n | n addShape: ROLabel].
	ROCircleLayout on: nodes. 
	view open.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 6/9/2012 18:42'!
nesting3
	"
	self new nesting3
	"
	
	| view elements edges outterElement |
	view := ROView new.
		
	elements := ROElement spritesOn: (1 to: 5).

	outterElement := ROElement new.
	outterElement addAll: elements.
	outterElement addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).

	ROTreeLayout on: elements edges: edges.

	view add: outterElement.
	
	view open.! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/29/2012 10:14'!
normalizer
	"
	self new normalizer
	"
	| view el |
	view := ROView new.
	self normalizerOn: view.
	view open! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/29/2012 10:14'!
normalizerOn: rawView
	| el normalizer nodes|
	
	normalizer := RONIdentityNormalizer beginingAtBlue.
	
	nodes := (1 to: 30) collect: [ :i | 
		el := ROElement on: i.
		el @ RODraggable.
		el @ ROPopup.
		el extent: 60 @ 30.
		el + (ROBox new color: normalizer) + ROBorder.
		el ].	
	rawView addAll: nodes.
	ROGridLayout on: nodes.

"-------------"
! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 12/1/2012 17:48'!
omgParticules

"
	self new omgParticules

"

	| rawView |
	rawView := ROView new.
	self omgParticulesOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'VanessaPena 3/12/2013 15:30'!
omgParticulesOn: rawView
	| particules |
	
	"Inspired from http://bl.ocks.org/1062544"
	particules := OrderedCollection new.
	rawView on: ROMouseMove do: [ :event | 
		| newElem |
		newElem := ROElement new + ROEllipse.
		newElem extent: 10 @ 10.
		newElem translateTo: (rawView camera realToVirtualPoint: event position).
		particules addFirst: newElem.
		rawView add: newElem.
		rawView signalUpdate.
		(particules size = 70) ifTrue: [ particules last remove.  particules removeLast ].
		].
	
ROPluggableAnimation new
	nbCycles: 300;
	block: [ particules do: [ :el | (el extent: (el extent + (3 @ 3))) ] ];
	on: rawView.
! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 8/23/2012 16:11'!
pointillism

"
	Idea from  Pointillism
	by Daniel Shiffman
	at Prossesing

	self new pointillism
 
"

	|view elto|
	view := ROView new.
	self pointillismOn: view.	
	view open.! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 3/12/2013 15:30'!
pointillismOn: rawView
	| elto |
	rawView on: ROMouseMove do: [ :event | 
		5 timesRepeat: [
			elto := ROElement new.
			elto size: (event position x / 10).
			elto + (ROEllipse color: (Color r: (155 atRandom / 255) g: (155 atRandom / 255) b: (155 atRandom / 255) alpha: 0.5)).
			elto translateTo: (500 atRandom @ 500 atRandom).
			rawView add: elto.
			rawView signalUpdate.
		]
	].! !

!ROExample methodsFor: 'interaction' stamp: ''!
popup

	"
	self new popup
	"
	
	| view |
	view := ROView new.
	view add: ((ROElement spriteOn: 'world')
				+ (ROLabel text: 'hello')
				@ (ROPopup)).
	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:37'!
popupOn: rawView
	rawView add: ((ROElement spriteOn: 'world')
				+ (ROLabel text: 'hello')
				@ (ROPopup)).
! !

!ROExample methodsFor: 'interaction' stamp: ''!
popupView

	"
	self new popupView 
	"

	| element view popupView |
	
	popupView := ROView new.
	popupView add: ((ROElement new extent: 50@60)+ (ROBox new color: Color blue)).
	
	view := ROView new.
	element := ROElement sprite.
	element @ (ROPopupView new view: popupView).
	view add: element.
	view open! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 7/14/2012 15:21'!
punchChart
	"inspired from http://raphaeljs.com/github/dots.html
	self new punchChart
	"

	| rawView |
	rawView := ROView new.
	self punchChartOn: rawView.
	rawView @ RODraggable.
	rawView open! !

!ROExample methodsFor: 'software' stamp: 'VanessaPena 3/12/2013 15:30'!
punchChartOn: rawView
	| classes metrics maxMetrics rx ry elements initialX initialY spaceX spaceY spaceYFromAxis spaceXFromAxis |

	"inspired from http://raphaeljs.com/github/dots.html"

	"Gathering the data"
	classes := OrderedCollection new.
	classes add: Object; add: Behavior; add: Metaclass; add: Collection; add: OrderedCollection.
	metrics :=  #(#numberOfMethods #numberOfVariables #numberOfSubclasses).
	
	"Visualzing the data"
	maxMetrics := metrics collect: [ :m | classes inject: 0 into: [:max :el | max max: (m roValue: el) ] ].
	initialX := 30.
	initialY := 60.
	spaceX := 100.
	spaceY := 30.
	spaceYFromAxis := 20.
	spaceXFromAxis := 20.
	rx := initialX.
	ry := initialY.
	elements := OrderedCollection new.
	
	classes do: [:cls | 
		ry := initialY.
		rx := rx + spaceX.
		
		metrics with: maxMetrics do: [ :m :mMax |
						| v |
						ry := ry + spaceX.
						v := m roValue: cls.
						elements add: 
							((ROElement on: cls)
							
								translateTo: rx @ ry;
								+ (ROEllipse color: ((Color green mix: Color red shades: 30) at: (v max: mMax in: (1 to: 30))));
								@ (ROPopup text: v printString);
								 radius: ((m roValue: cls) max: mMax in: (5 to: 10))) ].
		ry := ry + spaceYFromAxis.
		elements add: ((ROLabel elementOn: cls name) center: rx @ ry). ].
	
	ry := initialY.
	rx := rx + spaceX.
	rx := rx + spaceXFromAxis.
	metrics do: [ :m | 
		ry := ry + spaceX.
		elements add: ((ROElement labelOn: m) center: rx @ ry) ].
				
	rawView addAll: elements.
! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 3/12/2013 15:30'!
recursionProcessing
	"
	self new recursionProcessing
	"
	| view b |
	view := ROView new.

	b := [:x :radius :level | 
		| tt |
		tt := 126 * level / 4.0.
		view  add: ((ROElement new center: x@100 radius: radius)
							addShape: (ROEllipse new color: (Color gray256: tt) )).
		(level > 1) ifTrue: 
			[
				b value: (x - (radius / 2)) value: radius / 2 value: (level - 1).
				b value: (x + (radius / 2)) value: radius / 2 value: (level - 1).
			]
	].
	b value: 126 value: 170 value: 6.
	view open ! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 4/17/2012 17:14'!
recursionProcessing2
	"
	self new recursionProcessing2
	"
	| view b |
	view := ROView new.

	self drawCircle: view x: 126 radius: 170 level: 6.
	view open
! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 3/12/2013 15:30'!
recursionProcessingOn: rawView
	| b |

	b := [ :x :radius :level | 
		| tt |
		tt := 126 * level / 4.0.
		rawView  add: ((ROElement new center: x@100 radius: radius)
							addShape: (ROEllipse new color: (Color gray256: tt) )).
		(level > 1) ifTrue: 
			[
				b value: (x - (radius / 2)) value: radius / 2 value: (level - 1).
				b value: (x + (radius / 2)) value: radius / 2 value: (level - 1).
			]
	].
	b value: 126 value: 170 value: 6.
! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 3/12/2013 15:30'!
resizableCircle
	"
	self new resizableCircle
	"

	| view circles colors |
	view := ROView new.
	colors := Color wheel: 6 alpha: 0.7.
 
	circles := (1 to: 6) with: colors collect: [:i :c | 
		ROElement new
			@ RODraggable;
			+ (ROEllipse color: c);
			translateTo: (i * 60) @ (i \\ 3 * 50 + 50);
			extent: 50@50.
	].
	view on: ROMouseMove do: [:event | 
		circles do: [:c | | t |
			t := ((c bounds center - event position ) r / 2) max: 40.
			c size: t ].
		view signalUpdate  ].
	
	view addAll: circles.
	view open.

! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 3/12/2013 15:30'!
resizableCircleOn: rawView
	| circles colors |
	
	colors := Color wheel: 6 alpha: 0.7.
 
	circles := (1 to: 6) with: colors collect: [:i :c | 
		ROElement new
			@ RODraggable;
			+ (ROEllipse color: c);
			translateTo: (i * 60) @ (i \\ 3 * 50 + 50);
			extent: 50@50.
	].
	rawView on: ROMouseMove do: [:event | 
		circles do: [:c | | t |
			t := ((c bounds center - event position ) r / 2) max: 40.
			c size: t ].
		rawView signalUpdate  ].
	
	rawView addAll: circles.
! !

!ROExample methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 23:20'!
rubberBand
	"
	self new rubberBand
	"
	| view |
	view := ROView new.
	self rubberBandOn: view.
	view open! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 1/30/2013 12:05'!
rubberBandOn: rawView
	| rubberband |
	"Drag edges from '1x' to '2x' then from '2x' to '3x' etc..."
   	rubberband := RORubberBand new
		targeting:   
		( 	ROSelection new 
				for: [ :source :target | source model first asInteger + 1 = target model first asInteger ];
				onInclusion: [ :element | ROHighlightElement on: element color: Color blue ];
				onExclusion: [ :element | ROUnhighlightElement on: element ]
  		);                         
		onDrop: 
		[	:fromElement :toElement |
                   RORemoveEdge edgesTo: toElement. 
                   fromElement view add: (ROEdge lineFrom: fromElement to: toElement).
                   ROTreeLayout on: fromElement view elements. 
		]. 

	1 to: 4 do: 
	[	:num | 
		"$a asInteger = 97 en Pharo"
		"$d asInteger = 100 en Pharo"
		97 asInteger to: 100 do: 
		[	:charInt | | element |
			element := (ROElement on: num asString , charInt asCharacter asString) + ROBorder red + ROLabel.
			element extent: 40 @ 40.
			element @ rubberband.
			rawView add: element.
		]
	].
	ROTreeLayout on: rawView elements.! !

!ROExample methodsFor: 'layouts' stamp: 'VanessaPena 3/12/2013 15:30'!
scatterPlot
	"
	self new scatterPlot
	"

	| view elements |
	view := ROView new.
	elements := ROElement forCollection:  #(#(1 2) #(100 50) #(60 20)).
	elements do: [:el | el 
						addShape: ROEllipse;
						size: 30 ].
	view addAll: elements.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elements.
	view open.! !

!ROExample methodsFor: 'layouts' stamp: 'VanessaPena 3/12/2013 15:30'!
scatterPlotOn: rawView
	| elements |
	elements := ROElement forCollection:  #(#(1 2) #(100 50) #(60 20)).
	elements do: [:el | el 
						addShape: ROEllipse;
						size: 30 ].
	rawView addAll: elements.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elements.
	! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 6/9/2012 18:42'!
scrollbar

	| view els stack |
	view := ROView new.
	view add: ROElement sprite.

	els := ROElement spritesOn: (1 to: 500).
	els do: [ :el | el + ROLabel @ ROPopup ].
	view addAll: (ROGridLayout  on: els).
	view @ RODraggable .

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	stack open.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 12/13/2012 17:46'!
spaceInvaderOn: rawView
| ascii1 ascii2 ascii3 monsterAscii color size monster b |

ascii1 := '  XX        XX  
    XX    XX    
  XXXXXXXXXXXX  
 XXX  XXXX  XXX 
XXXXXXXXXXXXXXXX
X  XXXXXXXXXX  X
X  X        X  X
    XXX  XXX    '.

ascii2 := '     XXXXX     
 XXXXXXXXXXXXX 
XXXXXXXXXXXXXXX
XXX   XXX   XXX
XXXXXXXXXXXXXXX
   XXX   XXX   
  XX  XXX  XX  
XX           XX
'.

ascii3 := '    XXXXXXX    
   XXXXXXXXX   
  XXXXXXXXXXX  
 XXXXXXXXXXXXX 
XXXX  XXX  XXXX
XXXXXXXXXXXXXXX
    XX   XX    
  XX  XXX  XX  
XX  XX   XX  XX'.

b := [
	monsterAscii := (Array with: ascii1 with: ascii2 with: ascii3) at: 3 atRandom.
	color := (Array with: Color blue with: Color black with: Color yellow with: Color red) at: 4 atRandom.
	size := 20 atRandom + 10.

	monster := ROExample new monsterFrom: monsterAscii color: color size: size.
	monster translateTo:  600 atRandom @ (monster position y negated).
	rawView add: monster.

	ROLinearMove new 
		nbCycles: 200 atRandom;
		for:  monster to: 600 atRandom @ 600;
		after: [ monster remove. b value ]
	].

b value; value; value.! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 6/10/2012 15:59'!
stack
	"
	self new stack
	"
	
	| view1 label1 stack view2 label2 view3 label3 |
	view1 := ROView new.
	label1 := (ROElement on: 'view 2') + ROLabel @ ROLightlyHighlightable.
	label1 on: ROMouseClick do: [ :event | stack replaceFirstBy: view2 ].
	view1 add: label1.
	view1 addAll: (ROGridLayout on: (ROElement spritesOn: (1 to: 20))).
	
	view2 := ROView new.
	label2 := (ROElement on: 'view 3') +ROLabel @ ROLightlyHighlightable.
	label2 on: ROMouseClick do: [ :event | stack replaceFirstBy: view3 ].
	view2 add: label2.
	view2 addAll: (ROCircleLayout on: (ROElement spritesOn: (1 to: 20))).

	view3 := ROView new.
	label3 := (ROElement on: 'view 1') +ROLabel @ ROLightlyHighlightable.
	label3 on: ROMouseClick do: [ :event | stack replaceFirstBy: view1 ].
	view3 add: label3.
	view3 addAll: (ROHorizontalLineLayout on: (ROElement spritesOn: (1 to: 20))).

	stack := ROViewStack new addFirst: view1.
	stack open! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/9/2012 18:42'!
treeLayout 
	"
	self new treeLayout
	"
	
	| view elements edges |
	view := ROView new.
	elements := ROElement spritesOn: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.

	view open.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 7/14/2012 18:42'!
treeLayoutOn: rawView
	| elements edges |
	elements := ROElement spritesOn: (1 to: 5).
	rawView addAll: elements.
	rawView addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 1/25/2013 08:51'!
zIndexOn: rawView
	| normalizerSize elements |
	
	elements := ROElement forCollection: (1 to: 20).
	elements do: [ :el | 
		el + (ROBorder new size: 30).
		el + (ROBox new 
				color: (el model odd ifTrue: [ Color blue ] ifFalse: [ Color green ])). 
		el @ RODraggable ].
	rawView addAll: elements.
	ROHorizontalLineLayout on: (elements select: [ :el | el model odd ]).
	ROHorizontalLineLayout on: (elements select: [ :el | el model even ]).
	
	(elements select: [ :el | el model even ]) do: [ :el | el translateBy: 5 @ 5 ].
	
	"Elements are displayed from low zIndex to high zIndex"
	rawView zOrdering: (ROZOrdering new 
							setZIndex: 5 if: [ :el | el model odd ]; "Will be displayed first"
							setZIndex: 10 if: [ :el | el model even ]).
! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 1/3/2013 18:10'!
zooming

	"
	self new zooming
	"
	| view els classes stack |
	view := ROView new.
	view @ ROMiniMap .
	self zoomingOn: view.
	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:39'!
zoomingOn: rawView
	| els classes stack |
	
	"We gather what we want to visualize"
	classes := Smalltalk globals allClasses select: [ :c | c name beginsWith: 'RO' ].
	
	"We build the visualization"
	els := ROElement forCollection: classes.
	els do: [:spr |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable 
		].
	rawView addAll: els.
	ROGridLayout on: els.
! !

Object subclass: #ROMondrianExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROMondrianExample commentStamp: '<historical>' prior: 0!
Example for the Mondrian builder!

!ROMondrianExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:48'!
postScript
	^ '
"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
ROEaselMorphic new populateMenuOn: view.
view open'! !

!ROMondrianExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:34'!
preamble
	^ 'rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.'! !

!ROMondrianExample class methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:34'!
preambleVariables
	^ #('view' 'rawView')! !

!ROMondrianExample methodsFor: 'interations' stamp: 'VanessaPena 4/12/2013 13:28'!
addAndRemoveInteractivelyOn: view
	|closed|
	closed := true.
	view shape rectangle withText size: 40.
	view interaction 
		item: 'open/close' action: [  			
			closed 
				ifTrue: [
					view shape rectangle withText size: 40.
					view nodes: (2 to: 4).
					view shape arrowedLine.
					view edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->4); yourself) from: #key to: #value. 
					view treeLayout.
					view applyLayout.
					closed := false.]
				ifFalse: [ 	
					view removeNodesAndEdgesOf: (2 to: 4).
					view treeLayout.
					view applyLayout.
					closed := true.
					 ]				
			].		
	view node: 1.
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 3/6/2013 15:50'!
addingNameOn: view

"Hovering the mouse on a class give a name to its superclass"
view shape rectangle size: 10. 
view interaction on: ROMouseEnter do: [ :event |  
	| elSuperclass |
	elSuperclass := view elementFromModel: event model superclass.
	elSuperclass notNil 
		ifTrue: [ ROAddName toElement: elSuperclass ] ].
 
view interaction on: ROMouseLeave do: [ :event | 
	| elSuperclass |
	elSuperclass := view elementFromModel: event model superclass.
	elSuperclass notNil 
		ifTrue: [ ROAddName removeFrom: elSuperclass ] ].
 
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 21:42'!
attachPoint
	"
	self new attachPoint
	"
	| view |
	view := ROMondrianViewBuilder new.
	self attachPointOn: view.
	view open! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 21:41'!
attachPointOn: view
	view nodes: (ROAttachPoint subclasses) forEach: [ :cls |
		view shape rectangle size: 20.
		view nodes: #(1 2 3).
		view shape line attachPoint: cls new.
		view edgesFromAssociations: (Array with: 1-> 2 with: 2 -> 3 with: 1 -> 3).
		view circleLayout
	].! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
bottomFlowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view bottomFlowLayout.
	 ! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 3/6/2013 15:23'!
centeredText
	"
	self new centeredText
	"
	| view |
	view := ROMondrianViewBuilder new.
	self centeredTextOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'VanessaPena 3/6/2013 16:34'!
centeredTextOn: view

	view shape rectangle; withCenteredText;  width: 180.
	view node: 'centered text'.

	view shape rectangle; withText;  width: 180.
	view node: 'left text'.
	
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 4/18/2013 09:01'!
chooseLayoutOn: view

	(ROGridLayout on: (
	 ((OrderedCollection new) 
		add: ROTreeLayout; 
		add: ROGridLayout; 
		add: ROForceBasedLayout; 
		add: ROCircleLayout; 
		add: ROHorizontalTreeLayout;
		add: ROVerticalLineLayout; 
		add: ROHorizontalLineLayout; 
		add: ROSugiyamaLayout; 
		add: ROBottomFlowLayout; 
		add: ROFlowLayout; 
		add: RONarrowRadialTreeLayout; 
		add: ROScatterplotLayout;
		yourself) collect: [ :layoutClass | 
			| button |
			button := ((ROElement on: layoutClass name)  + ROLabel @ ROLightlyHighlightable + ROBorder).
			button on: ROMouseLeftClick do: [ :event | 
				layoutClass new 
					translator: (ROSmoothLayoutTranslator new);
					applyOn: (view raw elementsFromModels: (1 to: 5)) ].
			view stack firstView add: button.
			button ])) do: [ :button | button translateBy: 0 @ 380 ].

	
	"We start with a very simple graph"
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edgesFromAssociations:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself).
	"We use circle layout as default layout"
	view circleLayout executeOnElements: (view raw elementsFromModels: (1 to: 5)).
	! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:02'!
circleLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view circleLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:28'!
clickToFocus
	"
	self new clickToFocus
	"
	
	| builder | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	self clickToFocusOn: builder.	
	builder open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 9/29/2012 14:50'!
clickToFocusOn: view
		
	view interaction 
		on: ROMouseClick do:  [ :event |  
			ROFocusView on: event element ].
	view shape rectangle size: 30.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/26/2012 19:44'!
coloredSystemComplexity
	"
	self new systemComplexity
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	self coloredSystemComplexityOn: view.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/26/2012 19:44'!
coloredSystemComplexityOn: view
	view shape rectangle 
		width:  [ :cls | cls numberOfVariables * 7 ];  
		height: #numberOfMethods;
		fillColor: (RONColorLinearNormalizer 
					inContext: (Collection withAllSubclasses) 
					withCommand: #numberOfLinesOfCode 
					lowColor: Color green  highColor: Color red).
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:49'!
command

	"
	self new command
	
	An example that shows the commands that can be defined on the builder. Useful to add menus.
	"

	| view |
	view := ROMondrianViewBuilder new.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	
	view addMenu: 'Inspect stack' callBack: [ :stack | stack inspect.  ].

	view addMenu: '+Node Background' callBack: [ :stack | 
		stack firstView add: (ROElement sprite translateTo: 200 atRandom @ 200 atRandom).
		stack signalUpdate ].

	view addMenu: '+Node Foreground' callBack: [ :stack | 
		| el |
		el := ROElement sprite translateTo: 200 atRandom @ 200 atRandom.
		(el getShape: ROBorder) color: Color blue. 
		stack add:  el.
		stack signalUpdate ].
	
	view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
	view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].

	view open.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/7/2013 07:24'!
dynamicEdgeOn: view

	view interaction 
		dynamicEdge: [ :model | (Array with: 10 with: 20 with: 30) copyWithout: model ]
		using: (ROLine arrowed color: Color red).
	view shape rectangle size: 20.
	view nodes: (Array with: 10 with: 20 with: 30).
	view circleLayout.! !

!ROMondrianExample methodsFor: 'dynamic lines' stamp: 'AlexandreBergel 4/7/2013 01:10'!
dynamicLines2On: view
| dep |
dep := Dictionary new.
dep at: #Layer1 put: #(Layer2 Layer3 Layer5).
dep at: #Layer2 put: #(Layer1 Layer3 Layer4 Layer5).
dep at: #Layer3 put: #(Layer1 Layer2 Layer4 Layer5).


view interaction on: ROMouseEnter do: [ :event | 
	| edges | 
	(event view attributes includesKey: #dynamicEdges)
		ifTrue: [ (event view attributes at: #dynamicEdges) do: #remove ].
	event view attributes removeKey: #dynamicEdge ifAbsent: [].
	
	(dep includesKey: event model) ifTrue:
		[ view shape line color: Color red.
		  edges := view edge: event model toAll: [ :n | dep at: n ].
		 event view attributes at: #dynamicEdges put: edges ] ].

view interaction on: ROMouseLeave do: [ :event | 
	(event view attributes includesKey: #dynamicEdges)
		ifTrue: [ (event view attributes at: #dynamicEdges) do: #remove ].
	event view attributes removeKey: #dynamicEdge ifAbsent: [] ].

view shape rectangle withText.
view nodes: #(Layer1 Layer2 Layer3 Layer4 Layer5).
	 
view circleLayout.

! !

!ROMondrianExample methodsFor: 'dynamic lines' stamp: 'AlexandreBergel 4/7/2013 00:32'!
dynamicLinesOn: view
view interaction on: ROMouseEnter do: [ :event |
	view shape line color: Color blue.
	view edgesFrom: [ :i | i // 2 ].
	view raw signalUpdate ].

view interaction on: ROMouseLeave do: [:event |
	view raw allElementsDo: [ :el | el isEdge ifTrue: [ el remove ] ].
	view raw signalUpdate].

view shape rectangle size: 20.
view nodes: (1 to: 20).
	 
view circleLayout .

! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 17:01'!
edgesDefinedOutsideOn: view
	
	"The edges is defined outside the inner nodes. The layout takes those edges into account"
	view nodes: #(1 2) forEach: [ :each |
		view shape label.
		view nodes: (Array with: each * 10 with: (each * 100)). 
		view treeLayout.
		].
	view edgesFromAssociations: (Array with: 10 -> 100 with: 20 -> 200).! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 1/30/2013 12:11'!
explicitIdentityNormalizer2On: view

	 		
	view shape rectangle size: 30; fillColor: 
		(RONExplicitIdentityNormalizer 
						withCommand: #yourself 
						withColors: (Array with: Color blue with: Color white with: Color red)
						withDefaultColor: Color pink).
	view nodes: #(#foo #bar #zork #foo #bar #zork).! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 23:53'!
explicitIdentityNormalizerOn: view

	 		
	view shape rectangle size: 30; fillColor: ( RONExplicitIdentityNormalizer
						withCommand: #yourself
						withColors:  (Array with: Color blue with: Color white with: Color red)
						withDefaultColor: Color pink).
	view nodes: (5 to: 10).! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 4/29/2013 16:51'!
fixedSizeNodeOn: view

	view node: 1 forIt: [  
		view shape rectangle size: 20.
		view nodes: (1 to: 9).
		view gridLayout ].
	
	view horizontalLineLayout 
		on: ROLayoutEnd 
		do: [ :event |  view raw elementsDo: [ :el | el resizeStrategy: (ROFixedSizedParent instance) ] ].! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
flowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view flowLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 20:36'!
forceBasedLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view forceBasedLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 08:49'!
gridLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view gridLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:13'!
highlight
	"
	self new highlight
	"
	| view |

	view := ROMondrianViewBuilder new.
	self highlightOn: view.
	view open. ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:29'!
highlightInnerNodes
	" 
	self new highlightInnerNodes
	"

	| view |
	view := ROMondrianViewBuilder new.
	self highlightInnerNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:38'!
highlightInnerNodesOn: view

	view nodes: (1 to: 5) forEach: [:each |    
		view interaction highlightNodesWhenOver: [ :node | Array with: node ].    
		view shape rectangle withText; size: 20.    
		view nodes: (1 to: each).    
		view gridLayout ].
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 11/27/2012 20:10'!
highlightOn: view
	view interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROHighlightElements on: nodes ].

	view interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROUnhighlightElements on: nodes  ].
	
	view shape rectangle size: 10.
	view nodes: (Collection withAllSubclasses).
	view edgesFrom: #superclass.
	
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/18/2012 16:35'!
highlightSeveralNodes
	"
	self new highlightSeveralNodes
	"

	| view nodes |
	view := ROMondrianViewBuilder new.
	view interaction highlightWhenOver: [:v | ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)  ].
	view shape rectangle 
		width: 40;
		height: 30;
		borderColor: Color black; borderWidth: 2.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	
	view open.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/18/2013 09:21'!
highlightUsingBezierOn: view
	view interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROHighlightElements on: nodes ].

	view interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROUnhighlightElements on: nodes  ].
	
	view shape rectangle size: 10.
	view nodes: (Collection withAllSubclasses).
	view shape bezierLine.
	view edgesFrom: #superclass.
	
	view radialTreeLayout. 
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/1/2012 09:42'!
horizontalTreeLayoutLayeredOn: view

view shape rectangle width: #yourself.
view nodes: (1 to: 100).
view edgesFrom: [:x | x // 2  ].
view horizontalTreeLayout layered.
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/1/2012 09:42'!
horizontalTreeLayoutNoLayeredOn: view

view shape rectangle width: #yourself.
view nodes: (1 to: 100).
view edgesFrom: [:x | x // 2  ].
view horizontalTreeLayout.
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 1/30/2013 12:10'!
identityNormalizer2On: view

	view shape rectangle size: 30; fillColor: RONIdentityNormalizer beginingAtRed.
	view nodes: #(#foo #bar #zork).
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 16:23'!
identityNormalizerOn: view

	view shape rectangle size: 30; fillColor: RONIdentityNormalizer new.
	view nodes: (1 to: 30) , (30 to: 1).
! !

!ROMondrianExample methodsFor: 'basic' stamp: 'ChrisCunningham 2/15/2013 15:52'!
labeledCircle
	"
	self new labeledCircle
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self labeledCircleOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'ChrisCunningham 2/15/2013 15:53'!
labeledCircleOn: view
	
	view shape circle withText.
	view node: 'With rectangle'.
	
	view shape label.
	view node: 'Without rectangle'.

	view shape circle.
	view node: 'Without text'.
! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/2/2012 18:30'!
labeledRectangle
	"
	self new labeledRectangle
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self labeledRectangleOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/3/2012 09:38'!
labeledRectangleOn: view
	
	view shape rectangle withText.
	view node: 'With rectangle'.
	
	view shape label.
	view node: 'Without rectangle'.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 9/25/2012 15:27'!
lineWidthOn: view

	view shape rectangle size: 50.
	view nodes: #( 1 2 ).
	view shape line width: 4.
	
	view interaction popupText: 'edge!!'.
	view edgeFromAssociation: 1 -> 2.
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 23:54'!
linearNumberOn: view

	view shape rectangle size: ((RONumberLinearNormalizer inContext: #(1 2 3 4 3 2 1)) scale: 50).
	view nodes: #(1 2 3 4 3 2 1).

"The script above has the same effect than:
| maxPixel maxValue |
maxPixel := 50.
maxValue := 4.
view shape rectangle size: [:v | (v * maxPixel / maxValue) asInteger ].
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}
"! !

!ROMondrianExample methodsFor: 'edges' stamp: 'VanessaPena 12/23/2012 20:52'!
lines
	"
	self new lines
	"
	| view |
	view := ROMondrianViewBuilder new.
	self linesOn: view.
	view open.! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 5/3/2012 09:38'!
linesOn: view
	view shape label.
	view nodes: #(1 2 3 4 5 6 7 8 9 10).
	view edges: #(1 2 3 4 5 6 7 8 9 10) from: #yourself toAll: (#(1 2 3 4 5 6 7 8 9 10) select: #odd).
	view circleLayout.! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 16:24'!
lowerBoundNormalizerOn: view

	"Color normalizer use white as the lower bound. But it could be any color"
	view shape rectangle size: 30;
		fillColor: (RONColorLinearNormalizer 
					inContext: (1 to: 10) lowColor: Color gray highColor: Color black).
		
	view nodes: (1 to: 10).! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 22:44'!
makingInvisibleEdgesOn: view

	"The mondrian builder adds a shape per default. But this can be easily bypassed by using the low level facilities of Roassal"
	view nodes: Collection withAllSubclasses.
	(view edgesFrom: #superclass) do: [ :edge | edge - ROEdge ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:31'!
menuOnNodes

	"
	self new menuOnNodes
	Right click on a node gives a menu
	"

	| view |
	
	view := ROMondrianViewBuilder new.
	self menuOnNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/2/2012 20:31'!
menuOnNodesOn: view
	view shape rectangle size: 15.
	view interaction 
		item: 'inspect element' action: #inspect;
		item: 'inspect model' action: [ :el | el model inspect ];
		item: 'browse element class' action: [ :el | el model browse ].
	view nodes: (1 to: 5).
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:21'!
methodComplexity

	"
	self new methodComplexity 
	"
	| view d connectedMethods disconnectedMethods methodShape |
	view := ROMondrianViewBuilder titled: 'Method Complexity'.
	self methodComplexityOn: view.
	view open! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:15'!
methodComplexityFor: classes on: view

	| d connectedMethods disconnectedMethods methodShape |
	
	
	view nodes: classes forEach: [ :cls |
		d := IdentityDictionary new.
		cls methods do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 10/1/2012 12:30'!
methodComplexityOn: view
	| classesToAnalyze |
	
	"We analyze only the classes of Roassal"
	classesToAnalyze := (Object allSubclasses select: [ :cls | cls name beginsWith: 'RO' ]).
	view nodes: classesToAnalyze forEach: [ :cls |
		| d connectedMethods disconnectedMethods methodShape nativeUtil |
		d := IdentityDictionary new.
		nativeUtil := RONativeExampleUtility current .
		(nativeUtil getMethodsForClass: cls) do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:01'!
middleArrowOnEdgesOn: view
	view shape label.
	view nodes: #(1 2 3 ). 
	
	view shape arrowedLineWithOffset: 0.5.
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 3 -> 1).
	view circleLayout.
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'VanessaPena 1/2/2013 15:46'!
miniMap

"
	self new miniMap
 "
	|view|
	
	view := ROMondrianViewBuilder new.
	self miniMapOn: view.	
	view open.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'VanessaPena 1/3/2013 18:10'!
miniMapOn: view

	view raw @ (ROMiniMap new targetView: view stack).
	
	"press m to open the view minimap "
	
	view shape rectangle 
		width:  [ :cls | cls numberOfVariables * 5 ];  
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within:  Collection withAllSubclasses.
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'VanessaPena 1/3/2013 16:36'!
mouseMoveOn: view
	|node|
	
	view shape rectangle size: 50.
	node := view node: 'Hola'.
	view raw
		on: ROMouseMove 
		do: [:event | 
			|position x y|
			position := event position - node position.
			(position x = 0)
				ifTrue: [ x := 0 ]
				ifFalse: [ x := (position x / (position x abs)) ].
			(position y = 0)
				ifTrue: [ y := 0 ]
				ifFalse: [ y := (position y / (position y abs)) ].
			node translateByRealPoint: x@y. 
			view raw signalUpdate .].! !

!ROMondrianExample methodsFor: 'key pressing' stamp: 'VanessaPena 1/2/2013 15:41'!
moveViewWithKeys

"

	self new keyPressingMondrian

"

	|view |
	view := ROMondrianViewBuilder  new.
	self moveViewWithKeysOn: view.
	view open.! !

!ROMondrianExample methodsFor: 'key pressing' stamp: 'VanessaPena 1/2/2013 15:41'!
moveViewWithKeysOn: view

	view stack on: ROKeyDown  do: [:evt |
		|keyValue|
		keyValue  := evt keyValue.
		keyValue = 30 "up arrow"
			ifTrue: [view raw translateBy: 0@1].
		keyValue = 31 "down arrow"
			ifTrue: [view raw translateBy: 0@(-1)].
		keyValue = 29 "right arrow"
			ifTrue: [view raw translateBy: (-1)@0].
		keyValue = 28 "left arrow"
			ifTrue: [view raw translateBy: 1@0]
	].
	view shape rectangle size: 50; color: Color green.
	view nodes: (1 to: 400).
	view gridLayout.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:34'!
multilineLabel
	"
	self new multilineLabel
	"

	| view |
	view := ROMondrianViewBuilder new.
	self multilineLabelOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 1/30/2013 12:03'!
multilineLabelOn: view
	view shape label text: [:m | 'line1
	  line2
		line3    ']; color: Color blue.
	view node: 'a'.! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/4/2012 00:04'!
multipleColorLinearOn: view
	view shape rectangle size: 60; fillColor: (ROMultipleColorLinearNormalizer 
					valueRange: #(5 10 15) colorRange: (Array with: Color blue with: Color white with: Color red)).
	view nodes: (5 to: 15).		! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggable 
	"
	self new nodraggable
	"

	| view |
	view := ROMondrianViewBuilder new.
	self nodraggableOn: view.
	
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggableOn: view
	view interaction nodraggable.
	view shape label.
	view node: 'Cannot be dragged'.
	
	view shape label.
	view node: 'Can be dragged'.! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 8/22/2012 18:58'!
orthoHorizontalWithArrowLineOn: view

	view nodes: 
	( Array 
		with: [ROHorizontalArrow new offset: 0]
		with: [ROReversedHorizontalArrow new offset: 0]
		with: [ROHorizontalArrow new offset: 1] 
		with:  [ROReversedHorizontalArrow new offset: 1]
	)
	forEach: 
	[ 	:exampleBlock | 
		view shape rectangle size: 20.
		view nodes: (1 to: 16). 
		view shape: (ROOrthoHorizontalLineShape new add: exampleBlock value ).
		view edgesFrom: [ :i | (i / 4) ceiling ].
		view horizontalTreeLayout verticalGap: 10. 
	].
	view horizontalLineLayout.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/30/2012 00:02'!
orthoVerticalLineOn: view

	view shape rectangle size: 20.
	view nodes: (1 to: 20). 
	view shape: (ROOrthoVerticalLineShape new).
	view edgesFrom: [ :i | i \\ 3 ].
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 8/22/2012 18:59'!
orthoVerticalWithArrowLineOn: view

	view nodes: 
	(Array 
		with:  [ROVerticalArrow new offset: 0]
		with: [ROReversedVerticalArrow new offset: 0]
		with: [ROVerticalArrow new offset: 1]
		with: [ROReversedVerticalArrow new offset: 1]
	) 
	forEach: 
	[ 	:exampleBlock | 
		view shape rectangle size: 20.
		view nodes: (1 to: 16). 
		view shape: (ROOrthoVerticalLineShape new add: exampleBlock value ).
		view edgesFrom: [ :i | (i / 4) ceiling ].
		view treeLayout horizontalGap: 10. 
	].
	view verticalLineLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: ''!
polymetricViewWithMethods
	"
	self new polymetricViewWithMethods
	"

	| view classes elements  edge nodes |
	"Gathering the data"
	classes := ROTest withAllSubclasses.
	
	"Visualzing the data"
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
	nodes := view nodes: classes.
	nodes do: [:n | n @ ROZoomOnClick ].
	
	view edgesFrom: #superclass.
	view treeLayout.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/30/2012 17:29'!
popupAndNoPopup
	"
	self new popupAndNoPopup
	"
	
	| view |
	view := ROMondrianViewBuilder titled: 'Popup and No popup'.
	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.
	
	view shape label.
	view node: 'I have a popup'.

	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.

	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: ''!
popupView
	"
	self new popupView
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	view open
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:43'!
popupViewOn: view

	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 1/30/2013 12:11'!
scatterLayoutOn: view

	view node: 'scatter layout' forIt: [
		view nodes: #(#(10 5) #(20 50) #(2 4) #(60 20)).
		view layout: (ROScatterplotLayout new
						upSideDown;
						scaleFactor: 2;
						x: #first;
						y: #second) ].! !

!ROMondrianExample methodsFor: 'interations' stamp: 'BenComan 12/16/2012 15:12'!
selectionOn: view
| statusBar activeSelection |

activeSelection := ROSelection new					
	onInclusion: [ :element | ROHighlightElement on: element color: Color red ];
	onExclusion: [ :element | ROUnhighlightElement on: element ].
statusBar := (ROElement on: activeSelection) + (ROLabel text: [ :el | el model asString ]) + ROBox white.
view stack add: statusBar.
statusBar translateTo: 0 @ 480.

view shape label.
view interaction on: ROMouseLeftClick do: 
[	:ann | 
	ann shiftKeyPressed ifFalse: [ activeSelection clear ].
	activeSelection add: ann element.						
].
view nodes: #(1 2 3 4 5).
view gridLayout.

"TODO: Clicking on background should clear selection"

! !

!ROMondrianExample methodsFor: 'interations' stamp: 'VanessaPena 1/8/2013 14:55'!
semanticZoomOn: view
|zoom|

	zoom := ROZoomIntoElementOnClick new.
	zoom 
		stack: view stack; 
		view: [:el | |v|
			v := ROView new.
			v addAll: (ROElement spritesOn: (el model subclasses )).
			v elementsDo: [:el2 | el2 +ROLabel ].
			ROGridLayout new on: v elements.
			v translateBy: 0@30.
			v			
			];
		recursive: true.
	view raw add: (ROElement sprite model: ROInteraction; + ROLabel; @zoom; yourself).! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/18/2012 16:56'!
shrikingSizeOn: view
	| outterNode |
	
	outterNode := view node: 'hello' forIt: [ 
	view shape rectangle withText.
	view interaction on: ROMouseClick do: [ :event | 
		outterNode remove: event element. 
		ROHorizontalLineLayout on: outterNode elements.
		
		ROShrikingSize on: outterNode. 
		event element signalUpdate  ].
	 
	view nodes: (1 to: 20).
	].
	
	"Make the outter node shrink when it can"
	outterNode resizeStrategy:  ROShrinkingParent new.! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:16'!
simpleHierarchy
	"
	self new simpleHierarchy 
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self simpleHierarchyOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:15'!
simpleHierarchyOn: view
	
	view shape rectangle size: 20.
	view nodes: (1 to: 20).
	view shape line.
	view edgesFrom: [ :i | i \\ 3 ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/3/2012 19:08'!
statusBarOn: view
| statusBar |

statusBar := ROElement new + ROLabel + ROBox white.
view stack add: statusBar.
statusBar translateTo: 0 @ 480.

view interaction on: ROMouseEnter do: [ :event | 
	statusBar model: event element model.
].
view shape rectangle size: 10.
view nodes: (Collection withAllSubclasses).
view edgesFrom: #superclass.
view treeLayout.! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 09:27'!
step1CreatingNodesOn: view

	"A mondrian view is composed of nodes and egdes. 
	In this first step, we will have the simplest visualization possible. 
	A list of nodes representing each subclass of the class Collection."
	view nodes: Collection withAllSubclasses.
	"Since no shape is defined, each node is represented as a small white square, with a black border.
	The size of the square is 5 pixels wide.
	
	No layout is specified, therefore the horizontal line layout is used per default.
	All the nodes are lined up horizontally.
	
	Wave the mouse over a node, a popup will tell you which node you are pointing to.
	You can individually drag and drop each node.
	The whole view may be move around by dragging and dropping where there is no node, in the background."! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 10:23'!
step2AddingEdgesOn: view

	"We will now add edges to represent the superclass hierarchy of the collection classes."
	view nodes: Collection withAllSubclasses.
	
	"The message #edgesFrom: tells Roassal to draw edges between each node. The message #superclass is sent to each nodes (i.e., each subclass of Collection). A line is draw for each couple (subclassOfCollection -> subclassOfCollection superclass)."
	view edgesFrom: #superclass.
	
	"We need to provide a layout to structure the visualization. A tree layout is appropriate in Smalltalk since a class has only one superclass."
	view treeLayout.
	"The tree layout places a superclass aboves its subclasses.
	
	The Easel offers a number of actions. Zoom in, zoom out and find objects. Really handy and you have many nodes and you are looking for a specific node.
	"! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/12/2012 21:56'!
step3DefiningShapeOn: view

	"Up to now, all the boxes have the same graphical aspect (i.e., a 5 pixels white square). 
	Each node may particularize its shape depending on the object that is rendered."
	
	"We will now define a new shape in which the height represents the amount of mehtods the class has,
	Its width is the amount of variables the class defines."
	view shape rectangle 
		width: [ :cls | cls instVarNames size ]; 
		height: [ :cls | cls methods size ].
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:01'!
step4ColoringShapeOn: view

	"Shapes may be colored in many different ways. "
	
	"Let's paint with a blue border the classes for which the word Array appear in their name.
	Classes with Hash in their name will have a green border."
	
	"Classes are painted in veryLightGray. Classes with more than 20 methods are in gray.
	 The one with more than 30 methods are in back"
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		if: [ :cls | '*Array*' match: cls name ] borderColor: Color blue;
		if: [ :cls | '*Hash*' match: cls name ] borderColor: Color green;
		
		fillColor: Color veryLightGray;
		if: [ :cls | cls methods size > 20 ] fillColor: Color gray;
		if: [ :cls | cls methods size > 30 ] fillColor: Color black.
		
		
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:38'!
step5LinearFillColorOn: view

	"In the previous step, we have related the amount of methods a class may have with the darkness of its color:
	many methods is associated to black and few methods with light gray. In chromatography, the lightness (or darkness) of a color is called its 'value'.
	Relating a metric (e.g., the number of methods) with the color value is a common behavior that deserves its own facilities. "

	"In this example, we relate the number of lines of code a class has with its color value."
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		linearFillColor: #linesOfCode within: Collection withAllSubclasses.
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
	
	"linearFillColor: aBlock within: aCollection computes for each node a numerical value using aBlock and associates a gray value.
	The visualization we have obtained is well know in the field of software visualization. It is called 'System Complexity'. More description of this fantastic visualization may be found in the publication 'Polymetric Views -- A Lightweight Visual Approach to Reverse Engineering', TSE 29(9), 2003."
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:43'!
step6NestingNodesOn: view

	"Until now, the only relation between nodes that we have expressed is linking them with an edge. Another way to relate nodes is to nest them. A node acts as a view in which nodes and edges may be added."

	"Methods may be added within a class using nodes:forEach:"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 7/14/2012 19:00'!
step7GridLayoutOn: view

	"Having a long horizontal list of methods is not that exciting. They can be ordered a little bit by using a grid layout"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
		
		
		"The amount of space between each nodes may be specified using gapSize:. "
		view gridLayout gapSize: 2.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'DR 1/15/2013 21:11'!
step8PaintingMethodsOn: view


	"We will now paint the methods according to their amount of lines of code "
	
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		
		"The color of an element may be conditionally picked. "
		view shape rectangle
				if: [ :cm | cm numberOfLinesOfCode > 5 ] fillColor: Color green;
				if: [ :cm | cm numberOfLinesOfCode > 10 ] fillColor: Color red.
				
		view nodes: (aClass methods 
						asSortedCollection: [ :m1 :m2 | m1 numberOfLinesOfCode > m2 numberOfLinesOfCode]).
		view gridLayout gapSize: 2.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'VanessaPena 11/21/2012 00:04'!
systemComplexity
	"
	self new systemComplexity
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	self systemComplexityOn: view.
	view open.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 1/18/2013 15:22'!
systemComplexityFor: classes
	"
	self new systemComplexityFor: Morph withAllSubclasses
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
		
	view interaction popupText: [ :cls | 
		cls name, String cr, 
		cls methods size printString, ' methods', Character cr asString, 
		cls instVarNames size printString, ' variables', Character cr asString,
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: classes.
	view edgesFrom: #superclass.
	view treeLayout.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 7/14/2012 14:15'!
systemComplexityOn: view
	view shape rectangle 
		width:  [ :cls | cls numberOfVariables * 5 ];  
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within:  Collection withAllSubclasses.
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 3/6/2013 16:10'!
temporaryEdges 
	"
	self new temporaryEdges
	"

	| view |
	view := ROMondrianViewBuilder new.
	self temporaryEdgesOn: view.
	
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 3/6/2013 16:10'!
temporaryEdgesOn: view
| addedEdges wrongDependencies classes inheritanceLinks |

"My classes"
classes := #('Object' 'Model' 'Database' 'Car').
"My inheritance links"
inheritanceLinks :=
	Array with: 'Object' -> 'Model'
			with: 'Object' -> 'Database'
			with: 'Model' -> 'Car'.
"My wrong dependencies"
wrongDependencies := 
	Array with: 'Object' -> 'Database' 
		with: 'Car' -> 'Database'.

"Showing some (fake) dependencies"
addedEdges := nil.
view interaction on: ROMouseEnter do: [ :event |
	view shape arrowedLineWithOffset: 0.5; color: Color red.
	addedEdges := 
		view edgesFromAssociations: 
			wrongDependencies.
	view raw signalUpdate.
].

view interaction on: ROMouseLeave do: [ :event | 
	addedEdges ifNotNil: [ 
		addedEdges do: #remove. 
		addedEdges := nil.
		view raw signalUpdate. ].
].

"My system is made of 4 classes"
view shape rectangle withText.
view nodes: classes.

"Showing UML like diagram"
view shape arrowedLineReversed.
view edgesFromAssociations:
	inheritanceLinks.
			
view treeLayout.! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 19:59'!
treeLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view treeLayout.
	 ! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 11/1/2012 12:15'!
umlAggregateOn: view

	view shape rectangle withText.
	view nodes: #( 'container' 'element' ).
	view shape: (ROLine new add: (RODiamond new offset: 1 )).
	view edgesFromAssociations: (Array with: 'container' -> 'element' ).
	view treeLayout verticalGap: 40. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:04'!
umlLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROReversedVerticalArrow new offset: 1 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:05'!
umlReallyUpSideDownLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROVerticalArrow new offset: 1 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:05'!
umlUpSideDownLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROVerticalArrow new offset: 0 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 12:10'!
viewCollectionSubclassesTreeMapsOn: view			
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
			
	"Set size of all treemaps to 100 by 100."		
	view shape size: 100.
	
	view nodes: Collection subclasses forEach: [ :each |
			| subClasses |
			subClasses := each allSubclasses.
			subClasses notEmpty ifTrue: [
				
				view nodes: subClasses.
				view edgesFrom: #superclass.			
				view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model numberOfLinesOfCode ]).	
			].
	].
	
	view gridLayout. ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 12:34'!
viewCollectionSubclassesTreesOn: view
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
	
	view shape size: 100.
	
	view nodes: Collection subclasses forEach: [ :each |
			| subClasses |
			subClasses := each allSubclasses.
			subClasses notEmpty ifTrue: [
				view nodes: subClasses.
				view edgesFrom: #superclass.			
				view treeLayout.	
			].
	].
	
	view gridLayout. ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:34'!
viewCollectionTreeMapOn: view
	
	"Adding basic interaction capabilities to nodes: 
	 - Add a menu item which lets one explore the model of the node.
	 - Another menu item which lets one browse the class represented by the node.
	 - Show the node name on hover."
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
	
	"The treemap should have a dimension of 400 by 400."	
	view shape width: 400; height: 400.

	"Our nodes are all subclasses of Collection."
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	
	"The weights we use to draw the treemap are the classes lines of code (LOC)."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model numberOfLinesOfCode ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:16'!
viewMultipleTreeMapsOn: view
	
	"Make every treemap have a size of 100x100."
	view shape rectangle size: 100.

	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
			
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			(Array with: (each*10) -> (each*10+each*5*1) 
				    with: (each*10) -> (each*10+each*5*2)
				    with: (each*10) -> (each*10+each*5*3)
				    with: (each*10) -> (each*10+each*5*4)
				    with: (each*10) -> (each*10+each*5*5)
				    with: (each*10) -> (each*10+each*5*6)
			).
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].
	view edgesFromAssociations: 
		(Array with: 1 -> 2 with: 1 -> 3 with: 1 -> 4).	

	view treeLayout.
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:15'!
viewMultipleTreesOn: view
	
	"Displays the same tree as displayed in viewMultipleTreeMapsOn but as normal tree."
	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
			
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			(Array with: (each*10) -> (each*10+each*5*1) 
				    with: (each*10) -> (each*10+each*5*2)
				    with: (each*10) -> (each*10+each*5*3)
				    with: (each*10) -> (each*10+each*5*4)
				    with: (each*10) -> (each*10+each*5*5)
				    with: (each*10) -> (each*10+each*5*6)
			).
		view treeLayout.
	].

	view edgesFromAssociations: 
		(Array with: 1 -> 2 with: 1 -> 3 with: 1 -> 4).	

	view treeLayout.
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:35'!
viewSimpleTreeMapOn: view
	
	"Adding basic interaction capabilities: 
	 - Add a menu item which lets one explore the model of a node
	 - Show the node name on hover"	
	view interaction 
		item: 'Explore Element' action: #explore;
		popupText: [ :node | node ].
	
	"The treemap should have a dimension of 400 by 400."
	view shape width: 400; height: 400.
	
	"The nodes we draw are simply the numbers from 0 to 76."
	view nodes: (0 to: 76).
	view edgesFrom: [ :each | each // 10 ].
	
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:15'!
viewSimpleTreeOn: view

	"Displays the same tree as displayed in viewSimpleTreeMap but as normal tree."
	view shape rectangle.
	view nodes: (0 to: 76).
	view edgesFrom: [ :each | each // 10 ].
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:35'!
viewTreeMapOn: view
		
	"Adding basic interaction capabilities: 
	 - Add a menu item which lets one explore the model of a node
	 - Show the node name on hover"
	view interaction 
		item: 'Explore Element' action: #explore;
		popupText: [ :node | node ].
	
	"The treemap should have a dimension of 500 by 500."
	view shape width: 500; height: 500.

	"The nodes we draw are simply the numbers from 0 to 999."
	view nodes: (0 to: 999).
	view edgesFrom: [ :each | each // 10 ].
		
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 9/23/2012 12:48'!
viewVerySimpleTreeMapOn: view
	
	"Draw a Treemap that ihas a size of 100x100."
	view shape size: 100.
	
	"The nodes we draw are simply the numbers from 0 to 6."
	view nodes: 
		(OrderedCollection new add: 1;  add: 2; add: 3; add: 4; add: 5; add: 6; yourself).
	
	view edgesFromAssociations: 
		(OrderedCollection new add: 1 -> 2; add: 1 -> 3; add: 3 -> 4; add: 3 -> 5; add: 4 -> 6; yourself).
	
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

!ROMondrianExample methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 18:12'!
zOrderingOn: view

"zOrdering tells about the order the objects have to be displayed. 
This example gives a zIndex of 5 to edges, and 10 to nodes. Edges will be displayed first as a consequence."
view raw zOrdering: (ROZOrdering new 
						setZIndex: 5 if: #isEdge;
						setZIndex: 10 if: #isNotEdge).
						
view shape label text: #yourself.
view nodes: (1 to: 20).
view edges: (1 to: 20) from: [:x | x // 2] to: 1.
view edges: (1 to: 20) from: [:x | x // 3] to: 2.
view edges: (1 to: 20) from: [:x | x // 5] to: #yourself.
view edges: (1 to: 20) from: [:x | x // 7] to: #yourself.
view dominanceTreeLayout.! !

!ROMondrianExample methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 18:12'!
zOrderingOnDepthOn: view

"zOrdering tells about the order the objects have to be displayed. 
This example gives a zIndex of 5 to edges, and 10 to nodes. Edges will be displayed first as a consequence."
view raw zOrdering: (ROZOrdering new 
						setZIndex: [ :element | element depth ] if: true).
						
view shape label text: #yourself.
view nodes: (1 to: 20).
view edges: (1 to: 20) from: [:x | x // 2] to: 1.
view edges: (1 to: 20) from: [:x | x // 3] to: 2.
view edges: (1 to: 20) from: [:x | x // 5] to: #yourself.
view edges: (1 to: 20) from: [:x | x // 7] to: #yourself.
view dominanceTreeLayout.! !

Object subclass: #RONode
	instanceVariableNames: 'element father layer theta r x leftContour rightContour pointer mod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Algorithm'!

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:54'!
element
	"comment stating purpose of message"

	^element! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:53'!
element: anElement
	"comment stating purpose of message"

	element  := anElement ! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:47'!
father
	"comment stating purpose of message"

	^ father! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:55'!
father: aNode
	"comment stating purpose of message"

	father := aNode! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/26/2013 15:30'!
initialize
	super initialize .
	
		layer := 0.
		father := nil.
		leftContour := nil.
		rightContour := nil.
		x := 0.
		theta := 0.
		r := 0.! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:48'!
layer
	"comment stating purpose of message"

	^ layer! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:48'!
layer: anInteger
	"comment stating purpose of message"

	layer := anInteger! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:20'!
leftContour
	
	
	^leftContour! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 13:00'!
leftContour: aRONode
	
	
	leftContour := aRONode! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 16:21'!
mod
	
	
	^mod
	! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 11:11'!
mod: aFloat
	
	
	mod := aFloat
	! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:52'!
pointer

	^ pointer! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 21:40'!
pointer: aNode

	pointer := aNode ! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 3/4/2013 11:34'!
printOn: aStream
	"comment stating purpose of message"

	element ifNotNil: [ element printOn: aStream ] 
			 ifNil: [super printOn: aStream ]! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
r
	
	
	^r! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
r: aFloat
	
	
	r := aFloat
	! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:20'!
rightContour
	
	
	^rightContour! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 13:00'!
rightContour: aRONode
	
	
	rightContour := aRONode! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 13:22'!
theta
	"return the argument of the node's position in the radial tree"
	
	^theta
	! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
theta: aFloat
	
	
	theta := aFloat
	! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 20:48'!
x
	
	
	^x! !

!RONode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 20:48'!
x: aFloat
	
	
	x := aFloat
	! !

Object subclass: #ROObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROObject commentStamp: '<historical>' prior: 0!
A ROObject is the root of the roassal class hierarchy. The idea to have ROObject is to have an empty initialize and a new on the class side that calls the initialize. This class is particuarly useful in VisualWorks since Object does not has an initialize!

ROObject subclass: #ROAbstractAnimationMergeStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

ROAbstractAnimationMergeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractAnimationMergeStrategy commentStamp: '<historical>' prior: 0!
A ROAbstractAnimationMergeStrategy is a hierarchy of merging strategy for animation. Each animation has a merging strategy.
!

ROAbstractAnimationMergeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractAnimationMergeStrategy class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/2/2013 18:59'!
instance
	^ instance isNil ifTrue: [  instance := self new ] ifFalse: [ instance ]! !

!ROAbstractAnimationMergeStrategy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/2/2013 19:16'!
added: animation in: aView
	"The animation for which I am associated with has been added in aView"
	self subclassresponsibility! !

!ROAbstractAnimationMergeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 5/2/2013 18:58'!
isAppend
	^ false! !

!ROAbstractAnimationMergeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 5/2/2013 19:02'!
isExclusive
	^ false! !

ROAbstractAnimationMergeStrategy subclass: #ROAnimationAppend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAnimationAppend commentStamp: '<historical>' prior: 0!
A ROAbstractAnimationAppend means that an animation is simply added to the queue kept in the view. This is the default strategy!

!ROAnimationAppend methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/2/2013 19:16'!
added: animation in: aView
	"The animation for which I am associated with has been added in aView"
	"Good, so we do nothing"! !

!ROAnimationAppend methodsFor: 'testing' stamp: 'AlexandreBergel 5/2/2013 18:57'!
isAppend
	^ true! !

ROAbstractAnimationMergeStrategy subclass: #ROAnimationExclusive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAnimationExclusive commentStamp: '<historical>' prior: 0!
A ROAnimationExclusive replaces all other animation for the element!

!ROAnimationExclusive methodsFor: 'hooks' stamp: 'AlexandreBergel 5/3/2013 08:37'!
added: animation in: aView
	"The animation for which I am associated with has been added in aView"
	"We need to remove all other animation"
	aView removeAnimationSuchThat: [ :ani | ani class == animation class ]! !

!ROAnimationExclusive methodsFor: 'testing' stamp: 'AlexandreBergel 5/2/2013 19:02'!
isExclusive
	^ true! !

ROObject subclass: #ROAbstractCanvas
	instanceVariableNames: 'camera extent nativeCanvas offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractCanvas commentStamp: 'AlexandreBergel 8/19/2012 13:01' prior: 0!
A ROAbstractCanvas is the abstract class of the canvases. In the core of Roassal, it has only one subclass, RONullCanvas. The platform package should subclass ROAbstractCanvas.

Instance Variables
	camera:		<ROCamera>
	canvas:		<Object>
	extent:		<Point>

camera
	- xxxxx

canvas
	- xxxxx

extent
	- xxxxx
!

!ROAbstractCanvas class methodsFor: 'public' stamp: 'AlexandreBergel 4/19/2012 12:18'!
canvas: canvas camera: camera
	^ self new canvas: canvas; camera: camera; yourself! !

!ROAbstractCanvas class methodsFor: 'configuration' stamp: 'AlexandreBergel 4/19/2012 12:17'!
defaultExtent
	^ 40 @ 30! !

!ROAbstractCanvas class methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:19'!
onCamera: camera
	"Return a new canvas with a created canvas"
	"Implementation example: 
		| form canvas |
		form := Form extent: camera realExtent depth: Display depth.
		canvas := FormCanvas on: form.
		^ self canvas: canvas camera: camera
	"
	self subclassResponsibility! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera
	^ camera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera: aROCamera
	camera := aROCamera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 17:44'!
canvas
	^ nativeCanvas! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 17:44'!
canvas: aNativeCanvas 
	nativeCanvas := aNativeCanvas! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint 
	"Render a string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: Color black
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint color: color
	"Render a colored string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
			canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at:  p font: f color: color
	"Render a colored string at a given position using a particular font."
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: p) font: f color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
extent: aPoint
	extent := aPoint! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"Render an oval"
	"Implementation example
		canvas
		fillOval: (self virtualToRealRectangle: aRectangle)  color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
fillRectangle: aRectangle color: fillColor 
	"Render a rectangle"
	"Implementation example
	
		canvas fillRectangle: (self virtualToRealRectangle: aRectangle) color: fillColor
	"
	
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
form
	"Return a bitmap"
	"Implementation example
		^ canvas form
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:05'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	"Render a framed rectangle. Implementation example:

	canvas 
		frameAndFillRectangle: (self virtualToRealRectangle: aRectangle) fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor.
	"
	
	self subclassResponsibility.! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 7/27/2012 15:47'!
initialize 
	super initialize.
	
	extent := self class defaultExtent.
	
	"Maybe a global camera would be useful. The camera object is never used normally. Since the camera of the view has to be set prior any drawing"
	camera := ROCamera new.
	
	offset := 0 @ 0! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	"Draw a line between two points"
	"Implementation example
		canvas line: (self virtualToRealPoint: aPoint) to: (self virtualToRealPoint: aPoint2) width: aSmallInteger color: aColor.

	"
	self subclassResponsibility 
	


	! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 15:52'!
offset
	^ offset! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 15:22'!
offset: anOffsetAsPoint
	offset := anOffsetAsPoint ! !

!ROAbstractCanvas methodsFor: 'convenient' stamp: 'AlexandreBergel 4/19/2012 12:07'!
paintBackground: color

	self 
		frameAndFillRectangle: (camera realToVirtualRectangle: (0@0 extent: extent)) 
		fillColor: color
		borderWidth: 0 
		borderColor: Color white.! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:08'!
paintImage: aForm at: aPoint
	"Render a bitmap on screen"
	"Implementation example
		canvas paintImage: aForm at:  (self virtualToRealPoint: aPoint) 

	"
	self subclassResponsibility 
! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ camera realToVirtualPoint: aPoint
! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ camera realToVirtualRectangle: aRectangle! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 7/27/2012 15:51'!
virtualToRealPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ (camera virtualToRealPoint: aPoint) + offset
! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'VanessaPena 11/13/2012 19:39'!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ (camera virtualToRealRectangle: aRectangle) translateBy: offset! !

ROAbstractCanvas subclass: #RONullCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RONullCanvas commentStamp: '<historical>' prior: 0!
A RONullCanvas is a null canvas. Useful when testing.!

!RONullCanvas class methodsFor: 'public' stamp: 'AlexandreBergel 7/29/2012 12:45'!
onCamera: camera
	self error: 'Should not be called'! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at: aPoint 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at: aPoint color: color

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at:  p font: f color: color

	! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
fillRectangle: aRectangle color: fillColor 
! !

!RONullCanvas methodsFor: 'util' stamp: 'AlexandreBergel 7/27/2012 09:33'!
form
! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
paintImage: aForm at: aPoint
! !

ROAbstractCanvas subclass: #ROTracingCanvas
	instanceVariableNames: 'trace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROTracingCanvas commentStamp: '<historical>' prior: 0!
A ROTracingCanvas records all the drawing operations. It is essentially used by the test

Instance Variables
	trace:		<Array>

trace
	- list of drawing operations performed on the canvas!

!ROTracingCanvas class methodsFor: 'public' stamp: 'AlexandreBergel 12/10/2012 19:18'!
onCamera: camera
	self error: 'Should not be called'! !

!ROTracingCanvas methodsFor: 'util' stamp: 'AlexandreBergel 12/14/2012 13:57'!
colToStr: aColor
	"This method is useful for VW when Color white printString = 'ColorValue white'"
	| str |
	str := aColor printString.
	^ ((RONativeExampleUtility current substringsFor: str) size = 2)
			ifTrue: [ 'Color ', (RONativeExampleUtility current substringsFor: str) second ] 
			ifFalse: [ str ]! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:44'!
drawString: aByteString at: aPoint 
	trace add: (Array with: #drawString with: aByteString with: (self pointToStr: aPoint))! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:44'!
drawString: aByteString at: aPoint color: color
	trace add: (Array with: #drawStringColor with: aByteString with: (self pointToStr: aPoint) with: (self colToStr: color))! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 4/22/2013 09:15'!
drawString: aByteString at:  p font: f color: color
	| array |
	array := Array new: 5.
	array at: 1 put: #drawStringColor;
		  at: 2 put: aByteString;
		  at: 3 put: (self pointToStr: p);
		  at: 4 put: f height;
		  at: 5 put: (self colToStr: color).
	trace add: array.! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:49'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	trace add: (Array with: #fillOval: with: (self recToStr: aRectangle) with: aSmallInteger with: (self colToStr: aColor))! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:45'!
fillRectangle: aRectangle color: fillColor 
	trace add: (Array with: #fillRectangle with: (self recToStr: aRectangle) with: (self colToStr: fillColor))! !

!ROTracingCanvas methodsFor: 'util' stamp: 'AlexandreBergel 4/22/2013 09:15'!
fontToStr: f

	^ f name, ' ', f pointSize printString
	 ! !

!ROTracingCanvas methodsFor: 'util' stamp: 'AlexandreBergel 12/10/2012 19:18'!
form
! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:45'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	trace add: ((Array with: #frameAndFillRectangle: with: (self recToStr: aRectangle) with: (self colToStr: fillColor)), (Array with: aSmallInteger with: (self colToStr: aColor)))! !

!ROTracingCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 12/10/2012 19:18'!
initialize 
	super initialize.
	trace := OrderedCollection new! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:46'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	trace add: ((Array with: #line with: (self pointToStr: aPoint) with: (self pointToStr: aPoint2)), (Array with: aSmallInteger with: (self colToStr: aColor)))! !

!ROTracingCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 12/14/2012 13:46'!
paintImage: aForm at: aPoint
	trace add: (Array with: #paintImage with: (self pointToStr: aPoint))! !

!ROTracingCanvas methodsFor: 'util' stamp: 'AlexandreBergel 12/14/2012 13:33'!
pointToStr: aPoint
	^ '(', aPoint x printString, '@', aPoint y printString, ')'! !

!ROTracingCanvas methodsFor: 'util' stamp: 'AlexandreBergel 12/14/2012 13:34'!
recToStr: rectangle
	"Return a textual description of a rectangle"
	
	^ (self pointToStr: rectangle origin), ' corner: ', (self pointToStr: rectangle corner)! !

!ROTracingCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 11:59'!
trace
	^ trace copy asArray! !

ROObject subclass: #ROAbstractResizeStrategy
	instanceVariableNames: 'padding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy commentStamp: 'AlexandreBergel 3/2/2012 19:40' prior: 0!
This hierarchy defines how a parent should behave when a child is resized.!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy class methodsFor: 'public' stamp: ''!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAbstractResizeStrategy class methodsFor: 'public' stamp: 'AlexandreBergel 4/22/2013 19:28'!
reset
	instance := nil! !

!ROAbstractResizeStrategy class methodsFor: 'public' stamp: 'AlexandreBergel 5/6/2013 17:59'!
resetAll
	self allSubclasses do: #reset! !

!ROAbstractResizeStrategy methodsFor: 'configuration' stamp: 'JurajKubelka 4/24/2013 10:30'!
defaultPadding
	^ 5 @ 5! !

!ROAbstractResizeStrategy methodsFor: 'initialize-release' stamp: 'JurajKubelka 4/24/2013 10:30'!
initialize
	super initialize.
	padding := self defaultPadding! !

!ROAbstractResizeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:24'!
isExtensible
	^ false! !

!ROAbstractResizeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:24'!
isFixed
	^ false! !

!ROAbstractResizeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 4/29/2013 16:37'!
isPermissive
	^ false! !

!ROAbstractResizeStrategy methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:24'!
isShrinking
	^ false! !

!ROAbstractResizeStrategy methodsFor: 'action' stamp: ''!
on: childElement
	self subclassResponsibility ! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:19'!
padding
	^ padding! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:19'!
padding: aPoint
	self assert: [ aPoint class == Point ].
	padding := aPoint! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingBottom
	^ self paddingTop! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingGap: aSmallInteger
	self padding: aSmallInteger @ aSmallInteger! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingLeft
	^ self padding x! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingRight
	^ self paddingLeft! !

!ROAbstractResizeStrategy methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingTop
	^ self padding y! !

!ROAbstractResizeStrategy methodsFor: 'action' stamp: 'AlexandreBergel 4/29/2013 15:04'!
translate: innerElement by: aPoint
	innerElement translateWithoutUpdatingContainedElementsBy: aPoint.! !

ROAbstractResizeStrategy subclass: #ROExtensibleParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROExtensibleParent commentStamp: 'AlexandreBergel 3/2/2012 19:41' prior: 0!
The parent get expended!

!ROExtensibleParent methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:23'!
isExtensible
	^ true! !

!ROExtensibleParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	ROAdjustSizeOfNesting on: element! !

ROAbstractResizeStrategy subclass: #ROFixedSizedParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROFixedSizedParent commentStamp: '<historical>' prior: 0!
The size of the parent is fixed. Inner nodes cannot escape the outter element when they are dragged away.!

!ROFixedSizedParent methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:21'!
isFixed
	^ true! !

!ROFixedSizedParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	"We do nothing"! !

!ROFixedSizedParent methodsFor: 'action' stamp: 'AlexandreBergel 4/29/2013 16:41'!
translate: innerElement by: deltaPoint
	| adjustedDelta newPos parent parentExtent innerElementExtent initialPositionInner |

	adjustedDelta := deltaPoint.
	initialPositionInner := innerElement position.
	newPos := initialPositionInner + deltaPoint. 

	(newPos x < padding x) ifTrue: [ adjustedDelta := (adjustedDelta x - newPos x + padding x) @ adjustedDelta y  ].	
	(newPos y < padding y) ifTrue: [ adjustedDelta := adjustedDelta x @ (adjustedDelta y - newPos y + padding y) ]. 
 
	parent := innerElement parent.
	parentExtent := parent extent.
	innerElementExtent := innerElement extent.
	
	(newPos x > (parentExtent x - innerElementExtent x - padding x) )
		ifTrue: [ adjustedDelta := (parentExtent x - innerElementExtent x - padding x - initialPositionInner x) @ adjustedDelta y  ].	
	(newPos y > (parentExtent y - innerElementExtent y - padding y)) 
		ifTrue: [ adjustedDelta := adjustedDelta x @ (parentExtent y - innerElementExtent y - padding y - initialPositionInner y) ]. 
	
	innerElement translateWithoutUpdatingContainedElementsBy: adjustedDelta! !

ROAbstractResizeStrategy subclass: #ROPermissiveParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROPermissiveParent commentStamp: '<historical>' prior: 0!
A ROPermissiveParent is a fixed size of the parent, but does not constraint inner nodes to escape the outter node. This strategy is useful when we temporarily need to add many inner nodes without having to go through all the constraints (e.g., with the Mondrian builder or in the tree map layout)!

!ROPermissiveParent methodsFor: 'testing' stamp: 'AlexandreBergel 4/29/2013 16:37'!
isPermissive
	^ true! !

!ROPermissiveParent methodsFor: 'action' stamp: 'AlexandreBergel 4/29/2013 16:40'!
on: element
	"We do nothing"! !

ROAbstractResizeStrategy subclass: #ROShrinkingParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROShrinkingParent commentStamp: '<historical>' prior: 0!
A ROShrinkingParent is the minimum it can have according to the children it has!

!ROShrinkingParent methodsFor: 'testing' stamp: 'AlexandreBergel 4/22/2013 19:24'!
isShrinking
	^ true
! !

!ROShrinkingParent methodsFor: 'action' stamp: 'AlexandreBergel 9/16/2012 12:48'!
on: element
	ROShrikingSize on: element! !

ROObject subclass: #ROAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

!ROAttachPoint class methodsFor: 'public - creation' stamp: 'AlexandreBergel 1/23/2013 16:53'!
instance
	"Useful to avoid create unnecessary instances"
	
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAttachPoint class methodsFor: 'public - creation' stamp: 'AlexandreBergel 10/15/2012 13:06'!
resetInstance
	"
	self withAllSubclassesDo: #resetInstance
	"

	instance := nil.! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	self subclassResponsibility! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	self subclassResponsibility! !

ROAttachPoint subclass: #ROCenteredAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 05:20'!
endingPointOf: anEdge
	^ anEdge to absolutePosition + (anEdge to extent / 2) asIntegerPoint! !

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 05:17'!
startingPointOf: anEdge
	^ (anEdge from absolutePosition + (anEdge from extent / 2)) asIntegerPoint! !

ROAttachPoint subclass: #ROHorizontalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 05:20'!
endingPointOf: anEdge
	^ anEdge to absolutePosition + (0 @ (anEdge to bounds height / 2) asInteger)! !

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 05:18'!
startingPointOf: anEdge
	^ anEdge from absolutePosition + (anEdge from bounds width @ (anEdge from bounds height / 2) asInteger)
	! !

ROAttachPoint subclass: #ROShorterDistanceAttachPoint
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'AlexandreBergel 12/11/2012 05:21'!
attachPointFor: anEdge on: anElement with: elementsPossibleAttachPoints
	"Returns the attach point having the shortest route for given edge on given element."
	| p dp t |
	p := anElement absolutePosition + (anElement width @ anElement height).
	
	"We get the list of dot products"
	dp := elementsPossibleAttachPoints collect: [ :pp | 
		t := p - pp.
		Array with: (t dotProduct: t) with:  pp ].
	
	"We look for the shortest path and return the point"
	^ (dp inject: dp first into: [ :shorter :el | (shorter first < el first) ifTrue: [ shorter ] ifFalse: [ el ]]) second! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'AlexandreBergel 12/11/2012 05:21'!
attachPointsFor: anEdge on: anElement
	"Return the four possible attach points for each of the four sides for given edge on given element."
	^ Array 
		"upper side"
		with: (anElement absolutePosition) + (((anElement bounds width / 2) + offset) asInteger @ 0) 
		 "right side"
		with: (anElement absolutePosition) + (anElement bounds width @ ((anElement  bounds height / 2) + offset) asInteger)
		"lower side"
		with: (anElement absolutePosition) + (((anElement bounds width / 2) + offset) asInteger @ (anElement bounds height)) 
		"left side"
		with: (anElement absolutePosition) + (0 @ ((anElement bounds height / 2) + offset) asInteger) 
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:24'!
destinationAttachPointsFor: anEdge
	"Return the four possible attach points for each of the four sides for this edges destination node."
	^ self attachPointsFor: anEdge on: (anEdge to).
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'DennisSchenk 10/9/2012 12:26'!
endingPointOf: anEdge
	^ self attachPointFor: anEdge on: (anEdge from) with: (self destinationAttachPointsFor: anEdge).! !

!ROShorterDistanceAttachPoint methodsFor: 'initialize-release' stamp: 'AlexandreBergel 10/11/2012 13:13'!
initialize
	super initialize.
	offset := 0.! !

!ROShorterDistanceAttachPoint methodsFor: 'accessing' stamp: 'DennisSchenk 10/9/2012 09:39'!
offset
	^ offset.! !

!ROShorterDistanceAttachPoint methodsFor: 'accessing' stamp: 'DennisSchenk 10/9/2012 09:39'!
offset: aNumber
	offset := aNumber.! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:24'!
startingAttachPointsFor: anEdge
	"Return the four possible attach points for each of the four sides for this edges starting node."
	^ self attachPointsFor: anEdge on: (anEdge from).! !

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'DennisSchenk 10/9/2012 12:26'!
startingPointOf: anEdge
	^ self attachPointFor: anEdge on: (anEdge to) with: (self startingAttachPointsFor: anEdge).! !

ROAttachPoint subclass: #ROVerticalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 12:13'!
endingPointOf: anEdge
	^  (anEdge to absolutePosition) + ((anEdge to bounds width / 2) asInteger @ 0)
	! !

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 12/11/2012 12:13'!
startingPointOf: anEdge
	^ (anEdge from absolutePosition) + ((anEdge from bounds width / 2) asInteger @ (anEdge from bounds height ))
	! !

ROObject subclass: #ROBasicZOrdering
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBasicZOrdering methodsFor: 'accessing-computing' stamp: 'DennisSchenk 3/20/2013 09:22'!
setZindexOf: aGraphicalComponent
	aGraphicalComponent zIndex: (self zIndexOf: aGraphicalComponent)! !

!ROBasicZOrdering methodsFor: 'accessing-computing' stamp: 'DennisSchenk 2/26/2013 16:54'!
zIndexOf: aComponent
	^ aComponent zIndex.! !

ROBasicZOrdering subclass: #ROZOrdering
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROZOrdering methodsFor: 'accessing-computing' stamp: 'AlexandreBergel 12/3/2012 21:37'!
defaultZIndex
	^ 0! !

!ROZOrdering methodsFor: 'initialize-release' stamp: 'AlexandreBergel 12/3/2012 21:33'!
initialize
	super initialize.
	mapping := OrderedCollection new! !

!ROZOrdering methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 21:31'!
numberOfEntries
	^ mapping size! !

!ROZOrdering methodsFor: 'action' stamp: 'AlexandreBergel 1/25/2013 08:31'!
setZIndex: integerOrValue 
	"integerOrValue is evaluated against the graphical element of Roassal.
	aBlockOrAValue has to return a boolean. The block takes one argument, which is the element."

	self setZIndex: integerOrValue if: true! !

!ROZOrdering methodsFor: 'action' stamp: 'AlexandreBergel 12/13/2012 18:10'!
setZIndex: integerOrValue if: aBlockOrAValue
	"integerOrValue is evaluated against the graphical element of Roassal.
	aBlockOrAValue has to return a boolean. The block takes one argument, which is the element."
	
	mapping add: (integerOrValue -> aBlockOrAValue)! !

!ROZOrdering methodsFor: 'action' stamp: 'AlexandreBergel 12/3/2012 21:52'!
setZindexOf: aGraphicalComponent
	aGraphicalComponent zIndex: (self zIndexOf: aGraphicalComponent)! !

!ROZOrdering methodsFor: 'accessing-computing' stamp: 'AlexandreBergel 12/4/2012 08:49'!
zIndexOf: aComponent
	mapping
		do: [ :assoc | 
			(assoc value roValue: aComponent)
				ifTrue: [ ^ assoc key roValue: aComponent ] ].
	^ self defaultZIndex! !

ROObject subclass: #ROCamera
	instanceVariableNames: 'position angle realExtent extent windowSize scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCamera commentStamp: 'AlexandreBergel 11/14/2012 13:41' prior: 0!
ROCamera represents the notion of camera. A camera is the point of view from which a view object is actually viewed.  The direction of the camera is always perpendicular to the view. A camera has an altitude. Varying the altitude simulate the zooming facility of Roassal.

A view is always associated to a camera. 

Instance Variables:
	position	<Point>			Position of the camera
	angle	<Number>	Angle of aperture 
	realExtent	<Point>		The far extent. 
	extent	<Point>			What we are seeing
	windowSize 	<Point>	 The size of the window in which I am displayed!

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultAngle
	^ 95! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultExtent
	"Maybe this has to be replaced by defaultAngle and default Height"
	^ 500 @ 500! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultHeight
	^ 200! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultPosition
	^ 0 @ 0! !

!ROCamera class methodsFor: 'public' stamp: ''!
realExtent: aPoint
	^ self new realExtent: aPoint! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 11:56'!
altitude
	^ (self extent x / 2) / (self angleInRadian / 2 ) tan
! !

!ROCamera methodsFor: 'accessing' stamp: 'DR 3/25/2013 22:01'!
altitude: h
	"Adjust the extent variable to reflect what we are seeing"

	| nx ny oldExtent | 
	nx := 2 * h * (self angleInRadian / 2) tan.
	ny := self extent x * nx / self extent y.
	
	oldExtent := extent.
	extent := nx asInteger @ ny asInteger.
	self translateBy: ((extent - oldExtent ) / 2) asIntegerPoint! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angle
	^ angle! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angleInRadian
	^ angle asFloat / 180 * 3.1415! !

!ROCamera methodsFor: 'accessing' stamp: ''!
bounds
	"bounds "
	^ position extent: extent
	
"	| ra v p |
	ra := self angleInRadian.
	v := height * ra sin.
	p := position.
	^ ((p x - v) @ (p y - v)) asIntegerPoint corner: ((p x + v) @ (p y + v)) asIntegerPoint"! !

!ROCamera methodsFor: 'accessing' stamp: 'VanessaPena 3/12/2013 16:11'!
bounds: rec

	|aNumber max ext|
	"Should be removed!!"
	aNumber := self extent.
	position := rec topLeft.
	ext := rec extent.
	max := ext x max: ext y.
	self extent: max@max.
	aNumber := aNumber / self extent.
	scale := scale * aNumber.
! !

!ROCamera methodsFor: 'rendering' stamp: 'AlexandreBergel 7/25/2012 16:11'!
canvas
	^ ROPlatform current canvasClass onCamera: self! !

!ROCamera methodsFor: 'accessing' stamp: ''!
centerPosition
	^ self bounds center! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent
	^ extent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent: anExtent
	extent := anExtent! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 12:00'!
height
	^ self extent y! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 12:00'!
height: h
	self extent: (self width @ h)! !

!ROCamera methodsFor: 'initialize' stamp: 'VanessaPena 1/8/2013 12:56'!
initialize
	super initialize.
	angle := self class defaultAngle.
	position := self class defaultPosition.
	realExtent := self class defaultExtent.
	extent := self class defaultExtent.
	windowSize := 0 @ 0.
	"NOT sure of scale"
	scale := 1@1.! !

!ROCamera methodsFor: 'public' stamp: 'AlexandreBergel 11/14/2012 11:57'!
moveDown
	self altitude: self altitude - 10! !

!ROCamera methodsFor: 'public' stamp: ''!
moveToSee: aRectangle
	| t |
	t := aRectangle extent x min: aRectangle extent y.
	position := t @ t.
	"height := (t / 2 / (self angleInRadian / 2) tan) asInteger"
	"height := ((aRectangle extent x) / 2 / (self angleInRadian / 2) tan) asInteger"! !

!ROCamera methodsFor: 'public' stamp: 'AlexandreBergel 11/14/2012 11:56'!
moveUp
	self altitude: self altitude +10! !

!ROCamera methodsFor: 'accessing' stamp: ''!
position
	^ position! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds
	^ position extent: realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds: rec

	"Should be removed!!"
	position := rec topLeft.
	self realExtent: rec extent.! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent
	^ realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent: anObject
	realExtent := anObject! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 11/14/2012 12:25'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	| r |
	r := self realToVirtualPointNoTrunc: aPoint.
	^ r x asInteger @ r y asInteger
! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 11/14/2012 12:24'!
realToVirtualPointNoTrunc: aPoint
	"Return a real point from a one expressed in the virtual coordinates"
	
	| visibleBounds offset |
	(realExtent = (0 @ 0)) ifTrue: [ ^ 1 @ 1 ].
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat / realExtent x * visibleBounds width + offset x) asFloat) @
	   ((aPoint y asFloat / realExtent y * visibleBounds height + offset y) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ (self realToVirtualPoint: aRectangle origin) corner: (self realToVirtualPoint: aRectangle corner)! !

!ROCamera methodsFor: 'accessing' stamp: 'VanessaPena 3/12/2013 18:15'!
scale

	^ scale! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: pos
	position := position + pos! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: aPoint during: aBlock
	self translateBy: aPoint.
	aBlock value.
	self translateBy: aPoint negated.! !

!ROCamera methodsFor: 'public' stamp: ''!
translateByRealStep: aStep
	"aStep represents the step in pixel on what the user see the visu"
	
	self translateBy: (self realToVirtualPoint: aStep)! !

!ROCamera methodsFor: 'public' stamp: ''!
translateTo: pos
	position := pos! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 7/23/2012 12:18'!
virtualToRealPoint: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	^ (self virtualToRealPointNoTrunc: aPoint) asIntegerPoint ! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealPointNoTrunc: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	| visibleBounds offset |
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat - offset x  * realExtent x / visibleBounds width) asFloat) @
	   ((aPoint y asFloat - offset y * realExtent y / visibleBounds height) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ (self virtualToRealPoint: aRectangle origin) corner: (self virtualToRealPoint: aRectangle corner)! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 11:17'!
width
	^ self extent x! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 12:01'!
width: w
	self extent: (w @ self height)! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 1/1/2013 17:41'!
windowSize
	"Size of the window, as a point"
	^ windowSize! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 13:42'!
windowSize: anExtent
	"called when the window is resized"

	windowSize := anExtent ! !

ROObject subclass: #ROCanvasWrapper
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCanvasWrapper class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/4/2013 10:12'!
onCanvas: aROCanvas 

	^self new canvas: aROCanvas! !

!ROCanvasWrapper methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 10:41'!
camera
	
	^canvas camera! !

!ROCanvasWrapper methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 10:24'!
camera: aROCamera

	canvas camera: aROCamera ! !

!ROCanvasWrapper methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 10:22'!
canvas

	^canvas! !

!ROCanvasWrapper methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 10:13'!
canvas: aROCanvas

	canvas := aROCanvas! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
drawString: aByteString at: aPoint 
	
	canvas drawString: aByteString at: aPoint ! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
drawString: aByteString at: aPoint color: color
	
	canvas drawString: aByteString at: aPoint color: color! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
drawString: aByteString at:  p font: f color: color
	
	canvas drawString: aByteString at:  p font: f color: color! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	
	canvas fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 ! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
fillRectangle: aRectangle color: fillColor 
	
	canvas fillRectangle: aRectangle color: fillColor ! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:34'!
form
	
	^canvas form! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:35'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	
	canvas frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor ! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:35'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	
	canvas line: aPoint to: aPoint2 width: aSmallInteger color: aColor ! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:25'!
paintBackground: backgroundColor

	canvas paintBackground: backgroundColor! !

!ROCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:35'!
paintImage: aForm at: aPoint
	
	canvas paintImage: aForm at: aPoint! !

ROCanvasWrapper subclass: #RONoTextCanvasWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RONoTextCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:37'!
drawString: aByteString at: aPoint ! !

!RONoTextCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:37'!
drawString: aByteString at: aPoint color: color! !

!RONoTextCanvasWrapper methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:37'!
drawString: aByteString at:  p font: f color: color! !

ROObject subclass: #ROCommand
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROCommand methodsFor: 'accessing' stamp: 'VanessaPena 12/5/2012 15:54'!
name

	^name! !

ROCommand subclass: #ROExportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROExportCommand class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 11/19/2012 22:32'!
commands

	|commands|
	commands := OrderedCollection new.
	self subclasses do:[:cl | commands add: cl new].
	^commands ! !

!ROExportCommand methodsFor: 'execute' stamp: 'VanessaPena 11/19/2012 22:28'!
executeOn: view

	self subclassResponsibility ! !

ROExportCommand subclass: #ROExportHTMLCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROExportHTMLCommand methodsFor: 'execute' stamp: 'VanessaPena 11/25/2012 14:54'!
executeOn: view

	ROPlatform current htmlExporterClass exportViewAsHTML: view! !

!ROExportHTMLCommand methodsFor: 'initialize-release' stamp: 'VanessaPena 11/25/2012 14:55'!
initialize 

	name := 'Export as HTML'! !

ROExportCommand subclass: #ROExportPNGCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROExportPNGCommand methodsFor: 'execute' stamp: 'VanessaPena 11/19/2012 22:31'!
executeOn: view

	ROPlatform current imageExporterClass exportViewAsPNG: view! !

!ROExportPNGCommand methodsFor: 'initialize-release' stamp: 'VanessaPena 11/19/2012 22:29'!
initialize 

	name := 'Export as PNG'! !

ROExportCommand subclass: #ROExportSVGCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROExportSVGCommand methodsFor: 'execute' stamp: 'VanessaPena 11/19/2012 22:28'!
executeOn: view

	ROPlatform current svgExporterClass exportViewAsSVG: view! !

!ROExportSVGCommand methodsFor: 'initialize-release' stamp: 'VanessaPena 11/19/2012 22:29'!
initialize 

	name := 'Export as SVG'! !

ROCommand subclass: #ROLoadViewCommand
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROLoadViewCommand methodsFor: 'running' stamp: 'VanessaPena 12/5/2012 15:51'!
execute

	view := ROPlatform current serializerClass new interactiveImportView! !

!ROLoadViewCommand methodsFor: 'initialize-release' stamp: 'VanessaPena 12/5/2012 15:51'!
initialize 

	name := 'Load View'! !

!ROLoadViewCommand methodsFor: 'accessing' stamp: 'VanessaPena 12/5/2012 15:51'!
view

	^view! !

ROCommand subclass: #ROSaveViewCommand
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROSaveViewCommand class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 12/5/2012 16:08'!
on: aROView 

	^self new view: aROView ! !

!ROSaveViewCommand methodsFor: 'running' stamp: 'VanessaPena 12/5/2012 15:54'!
execute

	ROPlatform current serializerClass new interactiveExportView: view! !

!ROSaveViewCommand methodsFor: 'initialize-release' stamp: 'VanessaPena 12/5/2012 15:54'!
initialize 

	name := 'Save view'! !

!ROSaveViewCommand methodsFor: 'accessing' stamp: 'VanessaPena 12/5/2012 15:54'!
view: aROView

	view := aROView ! !

ROObject subclass: #ROCompactTreeNode
	instanceVariableNames: 'element father layer theta r x leftContour rightContour pointer mod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROCompactTreeNode commentStamp: '<historical>' prior: 0!
A ROCompactTreeNode is used by ROAbstractCompactTree
!

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:54'!
element
	"comment stating purpose of message"

	^element! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:53'!
element: anElement
	"comment stating purpose of message"

	element  := anElement ! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:47'!
father
	"comment stating purpose of message"

	^ father! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:55'!
father: aNode
	"comment stating purpose of message"

	father := aNode! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:32'!
initialize
	super initialize .
	
		layer := 0.
		father := nil.
		leftContour := nil.
		rightContour := nil! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:48'!
layer
	"comment stating purpose of message"

	^ layer! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 2/4/2013 13:48'!
layer: anInteger
	"comment stating purpose of message"

	layer := anInteger! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:20'!
leftContour
	
	
	^leftContour! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 13:00'!
leftContour: aRONode
	
	
	leftContour := aRONode! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 16:21'!
mod
	
	
	^mod
	! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 11:11'!
mod: aFloat
	
	
	mod := aFloat
	! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:52'!
pointer

	^ pointer! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 21:40'!
pointer: aNode

	pointer := aNode ! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 3/4/2013 11:34'!
printOn: aStream
	"comment stating purpose of message"

	element ifNotNil: [ element printOn: aStream ] 
			 ifNil: [super printOn: aStream ]! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
r
	
	
	^r! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
r: aFloat
	
	
	r := aFloat
	! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 15:20'!
rightContour
	
	
	^rightContour! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 13:00'!
rightContour: aRONode
	
	
	rightContour := aRONode! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 13:22'!
theta
	"return the argument of the node's position in the radial tree"
	
	^theta
	! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/2/2013 15:58'!
theta: aFloat
	
	
	theta := aFloat
	! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 20:48'!
x
	
	
	^x! !

!ROCompactTreeNode methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/3/2013 20:48'!
x: aFloat
	
	
	x := aFloat
	! !

ROObject subclass: #ROConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2013 14:13'!
constraintInItsParent: element
	
	element
		on: ROElementTranslated
		do: [ :event | 
			element translateTo: ((element position max: (0 @ 0)) min: (element parent extent - element extent)) ]! !

!ROConstraint class methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:05'!
move: element above: anotherElement
	^ element translateTo: anotherElement position - (0 @ element height)! !

!ROConstraint class methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:04'!
move: element below: anotherElement
	^ element translateTo: anotherElement position + (0 @ anotherElement height)! !

!ROConstraint class methodsFor: 'util' stamp: 'VanessaPena 3/14/2013 16:46'!
move: element onTheCenterOf: anotherElement

	|p|
	p := ((anotherElement width - element width) /2) @ ((anotherElement height - element height ) /2).
	^ element translateTo: anotherElement position + p.! !

!ROConstraint class methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 19:28'!
move: element onTheLeftOf: anotherElement
	^ element translateTo: anotherElement position - (element width @ 0)! !

!ROConstraint class methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:02'!
move: element onTheRightOf: anotherElement
	^ element translateTo: anotherElement position + (anotherElement width @ 0)! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element above: anotherElement
	self move: element above: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element above: anotherElement ]! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 10/2/2012 20:05'!
stick: element below: anotherElement
	self move: element below: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element below: anotherElement ].
	

! !

!ROConstraint class methodsFor: 'public' stamp: 'VanessaPena 3/14/2013 16:47'!
stick: element onTheCenterOf: anotherElement
	self move: element onTheCenterOf: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element onTheCenterOf: anotherElement ].
! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element onTheLeftOf: anotherElement
	self move: element onTheLeftOf: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element onTheLeftOf: anotherElement ].
! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element onTheRightOf: anotherElement
	self move: element onTheRightOf: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element onTheRightOf: anotherElement ].
! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 12/18/2012 15:38'!
stickToBottomLeft: element 
	^ self stickToBottomLeft: element offset: 0! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 12/18/2012 15:38'!
stickToBottomLeft: element offset: aNumber
	element translateTo: (aNumber @ element view camera windowSize y - element height - aNumber).
	element view
		on: ROWindowResized
		do: [ :event | element translateTo: (aNumber @ (event extent y - element height - aNumber)) ].
! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 12/18/2012 15:39'!
stickToTopRight: element
	^ self stickToTopRight: element offset: 0! !

!ROConstraint class methodsFor: 'public' stamp: 'AlexandreBergel 12/18/2012 15:39'!
stickToTopRight: element offset: aNumber
	element translateTo: ((element view camera windowSize x - element width) - aNumber @ aNumber).
	element view
		on: ROWindowResized
		do: [ :event | element translateTo:  ((event extent x - element width) - aNumber @ aNumber)].! !

ROObject subclass: #ROContainer
	instanceVariableNames: 'elements attributes resizeStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROContainer subclass: #ROAbstractComponent
	instanceVariableNames: 'model eventHandler interactions view parent shape zIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractComponent class methodsFor: 'public' stamp: 'AlexandreBergel 4/11/2013 10:55'!
model: anObject
	^ self on: anObject! !

!ROAbstractComponent class methodsFor: 'public' stamp: 'AlexandreBergel 8/19/2012 12:17'!
on: anObject 
	^ self basicNew on: anObject; initialize; yourself! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:01'!
+ aShape 
	"Add a shape to myself. aShape could either be an instance of a shape class or a class"
	
	self addShape: aShape.
	^ self ! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:00'!
- aShape 
	"Remove a shape from myself. aShape could either be an instance of a shape class or a class"
	
	self removeShape: aShape.
	^ self ! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:01'!
@ anInteractionClassOrInstance
	"Add an interaction to the node"
	
	self addInteraction: anInteractionClassOrInstance! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 23:11'!
addInteraction: anInteractionClassOrInstance
	"Add an interaction to the node"
	
	interactions at: anInteractionClassOrInstance key put: (anInteractionClassOrInstance initializeElement: self)
	! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:01'!
addShape: aShape 
	"Add a shape to myself. aShape could either be an instance of a shape class or simply a class"

	| s |
	s := (aShape installedOn: self).
	s addLast: shape.
	shape := s
! !

!ROAbstractComponent methodsFor: 'enumerating' stamp: 'AlexandreBergel 9/10/2012 09:03'!
allElementsDo: aBlock
	"aBlock is a one-arg block. This method executes aBlock for each element that I contains. 
	 The block receive the element as argument"
	
	self elementsDo: [:each | 
		aBlock value: each.
		each allElementsDo: aBlock ]! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 13:20'!
announce: anEvent
	"trigger an event. Objects who registered to me will get notified"

	| eventToBeSent |
	eventToBeSent := anEvent isBehavior 
						ifTrue: [ anEvent new ]
						ifFalse: [ anEvent ]. 
	
	eventToBeSent element: self.
	eventHandler announce: eventToBeSent! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:03'!
change: aShapeClass for: aShape
	"aDecorator could be a class or a shape"
	
	shape := shape change: aShapeClass for: (aShape installedOn: self).
! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 9/10/2012 09:03'!
changeInteraction: anInteractionClass for: anInteraction
	"Change an interaction, instance of anInteractionClass, for an Interaction"
	
	self removeInteraction: anInteractionClass.
	self @ anInteraction! !

!ROAbstractComponent methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/4/2012 08:43'!
depth

	^ 1 + parent depth! !

!ROAbstractComponent methodsFor: 'drawing' stamp: 'AlexandreBergel 9/14/2012 19:03'!
drawOn: aCanvas
	"This should be changed. drawOn: should not do an explicit iteration, but letting each shape call drawOn: on its next "

	shape chainedDrawOn: aCanvas for: self

! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:25'!
forShape: shapeClass do: aOneArgBlock
	"Find the shape that correspond to the shape class, and evaluate the block by passing the shape to it"

	| v |
	v := ( self getShape: shapeClass). 
	v ifNotNil: [ aOneArgBlock value: v  ]! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:12'!
forward
	eventHandler forward! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:12'!
forward: obj
	eventHandler forward: obj! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 8/20/2012 09:19'!
getInteraction: anInteractionClass

	^ interactions at: anInteractionClass
! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 22:07'!
getInteraction: anInteractionClass ifPresent: aBlock

	^ interactions at: anInteractionClass ifPresent: aBlock
! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:26'!
getShape: shapeClass
	"Return a shape instance, instance of the shape class provided as parameter"

	^ self shapeDetect: [ :de | de isKindOf: shapeClass ]! !

!ROAbstractComponent methodsFor: 'initialize-release' stamp: 'AlexandreBergel 12/3/2012 20:57'!
initialize
	super initialize.
	parent := ROView nullView.
	
	eventHandler := ROAnnouncer new.
	view := ROView nullView.
	
	"Actually, I am not sure we need to have a variable interactions"
	interactions := IdentityDictionary new.

	zIndex := 0! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 8/19/2012 17:16'!
interactionsDo: aBlock
	"Execute a block for each interaction"
	
	interactions ifNil: [ ^ self ].
	interactions values do: aBlock! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 17:17'!
is: anInteractionClass

	interactions ifNil: [ ^ false ].
	^ interactions includesKey: anInteractionClass! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 11/27/2012 21:00'!
isElement
	^ self isEdge not! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 13:18'!
isNotEdge
	^ self isEdge not! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 4/11/2013 15:16'!
isRendered
	"Return true I will be rendered by the view that contains me"
	
	^ self view isRendered: self ! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 12:39'!
isShapedAs: aShapeClass
	^ shape isShapedAs: aShapeClass! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:37'!
model
	"Return the object behind the element"

	^ model! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:36'!
model: anObject 
	"Set the object behind the element"
	
	model := anObject
! !

!ROAbstractComponent methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/2/2012 20:44'!
numberOfInteractions
	"Answer the number of interactions"
	
"	^ eventHandler numberOfSubscriptions
"
	interactions ifNil: [ ^ 0 ].
	^ interactions size ! !

!ROAbstractComponent methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2012 08:39'!
numberOfShapes
	"Return the number of shapes associated to the element"
	
	^ self shapes size ! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 15:29'!
on: anObject 
	"Set the object model of myself. The object model is used by the shape when computing metrics that may be used by the shapes"

	self model: anObject! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 9/2/2012 21:12'!
on: eventClass do: aBlock
	"Register a block as an handler for eventClass"
	

	eventHandler when: eventClass do: aBlock.
	"interactions at: eventClass put: aBlock"! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 11/25/2012 11:01'!
on: eventClass doOnce: aBlock
	"Register a block as an handler for eventClass. The callback is removed when exected"
	
	eventHandler when: eventClass do: [ :arg | 
		aBlock value: arg.
		eventHandler unsubscribeForEvent: eventClass.
		"self removeInteraction: eventClass "]! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:04'!
parent
	"Return the node in which I am contained"
	
	^ parent! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:04'!
parent: aViewOrAnElement
	"Set the node in which I am contained"

	parent := aViewOrAnElement! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 9/10/2012 09:07'!
parentAnnounce: event
	"Make the parent announce something"
		
	parent announce: event! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'AlexandreBergel 12/11/2012 15:03'!
remove
	"Remove myself from the view I belong to (if I actually belong to the view, else do nothing) and from my parent."

	self removeFromParent.
	self view removeElementToRender: self.	"We remove all the subelements"
	self allElementsDo: #remove! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'AlexandreBergel 12/11/2012 15:02'!
removeFromParent
	parent remove: self ifAbsent: [  ]! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 9/2/2012 20:58'!
removeInteraction: anInteractionClass
	"Remove an interaction from the receiver. No error is raised if no interaction is found"
	
	| ds |
	ds := interactions select: [ :d | d isKindOf: anInteractionClass ].
	ds associationsDo: [ :assoc | 
		interactions removeKey: assoc key.
		eventHandler unsubscribe: assoc value ].
! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:26'!
removeShape: aShapeClass
	"Remove a shape of the element"

	shape := shape removeShape: aShapeClass! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'DR 1/15/2013 21:23'!
reversedShapesDo: aBlock
	^ self shapes reverse do: aBlock! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'AlexandreBergel 4/11/2013 15:39'!
setAsNotRendered
	self view removeElementToRender: self.! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'AlexandreBergel 4/11/2013 15:39'!
setAsRendered
	self view addElementToRender: self! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'DR 1/15/2013 20:52'!
setZindexFrom: aZOrdering
	aZOrdering setZindexOf: self! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:34'!
shapeDetect: aBlock
	^ shape shapeDetect: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 13:05'!
shapes
	"Return the list of shapes"
	
	| ans d |
	ans := OrderedCollection new.
	d := shape. 
	[ d hasNext ] whileTrue: [ 
		ans add: d.
		d := d next ].
	ans add: d.
	^ ans.! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:34'!
shapesCollect: aBlock
	^ self shapes collect: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/24/2012 11:56'!
shapesDo: aBlock
	^ shape shapesDo: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:35'!
shapesSelect: aBlock
	^ self shapes select: aBlock! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:13'!
signalUpdate
	"Trigger a redisplay of the view"
	
	^ view signalUpdate! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:41'!
view
	"Answer the view in which I am defined"
	^ view! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 11/28/2012 18:26'!
view: aView
	"Set the view in which I am defined. All my elements should also belong to the same view"
	view := aView.
! !

!ROAbstractComponent methodsFor: 'enumerating' stamp: 'TudorGirba 9/9/2012 21:40'!
withAllElementsDo: aBlock
	aBlock value: self.
	self allElementsDo: aBlock! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 21:40'!
zIndex
	^ zIndex! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 21:40'!
zIndex: anInteger
	zIndex := anInteger! !

ROAbstractComponent subclass: #ROEdge
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROEdge class methodsFor: 'public' stamp: 'AlexandreBergel 7/14/2012 15:01'!
arrowedLineFrom: f to: t
	^ (self from: f to: t)
		+ (ROLine new addBegining: ROArrow new) ;
		yourself! !

!ROEdge class methodsFor: 'public' stamp: 'TudorGirba 7/29/2012 22:44'!
from: fromNode to: toNode

	^ self on: nil from: fromNode to: toNode! !

!ROEdge class methodsFor: 'public' stamp: ''!
lineFrom: f to: t
	^ (self from: f to: t)
		+ ROLine ;
		yourself! !

!ROEdge class methodsFor: 'public' stamp: ''!
linesFor: associations 
	"Return a collection of edges, one for each provided association"

	^ associations collect: [ :assoc | self lineFrom: assoc key to: assoc value ]! !

!ROEdge class methodsFor: 'public' stamp: 'TudorGirba 7/29/2012 22:44'!
on: aModel from: f to: t
	self assert: [ f isKindOf: ROElement ].
	self assert: [ t isKindOf: ROElement ].
	^ (self on: aModel) from: f to: t; yourself! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 4/11/2013 15:30'!
absolutePosition
	^  self from absolutePosition ! !

!ROEdge methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	aVisitor visitEdge: self! !

!ROEdge methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 13:14'!
addedInAnElement: el
	el addElement: self.
	self parent: el; view: el view.

! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/19/2012 18:37'!
bounds
	^  Rectangle merging: (Array with: self from bounds with: self to bounds)! !

!ROEdge methodsFor: 'testing' stamp: 'AlexandreBergel 1/26/2013 19:14'!
contains: aPoint
	^ shape contains:  aPoint for: self
! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/5/2012 17:21'!
edgeFromModel: object
	"if the object is equal to the mode, then return itself, else nil"
	
	(self model = object) ifTrue: [ ^ self ].
	^ nil! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/23/2012 22:52'!
elementAt: aPoint
	"Do nothing since an edge cannot contain other elements"
	^ self ! !

!ROEdge methodsFor: 'actions' stamp: 'AlexandreBergel 12/5/2012 17:21'!
elementFromModel: object
	"if the object is equal to the mode, then return itself, else nil"
	
	"(self model = object) ifTrue: [ ^ self ]."
	^ nil! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/19/2012 13:19'!
elementsDo: aBlock
	"Do nothing"! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2012 09:16'!
extent
	^ self bounds extent ! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from
	^ from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from: f to: t
	from := f.
	to := t! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/29/2012 05:07'!
height 

	 ^((self from position y) - (self to position y)) abs! !

!ROEdge methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/4/2012 12:53'!
initialize
	super initialize.
	shape := RONullShape new.! !

!ROEdge methodsFor: 'testing' stamp: ''!
isEdge
	^ true! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/26/2012 09:19'!
position 
	
	^self from position ! !

!ROEdge methodsFor: 'accessing' stamp: ''!
source
	^ self from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
target
	^ self to! !

!ROEdge methodsFor: 'accessing' stamp: ''!
to 
	^ to! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 1/26/2013 19:14'!
topLeft
	^ (shape lineSegmentsFor: self) first
! !

!ROEdge methodsFor: 'translation' stamp: 'VanessaPena 8/29/2012 05:05'!
translateBy: aPoint 
! !

!ROEdge methodsFor: 'translation' stamp: 'VanessaPena 8/29/2012 05:07'!
translateTo: aPoint 
! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/29/2012 05:03'!
width 

	 ^(self getShape: ROLine) width  ! !

ROAbstractComponent subclass: #ROElement
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROElement subclass: #ROButtonElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROButtonElement class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/1/2012 15:01'!
named: aName do: aOneArgBlockAsCallback
	^ self basicNew initializeWithName: aName Callback: aOneArgBlockAsCallback! !

!ROButtonElement methodsFor: 'public' stamp: 'AlexandreBergel 6/1/2012 15:04'!
initializeWithName: aName Callback: callbackAsOneArgBlock
	super initialize.
	self + (ROLabel text: aName).
	self @ ROLightlyHighlightable.
	self on: ROMouseClick do: callbackAsOneArgBlock.
	! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 9/25/2012 20:23'!
bare
	"Only has a nullshape, no children shape"
	^ self basicNew initializeBare! !

!ROElement class methodsFor: 'defaults' stamp: ''!
defaultBounds
	^ (0@0 corner: 5@5)! !

!ROElement class methodsFor: 'public' stamp: ''!
forCollection: aCollection 
	^ (aCollection collect: [ :v | self on: v ]) asArray! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:43'!
label
	^ self new + ROLabel! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:51'!
labelOn: obj
	^ (self on: obj) + ROLabel! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 6/11/2012 12:38'!
labelsOn: collection
	^ (self forCollection: collection) collect: [ :v | v + ROLabel ]! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 11:54'!
sprite

	^ self new
			extent: 50 @ 50;
			addInteraction: RODraggable;
			addShape: (ROBorder new color: Color red);
			yourself! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:44'!
spriteOn: value
	^ self sprite on: value! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:44'!
spritesOn: values
	^ values collect: [:v | self sprite on: v ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
absolutePosition
	"Return the absolute position of the element, the top left corner"

	^ parent 
		ifNil: [ self position ]
		ifNotNil: [ self position + parent absolutePosition ]! !

!ROElement methodsFor: 'visiting' stamp: 'AlexandreBergel 11/27/2012 19:36'!
accept: aVisitor
	aVisitor visitElement: self! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 12/13/2012 14:45'!
add: el
	self assert: [ el isKindOf: ROAbstractComponent ].
	self addChild: el.
	self view addElementRecursivelyToRender: el! !

!ROElement methodsFor: 'public' stamp: ''!
addAll: els
	els do: [:el | self add: el ]! !

!ROElement methodsFor: 'actions' stamp: 'VanessaPena 12/22/2012 19:47'!
addChild: el
	el addedInAnElement: self.! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 4/24/2013 09:23'!
addedInAnElement: el
	self translateBy: el topLeft negated.
	self translateBy: el resizeStrategy padding.
	self parent: el; view: el view.
	el addElement: self.
	
	el adjustSizeIfNecessary

! !

!ROElement methodsFor: 'actions' stamp: 'VanessaPena 12/21/2012 02:00'!
adjustSizeIfNecessary
	resizeStrategy on: self! !

!ROElement methodsFor: 'accessing' stamp: 'VanessaPena 4/12/2013 12:25'!
allEdgesFrom

	|edges|
	edges := OrderedCollection new.
	
	self view allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge from == self) ifTrue: 
			[ 	edges add: edge 
			] 
		] 
	].
	^edges
! !

!ROElement methodsFor: 'accessing' stamp: 'VanessaPena 4/12/2013 12:25'!
allEdgesTo

	|edges|
	edges := OrderedCollection new.
	self view allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge to == self) ifTrue: 
			[ 	edges add: edge
			] 
		] 
	].
	^edges
! !

!ROElement methodsFor: 'accessing' stamp: ''!
bottomCenter
	^ self bounds bottomCenter! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:53'!
bottomLeft
	^ self bounds bottomLeft! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:53'!
bottomRight 
	^ self bounds bottomRight! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:16'!
bounds
	"Return the bounds of the element"
	
	^ self position extent: (shape extentFor: self)! !

!ROElement methodsFor: 'accessing' stamp: ''!
center
	^ self bounds center! !

!ROElement methodsFor: 'accessing' stamp: ''!
center: pos

	^ self translateTo: (pos - (self extent / 2))! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:18'!
center: aPoint radius: d

	position := (aPoint - (d @ d)).
	self extent: (2 * d @ ( 2 * d))! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:29'!
collectPathToRootIn: aCollection
	"Return the path from this graph to the root graph"

	aCollection addLast: self.
	self parent ifNotNil: [self parent collectPathToRootIn: aCollection]! !

!ROElement methodsFor: 'testing' stamp: 'AlexandreBergel 12/11/2012 15:22'!
contains: aPoint
	"Return true if aPoint is within the bounds of myself. Note that aPoint is relative to the owner of the element"

	^ (aPoint < (self extent + self absolutePosition)) and: [ aPoint >= (self absolutePosition) ]
"	^ shape element: self containsPoint: aPoint "! !

!ROElement methodsFor: 'copying' stamp: 'AlexandreBergel 4/24/2013 09:27'!
copy
	"Return a copy of myself, shapes and interactions are not copied"
	| answer |
	answer := self class new.
	answer 
			translateTo: self position;
			extent: self extent.
	self shapesDo: [ :d | answer + d ].
	self interactionsDo: [ :i | answer @ i ].
	^ answer
			! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsFromModels: objects
	^ self elementsSuchThat: [ :el | objects includes: el model ]! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:27'!
extent
	"Return the extent of myself"
	^ shape extentFor: self! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:28'!
extent: aPoint 
	"Set the extent of myself. Do nothing if the new extent is the same that the one I have"
	(aPoint = self extent) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape extent: aPoint
! !

!ROElement methodsFor: 'testing' stamp: 'AlexandreBergel 6/18/2012 14:21'!
hasAttributes 
	"Return true if at least one attributes is present"
	
	^ attributes notNil and: [ attributes notEmpty ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
height
	^ self extent y! !

!ROElement methodsFor: 'accessing' stamp: 'VanessaPena 1/17/2013 15:59'!
height: h
	"h could either be a numerical constant, a symbol or a block. It is evaluated against the element"
	(h = shape height) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape height: h
! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 4/22/2013 19:19'!
initialize 
	super initialize.
	position := 0 @ 0.
	shape := RONullShape new.	! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 4/22/2013 19:19'!
initializeBare 
	super initialize.
	position := 0 @ 0.
	shape := RONullShape new.
! !

!ROElement methodsFor: 'testing' stamp: ''!
isEdge
	^ false! !

!ROElement methodsFor: 'accessing' stamp: ''!
leftCenter
	^ self bounds leftCenter! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 19:28'!
model: anObject
	super model: anObject.
	! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:15'!
mostSpecificParentCommonWith: anotherElement
	"Search the smallest possible element that is parent of self and of anotherNode"

	|  anotherPathToRoot | 
	anotherPathToRoot := anotherElement pathToRoot.

	self pathToRoot do: [ :eachElement | 
		(anotherPathToRoot includes: eachElement)
			ifTrue: [ ^ eachElement ] ]! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:22'!
pathToRoot
	"Return the path from this graph to the root graph"

	| path |
	path := OrderedCollection new.
	self parent ifNotNil: [self parent collectPathToRootIn: path].
	^path! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:18'!
position
	"Return the position of the element. Return a point of floats"
	
	^ position! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionAsInteger
	"Return the position as integer"
	
	^ self position asIntegerPoint ! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	"Return the position of myself against the position of one of my parent, anElement. The returned position is relative to it."
	"This method is useful to draw edges that are nested"

	(anElement == self)
		ifTrue: [ ^ 0 @ 0 ].
	
	^ self topLeft + (parent positionRelativeTo: anElement)! !

!ROElement methodsFor: 'printing' stamp: 'AlexandreBergel 12/16/2012 18:27'!
printOn: stream
	"A textual representation of myself.
	ROElement new printString => 'a ROElement' 
	(ROElement on: 10) printString =>  'a ROElement<10>'
	"
	super printOn: stream.
	model ifNotNil: [ 
		stream nextPutAll: '<'.
		model printOn: stream.
		stream nextPutAll: '>' ]! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/17/2012 20:31'!
radius
	^ self extent r / 2
	
! !

!ROElement methodsFor: 'accessing' stamp: ''!
radius: d

	^ self center: self position radius: d! !

!ROElement methodsFor: 'actions' stamp: 'VanessaPena 4/11/2013 18:53'!
removeAllEdgesFrom
	self view allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge from == self) ifTrue: 
			[ 	edge remove
			] 
		] 
	].
! !

!ROElement methodsFor: 'actions' stamp: 'BenComan 10/8/2012 14:12'!
removeAllEdgesTo
	self view allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge to == self) ifTrue: 
			[ 	edge remove
			] 
		] 
	].
! !

!ROElement methodsFor: 'accessing' stamp: ''!
rightCenter
	^ self bounds rightCenter! !

!ROElement methodsFor: 'translation' stamp: ''!
setBounds:  aBounds
	self extent: aBounds extent.
	self translateTo: aBounds origin.! !

!ROElement methodsFor: 'accessing' stamp: ''!
size: d
	self extent: d @ d! !

!ROElement methodsFor: 'accessing' stamp: ''!
topCenter
	^ self bounds topCenter! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:52'!
topLeft
	^ self bounds topLeft ! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:52'!
topRight
	^ self bounds topRight! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 4/29/2013 15:00'!
translateBy: aPoint 
	parent translate: self by: aPoint
! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 9/16/2012 12:46'!
translateByRealPoint: aPoint 
	| p |
	p := self view camera virtualToRealPointNoTrunc: self position.
	self translateTo: (self view camera realToVirtualPointNoTrunc: (p + aPoint)).
! !

!ROElement methodsFor: 'translation' stamp: ''!
translateTo: aPoint 
	self translateBy: (aPoint - self bounds origin)! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 4/22/2013 19:12'!
translateToRealPoint: aPoint 
	| p |
	p := self view camera realToVirtualPoint: aPoint. 
	self translateTo: p.
! !

!ROElement methodsFor: 'translation' stamp: 'VanessaPena 12/22/2012 19:45'!
translateWithoutUpdatingContainedElementsBy: aPoint
	"translate myself without updating the parent."
	aPoint = (0 @ 0) ifTrue: [ ^ self ].

	position := position + aPoint.
	self announce: ROElementTranslated! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 22:26'!
view: aView
	"Set the view in which I am defined. All my elements should also belong to the same view"
	super view: aView.
	self elementsDo: [ :el | el view: aView ]
	! !

!ROElement methodsFor: 'accessing' stamp: ''!
width
	^ self extent x! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 13:57'!
width: w
	"w could either be a numerical constant, a symbol or a block. It is evaluated against the element"
	(w = shape width) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape width: w! !

ROElement subclass: #ROMenuElement
	instanceVariableNames: 'actionDictionary targetObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROMenuElement class methodsFor: 'example' stamp: 'AlexandreBergel 9/21/2012 14:00'!
example

"
self example
"

"Preambule. It includes the initialization. "
| rawView view element |
rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.
"enter your script below"
"-------------"
"-------------" 

view shape rectangle size: 80.
element := view node: 100.

element on: ROMouseClick do: [ :ann |
	| menu |
	menu := ROMenuElement new.
	menu item: 'foo10' action: [ :an | 10 inspect ].
	menu item: 'foo20' action: [ :an | 20 inspect ].
	menu item: 'foo30' action: [ :an | 30 inspect ].
	
	menu create.
		
	view raw add: menu. 
	
	menu translateTo: ann position - (10 @ 40).
	 element on: ROMouseDragging do: [ :v | menu remove ].
	element on: ROMouseClick do: [ :v | menu remove ].
	 
	
	"element on: ROMouseLeave doOnce: [ :v | menu remove ].
	element on: ROMouseEnter doOnce: [ :v | menu remove ].
	"

view raw signalUpdate.
].

"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
"ROEaselMorphic new populateMenuOn: view."
view open! !

!ROMenuElement methodsFor: 'private' stamp: 'AlexandreBergel 9/2/2012 00:22'!
create
	self createEntries.
	self + ROBorder blue.
	! !

!ROMenuElement methodsFor: 'private' stamp: 'AlexandreBergel 9/4/2012 00:28'!
createEntries
	| nameElements |
	nameElements := actionDictionary keys collect: [ :title |
		(ROElement labelOn: title)
			@ ROLightlyHighlightable;
			"forward: ROMouseLeave;"
			on: ROMouseClick do: [ :ann | 
				(actionDictionary at: title) value: targetObject.
				self remove.
				self view signalUpdate ]
			yourself  ].
	 
	self addAll: nameElements.
	
	ROVerticalLineLayout on: nameElements.! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:51'!
evaluate: aTitleAsString
	"Evaluate the callback associate to the title given as parameter"
	
	(actionDictionary at: aTitleAsString) value: targetObject! !

!ROMenuElement methodsFor: 'initialization' stamp: 'AlexandreBergel 9/1/2012 23:35'!
initialize
	super initialize.
	targetObject := self.
	actionDictionary := Dictionary new.
	 ! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:45'!
item: aTitleAsString action: aBlock
	"Register a menu entry. The title is used as the entry name when the menu is displayed.
	 The callback is defined as a one-arg block. The block is evaluated with the content of the variable targetObject"

	actionDictionary at: aTitleAsString put: aBlock! !

!ROMenuElement methodsFor: 'accessing computed' stamp: 'AlexandreBergel 9/1/2012 19:38'!
numberOfActions
	"Return the number of actions"
	
	^ actionDictionary size! !

!ROMenuElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/1/2012 19:46'!
targetObject
	^ targetObject! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:46'!
targetObject: anObject
	"set the object that is passed to the callback blocks when being evaluated"

	targetObject := anObject! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/10/2012 19:02'!
addElement: element
	elements add: element.
! !

!ROContainer methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/3/2012 22:32'!
allElementsDo: aBlock
	self elementsDo: [ :each | each withAllElementsDo: aBlock ]! !

!ROContainer methodsFor: 'accessing' stamp: 'VanessaPena 12/22/2012 18:27'!
attributes
	"Return the list of attributes associated to the element. Attributes are useful for caching values"

	^ attributes ifNil: [ attributes := Dictionary new ]! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/13/2013 23:18'!
attributesAt: aKey
	^ self attributes at: aKey! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/13/2013 23:18'!
attributesAt: aKey put: value
	^ self attributes at: aKey put: value! !

!ROContainer methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/5/2012 18:02'!
edgeFromModel: object
	"Recursively look for the element with a model object"
	| v |
	
	(self model = object) ifTrue: [ ^ self ].
	
	v :=  elements 
		detect: [ :e | (e model = object) and: [ e isEdge ] ]
		ifNone: [ nil ].
	v ifNotNil: [ ^ v ].
	
	elements do: [ :e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	
	^ nil

	"^ (self elementsSuchThat: [ :el | object = el model ]) first"! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/5/2012 18:30'!
elementFromModel: object
	"Recursively look for the element with a model object"
	| v |
	
	(self model = object) ifTrue: [ ^ self ].
	
	v :=  elements reverse
		detect: [ :e | (e model = object) and: [ e isElement ] ]
		ifNone: [ nil ].
	v ifNotNil: [ ^ v ].
	
	elements reverse do: [ :e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	
	^ nil

	"^ (self elementsSuchThat: [ :el | object = el model ]) first"! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 22:30'!
elements
	^ elements copy asArray! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/3/2012 22:30'!
elementsCollect: aBlock
	^ elements collect: aBlock! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/3/2012 22:29'!
elementsDo: aBlock
	^ elements copy do: aBlock! !

!ROContainer methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/3/2012 22:29'!
elementsNotEdge
	^ elements reject: #isEdge! !

!ROContainer methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/6/2012 16:51'!
elementsReverseDo: aBlock
	^ elements reverse do: aBlock! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/3/2012 22:29'!
elementsSuchThat: aBlock
	^ elements select: aBlock! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 22:29'!
elementsWithModelDo: aBlock
	^ (elements copy select: [ :n | n model notNil ]) do: aBlock
	! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:21'!
encompassingNestedRectangle
	elements isEmpty
		ifTrue: [ ^ Rectangle origin: self topLeft extent: self padding ].
	^ ((Rectangle merging: (self elementsNotEdge collect: #bounds)) translateBy: self topLeft) extendBy: self padding! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2013 18:42'!
encompassingRectangle
	elements isEmpty ifTrue: [ ^ self bounds ].
	^ Rectangle merging: 
		(Array with: self encompassingNestedRectangle),
		(Array with: self bounds)! !

!ROContainer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/22/2013 19:19'!
initialize
	super initialize.
	elements := OrderedCollection new.

	"Per default, the parent is always extensible"
	resizeStrategy := ROExtensibleParent instance.
	
! !

!ROContainer methodsFor: 'testing' stamp: 'JurajKubelka 4/22/2013 13:47'!
isView

	^ false! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 12/3/2012 22:29'!
numberOfElements 
	^ elements size! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/24/2013 09:23'!
padding
	^ resizeStrategy padding! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/13/2012 11:41'!
remove: element
	"Remove the element from myself. However, the element is not removed from the visualization. Send #remove to element to actually remove it."
	elements remove: element! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/3/2012 22:29'!
remove: element ifAbsent: aBlock
	elements remove: element ifAbsent: aBlock! !

!ROContainer methodsFor: 'actions' stamp: 'AlexandreBergel 12/3/2012 22:28'!
removeAllElements
	elements := OrderedCollection new.! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/22/2013 19:20'!
resizeStrategy
	"No reason to give the object itself"
	^ resizeStrategy copy! !

!ROContainer methodsFor: 'accessing' stamp: 'AlexandreBergel 4/22/2013 19:20'!
resizeStrategy: anInstanceOfROAbstractResizeStrategy
	resizeStrategy := anInstanceOfROAbstractResizeStrategy! !

!ROContainer methodsFor: 'translating' stamp: 'AlexandreBergel 4/29/2013 15:04'!
translate: innerElement by: aPoint
	"Translate innerElement by aPoint amount of pixels"
	
	resizeStrategy translate: innerElement by: aPoint.
	self adjustSizeIfNecessary
! !

ROContainer subclass: #ROView
	instanceVariableNames: 'camera eventHandler title backgroundColor animations elementsToRender zOrdering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROView class
	instanceVariableNames: 'nullView'!

!ROView commentStamp: 'AlexandreBergel 3/6/2013 11:56' prior: 0!
ROView is the main container of all Roassal objects. A view contains elements, typically instances of ROElement and ROEdges. It has also a camera that indicates what is currently visible. A view also contains animations that are currently operating. 
A view has a title, which is used when displayed in a window.
ROView is an essential class.

elementsToRender is the list of elements that are displayed. It contains a sorted collection of associations. Each association has a number of a key, and a collection of elements as a value. The key number corresponds to the zIndex. Elements with a low zIndex are displayed first.

Instance Variables:
	camera	<ROCamera>
	eventHandler	<ROAnnouncer>
	title	<ProtoObject>
	backgroundColor	<Color>
	animations	<(Collection of: ROAnimation)>
	elementsToRender	<SequenceableCollection>
	zOrdering	<ROZOrdering>

Class Instance Variables:
	nullView	<ProtoObject>!

ROView class
	instanceVariableNames: 'nullView'!

!ROView class methodsFor: 'configuration' stamp: ''!
defaultWindowTitle
	^ 'Roassal visualization'! !

!ROView class methodsFor: 'initialize' stamp: 'AlexandreBergel 12/14/2012 14:08'!
initialize
	self resetNullView ! !

!ROView class methodsFor: 'accessing' stamp: 'AlexandreBergel 1/10/2013 10:55'!
nullView
	"Used when creating new element. For example, we have the relation:
	  ROElement new view == ROView nullView"
	
	^ nullView ifNil: [ nullView := self new ].! !

!ROView class methodsFor: 'public' stamp: 'AlexandreBergel 1/10/2013 10:55'!
resetNullView 
	nullView := nil! !

!ROView class methodsFor: 'public' stamp: ''!
titled: aTitle
	"Create an instance of the view and set a title to it"

	^ self new 
		title: aTitle; 
		yourself! !

!ROView methodsFor: 'interaction' stamp: ''!
@ anInteractionClassOrInstance

	anInteractionClassOrInstance initializeElement: self ! !

!ROView methodsFor: 'accessing' stamp: ''!
absolutePosition
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/13/2012 14:45'!
add: element 
	"Add an element in the view. Do nothing if the element is already in"
	(element view ~~ ROView nullView) ifTrue: [ ^ self ].
	
	self addElement: element.
	element parent: self.
	element view: self.

	self addElementRecursivelyToRender: element! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 3/31/2013 11:43'!
addAll: els 
	"Add a collection of graphical objects in the view"

	self assert: [ els isKindOf: Collection ].
	els do: [:n | self add: n ]! !

!ROView methodsFor: 'animation' stamp: 'AlexandreBergel 5/2/2013 19:23'!
addAnimation: animation
	"Add an animation to the view. The animation takes effect as soon as it is added"
	
	animation addedIn: self.
	animations add: animation.
	self signalUpdate ! !

!ROView methodsFor: 'rendering elements' stamp: 'AlexandreBergel 12/13/2012 14:46'!
addElementRecursivelyToRender: element
	self addElementToRender: element.
	element allElementsDo: [ :el | 
		self addElementToRender: el ]! !

!ROView methodsFor: 'rendering elements' stamp: 'DennisSchenk 2/19/2013 11:50'!
addElementToRender: element
	element setZindexFrom: zOrdering.
	elementsToRender do: [ :assoc | 
		(assoc key = element zIndex) ifTrue: [ assoc value add: element. ^ self ] ].
	
	"We have found the key, so we need to add it"
	elementsToRender add: element zIndex -> (OrderedCollection with: element)! !

!ROView methodsFor: 'rendering elements' stamp: 'AlexandreBergel 12/13/2012 14:49'!
addElementsToRender: els
	els do: [ :el | self addElementToRender: el ]! !

!ROView methodsFor: 'accessing' stamp: ''!
addFirst: element 
	elements addFirst: element.
	element view: self! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 00:42'!
adjustSizeIfNecessary
	"do nothing"! !

!ROView methodsFor: 'animation' stamp: 'AlexandreBergel 5/2/2013 19:10'!
animations
	"Return a copy of the animations"
	^ animations copy! !

!ROView methodsFor: 'events' stamp: ''!
announce: event
	eventHandler announce: event! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor
	^ backgroundColor ! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor: aColor
	
	backgroundColor := aColor! !

!ROView methodsFor: 'camera' stamp: ''!
camera
	^ camera! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateBy: point
	camera translateBy: point.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateByRealStep: aStep
	camera translateByRealStep: aStep.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:29'!
cameraTranslateTo: point
	camera translateTo: point.
	self signalUpdate! !

!ROView methodsFor: 'rendering' stamp: ''!
canvasForRealSize: realSize
	^ camera extent: realSize; realExtent: realSize; canvas! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 15:22'!
collectPathToRootIn: aCollection
	"Return the path from this graph to the root graph"

	aCollection addLast: self.! !

!ROView methodsFor: 'opening' stamp: ''!
defaultWindowSize
	^ 500 @ 500! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2012 08:45'!
depth
	^ 0! !

!ROView methodsFor: 'animation' stamp: 'AlexandreBergel 12/1/2012 10:58'!
doAllAnimationCycles
	"This methos is useful in testing. It executes all the animation without actually displaying anything"
	
	[ self hasAnimation ] whileTrue: [ self doAnimationCycle ]
	! !

!ROView methodsFor: 'animation' stamp: 'DR 1/15/2013 21:02'!
doAnimationCycle
	animations notEmpty ifTrue: [ self signalUpdate ].
	animations do: [:e | e doCycle].
	animations := animations reject: #hasCompleted.
	! !

!ROView methodsFor: 'rendering' stamp: 'AlexandreBergel 12/13/2012 14:46'!
drawElementsOn: canvas
	canvas camera: self camera.
	self elementsToRenderDo: [ :n | n drawOn: canvas ]! !

!ROView methodsFor: 'rendering' stamp: 'VanessaPena 1/17/2013 11:17'!
drawOn: canvas
	canvas paintBackground: backgroundColor.
	self drawElementsOn: canvas.
	self doAnimationCycle.
! !

!ROView methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:07'!
drawWithoutSettingCameraElementsOn: canvas
	self elementsToRenderDo: [ :n | n drawOn: canvas ].! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/13/2012 14:29'!
elementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	self elementsToRenderReverseDo: [ :el | (el contains: aPoint) ifTrue: [ ^ el ] ].
	^ self! !

!ROView methodsFor: 'accessing' stamp: ''!
elementAtRealPosition: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	^ self elementAt: (self camera realToVirtualPoint: aPoint)
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementDetect: aBlock
	^ elements copy detect: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 18:33'!
elementsFromModels: objects
	^ (objects collect: [ :o | self elementFromModel: o ]) copyWithout:  nil
! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/13/2012 14:51'!
elementsToRender
	"Return the number of elements that will be rendered"
	| answer |
	answer := OrderedCollection new.
	self elementsToRenderDo: [ :el | answer add: el ].
	^ answer asArray.! !

!ROView methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/13/2012 14:56'!
elementsToRenderDo: aBlock
	elementsToRender do: [ :assoc | assoc value do: aBlock ]! !

!ROView methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/13/2012 14:56'!
elementsToRenderReverseDo: aBlock
	elementsToRender reverse do: [ :assoc | assoc value reverse do: aBlock ]
	 ! !

!ROView methodsFor: 'accessing' stamp: 'VanessaPena 1/5/2013 15:46'!
encompassingRectangle
	"Return the encompassing rectangle of the view. All the elements are contained in this rectangle"

	| max maxPoint lowerPoint |
	elements isEmpty ifTrue: [ ^ 0@0 corner: 1@1 ].
	
	max := 1000000.
	maxPoint := max negated @ max negated.
	lowerPoint := max @ max.
	
	self elementsDo: [ :el |
		maxPoint := maxPoint max: el bounds bottomRight.
		lowerPoint := lowerPoint min: el position ].

	^ lowerPoint corner: maxPoint! !

!ROView methodsFor: 'testing' stamp: 'AlexandreBergel 11/30/2012 17:27'!
hasAnimation
	"Return true if some animations are present in the visualization"

	^ animations notEmpty! !

!ROView methodsFor: 'initialize' stamp: 'DennisSchenk 2/19/2013 12:59'!
initialize 
	super initialize.
	camera := ROCamera new.
	eventHandler := ROAnnouncer new.
	title := self class defaultWindowTitle.
	backgroundColor := Color white.
	animations := OrderedCollection new.
	zOrdering := ROZOrdering new.
	elementsToRender := OrderedCollection new
	! !

!ROView methodsFor: 'testing' stamp: 'AlexandreBergel 4/18/2012 15:35'!
is: aClass
	"Not sure whether this is important or not"
	^ false! !

!ROView methodsFor: 'testing' stamp: 'AlexandreBergel 4/11/2013 15:10'!
isRendered: anElement
	elementsToRender do: [ :assoc | (assoc value includes: anElement) ifTrue: [ ^ true ] ].
	^ false! !

!ROView methodsFor: 'testing' stamp: 'JurajKubelka 4/22/2013 13:47'!
isView

	^ true! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 9/25/2012 15:42'!
localElementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	| el |
	el := (elements reverse detect: [ :e | e contains: (aPoint - e topLeft) ] ifNone: [ ^ self ]).
	^ el elementAt: (aPoint - el topLeft)
	! !

!ROView methodsFor: 'accessing' stamp: ''!
localElementAtRealPoint: aPoint

	^ self localElementAt: (camera realToVirtualPoint: aPoint)! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 09:20'!
model
	"To be polymorphic with ROElement"
	
	^ self ! !

!ROView methodsFor: 'animation' stamp: 'AlexandreBergel 5/2/2013 19:05'!
numberOfAnimations
	^ animations size! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/13/2012 14:48'!
numberOfElementsToRender
	"Return the number of elements that will be rendered"
	| t |
	t := 0.
	self elementsToRenderDo: [ :el | t := t + 1 ].
	^ t! !

!ROView methodsFor: 'events' stamp: 'AlexandreBergel 4/18/2012 13:58'!
on: event do: aBlock
	eventHandler when: event do: aBlock! !

!ROView methodsFor: 'events' stamp: 'AlexandreBergel 11/25/2012 10:50'!
on: eventClass doOnce: aBlock
	"Register a block as an handler for eventClass. The callback is removed when exected"
	
	"interactions at: eventClass put: aBlock."
	eventHandler when: eventClass do: [ :arg | 
		aBlock value: arg.
		eventHandler unsubscribeForEvent: eventClass.
		"self removeInteraction: eventClass "]! !

!ROView methodsFor: 'opening' stamp: 'AlexandreBergel 11/23/2012 08:34'!
open
	^ self openInWindowSized: self defaultWindowSize! !

!ROView methodsFor: 'opening' stamp: 'AlexandreBergel 7/25/2012 16:15'!
openInWindowSized: aPoint

	^ ROPlatform current widgetFactory forView: self windowSized: aPoint
	! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 11/28/2012 22:23'!
position
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	^ 0 @ 0! !

!ROView methodsFor: 'rendering elements' stamp: 'DennisSchenk 2/20/2013 17:49'!
removeAllElementsToRender
	elementsToRender := OrderedCollection new.! !

!ROView methodsFor: 'animation' stamp: 'AlexandreBergel 5/2/2013 19:19'!
removeAnimationSuchThat: aOneArgBlock
	"Remove all animations that satisfy the one-arg block passed as parameter"
	| animationsToRemove |
	animationsToRemove := animations select: aOneArgBlock.
	animations := animations copyWithoutAll: animationsToRemove! !

!ROView methodsFor: 'rendering elements' stamp: 'DennisSchenk 2/19/2013 13:03'!
removeElementToRender: element
	elementsToRender do: [ :assoc | 
		(assoc key = element zIndex) ifTrue: [ assoc value remove: element ifAbsent: [ ] ] ].
! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:26'!
resizeStrategy
	^ ROFixedSizedParent instance! !

!ROView methodsFor: 'events' stamp: ''!
signalUpdate
	self announce: RORefreshNeeded! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 13:55'!
sortElementsWith: aTwoArgBlock
	elements sort: aTwoArgBlock
	
! !

!ROView methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/6/2012 13:58'!
title: aString
	"Set the title of the view. Useful when opening up a window"
	
	title := aString! !

!ROView methodsFor: 'camera' stamp: 'VanessaPena 1/5/2013 17:35'!
translateBy: point
	self cameraTranslateBy: point negated.
	self announce: (ROCameraTranslated new step: point negated).! !

!ROView methodsFor: 'camera' stamp: ''!
translateByRealPoint: aPoint 
	| p1 p2 |
	p1 := self camera position.
	p2 := self camera realToVirtualPoint: aPoint. 
	self translateBy: (p2 - p1).
! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:30'!
translateTo: point
	self cameraTranslateTo: point negated! !

!ROView methodsFor: 'accessing' stamp: ''!
view
	^ self ! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 11/15/2012 15:11'!
windowSize: anExtent
	"Tell the camera what is the size of the window that contains me"
	
	| oldExtent |
	oldExtent := self camera windowSize.
	self camera windowSize: anExtent.
	self announce: (ROWindowResized new 
							oldExtent: oldExtent;
							extent: anExtent)! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/10/2012 19:01'!
zOrdering
	^ zOrdering! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 12/13/2012 15:11'!
zOrdering: aZOrdering
	"Dedicated object to assign zIndex to graphical elements"
	
	| oldEls |
	zOrdering := aZOrdering.
	oldEls := self elementsToRender.
	elementsToRender := SortedCollection sortBlock: [ :a :b | a key < b key ].
	self addElementsToRender: oldEls
	
	! !

ROView subclass: #ROViewStack
	instanceVariableNames: 'views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewStack methodsFor: 'accessing' stamp: ''!
addFirst: aView
	views addFirst: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addLast: aView
	views addLast: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addView: aView
	self addLast: aView! !

!ROViewStack methodsFor: 'rendering' stamp: 'VanessaPena 1/8/2013 10:50'!
drawOn: aROCanvas
	self viewReverseDo: [ :v | v drawOn: aROCanvas ].
	self drawElementsOn: aROCanvas
! !

!ROViewStack methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2012 17:36'!
elementAtRealPosition: aPoint
	"Override of the superclass. If nothing is found in myself, then we look in the embedded views"

 	| t el |
	
	el := self elementAt: (self camera realToVirtualPoint: aPoint).
	(el == self) 
		ifTrue: [ self viewDo: [ :v | 
					^ v elementAtRealPosition: aPoint ] ]
		ifFalse: [ ^ el ].
	^ self
! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
firstView
	^ views first! !

!ROViewStack methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	views := OrderedCollection new.
	 ! !

!ROViewStack methodsFor: 'interactions' stamp: ''!
on: eventClass do: aBlock
	super on: eventClass do: aBlock.
	self viewDo: [ :v | v on: eventClass do: aBlock ]! !

!ROViewStack methodsFor: 'accessing' stamp: 'VanessaPena 1/8/2013 11:19'!
removeFirst
	views removeFirst.
	self announce: (ROViewChanged new newView: views first).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
replaceFirstBy: view
	views removeFirst.
	self addFirst: view ! !

!ROViewStack methodsFor: 'opening' stamp: ''!
viewDo: aBlock
	views do: [:v | aBlock value: v ].! !

!ROViewStack methodsFor: 'opening' stamp: 'VanessaPena 1/8/2013 10:50'!
viewReverseDo: aBlock
	views reverseDo: [:v | aBlock value: v ].
				
	! !

!ROViewStack methodsFor: 'accessing' stamp: 'VanessaPena 1/8/2013 10:33'!
viewsSize

	^views size! !

!ROViewStack methodsFor: 'accessing' stamp: 'AlexandreBergel 11/14/2012 13:51'!
windowSize: anExtent
	super windowSize: anExtent.
	views do: [ :v | v windowSize: anExtent ]! !

ROObject subclass: #ROCountingNullCanvas
	instanceVariableNames: 'numberOfRectangles numberOfLines numberOfImages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCountingNullCanvas class methodsFor: 'instance creation' stamp: ''!
on: aForm
	"we do nothing"
	^ self new! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/11/2013 14:26'!
camera
	^ ROCamera new! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
clipRect
	^1@1 extent: 100000@100000! !

!ROCountingNullCanvas methodsFor: 'drawing-rectangles' stamp: ''!
frameAndFillRectangle: bounds fillColor: c borderWidth: width borderColor: cc
	numberOfRectangles := numberOfRectangles + 1.
! !

!ROCountingNullCanvas methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize .
	numberOfRectangles := 0.
	numberOfLines := 0.
	numberOfImages := 0! !

!ROCountingNullCanvas methodsFor: 'drawing' stamp: ''!
line: fromPoint to: toPoint width: width color: color
	numberOfLines := numberOfLines + 1.! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfImages
	^ numberOfImages! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfLines
	^ numberOfLines! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfRectangles
	^ numberOfRectangles! !

!ROCountingNullCanvas methodsFor: 'drawing-images' stamp: ''!
paintImage: cacheForm at: position
	numberOfImages := numberOfImages + 1.
! !

!ROCountingNullCanvas methodsFor: 'hook' stamp: ''!
warpImage: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"We cancel this method. It is defined as abstract in the Canvas class"! !

ROObject subclass: #ROFileOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROFileOrganizer class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 12/6/2012 13:48'!
current

	^self allSubclasses first ! !

!ROFileOrganizer class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 12/6/2012 13:47'!
deleteFile: aFilename

	self subclassResponsibility ! !

ROObject subclass: #ROFontOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROFontOrganizer commentStamp: '<historical>' prior: 0!
Abstract class that tells about what a font looks like!

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/25/2012 15:47'!
current
	^ self subclasses first! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'VanessaPena 12/23/2012 21:22'!
defaultFont

	self subclassResponsibility ! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'VanessaPena 12/23/2012 21:23'!
defaultFontForSize: aNumber

	self subclassResponsibility ! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'VanessaPena 12/23/2012 21:22'!
defaultFontSize

	self subclassResponsibility ! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/27/2012 18:02'!
height
	self subclassResponsibility! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:35'!
offsetWhenDrawing
	^ 0 @ 0! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/18/2012 15:50'!
widthOfString: string
	self subclassResponsibility! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/6/2013 18:17'!
widthOfString: string font: font
	"Return the length of a string"
	
	self subclassResponsibility! !

ROObject subclass: #ROGraphTransformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:02'!
containsCycleIn: nodes with: edges 
	"Broken so far"
	^ self containsCycleIn: nodes with: edges alreadyPassedNodes: #() root: nodes first
! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:00'!
containsCycleIn: nodes with: edges alreadyPassedNodes: passedNodes root: rootNode

	| newNodes newPassedNode c res |
	nodes ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	
	newNodes := nodes.
	newPassedNode := passedNodes.
	
	res := false.
	nodes do: [ :node | 
		(passedNodes contains: node) ifTrue: [ ^ true ].
		newNodes := nodes copyWithout: rootNode.
		c := self getConnectedNodesFrom: node using: edges.
		newNodes := newNodes copyWithoutAll: c.
		newPassedNode := newPassedNode, (Array with: rootNode).
		
		res := res and: [self containsCycleIn: newNodes with: edges alreadyPassedNodes: passedNodes root: node]	
	].
	^ res
	! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:38'!
containsCycleIn: rootNode with: edges passedNodes: passedNodes

	| c usedEdges |
	edges ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	c := self getConnectedNodesFrom: rootNode using: edges.
	usedEdges := edges select: [ :edge | edge from == rootNode ].
	passedNodes add: rootNode.
	c do: [ :nr | 
		(self containsCycleIn: nr with: (edges copyWithoutAll: usedEdges) passedNodes: passedNodes)
			ifTrue: [ ^ true ].
		passedNodes add: nr. ].
	^ false! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DennisSchenk 6/27/2012 13:39'!
fromEdgesToNesting: nodes edges: edges
	^ self fromEdgesToNesting: nodes edges: edges roots: (self rootNodesFor: nodes edges: edges).! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DR 3/27/2013 16:49'!
fromEdgesToNesting: nodes edges: edges root: root
	| children restOfNodes |
	"self assert: [ self containsCycleIn: nodes with: edges ] description: 'Cannot contain cycle'."
	
	children := self getConnectedNodesFrom: root using: edges.
	
	"Remove found children from rest of given nodes."
	restOfNodes := nodes copy asOrderedCollection.
	children do: [: n | restOfNodes remove: n ifAbsent: []].
	
	"Recurse, do the same for all children."
	children := children collect: [ :child | self 
										fromEdgesToNesting: restOfNodes 
										edges: edges 
										root: child ].
									
	"Remove children from any previous parent there might be (?)."
	children do: [:e |e removeFromParent].
	
	"Add children to given root, which is their new parent."
	children do: [ :child | root addChild: child ].
	
	^ root! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DennisSchenk 6/27/2012 13:40'!
fromEdgesToNesting: nodes edges: edges roots: roots
	roots size > 1 ifTrue: [
		| result |
		result := OrderedCollection new.
		roots do: [ :root |
			result add: (self fromEdgesToNesting: nodes edges: edges root: root).
		].
		^ result.
	].
	^ self fromEdgesToNesting: nodes edges: edges root: roots first.
! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:49'!
getConnectedEdgesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ])! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 09:30'!
getConnectedNodesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ]) collect: #to! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DR 1/15/2013 21:20'!
hasCycleIn: nodes with: edges	
	| connectedNodes connectedEdges runningNodes runningEdges |

	runningNodes := nodes.
	runningEdges := edges.
	nodes copy do: [ :n |	
		runningNodes := runningNodes copyWithout: n.
		
		connectedNodes := self getConnectedNodesFrom: n using: runningEdges.
		connectedEdges := self getConnectedEdgesFrom: n using: runningEdges.
		
		(runningNodes includesAll: connectedNodes) ifFalse: [ ^ true ].
		
		runningNodes := runningNodes copyWithoutAll: connectedNodes.
		runningEdges := runningEdges copyWithoutAll: connectedEdges.

		runningEdges ifEmpty: [ ^ false ].
		runningNodes ifEmpty: [ ^ false ].

	]! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:41'!
parentsFor: aNode edges: edges
	| nodes |
	nodes := OrderedCollection new.
	edges do: [ :edge | edge to == aNode ifTrue: [ nodes add: edge from ] ].
	^ nodes.! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:44'!
rootNodeFor: nodes edges: edges
	| rootNodes |
	rootNodes := self rootNodesFor: nodes edges: edges.
	rootNodes size > 1 ifTrue: [ self error: 'More than one root node found' ].
	^ rootNodes first.! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:43'!
rootNodesFor: aNodeCollection edges: edges
	^ aNodeCollection select: [:node | (self parentsFor: node edges: edges) isEmpty ].! !

ROObject subclass: #ROHTMLShapeVisitor
	instanceVariableNames: 'attributes stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

ROHTMLShapeVisitor subclass: #ROHTMLEdgeShapeVisitor
	instanceVariableNames: 'idNodeFrom idNodeTo edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROHTMLEdgeShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 18:00'!
addToStream: aShape

	stream 
		nextPutAll: '{ ';
		nextPutAll: ('sourceID: "<1p>"' expandMacrosWith: idNodeFrom); 
		nextPutAll: ', ';
		nextPutAll: ('targetID: "<1p>"' expandMacrosWith: idNodeTo); 
		nextPutAll: ', ';
		nextPutAll: ('edgeColor: "<1s>"' expandMacrosWith: (attributes at: #edgeColor)); 
		nextPutAll: ', ';
		nextPutAll: ('edgeWidth: "<1p>"' expandMacrosWith: (attributes at: #edgeWidth)); 
		nextPutAll: '},'.
		! !

!ROHTMLEdgeShapeVisitor methodsFor: 'accessing' stamp: 'VanessaPena 1/31/2013 17:44'!
edge: anObject

	edge := anObject! !

!ROHTMLEdgeShapeVisitor methodsFor: 'accessing' stamp: 'VanessaPena 1/31/2013 17:47'!
idNodeFrom: anObject

	idNodeFrom := anObject! !

!ROHTMLEdgeShapeVisitor methodsFor: 'accessing' stamp: 'VanessaPena 1/31/2013 17:46'!
idNodeTo: anObject

	idNodeTo := anObject! !

!ROHTMLEdgeShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 18:00'!
visitAbstractLine: aShape

	attributes at: #edgeColor put: (aShape color roValue: edge) asHTMLColor.
	attributes at: #edgeWidth put: (aShape widthFor: edge) .
	
	self addToStream: aShape.
! !

ROHTMLShapeVisitor subclass: #ROHTMLElementShapeVisitor
	instanceVariableNames: 'aNode nodeID nodeParentID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addBorderColorToStream: aShape

	| nodeBorderColor |
	
	nodeBorderColor := attributes at: #borderColor.	
	nodeBorderColor ifNotNil: [
		stream 
			nextPutAll: ', ';
			nextPutAll: ('nodeBorderColor: "<1s>"' expandMacrosWith: nodeBorderColor)]. 
	! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:36'!
addBorderWidthToStream: aShape
	
	|borderWidth|
	
	borderWidth := attributes at: #borderWidth.	
	borderWidth ifNotNil: [
		stream 
			nextPutAll: ', ';
			nextPutAll: ('nodeBorderWidth: "<1p>"' expandMacrosWith: borderWidth)].! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addBoundsToStream: aShape


	| nodeWidth nodeHeight |
	
	nodeWidth := aNode width.
	nodeHeight := aNode height.	
	stream
		nextPutAll: ('nodeWidth: <1p>' expandMacrosWith: nodeWidth); 
		nextPutAll: ', ';
		nextPutAll: ('nodeHeight: <1p>' expandMacrosWith: nodeHeight).! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addEndToStream

	stream 
		nextPutAll: '},'.! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addFillColorToStream: aShape

	| nodeFillColor |
	
	nodeFillColor := attributes at: #fillColor.
	nodeFillColor ifNotNil: [
		stream 
			nextPutAll: ', ';
			nextPutAll: ('nodeFillColor: "<1s>"' expandMacrosWith: nodeFillColor)] .! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addInteractionToStream: aShape
	
	| draggable |
	
	draggable := aNode is: RODraggable.	
	stream 
		nextPutAll: ', ';
		nextPutAll: ('draggable: "<1p>"' expandMacrosWith: draggable).! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:07'!
addNodeInfoToStream: aShape

	| nodeModel |
	
	nodeModel := attributes at: #text.
	stream 
		nextPutAll: ('nodeID: <1p>' expandMacrosWith: nodeID); 
		nextPutAll: ', ';
		nextPutAll: ('nodeParentID: <1s>' expandMacrosWith: nodeParentID).
		
	nodeModel ifNotNil: [
		stream 
			nextPutAll: ', ';
			nextPutAll: ('nodeModel: "<1s>"' expandMacrosWith: nodeModel)] . ! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addPositionToStream: aShape

	| position |
	
	position := attributes at: #position.
	stream
		nextPutAll: ('x: <1p>' expandMacrosWith: position x); 
		nextPutAll: ', ';
		nextPutAll: ('y: <1p>' expandMacrosWith: position y).		
! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addSeparationToStream

	stream
		nextPutAll: ', '.! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:26'!
addShapeNameToStream: aShape

	|nodeShape|
	
	nodeShape := aShape class name asString.
	stream
		nextPutAll: ('nodeShape: "<1s>"' expandMacrosWith: nodeShape).! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:04'!
addStartToStream

	stream 
		nextPutAll: '{ '.! !

!ROHTMLElementShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 16:26'!
addToStream: aShape

	self addStartToStream.
	self addNodeInfoToStream: aShape.
	self addSeparationToStream.
	self addShapeNameToStream: aShape.
	self addSeparationToStream.
	self addBoundsToStream: aShape.
	self addSeparationToStream.
	self addPositionToStream: aShape.
	self addFillColorToStream: aShape.
	self addBorderColorToStream: aShape.
	self addBorderWidthToStream: aShape.
	self addInteractionToStream: aShape.
	self addEndToStream.
	
	! !

!ROHTMLElementShapeVisitor methodsFor: 'util' stamp: 'VanessaPena 1/31/2013 18:02'!
labelOffset

	^0@10! !

!ROHTMLElementShapeVisitor methodsFor: 'accesing' stamp: 'VanessaPena 1/3/2013 12:53'!
node
	
	^aNode! !

!ROHTMLElementShapeVisitor methodsFor: 'accesing' stamp: 'VanessaPena 1/3/2013 12:53'!
node: node

	aNode := node! !

!ROHTMLElementShapeVisitor methodsFor: 'accesing' stamp: 'VanessaPena 1/31/2013 16:01'!
nodeID: aNumber

	nodeID := aNumber

	! !

!ROHTMLElementShapeVisitor methodsFor: 'accesing' stamp: 'VanessaPena 1/31/2013 16:01'!
nodeParentID: aNumber

	nodeParentID := aNumber

	! !

!ROHTMLElementShapeVisitor methodsFor: 'util' stamp: 'VanessaPena 1/31/2013 14:52'!
setLabelPositionFor: aShape

	attributes 
		at: #position 
		put: ((aNode view camera virtualToRealPoint: aNode topLeft) + self labelOffset).

! !

!ROHTMLElementShapeVisitor methodsFor: 'util' stamp: 'VanessaPena 1/31/2013 14:53'!
setPositionFor: aShape

	attributes 
		at: #position 
		put: (aNode view camera virtualToRealPoint: aNode topLeft).

! !

!ROHTMLElementShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 16:24'!
visitAbstractLabel: aShape

	attributes at: #borderColor put: (aShape color roValue: aNode) asHTMLColor.
	attributes at: #borderWidth put: nil.
	attributes at: #fillColor put: 'none'.
	attributes at: #text put: (aShape textAdaptedFor: aNode).
	self setLabelPositionFor: aShape.
	self addToStream: aShape.! !

!ROHTMLElementShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 16:35'!
visitBorder: aShape

	attributes at: #borderColor put: (aShape color roValue: aNode) asHTMLColor.
	attributes at: #borderWidth put: nil.
	attributes at: #fillColor put: 'none'.
	attributes at: #text put: nil.
	self setPositionFor: aShape.
	self addToStream: aShape.! !

!ROHTMLElementShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 16:35'!
visitBox: aShape

	attributes at: #borderColor put: (aShape borderColor roValue: aNode)  asHTMLColor.
	attributes at: #borderWidth put: (aShape borderWidth roValue: aNode).
	attributes at: #fillColor put: (aShape colorFor: aNode)  asHTMLColor.
	attributes at: #text put: nil.
	self setPositionFor: aShape.
	self addToStream: aShape.! !

!ROHTMLElementShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 16:00'!
visitCircle: aShape

	attributes at: #borderColor put: (aShape borderColor roValue: aNode)  asHTMLColor.
	attributes at: #borderWidth put: (aShape borderWidth roValue: aNode).
	attributes at: #fillColor put: (aShape colorFor: aNode)  asHTMLColor.
	attributes at: #text put: nil.
	self setPositionFor: aShape.
	self addToStream: aShape.! !

!ROHTMLElementShapeVisitor methodsFor: 'visit' stamp: 'VanessaPena 12/27/2012 12:52'!
visitNullShape: aShape! !

!ROHTMLShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 18:05'!
addToStream: aShape! !

!ROHTMLShapeVisitor methodsFor: 'accesing' stamp: 'VanessaPena 1/31/2013 18:04'!
attributes

	^attributes ifNil: [ attributes := Dictionary new ]! !

!ROHTMLShapeVisitor methodsFor: 'initialize-release' stamp: 'VanessaPena 1/31/2013 17:56'!
initialize

	attributes := IdentityDictionary new.! !

!ROHTMLShapeVisitor methodsFor: 'stream' stamp: 'VanessaPena 1/31/2013 17:56'!
stream: aStream

	stream := aStream! !

ROObject subclass: #ROIdentityMatrix
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROIdentityMatrix commentStamp: '<historical>' prior: 0!
A ROIdentityMatrix is essentially used by the sugiyama tree layout!

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row keys! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row
		at: v
		ifAbsent: [false]! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v put: aBoolean
	
	| row |
	"u -> v"
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	row at: v put: aBoolean.	"v -> u"
	row := rows
		at: v
		ifAbsentPut: [IdentityDictionary new].
	row at: u put: aBoolean! !

!ROIdentityMatrix methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/18/2012 14:27'!
initialize
	
	rows := IdentityDictionary new! !

ROObject subclass: #ROInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

ROInteraction subclass: #ROAbstractExpandChildrenOnClick
	instanceVariableNames: 'childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAbstractExpandChildrenOnClick class methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/21/2012 15:41'!
childrenBlock: aBlock
	^self new
		childrenBlock: aBlock;
		yourself.! !

!ROAbstractExpandChildrenOnClick class methodsFor: 'instance creation' stamp: 'AlexandreBergel 10/7/2012 13:10'!
childrenForModel: aBlock

	^ self childrenBlock: [ :el | 
		| children |
		children := aBlock value: el model.
		children collect: [:c | (ROElement on: c) + ROLabel + ROBox] ]! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:41'!
addChildren: newNode to: element

	| edge line |
	self adjustNode: newNode.
	element view add: newNode.
	
	line := ROLine new.
	edge := (ROEdge from: element to: newNode) + line.
	line attachPoint: ROVerticalAttachPoint new.
	element view add: edge.
	^ newNode! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:40'!
addChildrenFromModel: model to: element

	| newNode edge line |
	newNode := ROElement spriteOn: model.
	newNode + ROLabel @ (ROExpandChildrenOnClick childrenBlock: childrenBlock).
	element view add: newNode.
	
	line := ROLine new.
	edge := (ROEdge from: element to: newNode) + line.
	line attachPoint: ROVerticalAttachPoint new.
	element view add: edge.
	^ newNode! !

!ROAbstractExpandChildrenOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	self subclassResponsibility ! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 6/21/2012 15:40'!
childrenBlock
	^ childrenBlock! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 6/21/2012 15:40'!
childrenBlock: anObject
	childrenBlock := anObject! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 10/7/2012 12:57'!
computeChildrenFor: element
	^ childrenBlock value: element! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:40'!
initializeElement: element

	element on: ROMouseClick do: [:event |
		| elements newElements roElements |
		
		newElements := childrenBlock value: element.
		roElements := newElements collect: [:children | 
			self addChildren: children to: element ].
		roElements do: [ :el | el translateTo: element position].


		elements := element view elementsSuchThat: #notNil.
		ROTreeLayout new
			translator: ROSmoothLayoutTranslator new;
			applyOn: elements.
			
		element signalUpdate. ].! !

ROAbstractExpandChildrenOnClick subclass: #ROExpandChildrenOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROExpandChildrenOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	! !

ROAbstractExpandChildrenOnClick subclass: #RORecursiveExpandOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RORecursiveExpandOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	node @ (ROExpandChildrenOnClick childrenBlock: childrenBlock).! !

ROInteraction subclass: #ROAbstractPopup
	instanceVariableNames: 'receivingView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

ROAbstractPopup class
	instanceVariableNames: 'popups'!

ROAbstractPopup class
	instanceVariableNames: 'popups'!

!ROAbstractPopup class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:46'!
defaultPopupOffset
	^ 10 @ 10! !

!ROAbstractPopup class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/17/2013 12:06'!
popups

	^ popups ifNil: [ popups := OrderedCollection new ]! !

!ROAbstractPopup class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 1/17/2013 12:04'!
resetPopups

	popups := nil! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 4/6/2013 22:26'!
closestPositionOf: el from: realPosition in: aView
	"Return the closest position for el to realPosition to be entierely visible in the view"

	| idealVirtualPosition virtualPositionX virtualPositionY winSize |
	idealVirtualPosition := (aView camera realToVirtualPoint: realPosition).
	
	winSize := aView camera windowSize.
	
	"If the popup is larger than the window, then there is not much we can do"
	(el width > winSize x or: [ el height > winSize y ]) 
		ifTrue: [ ^ idealVirtualPosition + self popupOffset ].
	
	"Check if the element is within the width of the view"
	virtualPositionX := 
		((idealVirtualPosition x + el width + self popupOffset x) < winSize x) 
			ifTrue: [ idealVirtualPosition x + self popupOffset x ]
			ifFalse: [ idealVirtualPosition x - el width - self popupOffset x ].

	virtualPositionY := 
		((idealVirtualPosition y + el height + self popupOffset y) < winSize y) 
			ifTrue: [ idealVirtualPosition y + self popupOffset y ]
			ifFalse: [ idealVirtualPosition y - el height - self popupOffset y ].
		
	^ virtualPositionX @ virtualPositionY! !

!ROAbstractPopup methodsFor: 'hooks' stamp: ''!
createElementFor: element
	self subclassResponsibility! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:32'!
createPopupFor: element
	| el |
	el := self createElementFor: element.
	el on: ROMouseLeave do: [ :e | el view remove: el ifAbsent: [  ] ].

	(self receivingViewFor: element) add: el.	

	self popups add: el.

	^ el! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 6/1/2012 18:27'!
initialize
	super initialize.
	receivingView := [ :element | element view ]. ! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 4/6/2013 21:56'!
initializeElement: element
	 element on: ROMouseEnter do: [ :event | 
		| el popupPosition |
		self removeAllPopups.
		el := self createPopupFor: element.

		popupPosition := self 
								closestPositionOf: el 
								from: event realPosition 
								in: (self receivingViewFor: element).
		el translateTo: popupPosition.
		el signalUpdate ].
	
	 element on: ROMouseLeave do: [ :event | 
		self removeAllPopups.
		element signalUpdate ].

	 element on: ROMouseDragging do: [ :event | 
		self removeAllPopups ].! !

!ROAbstractPopup methodsFor: 'configuration' stamp: 'AlexandreBergel 1/2/2013 09:02'!
popupOffset
	"Return a point representing the offset of the popup"
	
	^ self class defaultPopupOffset! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'VanessaPena 1/17/2013 12:04'!
popups
	^ self class popups! !

!ROAbstractPopup methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:28'!
receivingView: rView
	receivingView := rView! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:30'!
receivingViewFor: element
	"Return the view in which the popup has to be added. Per default this view is the view in which the element is contained.
	However, this may be different, especially when contained in a stack"
	^ receivingView roValue: element! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'VanessaPena 1/17/2013 12:04'!
removeAllPopups
	self popups do: [ :p | self removePopup: p ].
	self class resetPopups! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 12/11/2012 11:48'!
removePopup: el
	el ifNotNil: [ el remove ].! !

ROAbstractPopup subclass: #ROPopup
	instanceVariableNames: 'text textColor box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopup class methodsFor: 'public' stamp: ''!
text: txtBlock
	^ self new text: txtBlock; yourself! !

!ROPopup methodsFor: 'accessing' stamp: 'DennisSchenk 10/2/2012 13:02'!
box
	^ box! !

!ROPopup methodsFor: 'accessing' stamp: 'DennisSchenk 10/2/2012 13:03'!
box: aROBox
	 box := aROBox.! !

!ROPopup methodsFor: 'creation' stamp: 'DennisSchenk 10/2/2012 16:39'!
createElementFor: element
	^ ROElement new
			add: (ROElement new 
					+ ((ROLabel 
						text: (text roValue: element model)) color: textColor))
					+ box copy;
			yourself! !

!ROPopup methodsFor: 'initialization' stamp: 'DennisSchenk 10/2/2012 16:35'!
initialize 
	super initialize.
	text := #yourself.
	textColor := Color white.
	box := ROBox new.! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text: anObject
	text := anObject! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor
	^ textColor! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor: anObject
	textColor := anObject! !

ROAbstractPopup subclass: #ROPopupView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopupView class methodsFor: 'public' stamp: 'AlexandreBergel 7/6/2012 13:51'!
view: v
	^ self new view: v! !

!ROPopupView methodsFor: 'hooks' stamp: 'AlexandreBergel 12/10/2012 18:56'!
createElementFor: element
	| bitmap v extent encompassingRectangle |
	"We need here to have a proper extent here."

	v := (view roValue: element) view.
	encompassingRectangle := v encompassingRectangle.
	extent := encompassingRectangle corner asIntegerPoint + (1 @ 1).
	^ (ROElement new extent: extent) + (ROViewDisplayer new view: v; yourself)
! !

!ROPopupView methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/5/2013 14:56'!
initialize
	super initialize.
	view := ROView nullView.! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view
	^ view! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view: aView
	view := aView! !

ROInteraction subclass: #ROAddName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAddName class methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 18:16'!
removeFrom: anElement
 
	(anElement attributes includesKey: #addedName)
		ifTrue: [ (anElement attributes at: #addedName) remove.
				anElement attributes removeKey: #addedName ]! !

!ROAddName class methodsFor: 'public' stamp: 'AlexandreBergel 12/5/2012 18:28'!
toElement: anElement
	| label |
	"We first make sure no previous element are around"
	self removeFrom: anElement. 
	
	label := ROElement on: anElement model.
	label + ROLabel + ROBox white.

	anElement attributes at: #addedName put: label.	
	anElement view add: label.
	
	ROConstraint stick: label below: anElement! !

ROInteraction subclass: #ROAnimation
	instanceVariableNames: 'nbCycles afterBlock remainingCycles strategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAnimation methodsFor: 'action' stamp: 'AlexandreBergel 5/2/2013 19:15'!
addedIn: aView
	"I m added in a view"
	strategy added: self in: aView! !

!ROAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2012 17:24'!
after: aBlock
	"The after block is used to do something after the animation has completed"
	afterBlock := aBlock! !

!ROAnimation methodsFor: 'hooks' stamp: ''!
defaultNumberOfCycles
	^ 10! !

!ROAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2012 17:54'!
doAfter
	afterBlock value! !

!ROAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2012 19:07'!
doCycle
	self hasCompleted 
		ifFalse: [ 
			remainingCycles := remainingCycles - 1. 
			self doStep.
			self hasCompleted ifTrue: [ self doAfter ] ]! !

!ROAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 12/1/2012 11:35'!
doStep
	"To be overriden"! !

!ROAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:16'!
elapsedCycles
	^ nbCycles - remainingCycles! !

!ROAnimation methodsFor: 'testing' stamp: ''!
hasCompleted 
	^ remainingCycles = 0! !

!ROAnimation methodsFor: 'initialization' stamp: 'AlexandreBergel 5/2/2013 19:00'!
initialize
	super initialize.
	self nbCycles: self defaultNumberOfCycles.
	afterBlock := #yourself.
	strategy := ROAnimationAppend instance! !

!ROAnimation methodsFor: 'accessing' stamp: ''!
nbCycles
	^ nbCycles! !

!ROAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2012 19:06'!
nbCycles: integer
	nbCycles := integer.
	remainingCycles := integer! !

!ROAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 5/2/2013 18:58'!
strategy
	"Return the merging strategy associated to this animation"
	^ strategy! !

!ROAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 5/2/2013 19:04'!
strategy: anAnimationStrategy
	"Set a new strategy when merging animations"
	strategy := anAnimationStrategy ! !

ROAnimation subclass: #ROFuncionMove
	instanceVariableNames: 'element blockX blockY'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROFuncionMove methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:28'!
blockX
	^ blockX! !

!ROFuncionMove methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:29'!
blockX: aBlock
	blockX := aBlock! !

!ROFuncionMove methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:29'!
blockY
	^ blockY! !

!ROFuncionMove methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:29'!
blockY: aBlock
	blockY := aBlock! !

!ROFuncionMove methodsFor: 'hooks' stamp: 'AlexandreBergel 12/1/2012 16:31'!
doStep

	element translateTo: ((blockX roValue: self elapsedCycles) @ (blockY roValue: self elapsedCycles))! !

!ROFuncionMove methodsFor: 'initialization' stamp: 'AlexandreBergel 12/1/2012 16:32'!
initialize
	super initialize.
	blockX := [ :elapsed | elapsed ].
	blockY := [ :elapsed | elapsed ].! !

!ROFuncionMove methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:22'!
on: anElement
	element := anElement.
	element view addAnimation: self.! !

ROAnimation subclass: #ROIncrementalZoomMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROIncrementalZoomMove methodsFor: 'public' stamp: 'VanessaPena 1/8/2013 11:53'!
on: view
	| v |
	v := view camera bounds.
	v := (v origin + self step) corner: (v corner - self step).
	ROZoomMove new 
		nbCycles: nbCycles; 
		on: view to: v! !

ROIncrementalZoomMove subclass: #ROZoomInMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomInMove methodsFor: 'config' stamp: ''!
step
	^ 40 @ 40! !

ROIncrementalZoomMove subclass: #ROZoomOutMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOutMove methodsFor: 'config' stamp: ''!
step
	^ -40 @ -40! !

ROAnimation subclass: #ROLinearMove
	instanceVariableNames: 'increment element finalPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLinearMove commentStamp: 'AlexandreBergel 11/28/2011 10:50' prior: 0!
ROLinearMove moves an element in a number of cycles.

Example of usage:
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	| view el |
	view := ROView new.
	el := ROElement sprite.
	view add: el.
	view on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el until: event position.
	].
	view open.
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=!

!ROLinearMove class methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 21:22'!
for: element by: position
	^ self new for: element by: position! !

!ROLinearMove class methodsFor: 'public' stamp: 'AlexandreBergel 11/30/2012 17:36'!
for: element to: position
	^ self new for: element to: position! !

!ROLinearMove methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2012 18:06'!
after
	super after.
	element translateTo: finalPosition.! !

!ROLinearMove methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2012 17:54'!
doStep
	element translateBy: increment.
	element signalUpdate.! !

!ROLinearMove methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2012 17:56'!
element
	^ element! !

!ROLinearMove methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 21:22'!
for: anElement by: aPoint
	self for: anElement to: (anElement position + aPoint)! !

!ROLinearMove methodsFor: 'public' stamp: 'miltonmamani 4/17/2013 15:31'!
for: anElement to: aFinalPosition

	| p |
	element := anElement.
	p := aFinalPosition - anElement position.
	increment := (p x / nbCycles) @ (p y / nbCycles).
	remainingCycles := nbCycles.
	finalPosition := aFinalPosition.
	anElement view addAnimation: self! !

ROAnimation subclass: #ROMotionMove
	instanceVariableNames: 'element speedPoint increment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMotionMove methodsFor: 'hooks' stamp: 'AlexandreBergel 12/1/2012 11:34'!
doStep
	element translateBy: (speedPoint / increment) asIntegerPoint.
	increment := increment + 1.! !

!ROMotionMove methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 10:59'!
for: anElement initialSpeed: aSpeedPoint
	"Apparently problem may occur"
	aSpeedPoint isNil ifTrue: [ ^self].
	
	element := anElement.
	speedPoint := aSpeedPoint.
	increment := 1.

	anElement view addAnimation: self.! !

!ROMotionMove methodsFor: 'testing' stamp: 'AlexandreBergel 12/1/2012 10:52'!
hasCompleted

	^ (speedPoint / increment) r <= 2 ! !

ROAnimation subclass: #RONopAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RONopAnimation commentStamp: 'AlexandreBergel 12/1/2012 15:49' prior: 0!
RONopAnimation is a do nothing animation. Useful to simulate a pause between two animations!

!RONopAnimation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:01'!
on: aView
	aView addAnimation: self! !

ROAnimation subclass: #ROPluggableAnimation
	instanceVariableNames: 'block nbIterationsBeforeRefresh nbIterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:06'!
block
	^ block! !

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 12/1/2012 16:06'!
block: anObject
	block := anObject! !

!ROPluggableAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 1/23/2013 16:47'!
doStep
	nbIterations := nbIterations + 1.
	nbIterations >= nbIterationsBeforeRefresh  
		ifTrue: [ block value. nbIterations := 0 ]! !

!ROPluggableAnimation methodsFor: 'initialization' stamp: 'AlexandreBergel 1/23/2013 16:46'!
initialize
	super initialize.
	nbIterations := 0.
	nbIterationsBeforeRefresh := 0! !

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:46'!
nbIterations
	^ nbIterations! !

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:46'!
nbIterations: anObject
	nbIterations := anObject! !

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:46'!
nbIterationsBeforeRefresh
	^ nbIterationsBeforeRefresh! !

!ROPluggableAnimation methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:46'!
nbIterationsBeforeRefresh: anObject
	nbIterationsBeforeRefresh := anObject! !

!ROPluggableAnimation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:08'!
on: aView

	aView addAnimation: self! !

ROAnimation subclass: #ROTranslation
	instanceVariableNames: 'numberOfCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROTranslation commentStamp: 'VanessaPena 8/26/2012 09:44' prior: 0!
A ROFunctionMove is just a test, is not a complete interaction yet :)
!

!ROTranslation methodsFor: 'hooks' stamp: 'VanessaPena 8/23/2012 16:21'!
defaultNumberOfCycles
	^ 100! !

!ROTranslation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:22'!
for: element function: aBlock intervalIni: ini IntervalEnd: end 
 
	| xIncrement yIncrement position |
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat .
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: xIncrement @ yIncrement.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 30) wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROTranslation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:27'!
for: element function: aBlock intervalIni: ini IntervalEnd: end XFactor: factor

	|xIncrement yIncrement position|
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat.
	"xIncrement inspect ."
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: (xIncrement * factor)@ yIncrement.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 30) wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROTranslation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:27'!
for: element functionX: aXBlock Y: aYBlock intervalIni: ini IntervalEnd: end

	|xIncrement yIncrement position increment|
	[
	increment := ((end - ini)/ nbCycles) asFloat.
	yIncrement := (aYBlock value: ini).
	xIncrement := (aXBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aYBlock value: (increment * i)) - yIncrement) asFloat.
		xIncrement := ((aXBlock value: (increment * i)) - xIncrement) asFloat.
		element translateBy: (xIncrement@ yIncrement).
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 30) wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROTranslation methodsFor: 'public' stamp: 'AlexandreBergel 12/1/2012 16:27'!
for: element functionXY: aBlock intervalIni: ini IntervalEnd: end XFactor: factor

	|xIncrement yIncrement position|
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat.
	"xIncrement inspect ."
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: (xIncrement * factor)@ 0.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 30) wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROTranslation methodsFor: 'public' stamp: 'AlexandreBergel 11/30/2012 17:34'!
for: element to: endPosition
! !

ROAnimation subclass: #ROZoomMove
	instanceVariableNames: 'camera incrementX1Y1 incrementX2Y2 topLeft bottomRight view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomMove methodsFor: 'hooks' stamp: 'VanessaPena 12/23/2012 20:21'!
doStep

	|oldBounds|
	oldBounds := camera bounds.
	topLeft := topLeft + incrementX1Y1.
	bottomRight := bottomRight + incrementX2Y2.
	camera bounds: (topLeft asIntegerPoint corner: bottomRight asIntegerPoint).
	view announce: (ROCameraResized new oldBounds: oldBounds; newBounds: camera bounds)
! !

!ROZoomMove methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	nbCycles := 50.! !

!ROZoomMove methodsFor: 'public' stamp: 'DR 1/16/2013 19:11'!
on: aView to: finalRealBounds

	| initialRealBounds animBlock |
	camera := aView camera.
	view := aView.
	initialRealBounds := camera bounds.
	incrementX1Y1 := ((finalRealBounds topLeft - initialRealBounds topLeft) / nbCycles).
	incrementX2Y2 := ((finalRealBounds bottomRight - initialRealBounds bottomRight) / nbCycles).
	 
	 topLeft := initialRealBounds topLeft.
	 bottomRight := initialRealBounds bottomRight.	
		
	aView addAnimation: self.! !

ROInteraction subclass: #RODraggable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggable methodsFor: 'hooks' stamp: 'VanessaPena 12/22/2012 19:52'!
initializeElement: element
	 element on: ROMouseDragging do: [ :event | 			
			element translateByRealPoint: (event step).
			element signalUpdate
	].! !

ROInteraction subclass: #RODraggableWithVelocity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggableWithVelocity methodsFor: 'initialization' stamp: 'AlexandreBergel 5/3/2013 08:51'!
initializeElement: element
	| lastStep |
	
	element on: ROMouseDragging do: [:event |
		lastStep := event step.
		"lastTimeStamp := ROPlatform current timeOrganizerClass milliseconds "].

	 element on: ROMouseDragged do: [ :event | 
		ROMotionMove new 
			strategy: ROAnimationExclusive instance;
			for: element initialSpeed: lastStep ].
		
	element on: ROMouseClick do: [ :event |
		ROMotionMove new 
			strategy: ROAnimationExclusive instance;
			for: element initialSpeed: 0 @ 0 ]! !

ROInteraction subclass: #RODynamicEdge
	instanceVariableNames: 'toAllElements lineShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODynamicEdge class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/7/2013 00:54'!
toAll: elements using: aLineShape
	^ self new toAll: elements using: aLineShape! !

!RODynamicEdge methodsFor: 'util' stamp: 'miltonmamani 4/17/2013 14:45'!
attributeKey
	^ (#dynamicEdges, self hash printString) asSymbol! !

!RODynamicEdge methodsFor: 'hooks' stamp: 'AlexandreBergel 4/10/2013 16:41'!
initializeElement: element
	element on: ROMouseEnter do: [ :event |
		| edges |
		self removeEdgesFromView: event view.
			
		edges := (toAllElements roValue: element) collect: [ :el | 
			| l |
			event view add: (l := lineShape elementFrom: event element to: el).
			l ].
		
		event view attributes at: self attributeKey put: edges.
		event view signalUpdate ].
	
	element on: ROMouseLeave do: [ :event | 
		self removeEdgesFromView: event view.
		event view signalUpdate ].
! !

!RODynamicEdge methodsFor: 'util' stamp: 'AlexandreBergel 4/10/2013 16:41'!
removeEdgesFromView: view
	(view attributes includesKey: self attributeKey)
		ifTrue: [ (view attributes at: self attributeKey) do: #remove ].
	view attributes removeKey: self attributeKey ifAbsent: [  ]! !

!RODynamicEdge methodsFor: 'public' stamp: 'AlexandreBergel 4/7/2013 00:54'!
toAll: elements using: aLineShape
	toAllElements := elements.
	lineShape := aLineShape! !

ROInteraction subclass: #ROGrowable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROGrowable commentStamp: '<historical>' prior: 0!
A ROGrowable makes the object grow when clicking on it.
!

!ROGrowable methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 element on: ROMouseClick do: [ :event | 
		ROGrow on: element by: 10.
		element signalUpdate ].! !

!ROInteraction class methodsFor: 'public' stamp: ''!
elementToBeAdded
	^ self new ! !

!ROInteraction class methodsFor: 'public' stamp: ''!
initializeElement: element
	^ self elementToBeAdded initializeElement: element; yourself! !

!ROInteraction class methodsFor: 'public' stamp: 'BenComan 10/14/2012 23:08'!
key 
	"Used in the dictionary each element has"

	^ self ! !

!ROInteraction methodsFor: 'accessing' stamp: ''!
elementToBeAdded
	^ self ! !

!ROInteraction methodsFor: 'hooks' stamp: ''!
initializeElement: element
	self subclassResponsibility ! !

!ROInteraction methodsFor: 'hooks' stamp: 'BenComan 10/14/2012 23:09'!
key 
	"Used in the dictionary each element has"

	^ self class
! !

ROInteraction subclass: #ROLightlyHighlightable
	instanceVariableNames: 'highlightColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLightlyHighlightable commentStamp: '<historical>' prior: 0!
A ROLightlyHighlightable is a decorator that highlights the element when the mouse is over it.!

!ROLightlyHighlightable class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:02'!
highlightedColor
	^ Color blue! !

!ROLightlyHighlightable class methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:11'!
lightBlue
	^ self new highlightColor: Color lightBlue; yourself! !

!ROLightlyHighlightable class methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:13'!
lightGray
	^ self new highlightColor: Color lightGray; yourself! !

!ROLightlyHighlightable class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ Color gray! !

!ROLightlyHighlightable class methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:13'!
veryVeryLightGray
	^ self new highlightColor: Color veryVeryLightGray; yourself! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 11:11'!
cacheKey
	"Key used as attribute"
	
	^ #previousColorBeforeHighlighting! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 12:07'!
defaultHighlightColor
	^ self class highlightedColor
	
! !

!ROLightlyHighlightable methodsFor: 'accessing' stamp: 'AlexandreBergel 9/24/2012 12:09'!
highlightColor
	^ highlightColor! !

!ROLightlyHighlightable methodsFor: 'accessing' stamp: 'AlexandreBergel 9/24/2012 12:09'!
highlightColor: aColor
	highlightColor := aColor! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/29/2012 15:25'!
highlightElement: element
	ROHighlightElement on: element color: highlightColor 
! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 12:09'!
initialize
	super initialize.
	self highlightColor: self defaultHighlightColor! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 11:04'!
initializeElement: element
	element
		on: ROMouseEnter
		do: [ 
			self highlightElement: element.
			element signalUpdate ].
	element
		on: ROMouseLeave
		do: [ 
			self unhighlightElement: element.
			element signalUpdate ].! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/29/2012 15:25'!
unhighlightElement: element

	ROUnhighlightElement on: element
! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ self class unhighlightedColor
! !

ROInteraction subclass: #ROMenuActivable
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMenuActivable class methodsFor: 'public' stamp: 'AlexandreBergel 4/11/2013 11:14'!
item: titleAsString action: aBlockOrSymbol
	^ self new item: titleAsString action: aBlockOrSymbol! !

!ROMenuActivable methodsFor: 'accessing' stamp: 'AlexandreBergel 12/17/2012 21:24'!
actionNamed: aName
	"Return the block corresponding to the action name"
	
	^ actions detect: [ :assoc | assoc key = aName ]! !

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
addActions: someActions
	actions addAll: someActions! !

!ROMenuActivable methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	actions := OrderedCollection new.
	! !

!ROMenuActivable methodsFor: 'hooks' stamp: ''!
initializeElement: element
	^ (element is: self class)
		ifTrue: [ self installOnExistingInteractionOn: element ]
		ifFalse: [ self installHandlerOn: element]! !

!ROMenuActivable methodsFor: 'hooks' stamp: 'AlexandreBergel 7/25/2012 16:14'!
installHandlerOn: element
	element on: ROMouseRightClick do: [ :event |
		ROPlatform current widgetFactory menuForAssociations: actions on: element
	]! !

!ROMenuActivable methodsFor: 'hooks' stamp: 'AlexandreBergel 12/17/2012 21:28'!
installOnExistingInteractionOn: element
	| el |
	el := (element getInteraction: ROMenuActivable).
	el addActions: actions.
	^ el! !

!ROMenuActivable methodsFor: 'public' stamp: ''!
item: titleAsString action: aBlockOrSymbol

	actions add: (titleAsString -> aBlockOrSymbol)! !

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
numberOfEntries
	^ actions size! !

ROInteraction subclass: #ROMiniMap
	instanceVariableNames: 'miniMap lupa camera miniWindow miniMapWindow targetView moView miniMapContainer containerSize miniMapDisplayer miniMapExtent lupaBack miniMapStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/5/2013 15:52'!
camera

	^miniMapDisplayer camera! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/5/2013 12:56'!
container

	^miniMapContainer! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 12:49'!
containerSize

	^containerSize! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 12:31'!
defaultWindowSize

	^200@200! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 11:29'!
factor

	^0.2! !

!ROMiniMap methodsFor: 'hooks' stamp: 'VanessaPena 1/7/2013 16:00'!
initializeElement: view
	
	"TODO: remove targetView and make the ROKeyEvent work without help "
	targetView isNil 
		ifTrue: [ targetView := view].
	
	containerSize := self defaultWindowSize.
	
	self setupMiniMapFor: view.
	self setupLupaFor: view.
	self setupMiniMapContainerForView: view.
	self setupStackFor: view. 
	
	self setViewAnnouncementsFor: view.
	
	view attributes at: #miniMap put: self.! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 12/22/2012 18:32'!
lupa

	^lupa! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/4/2013 12:36'!
miniMap

	^miniMap! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/5/2013 13:06'!
miniMapDisplayer
	
	^miniMapDisplayer! !

!ROMiniMap methodsFor: 'opening' stamp: 'VanessaPena 1/7/2013 15:12'!
openMiniMapFor: view

	(miniMapWindow isNil or:[miniMapWindow owner isNil])
		ifTrue: [ miniMapWindow := miniMapStack openInWindowSized: self defaultWindowSize ]
		ifFalse: [ miniMapWindow delete. miniMapWindow := nil.]! !

!ROMiniMap methodsFor: 'container' stamp: 'VanessaPena 1/5/2013 21:07'!
resizeContainer: extent for: view

	 containerSize := extent.
	self setMiniMapPositionAndSizeFor: view.
	miniMapDisplayer setCameraRealExtentFor: miniMap.
	self setLupaPositionAndSizeFor: view.! !

!ROMiniMap methodsFor: 'events' stamp: 'VanessaPena 1/5/2013 21:04'!
setLupaAnnouncementsFor: view
	
	lupa on: ROMouseDragging do: [ :event | 
		lupa translateByRealPoint: (event step).
		lupaBack translateByRealPoint: (event step).
		view camera translateBy: event step * (view camera realExtent / self camera realExtent).
		lupa signalUpdate.
		lupaBack signalUpdate.			
		view signalUpdate.
	].

	lupa on: ROMouseLeftClick do:[:event |
		self translateLupaTo: event position for: view
	].! !

!ROMiniMap methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 17:43'!
setLupaPositionAndSizeFor: view

	self setLupaSizeFor: view.
	self setLupaPositionFor: view.
! !

!ROMiniMap methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 17:44'!
setLupaPositionFor: view

	|position|
	position := view camera position * (self camera realExtent / view camera realExtent) + miniMap position.
	lupa translateToRealPoint: position.
	lupaBack translateToRealPoint: position.

! !

!ROMiniMap methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 17:47'!
setLupaSizeFor: aView
	
	|extent|
	extent := self camera virtualToRealPoint: (aView camera windowSize * (aView camera extent/ aView camera realExtent)).
	lupa extent: extent.
	lupaBack extent: extent.
	! !

!ROMiniMap methodsFor: 'events' stamp: 'VanessaPena 1/5/2013 21:07'!
setMiniMapAnnouncementsFor: view

	miniMap on: ROMouseLeftClick do:[:event |
		self translateLupaTo: event position for: view
	].! !

!ROMiniMap methodsFor: 'events' stamp: 'VanessaPena 1/5/2013 21:07'!
setMiniMapContainerAnnouncementsFor: view

	miniMapContainer on: ROKeyDown do: [:event | 
		(event keyValue = self symbolValueForOpen)
			ifTrue: [
				self openMiniMapFor: view				
			]	
		].
	miniMapContainer on: ROWindowResized do:[:event |
			 self resizeContainer: event extent for: view
	].
	miniMapContainer on: ROMouseLeftClick do: [:event | 
		self translateLupaTo: event position for: view
	].! !

!ROMiniMap methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 20:31'!
setMiniMapPosition

	|position|
	position := (0@0 corner: containerSize) center - (miniMap extent /2).
	miniMap translateToRealPoint: position.

! !

!ROMiniMap methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 15:31'!
setMiniMapPositionAndSizeFor: view

	self setMiniMapSizeFor: view.
	self setMiniMapPosition.! !

!ROMiniMap methodsFor: 'minimap' stamp: 'VanessaPena 1/5/2013 21:11'!
setMiniMapSizeFor: view

	| enRect extent max scale size e maxX maxY |
	enRect := view encompassingRectangle.
	extent := (self camera virtualToRealPoint: enRect extent) .
	((extent y * (containerSize x / extent x)) < containerSize y) 
			ifTrue: [ e := (containerSize x) @ (extent y * (containerSize x / extent x))]
			ifFalse:[	e := (extent x * (containerSize y / extent y)) @ (containerSize y)].
	miniMap extent: e.
! !

!ROMiniMap methodsFor: 'events' stamp: 'VanessaPena 1/17/2013 12:08'!
setViewAnnouncementsFor: view
	
	view on: ROCameraTranslated do: [:event | 
		|trans|
		trans := event step * (self camera realExtent / view camera realExtent).
		lupa translateBy: trans.
		lupaBack translateBy: trans.
		miniMapContainer signalUpdate.
	].
	view on: ROCameraResized do: [:event |
			self setLupaPositionAndSizeFor: view.
			lupa signalUpdate.
		].
	targetView on: ROKeyDown do: [:event | 
		(event keyValue = self symbolValueForOpen)
			ifTrue: [
				self openMiniMapFor: view.
			]	
		].
	view on: ROWindowResized do: [:event |
		self setLupaSizeFor: view.
		lupa signalUpdate.
		].! !

!ROMiniMap methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 20:42'!
setupLupaFor: aView
	
	lupa := ROElement new.
	lupa + (ROBorder new color: Color black ).
	
	lupaBack := ROElement new.
	lupaBack + (ROBox new color: Color white).
	
	self setLupaAnnouncementsFor: aView.
	lupa resizeStrategy: ROFixedSizedParent instance.! !

!ROMiniMap methodsFor: 'container' stamp: 'VanessaPena 1/7/2013 15:59'!
setupMiniMapContainerForView: view
	
	miniMapContainer := ROView new title: (view title , ' miniMap').
	miniMapContainer backgroundColor: Color gray.
	
	miniMapContainer add: lupaBack.
	miniMapContainer add: miniMap.
	miniMapContainer add: lupa.
		
	self setMiniMapContainerAnnouncementsFor: view.! !

!ROMiniMap methodsFor: 'minimap' stamp: 'VanessaPena 1/7/2013 15:57'!
setupMiniMapFor: view

	|size enRect extent max scale position |
	miniMap := ROElement new.
	miniMapDisplayer  := ROMiniMapDisplayer new view: view; factor: self factor.
	miniMap + miniMapDisplayer.
	self setMiniMapPositionAndSizeFor: view.
	miniMap resizeStrategy: ROFixedSizedParent instance.	
	self setMiniMapAnnouncementsFor: view.! !

!ROMiniMap methodsFor: 'hooks' stamp: 'VanessaPena 1/7/2013 16:03'!
setupStackFor: view

	| zoomIn zoomOut |
	miniMapStack := ROViewStack new.
	
	zoomIn := ROElement new model: 'zoom in'; 
				+(ROLabel new color: Color red ); 
				+ (ROBorder new color: Color red );
				yourself.
	zoomOut := ROElement new model: 'zoom out'; 
				+(ROLabel new color: Color red ); 
				+ (ROBorder new color: Color red );
				yourself.
	
	zoomIn on: ROMouseLeftClick do:[:event |
			ROZoomInMove new on: view.		
	].

	zoomOut on: ROMouseLeftClick do:[:event |
			ROZoomOutMove new on: view.		
	].
	
	miniMapStack 
		add: zoomIn; 
		add: zoomOut;
		addView: miniMapContainer.
		
	ROHorizontalLineLayout new on: miniMapStack elements.! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/2/2013 09:49'!
symbolValueForOpen

	^$m asInteger! !

!ROMiniMap methodsFor: 'accesing' stamp: 'VanessaPena 1/2/2013 10:14'!
targetView: aView

	targetView := aView! !

!ROMiniMap methodsFor: 'lupa' stamp: 'VanessaPena 1/5/2013 21:03'!
translateLupaTo: position for: view

		|step|
		step := position - lupa position.
		lupa translateByRealPoint: step.
		lupaBack translateByRealPoint: step.
		view camera translateBy: step * (view camera realExtent / self camera realExtent).
		lupa signalUpdate.
		lupaBack signalUpdate.			
		view signalUpdate.! !

ROInteraction subclass: #RORubberBand
	instanceVariableNames: 'tmpLine tmpElement dropAction targetSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RORubberBand methodsFor: 'hooks' stamp: 'BenComan 11/25/2012 11:28'!
initializeElement: sourceElement
"
	ROExample new rubberBanding	
"
	
	sourceElement on: ROMouseDragging do: 
	[ 	:event | | relativePosition |
		tmpLine ifNil: 
		[
			tmpElement := ROElement new.
			tmpLine := (ROEdge from: event element to: tmpElement) + ROLine; yourself.
			sourceElement view add: tmpLine.
			sourceElement view add: tmpElement. 			
	
			sourceElement view allElementsDo: 
			[	:candidateTarget | 
				candidateTarget getInteraction: self ifPresent:
				[	:interaction |
					targetSelection source: sourceElement target: candidateTarget. 
				].
			].
		].

        	relativePosition := sourceElement view camera realToVirtualPoint: (event position).
        	tmpElement translateTo: relativePosition.
	
        	sourceElement view signalUpdate.
	].


	sourceElement on: ROMouseDragged do: 
	[ 	:event | | targetElement newEdgeRaw |
		tmpElement remove.
		tmpLine remove.
		tmpLine := nil.
		tmpElement := nil.
	
		targetElement := (sourceElement view elementAtRealPosition: event position).
		(targetSelection contains: targetElement) ifTrue:
		[	
			dropAction ifNotNil: [ dropAction value: event element value: targetElement ] 
		].
		targetSelection clear.
		
		sourceElement view signalUpdate.
	].  ! !

!RORubberBand methodsFor: 'hooks' stamp: 'BenComan 10/14/2012 23:16'!
key 
	"Used in the dictionary each element has"
	"Key on instance rather than class"

	^ self
! !

!RORubberBand methodsFor: 'accessing' stamp: 'BenComan 10/14/2012 23:16'!
onDrop: aBlock
	dropAction := aBlock! !

!RORubberBand methodsFor: 'accessing' stamp: 'BenComan 10/15/2012 22:10'!
targeting: aBlock
	targetSelection := aBlock! !

ROInteraction subclass: #ROScrollbable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:17'!
horizontalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 80.
	scrollbar height: 15.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 
		scrollbar translateByRealPoint: (event step * (1@0)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera width - scrollbar width) @ 0).
		
		(scrollbar position x >= 0 and: [ scrollbar position x  <=  (aStack camera extent x - scrollbar width)])
			ifTrue: [ 
				| xView |
				xView := view encompassingRectangle width * scrollbar position x / view camera width negated.
				view translateTo: (xView @ view camera position y negated) asIntegerPoint ].
		scrollbar signalUpdate.
	].

"	view  on: ROMouseDragging do: [ :event | 
		| xView |
		xScroll := view encompassingRectangle width * scrollbar position x / view camera width negated.
		scrollbar translateTo: (xScroll @ 0).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera extent x - scrollbar width) @ 0).
	]."
 
	^ scrollbar! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 17:58'!
initializeElement: aStack
	| view horizontalScrollbar verticalScrollbar |
	self assert: [ aStack isKindOf: ROViewStack ].
	 
	view := aStack firstView.
	
	horizontalScrollbar := self horizontalScrollbarFor: aStack.
	verticalScrollbar := self verticalScrollbarFor: aStack.
	
	aStack add: horizontalScrollbar.
	aStack add: verticalScrollbar.! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:18'!
verticalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 15.
	scrollbar height: 80.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 

		scrollbar translateByRealPoint: (event step * (0@1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ (aStack camera extent y - scrollbar height)).
		
		(scrollbar position y >= 0 and: [ scrollbar position y  <=  (aStack camera extent y  - scrollbar height)])
			ifTrue: [ 
				| yView |
				yView := view encompassingRectangle height * scrollbar position y / view camera extent y  negated.
				view translateTo: (view camera position x negated @ yView) asIntegerPoint ].
		scrollbar signalUpdate.
	].

	view on: ROMouseDragging do: [ :event | 
		scrollbar translateBy: (event step negated * (0 @ 1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ aStack camera extent y - scrollbar height).
	].
 
	^ scrollbar! !

ROInteraction subclass: #ROSelection
	instanceVariableNames: 'filter inclusionAction exclusionAction selectedElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROSelection methodsFor: 'events-triggering' stamp: 'BenComan 12/9/2012 13:19'!
add: targetElement
	targetElement ifNotNil: 
	[ 	
		selectedElements add: targetElement .
		inclusionAction ifNotNil: [ inclusionAction value: targetElement ].
	].

! !

!ROSelection methodsFor: 'events-triggering' stamp: 'BenComan 10/15/2012 22:08'!
clear
	exclusionAction ifNotNil: [ selectedElements do: [ :element | exclusionAction value: element ] ].
	selectedElements := OrderedCollection new.
! !

!ROSelection methodsFor: 'comparing' stamp: 'BenComan 10/15/2012 22:23'!
contains: aROElement 
	selectedElements do: [ :element | (element = aROElement) ifTrue: [ ^true] ].
	^false.! !

!ROSelection methodsFor: 'events-registering' stamp: 'BenComan 10/15/2012 22:05'!
for: aBlock 
	filter := aBlock.
	! !

!ROSelection methodsFor: 'initialize-release' stamp: 'BenComan 10/15/2012 22:12'!
initialize 
	super initialize.
	filter := [ :source :target | false ].
	selectedElements := OrderedCollection new.
! !

!ROSelection methodsFor: 'events-registering' stamp: 'BenComan 10/15/2012 22:09'!
onExclusion: aBlock 
	exclusionAction := aBlock.
	! !

!ROSelection methodsFor: 'events-registering' stamp: 'BenComan 10/15/2012 22:09'!
onInclusion: aBlock 
	inclusionAction := aBlock.
	! !

!ROSelection methodsFor: 'printing' stamp: 'BenComan 12/9/2012 11:38'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '[' .
	selectedElements do: 
	[	:el |
		aStream nextPutAll: el model asString.
		aStream nextPutAll: ' '.
	].
	aStream nextPutAll: ']' .
	! !

!ROSelection methodsFor: 'events-triggering' stamp: 'BenComan 12/9/2012 12:05'!
source: sourceElement target: targetElement
	(filter value: sourceElement value: targetElement) ifTrue:
	[
		self add: targetElement.
	]! !

ROInteraction subclass: #ROZoomIntoElementOnClick
	instanceVariableNames: 'stack view recursive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomIntoElementOnClick methodsFor: 'view to add' stamp: 'VanessaPena 1/17/2013 12:47'!
addInteractionsToReturnFor: viewToAdd

	| oldBounds rect |
	oldBounds := (stack firstView camera bounds).
	
	viewToAdd on: ROMouseRightClick do: [:event | 
		| move original |
		stack removeFirst.
		rect := viewToAdd encompassingRectangle.
		"stack firstView translateBy: ((0@0 corner: stack camera  windowSize) center - ((rect width / 2) @ (rect height / 2)))."
		move := ROZoomMove new.
		move nbCycles: 10.
		move on: stack firstView to: oldBounds] .! !

!ROZoomIntoElementOnClick methodsFor: 'view to add' stamp: 'VanessaPena 1/8/2013 12:42'!
addRecursivelyOn: aView

	recursive 
		ifTrue: [aView elementsDo: [:el | el @self ]].	

! !

!ROZoomIntoElementOnClick methodsFor: 'view to add' stamp: 'VanessaPena 1/17/2013 12:38'!
createViewToAddFor: element

	|viewToAdd rect|

	viewToAdd := (view roValue: element ).
	self addInteractionsToReturnFor: viewToAdd.
	self addRecursivelyOn: viewToAdd.	
	rect := viewToAdd encompassingRectangle.
	viewToAdd translateBy: ((0@0 corner: stack camera  windowSize) center - ((rect width / 2) @ (rect height / 2))) - viewToAdd position .	
	^viewToAdd ! !

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: 'VanessaPena 1/8/2013 12:30'!
initialize

	recursive := false.! !

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: 'VanessaPena 1/8/2013 14:51'!
initializeElement: element
	
	 element on: ROMouseLeftClick do: [:event | 
		| move viewToAdd|
		viewToAdd := (self createViewToAddFor: element).
		move := ROZoomMove new.
		move after: [ stack addFirst: viewToAdd ].
		move on: element view to: element bounds ].
	
	! !

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: 'VanessaPena 1/8/2013 12:31'!
recursive: aBoolean

	recursive := aBoolean.! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: ''!
stack
	^ stack! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: 'VanessaPena 1/8/2013 11:31'!
stack: aStack

	stack := aStack.
	
 	! !

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: 'VanessaPena 1/8/2013 10:11'!
view: aROViewOrBlock

	view := aROViewOrBlock
	! !

ROInteraction subclass: #ROZoomOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 | el isZoomed originalBounds |
	isZoomed := false.
	
	 element on: ROMouseClick do: [:event | 
		isZoomed 
			ifTrue: [ ROZoomMove new on: element view to: originalBounds ]
			ifFalse: [
				originalBounds := element view camera bounds.
				ROZoomMove new on: element view to: element bounds ].
		isZoomed := isZoomed not ].
	
! !

ROObject subclass: #ROLayout
	instanceVariableNames: 'affectedNodes translator eventHandler currentIteraction maxInterations iterationsToSendEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROLayout commentStamp: '<historical>' prior: 0!
A ROLayout is the superclass of all.

Instance Variables
	affectedNodes:		<Object>
	currentIteraction:		<Object>
	eventHandler:		<Object>
	maxInterations:		<Object>
	translator:		<Object>

affectedNodes
	- xxxxx

currentIteraction
	- xxxxx

eventHandler
	- xxxxx

maxInterations
	- xxxxx

translator
	- xxxxx
!

ROLayout subclass: #ROAbstractLineLayout
	instanceVariableNames: 'gapSize horizontalGap verticalGap horizontalOutGap verticalOutGap alignment horizontallyStretchable verticallyStretchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractLineLayout class methodsFor: 'testing' stamp: 'AlexandreBergel 11/15/2012 13:24'!
isAbstract
	^ self name =  #ROAbstractLineLayout! !

!ROAbstractLineLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger
	
	^(self new)
		gapSize: anInteger;
		yourself! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignBottom
	
	alignment := #bottom! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignCenter
	
	alignment := #center! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignLeft
	
	alignment := #left! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignRight
	
	alignment := #right! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignTop
	
	alignment := #top! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment
	
	^alignment! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment: anObject
	
	alignment := anObject! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
center
	self alignment: #center! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph
	self subclassResponsibility ! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/22/2013 16:19'!
doExecute: elements 
	| pointer delta |
	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: elements ].
	verticallyStretchable ifTrue: 
		[ self doStretchVertical: elements ].
	pointer := self positionOriginalPointer: elements.
	elements do: 
		[ :element |
		delta := self deltaFor: element.
		translator translate: element to: pointer - delta.
		pointer := self 
					movePointer: pointer
					accordingToFigure: element.
		self step ].! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/22/2013 18:08'!
doStretchHorizontal: aCollectionOfElements 

	self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/22/2013 18:09'!
doStretchVertical: aCollectionOfElements 

	self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize: aNumber
	gapSize := aNumber. " This value is never used actually "
	
	verticalGap := 2 * aNumber.
	horizontalGap := 2 * aNumber.
	verticalOutGap := aNumber.
	horizontalOutGap := aNumber! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anObject
	
	horizontalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap
	
	^horizontalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap: anObject
	
	horizontalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
horizontallyStretchable
	^ horizontallyStretchable! !

!ROAbstractLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	verticalGap := 10.
	horizontalGap := 10.
	horizontalOutGap := 5.
	verticalOutGap := 5.
	horizontallyStretchable := verticallyStretchable := false! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ true! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: aNodeFigure
	
	self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: aGraph
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretch
	horizontallyStretchable := verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchHorizontally
	horizontallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchVertically
	verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anObject
	
	verticalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap
	
	^verticalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap: anObject
	
	verticalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
verticallyStretchable
	^ verticallyStretchable! !

ROAbstractLineLayout subclass: #ROHorizontalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalLineLayout commentStamp: '<historical>' prior: 0!
A ROHorizontalLineLayout locates all the elements horizontally!

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #bottom ifTrue: [delta := aNodeFigure height].
	self alignment == #center ifTrue: [delta := aNodeFigure height / 2.0].
	^0 @ delta! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/23/2013 15:34'!
doCenter: elements 

 	| midTallest step |
	midTallest := 0.
	midTallest := elements nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds height )].
	midTallest := midTallest / 2.
	elements nodes do: [ :node | 
		step := 0 @ (midTallest - (node bounds height / 2)) asInteger.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/6/2013 17:52'!
doStretchHorizontal: aCollectionOfElements 

 	| parent parentBounds addedWidth parentBoundsWidth runningIndex newWidth |

	aCollectionOfElements isEmpty ifTrue: [ ^ self "nothing to do" ].
	parent := aCollectionOfElements anyOne parent.
	parent isView ifTrue: [ ^ self "ROView does not have bounds" ].
	parentBounds := parent bounds.

	addedWidth := aCollectionOfElements
		inject: 0
		into: [ :m :el | m + el width ].

	parentBoundsWidth := parentBounds width.
	parentBoundsWidth := parentBoundsWidth - ((aCollectionOfElements size - 1) * horizontalGap) - (2 * horizontalOutGap).
	
	runningIndex := horizontalOutGap.
	parentBounds width > addedWidth
		ifTrue: [ aCollectionOfElements do: [ :element | 
						newWidth := (element width * parentBoundsWidth / addedWidth) asInteger.
						element width: newWidth.
						runningIndex := runningIndex + newWidth + horizontalGap ] ]! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/6/2013 17:53'!
doStretchVertical: aCollectionOfElements 

 	| parent parentBounds |
	aCollectionOfElements isEmpty ifTrue: [ ^ self "nothing to do" ].
	parent := aCollectionOfElements anyOne parent.
	parent isView ifTrue: [ ^ self "ROView does not have bounds" ].
	parentBounds := parent bounds.

	aCollectionOfElements do: [ :element | 
		element height: (parentBounds height - (2 * verticalOutGap) ) ]! !

!ROHorizontalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignTop! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: element
	
	^ (pointer x + element width + self horizontalGap) @ pointer y! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/24/2013 09:22'!
positionOriginalPointer: elements 
	| maxHeight delta |
	delta := 0.
	self alignment == #bottom ifTrue: 
		[ maxHeight := elements maxValue: #height.
		delta := maxHeight ].
	self alignment == #center ifTrue: 
		[ maxHeight := elements maxValue: #height.
		delta := maxHeight / 2.0 ].
	^ (self paddingLeftFor: elements) @ ((self paddingTopFor: elements) + delta)! !

ROAbstractLineLayout subclass: #ROVerticalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROVerticalLineLayout commentStamp: '<historical>' prior: 0!
A ROVerticalLineLayout locates all the elements vertically!

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #right ifTrue: [delta := aNodeFigure width].
	self alignment == #center ifTrue: [delta := aNodeFigure width / 2.0].
	^delta @ 0! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph 

 	| midWidest step |
	midWidest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds width )].
	midWidest := midWidest / 2.
	aGraph nodes do: [ :node | 
		step := (midWidest - (node bounds width /2)) asInteger @ 0.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/23/2013 12:06'!
doStretchHorizontal: aCollectionOfElements 
	
 	| parent parentBounds |
	aCollectionOfElements ifEmpty: [ ^ self "nothing to do" ].
	parent := aCollectionOfElements anyOne parent.
	parent isView ifTrue: [ ^ self "ROView does not have bounds" ].
	parentBounds := parent bounds.

	aCollectionOfElements do: [ :element | 
		element width: (parentBounds width - (2 * horizontalOutGap)) ]! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/6/2013 17:53'!
doStretchVertical: aCollectionOfElements 

 	| parent parentBounds addedHeight parentBoundsHeight runningIndex newHeight |

	aCollectionOfElements isEmpty ifTrue: [ ^ self "nothing to do" ].
	parent := aCollectionOfElements anyOne parent.
	parent isView ifTrue: [ ^ self "ROView does not have bounds" ].
	parentBounds := parent bounds.

	addedHeight := aCollectionOfElements 
		inject: 0
		into: [ :m :el | m + el height ].

	parentBoundsHeight := parentBounds height.
	parentBoundsHeight := parentBoundsHeight - ((aCollectionOfElements size - 1) * verticalGap) - (2 * verticalOutGap).
	
	runningIndex := verticalOutGap.
	parentBounds height > addedHeight
		ifTrue: [ aCollectionOfElements do: [ :element | 
						newHeight := (element height * parentBoundsHeight / addedHeight) asInteger.
						element height: newHeight.
						runningIndex := runningIndex + newHeight + verticalGap ] ]
! !

!ROVerticalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignLeft! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/23/2013 15:44'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^ pointer setX: pointer x setY: pointer y + aNodeFigure height + self verticalGap! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/24/2013 09:22'!
positionOriginalPointer: elements 
	| maxWidth delta |
	delta := 0.
	self alignment == #right ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth ].
	self alignment == #center ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth / 2.0 ].
	^ ((self paddingLeftFor: elements) + delta) @ (self paddingTopFor: elements)
! !

ROLayout subclass: #ROCircleLayout
	instanceVariableNames: 'factor initialAngle initialRadius initialIncrementalAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROCircleLayout class methodsFor: 'instance creation' stamp: ''!
scaleBy: aNumber
	
	^self new scaleBy: aNumber! !

!ROCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 1/23/2013 16:03'!
computeIncrementalAngleFor: elements
	"Return the value _in radian_ of the incremental angle"
	
	^ initialIncrementalAngle = 0
		ifTrue: [ 2 * Float pi / elements size ]
		ifFalse: [ initialIncrementalAngle ]! !

!ROCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 1/23/2013 15:54'!
computeRadiusFor: elements
	"Return the radius of the circle. If none has been set (i.e., initialRadius = 0), then it is computed as the scale factor times the number of elements"
	^ initialRadius = 0 
		ifTrue: [ elements size * self scaleFactor ]
		ifFalse: [ initialRadius ]! !

!ROCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 1/23/2013 15:58'!
doExecute: elements
	| angleIncrement angle rad center |
	rad := self computeRadiusFor: elements.
	center := Point x: rad y: rad.
	angleIncrement := self computeIncrementalAngleFor: elements.
	angle := self initialAngle.
	elements
		do: [ :each | 
			| point |
			point := center + (Point radius: rad theta: angle).
			angle := angle + angleIncrement.
			translator translate: each to: point.
			self step ]! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:04'!
initialAngle
	"Return the initial angle, in radian"
	^ initialAngle! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:01'!
initialAngle: anObject
	initialAngle := anObject! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:06'!
initialAngleInDegree 
	"Return the initial angle in degree"
	^ self initialAngle * 180 / Float pi! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:03'!
initialAngleInDegree: aNumber
	self initialAngle: aNumber * Float pi / 180! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:00'!
initialIncrementalAngle
	"Return the initial incremental angle"
	^ initialIncrementalAngle! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:59'!
initialIncrementalAngle: aNumberInRadian
	initialIncrementalAngle := aNumberInRadian! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 16:06'!
initialIncrementalAngleInDegree: aNumberInDegree
	self initialIncrementalAngle: aNumberInDegree * Float pi / 180! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:55'!
initialRadius
	"Return the radius in pixels of the circle"
	^ initialRadius! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:55'!
initialRadius: aNumber
	"Set the radius of the circle"
	initialRadius := aNumber! !

!ROCircleLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 1/23/2013 16:04'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self scaleBy: 11.
	
	"Represent the initial angle to place the elements"
	initialAngle := 0.
	
	"Distance of the circle. If it is 0 when entering doExecute, then it is computed"
	initialRadius := 0.
	
	"0 means that it is computed, and not set by the user"
	initialIncrementalAngle := 0.! !

!ROCircleLayout methodsFor: 'accessing' stamp: ''!
scaleBy: aNumber
	
	factor := aNumber! !

!ROCircleLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 1/23/2013 15:47'!
scaleFactor
	^ factor! !

ROLayout subclass: #ROEdgeDrivenLayout
	instanceVariableNames: 'edges userDefinedEdges fromPositions toPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROEdgeDrivenLayout subclass: #ROAbstractFlowLayout
	instanceVariableNames: 'maxWidth gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractFlowLayout class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/15/2012 13:25'!
isAbstract
	^ self name = #ROAbstractFlowLayout! !

!ROAbstractFlowLayout class methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger
	
	^(self new)
		maxWidth: anInteger;
		yourself! !

!ROAbstractFlowLayout class methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger withGap: anotherInteger
	
	^(self new)
		maxWidth: anInteger;
		gapSize: anotherInteger;
		yourself! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize: anObject
	
	gapSize := anObject! !

!ROAbstractFlowLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	maxWidth := 100.
	gapSize := 5! !

!ROAbstractFlowLayout methodsFor: 'private' stamp: ''!
maxWidth
	
	^maxWidth! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
maxWidth: anObject
	
	maxWidth := anObject! !

ROAbstractFlowLayout subclass: #ROBottomFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROBottomFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 11/16/2012 08:59'!
doExecute: nodeElements 
	| x y maxLastLineHeight lineHeights lineNumber |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	lineHeights := OrderedCollection new.
	lineNumber := 1.
	nodeElements do: 
		[ :aNodeFigure | 
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ lineHeights addLast: maxLastLineHeight.
			x := self gapSize.
			maxLastLineHeight := 0 ] ].
	lineHeights addLast: maxLastLineHeight.
	x := self gapSize.
	nodeElements do: 
		[ :aNodeFigure | 
		| lineHeight |
		lineHeight := lineHeights at: lineNumber.
		translator translate: aNodeFigure to: x @ (y + lineHeight - aNodeFigure height).
		x := x + aNodeFigure width + (2 * self gapSize).
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + lineHeight.
			lineNumber := lineNumber + 1 ].
		self step ]! !

ROAbstractFlowLayout subclass: #ROFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 11/16/2012 08:59'!
doExecute: nodeElements 
	| x y maxLastLineHeight |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	nodeElements do: 
		[ :aNodeFigure | 
		translator translate: aNodeFigure to: x @ y.
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + maxLastLineHeight.
			maxLastLineHeight := 0 ].
		self step ]! !

ROEdgeDrivenLayout subclass: #ROAbstractGraphLayout
	instanceVariableNames: 'verticalGap horizontalGap cachedChildren cachedParents cachedParentsWithHighestNestings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROAbstractGraphLayout subclass: #ROAbstractCompactTree
	instanceVariableNames: 'nodeDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Algorithm'!

!ROAbstractCompactTree class methodsFor: 'testing' stamp: 'AlexandreBergel 4/18/2013 09:03'!
isAbstract
	^ self name = #ROAbstractCompactTree

! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/11/2013 10:26'!
compareContourOf: aNode with: another
	"return the number of radians the subtree induced by aNode must be displaced to be separated by a predefined distance (horizontalGap) from the one induced by anotherNode"

	| difference max nodeA nodeB |
	nodeB := aNode.	"the right one"
	nodeA := another.	"the left one"
	max := aNode = another
		ifTrue: [ 0 ]
		ifFalse: [ horizontalGap / 2 - (nodeB x - (self getAbcissaOf: nodeA inSubtreeFromLayer: aNode layer - 1)) ].
	nodeB := self followLeftContour: nodeB toLayer: nodeB layer + 1.
	nodeA := self followRightContour: nodeA toLayer: nodeA layer + 1.
	[ nodeB isNil not & nodeA isNil not ]
		whileTrue: [ 
			difference := horizontalGap
				-
					((self getAbcissaOf: nodeB inSubtreeFromLayer: aNode layer - 1)
						- (self getAbcissaOf: nodeA inSubtreeFromLayer: aNode layer - 1)).
			max := max max: difference.
			nodeB := self followLeftContour: nodeB toLayer: nodeB layer + 1.
			nodeA := self followRightContour: nodeA toLayer: nodeA layer + 1 ].
	^ max! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/11/2013 10:25'!
computePosition: aNode
"compute the position of the given node and of his sons recursively"

	| children neighbor nodeA |
	
	children := self childrenFor: (aNode element).
	neighbor := self leftSiblingOf: aNode.
	
	children isEmpty ifTrue: [ neighbor isNil ifTrue: [ aNode x: 0; mod: 0.]  
											 ifFalse: [ aNode x: (neighbor x + (horizontalGap /2)); mod: (neighbor mod);
													  pointer: (self followRightContour: neighbor toLayer: (aNode layer + 1)) ] ]
					 
					 ifFalse: [aNode leftContour: (nodeDictionary at:( children first));
									rightContour: (nodeDictionary at:( children last)).
							  children do: [:e | self computePosition: (nodeDictionary at: e) ].
							      aNode x: (aNode leftContour x + aNode rightContour x + aNode rightContour mod ) /2;
										mod: 0. 
								neighbor isNil ifFalse: [ aNode mod: (self compareContourOf: aNode with: neighbor).
									
													  nodeA := (self followLeftContour: (aNode father) toLayer: (aNode layer)).
													  [(self followLeftContour: nodeA toLayer: (nodeA layer + 1)) isNil ] whileFalse: [ nodeA := self followLeftContour: nodeA toLayer: (nodeA layer + 1) ].
													 nodeA pointer: (self followLeftContour: aNode toLayer: (nodeA layer + 1)).
													
													 nodeA := self followRightContour: aNode toLayer: (aNode layer + 1).
													 [(self followRightContour: nodeA toLayer: (nodeA layer +1)) isNil ] whileFalse: [ nodeA := self followRightContour: nodeA toLayer: (nodeA layer +1) ].
													nodeA pointer: (self followRightContour: neighbor toLayer: (nodeA layer +1) ) ] ] ! !

!ROAbstractCompactTree methodsFor: 'hook' stamp: 'MathieuDehouck 4/11/2013 10:25'!
doExecute: nodeElements 
	| rootNodes |

	nodeDictionary := Dictionary new.
	
	rootNodes := self rootNodesFor: nodeElements.
	rootNodes do: [:e | self fillDictionaryWith: e whoseFatherIs: nil ];
		do: [:e | self computePosition:( nodeDictionary at: e)].
	
	(self rootNodesFor: nodeElements) do: [:e |
												self draw:(nodeDictionary at:e) withMod: 0  ]! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/23/2013 15:28'!
fillDictionaryWith: anElement whoseFatherIs: another
	"return an ordered collection of collections of nodes representing each layer"

	| children node |

	node := ROCompactTreeNode new.
	node element: anElement;
		father: (another isNil ifTrue: [ nil ] ifFalse: [nodeDictionary at: another] );
		layer: ( node father isNil ifTrue: [ 0 ] ifFalse: [ node father layer +1 ] ).
		
	nodeDictionary add:(Association new key: anElement value: node ).
		
	children := self childrenFor: anElement.
	children do: [:e | self fillDictionaryWith: e whoseFatherIs: anElement ]! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:19'!
followLeftContour: aNode toLayer: anInteger
	"return the last node in the left contour begining at anode"
	
	(aNode layer = anInteger ) ifTrue: [^ aNode  ].
	(aNode layer > anInteger ) ifTrue: [^ nil  ].
	
	aNode leftContour isNil ifTrue: [ aNode pointer isNil ifTrue: [ ^ nil ] 
														 ifFalse: [ ^ ( self followLeftContour: aNode pointer toLayer: anInteger ) ] ]
	
			  				ifFalse: [ ^ (self followLeftContour: aNode leftContour toLayer: anInteger ) ]! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:19'!
followRightContour: aNode toLayer: anInteger
	"return the node in the right contour begining at anode in layer anInteger"

	(aNode layer = anInteger ) ifTrue: [^ aNode  ].
	(aNode layer > anInteger ) ifTrue: [^ nil  ].

	aNode rightContour isNil ifTrue: [ aNode pointer isNil ifTrue: [ ^ nil ] 
														 ifFalse: [ ^ ( self followRightContour: aNode pointer toLayer: anInteger ) ] ]
	
			  				ifFalse: [ ^ (self followRightContour: aNode rightContour toLayer: anInteger ) ]! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:20'!
getAbcissaOf: aNode inSubtreeFromLayer: anInteger

	| node x |
	
	(anInteger < 0) ifTrue: [^ self getAbcissaOf: aNode inSubtreeFromLayer: 0 ].
	
	(aNode layer = anInteger ) ifTrue: [ ^ aNode x ].
	(aNode layer < anInteger ) ifTrue: [ ^ nil ].
	
	x := aNode x + aNode mod.
	
	node := aNode father.
	
	[node layer = anInteger  ] whileFalse: [ x := x + node mod.
									node := node father].
								
	^ x! !

!ROAbstractCompactTree methodsFor: 'initialize-release' stamp: 'MathieuDehouck 4/9/2013 11:29'!
initialize 

	super initialize.
	verticalGap := 20.
	horizontalGap := 30.! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:20'!
leftSiblingOf: aNode
"return the left sibling of the given node "

	| children |

	aNode father isNil ifTrue: ["has no sibling" ^ nil]
					    ifFalse: [ children := self childrenFor:( aNode father element).
								(children first) = (aNode element) ifTrue: ["as no left sibling" ^ nil ]
																    ifFalse: [^ (nodeDictionary at: (children at: ((children indexOf: aNode element)-1))) ] ]! !

!ROAbstractCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:20'!
rightSiblingOf: aNode
"return the left sibling of the given node "

	| children |

	aNode father isNil ifTrue: ["has no sibling" ^ nil]
					    ifFalse: [ children := self childrenFor:( aNode father element).
								(children last) = (aNode element) ifTrue: ["as no right sibling" ^ nil ]
																    ifFalse: [^ (nodeDictionary at: (children at: ((children indexOf: aNode element)+1))) ] ]! !

ROAbstractCompactTree subclass: #ROHorizontalCompactTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Algorithm'!

!ROHorizontalCompactTree methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/18/2013 09:08'!
draw: aNode withMod: aFloat
	"draw the subtree induced by the given node, translating it with the given modifier"

	| children |
	
	aNode element translateTo: (Point x: (aNode layer * verticalGap) y: (aNode x + aFloat + aNode mod) ).
	
	children := self childrenFor: (aNode element).
	
	children do:[ :e | self draw: (nodeDictionary at:e) withMod: ( aNode mod + aFloat). self step ]! !

!ROHorizontalCompactTree methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/29/2013 11:10'!
initialize 

	super initialize .
	
	verticalGap := 40.! !

ROAbstractCompactTree subclass: #RORadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RORadialTreeLayout methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/11/2013 10:11'!
compareContourOf: aNode with: another
	"return the number of radians the subtree induced by aNode must be displaced to be separated by a predefined distance (horizontalGap) from the one induced by anotherNode"

	| difference max nodeA nodeB |
	nodeB := aNode.	"the right one"
	nodeA := another.	"the left one"
	max := aNode = another
		ifTrue: [ 0 ]
		ifFalse: [ horizontalGap / nodeB layer / 2 - (nodeB x - (self getAbcissaOf: nodeA inSubtreeFromLayer: aNode layer - 1)) ].
	nodeB := self followLeftContour: nodeB toLayer: nodeB layer + 1.
	nodeA := self followRightContour: nodeA toLayer: nodeA layer + 1.
	[ nodeB isNil not & nodeA isNil not ]
		whileTrue: [ 
			difference := horizontalGap / nodeA layer
				-
					((self getAbcissaOf: nodeB inSubtreeFromLayer: aNode layer - 1)
						- (self getAbcissaOf: nodeA inSubtreeFromLayer: aNode layer - 1)).
			max := max max: difference.
			nodeB := self followLeftContour: nodeB toLayer: nodeB layer + 1.
			nodeA := self followRightContour: nodeA toLayer: nodeA layer + 1 ].
	^ max! !

!RORadialTreeLayout methodsFor: 'hook' stamp: 'MathieuDehouck 4/10/2013 09:25'!
computeGap: aNode
" compute the vertical gap needed for drawing the radial tree "

	| gap maxAbcissa i abc nodeL nodeR layer |
	
	gap := 0.
	maxAbcissa := 0.
	layer := 1.
	
	i := 1.
	[ nodeL :=(self followLeftContour: aNode toLayer: i).
	nodeR := (self followRightContour: aNode toLayer: i).
	nodeL isNil not & nodeR isNil not ] whileTrue: [ abc := (((self getAbcissaOf: nodeR inSubtreeFromLayer: 0) - (self getAbcissaOf: nodeL inSubtreeFromLayer: 0 ) + (horizontalGap / layer/2)) / layer).
																	(abc > maxAbcissa) ifTrue: [ maxAbcissa := abc. 
																								layer := layer ].
																	i := i + 1 ].

	
	gap:= (maxAbcissa / 2 /Float pi ) floor +1.
	
	((verticalGap isNil) or: [gap > verticalGap])  ifTrue: [ self verticalGap: gap ]! !

!RORadialTreeLayout methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/9/2013 11:31'!
computePosition: aNode
"compute the position of the given node and of his sons recursively"

	| children neighbor nodeA |
	
	children := self childrenFor: (aNode element).
	neighbor := self leftSiblingOf: aNode.
	
	children isEmpty ifTrue: [ neighbor isNil ifTrue: [ aNode x: 0; mod: 0. ]  
											 ifFalse: [ aNode x: (neighbor x + (horizontalGap /aNode layer /2)); mod: (neighbor mod);
													  pointer: (self followRightContour: neighbor toLayer: (aNode layer + 1)) ] ]
					 
					 ifFalse: [aNode leftContour: (nodeDictionary at:( children first));
									rightContour: (nodeDictionary at:( children last)).
							  children do: [:e | self computePosition: (nodeDictionary at: e) ].
							      aNode x: (aNode leftContour x + aNode rightContour x + aNode rightContour mod ) /2;
										mod: 0. 
								neighbor isNil ifFalse: [ aNode mod: (self compareContourOf: aNode with: neighbor).
									
													  nodeA := (self followLeftContour: (aNode father) toLayer: (aNode layer)).
													  [(self followLeftContour: nodeA toLayer: (nodeA layer + 1)) isNil ] whileFalse: [ nodeA := self followLeftContour: nodeA toLayer: (nodeA layer + 1) ].
													 nodeA pointer: (self followLeftContour: aNode toLayer: (nodeA layer + 1)).
													
													 nodeA := self followRightContour: aNode toLayer: (aNode layer + 1).
													 [(self followRightContour: nodeA toLayer: (nodeA layer +1)) isNil ] whileFalse: [ nodeA := self followRightContour: nodeA toLayer: (nodeA layer +1) ].
													nodeA pointer: (self followRightContour: neighbor toLayer: (nodeA layer +1) ) ] ] ! !

!RORadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2013 09:08'!
doExecute: nodeElements 
	| rootNodes |

	nodeDictionary := Dictionary new.
	
	rootNodes := self rootNodesFor: nodeElements.
	rootNodes do: [:e | self fillDictionaryWith: e whoseFatherIs: nil ];
		do: [:e | self computePosition:( nodeDictionary at: e)];
		do: [:e | self computeGap: (nodeDictionary at: e) ];
		do: [:e | self toRadialTree: (nodeDictionary at: e) withMod: 0 ].
	
	(self rootNodesFor: nodeElements) do: [ :e | self radialDraw: (nodeDictionary at: e). self step  ]! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
gap
	
	^self verticalGap! !

!RORadialTreeLayout methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/11/2013 09:38'!
radialDraw: aNode
	"draw the subtree induced by the given node"

	| children |
	
	aNode element translateTo: (Point radius: (aNode r) theta: (aNode theta) ).
	
	children := self childrenFor: (aNode element).

	children do:[:e | self radialDraw:(nodeDictionary at:e) ]! !

!RORadialTreeLayout methodsFor: 'as yet unclassified' stamp: 'MathieuDehouck 4/11/2013 09:39'!
toRadialTree: aNode withMod: aFloat
"compute polar coordinates of the subtree induced by anode from its cartesian coordinates "

	| children |
	
	aNode r: (aNode layer * verticalGap ).
	(aNode r = 0) ifTrue: [ aNode theta: 0 ] 
					ifFalse: [aNode theta: (aNode x + aFloat + aNode mod) / verticalGap ].
	
	children := self childrenFor: (aNode element).
	
	children do:[:e | self toRadialTree:(nodeDictionary at:e) withMod: ( aNode mod + aFloat)]! !

ROAbstractCompactTree subclass: #ROVerticalCompactTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Algorithm'!

!ROVerticalCompactTree methodsFor: 'positioning' stamp: 'AlexandreBergel 4/18/2013 09:10'!
draw: aNode withMod: aFloat
	"draw the subtree induced by the given node, translating it with the given modifier"

	| children |
	
	aNode element translateTo: (Point x: (aNode x + aFloat + aNode mod) y: (aNode layer * verticalGap) ).
	
	children := self childrenFor: (aNode element).
	
	children do:[:e | self draw: (nodeDictionary at: e) withMod: (aNode mod + aFloat) ]! !

!ROVerticalCompactTree methodsFor: 'positioning' stamp: 'MathieuDehouck 4/29/2013 11:10'!
initialize 

	super initialize.
	
	verticalGap := 40.! !

!ROAbstractGraphLayout class methodsFor: 'constants' stamp: ''!
horizontalGap
	
	^3.0! !

!ROAbstractGraphLayout class methodsFor: 'testing' stamp: 'AlexandreBergel 11/15/2012 13:25'!
isAbstract
	^ self name = #ROAbstractGraphLayout! !

!ROAbstractGraphLayout class methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"Do the layout of the elements tacking into account the provided edges"

	^ self new 
		userDefinedEdges: edges;
		applyOn: elements.! !

!ROAbstractGraphLayout class methodsFor: 'constants' stamp: ''!
verticalGap
	
	^20.0! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedChildren
	
	cachedChildren ifNil: [cachedChildren := IdentityDictionary new: 1000].
	^cachedChildren! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParents
	
	cachedParents ifNil: [cachedParents := IdentityDictionary new: 1000].
	^cachedParents! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParentsWithHighestNestings
	
	cachedParentsWithHighestNestings
		ifNil: [cachedParentsWithHighestNestings := IdentityDictionary new: 1000].
	^cachedParentsWithHighestNestings! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenFor: aNode
	
	^self cachedChildren
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | 
					(edge from == aNode and: [edge to ~= aNode])
						ifTrue:
							[(nodes includes: edge from) ifFalse: [nodes add: edge to]]].
			nodes]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: 'TudorGirba 7/29/2012 20:20'!
childrenFor: aNode except: aNodeCollection
	
	^(self childrenFor: aNode) 
		reject: [:each | aNodeCollection includes: each]
	
	"we are explicitly not using the default Collection>>difference: behavior here because we want to preserve the order of the collection"! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenWithHighestNestingLevelFor: aNode
	
	^(self childrenFor: aNode)
		select: [:eachChild | (self highestNestingParentFor: eachChild) == aNode]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
clear
	
	cachedParents := nil.
	cachedChildren := nil.
	cachedParentsWithHighestNestings := nil! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	
	^#(#bottomCenter)! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	
	^#(#topCenter)! !

!ROAbstractGraphLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements 
	super doInitialize: elements.
	self clear.
	self greedyCycleRemoval: elements! !

!ROAbstractGraphLayout methodsFor: 'battista' stamp: ''!
greedyCycleRemoval: aCollection
	"Di Battista Greedy-Cycle-Removal algorithm. Chapter 9.4, page 297. The last part is not like in the book. The original algorithm only takes
	 local optimas into account. This will break ordinary trees sometimes. This version also takes global optimas into account."
	
	| g sl sr s indeg outdeg degrees vertex |
	g := aCollection copy asOrderedCollection.
	sl := OrderedCollection new.
	sr := OrderedCollection new.	"While g contains a sink (aka leaf)"
	g copy
		do:
			[:node | 
			(self childrenFor: node) isEmpty
				ifTrue:
					[sr addFirst: node.
					g remove: node]	"self edges detect: [:edge | edge fromFigure == node] ifNone: [sr addFirst: node. g remove: node]"].	"While g contains a source (aka root)"
	g copy
		do:
			[:node | 
			(self parentsFor: node) isEmpty
				ifTrue:
					[sl addLast: node.
					g remove: node]	"self edges detect: [:edge | edge toFigure == node] ifNone: [sl addLast: node. g remove: node]"].	"Calculate deg for all remaining vertices"
	degrees := IdentityDictionary new.
	g
		do:
			[:node | 
			indeg := (self parentsFor: node) size.
			outdeg := (self childrenFor: node) size.	"indeg := self edges inject: 0 into: [:sum :edge | (edge toFigure == node) ifTrue: [sum + 1] ifFalse: [sum]].
		outdeg := self edges inject: 0 into: [:sum :edge | (edge fromFigure == node) ifTrue: [sum + 1] ifFalse: [sum]]."
			degrees
				at: node
				put: outdeg - indeg].	"While g not empty"
	g := g asSortedCollection: [:a :b | (degrees at: a) >= (degrees at: b)].
	[g isEmpty]
		whileFalse:
			[vertex := g
				detect: [:v | (self parentsFor: v) anySatisfy: [:w | sl includes: w]]
				ifNone: [g first].	"Corner case: Closed cycle with not root at all. Eg 1 -> 2 -> 3 -> 1"
			sl addLast: vertex.
			g remove: vertex].	"Remove all leftward edges"
	s := sl , sr.
	self edges notNil
		ifTrue: 
			[ self edges copy
				do:
					[:edge | 
					(s indexOf: edge source) > (s indexOf: edge target)
						ifTrue: [self edges remove: edge ] ] ].	
	"Reset the cache"
	self clear! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
highestNestingParentFor: aNodeFigure
	
	| parents |
	^self cachedParentsWithHighestNestings
		at: aNodeFigure
		ifAbsentPut:
			[parents := self parentsFor: aNodeFigure.
			parents isEmpty
				ifTrue: [0]
				ifFalse:
					[parents detectMax: [:eachParent | self nestingLevelFor: eachParent]]]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap ifNil: [self class horizontalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anInteger
	
	horizontalGap := anInteger! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
nestingLevelFor: aNodeFigure
	
	| parents parentsNesting |
	parents := self parentsFor: aNodeFigure.
	parentsNesting := parents
		collect: [:eachParent | self nestingLevelFor: eachParent].
	^parentsNesting isEmpty
		ifTrue: [0]
		ifFalse: [parentsNesting max + 1]
! !

!ROAbstractGraphLayout methodsFor: 'actions' stamp: 'VanessaPena 4/12/2013 10:29'!
on: el edges: edgs
	"Do the layout of the elements tacking into account the provided edges"

	self userDefinedEdges ifNil: [ self userDefinedEdges: edgs ].

	^ self applyOn: el.! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
parentsFor: aNode
	^ self cachedParents
		at: aNode
		ifAbsentPut:
			[ | nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | edge to == aNode ifTrue: [ nodes add: edge from ] ].
			nodes ]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: 'AlexandreBergel 8/19/2012 13:18'!
rootNodesFor: aCollection
	^ aCollection select: [:node | 
		node isNotEdge and: 
			[ (self parentsFor: node) isEmpty ] ].
	! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap ifNil: [self class verticalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anInteger
	
	verticalGap := anInteger! !

ROAbstractGraphLayout subclass: #ROAbstractRegularTreeLayout
	instanceVariableNames: 'alreadyLayoutedNodes topGap leftGap nodesByLayer isLayered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROAbstractRegularTreeLayout subclass: #ROAbstractHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractHorizontalTreeLayout class methodsFor: 'testing' stamp: 'AlexandreBergel 11/15/2012 13:26'!
isAbstract
	^ self name = #ROAbstractHorizontalTreeLayout! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 7/28/2012 13:43'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 8/5/2012 15:53'!
defaultFromPositions
	
	^#(#rightCenter)
	
"BTC-2012-08-05 Not sure what effect this has or if this is a valid symbol - its just pattern matching."! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 8/5/2012 15:53'!
defaultToPositions

	^#(#leftCenter)
	
"BTC-2012-08-05 Not sure what effect this has or if this is a valid symbol - its just pattern matching."! !

!ROAbstractHorizontalTreeLayout methodsFor: 'initialize-release' stamp: 'BenComan 7/28/2012 13:43'!
initialize
	super initialize.
	verticalGap := 3.
	horizontalGap := 20! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'AlexandreBergel 11/16/2012 09:04'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := x + each width + self horizontalGap.
		treeSize := each height
			max: (self layout: (self computeChildrenFor: each) atPoint: childrenPosition @ y atLayer: aNumber + 1).
		middleOfTree := y + (treeSize / 2.0) - (each height / 2.0).
		translator translate: each to: (x @ middleOfTree).
		y := y + treeSize + self verticalGap.
		self step ].
	^ y - aPoint y - self verticalGap! !

!ROAbstractHorizontalTreeLayout methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 14:10'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self leftGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			translator translate: eachNode to: (cursor @ eachNode bounds top).
			max max: eachNode width ].
		cursor := cursor + layerDepthSize + self horizontalGap ]! !

ROAbstractHorizontalTreeLayout subclass: #ROHorizontalDominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalDominanceTreeLayout commentStamp: 'TudorGirba 10/1/2012 14:06' prior: 0!
The dominance tree layout is similar to a regular tree layout, only it poses a stronger condition in the way it places a node: a child is placed under the deepest parent. This layout is for example useful when identifying layers of dependencies.

Note: the layout is slower than the tree layout because of the more complex lookup!

!ROHorizontalDominanceTreeLayout methodsFor: 'hook-private' stamp: 'TudorGirba 9/27/2012 23:07'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

ROAbstractHorizontalTreeLayout subclass: #ROHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 7/28/2012 13:50'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

!ROAbstractRegularTreeLayout class methodsFor: 'testing' stamp: 'AlexandreBergel 11/15/2012 13:26'!
isAbstract
	^ self name = #ROAbstractRegularTreeLayout! !

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
atLayer: aNumber add: aNodeCollection
	| collection |
	collection := nodesByLayer at: aNumber ifAbsentPut: [OrderedCollection new].
	collection addAll: aNodeCollection! !

!ROAbstractRegularTreeLayout methodsFor: 'hook' stamp: ''!
doExecute: elements
	| rootNodes |
	alreadyLayoutedNodes := OrderedCollection new.
	rootNodes := self rootNodesFor: elements.
	nodesByLayer := OrderedCollection new.
	self
		layout: rootNodes
		atPoint: self leftGap @ self topGap
		atLayer: 1.
	self isLayered ifTrue: [
		self rearrangeByLayers: elements ]! !

!ROAbstractRegularTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	topGap := 5.
	leftGap := 5.
	isLayered := false! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered
	"Is the layout layered"
	
	^ isLayered! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered: boolean
	"Is the layout layered"
	
	isLayered := boolean! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
layered
	self isLayered: true! !

!ROAbstractRegularTreeLayout methodsFor: 'hook-private' stamp: ''!
layout: aNodeCollection atPoint: aPoint atLayer: anObject
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap
	^ leftGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap: anInteger
	leftGap := anInteger! !

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
rearrangeByLayers: aGraph
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap
	^ topGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap: anInteger
	topGap := anInteger! !

ROAbstractRegularTreeLayout subclass: #ROAbstractVerticalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractVerticalTreeLayout class methodsFor: 'testing' stamp: 'AlexandreBergel 11/15/2012 13:26'!
isAbstract
	^ self name = #ROAbstractVerticalTreeLayout! !

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	self subclassResponsibility! !

!ROAbstractVerticalTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	verticalGap := 20.
	horizontalGap := 3! !

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: 'AlexandreBergel 11/16/2012 09:05'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := y + each height + self verticalGap.
		treeSize := each width
			max: (self layout: (self computeChildrenFor: each) atPoint: x @ childrenPosition atLayer: aNumber + 1).
		middleOfTree := x + (treeSize / 2.0) - (each width / 2.0).
		translator translate: each to: middleOfTree @ y.
		x := x + treeSize + self horizontalGap.
		self step ].
	^ x - aPoint x - self horizontalGap! !

!ROAbstractVerticalTreeLayout methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 14:09'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self topGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (eachNode bounds left @ cursor ).
			max max: eachNode height ].
		cursor := cursor + layerDepthSize + self verticalGap ]! !

ROAbstractVerticalTreeLayout subclass: #RODominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODominanceTreeLayout commentStamp: 'TudorGirba 10/1/2012 14:06' prior: 0!
The dominance tree layout is similar to a regular tree layout, only it poses a stronger condition in the way it places a node: a child is placed under the deepest parent. This layout is for example useful when identifying layers of dependencies.

Note: the layout is slower than the tree layout because of the more complex lookup!

!RODominanceTreeLayout methodsFor: 'hook-private' stamp: 'TudorGirba 10/1/2012 13:59'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

ROAbstractVerticalTreeLayout subclass: #ROTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

ROAbstractGraphLayout subclass: #RONarrowRadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RONarrowRadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 7/29/2012 08:48'!
doExecute: nodeElements 
	| rootNodes maximumRadius xOffset |

	rootNodes := self rootNodesFor: nodeElements.
	xOffset := 0.
	rootNodes do: 
		[ :node | 
		node translateTo: 0 @ 0.	"Move the node to the origin of the coordinate system"
		maximumRadius := self 
			layoutLayer: (self childrenFor: node)
			radius: node radius
			from: 0
			to: 2 * Float pi.
		self 
			shiftTree: node
			by: (maximumRadius + xOffset) @ maximumRadius.
		xOffset := xOffset + (2 * maximumRadius) ]! !

!RONarrowRadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
gap
	
	^self verticalGap! !

!RONarrowRadialTreeLayout methodsFor: 'private' stamp: 'VanessaPena 12/2/2012 19:08'!
layoutLayer: aCollection radius: oldRadius from: aFromAngle to: aToAngle
	
	| delta childRadius maximumRadius myRadius fromAngle toAngle |
	"Initialize with default value"
	maximumRadius := oldRadius.
	aCollection isEmpty
		ifFalse:
			[myRadius := oldRadius + self gap + (self maximumRadius: aCollection).
			childRadius := oldRadius + self gap + (self maximumDiameter: aCollection).	"This is a purely optical tweak"
			(aCollection size = 1 and: [aToAngle - aFromAngle = (2 * Float pi)])
				ifTrue:
					[delta := 0.4 * Float pi.
					fromAngle := 0.8 * Float pi.
					toAngle := fromAngle + delta]
				ifFalse:
					[delta := (aToAngle - aFromAngle) / aCollection size.
					fromAngle := aFromAngle.
					toAngle := aFromAngle + delta].
			aCollection
				do:
					[:child | 
					child
						translateTo:
							(Point
								radius: myRadius
								theta: toAngle - (delta / 2.0)).
					maximumRadius := maximumRadius
						max:
							(self
								layoutLayer: (self childrenFor: child)
								radius: childRadius
								from: fromAngle
								to: toAngle).
					fromAngle := toAngle.
					toAngle := toAngle + delta]].
	^maximumRadius! !

!RONarrowRadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:23'!
maximumDiameter: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: (node radius * 2) ]
 ! !

!RONarrowRadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
maximumRadius: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node radius]! !

!RONarrowRadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
shiftTree: aNode by: aPoint
	
	aNode translateBy: aPoint.
	(self childrenFor: aNode) do: [:child | self shiftTree: child by: aPoint]! !

ROAbstractGraphLayout subclass: #RONarrowTreeLayout
	instanceVariableNames: 'layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

RONarrowTreeLayout subclass: #ROHorizontalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'JurajKubelka 4/2/2013 10:17'!
defaultFromPositions
	
	^#(#rightCenter)! !

!ROHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'JurajKubelka 4/2/2013 10:17'!
defaultToPositions
	
	^#(#leftCenter)! !

!ROHorizontalNarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:17'!
shapeTree: aRoot position: xOffset
	
	| treeHeight layerKeys layer layerHeight horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeHeight := self currentTreeSize.
	horizontalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerHeight := layer width: self horizontalGap.
		verticalPosition := treeHeight / 2.0 + xOffset - (layerHeight / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			verticalPosition := verticalPosition + aFigure width + self horizontalGap].
		horizontalPosition := horizontalPosition + layer height + self verticalGap].
	^treeHeight! !

!RONarrowTreeLayout class methodsFor: 'testing' stamp: 'JurajKubelka 4/2/2013 11:30'!
isAbstract 

	^ self name =  #RONarrowTreeLayout! !

!RONarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 17:28'!
atLayer: aLayer add: aFigure
	"Associates the figure aFigure with the layer aLayer"
	
	| layer |
	layer := layers
		at: aLayer
		ifAbsent:
			[layers
				at: aLayer
				put: ROTreeLayerWrapper new.
			layers at: aLayer].
	layer add: aFigure! !

!RONarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:16'!
buildLayers: aRoot
	layers := Dictionary new.
	self buildLayers: aRoot layer: 0! !

!RONarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:16'!
buildLayers: aRoot layer: aLayer
	self atLayer: aLayer add: aRoot.
	(self childrenFor: aRoot) do: [:aChild | 
		self
			buildLayers: aChild
			layer: aLayer + 1 ]! !

!RONarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:16'!
currentTreeSize
	| maximum |
	maximum := 0.
	layers values do: [:aLayer | 
		maximum := maximum max: (aLayer width: self horizontalGap)].
	^maximum! !

!RONarrowTreeLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/2/2013 11:59'!
doExecute: elements 
	| roots offset treeWidth |
	roots := self rootNodesFor: elements.
	offset := self horizontalGap.
	roots do: 
		[ :aRoot | 
		treeWidth := self 
			shapeTree: aRoot
			position: offset.
		offset := offset + treeWidth + (2 * self horizontalGap).
		self step]! !

!RONarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:16'!
shapeTree: aRoot position: xOffset
	self subclassResponsibility! !

RONarrowTreeLayout subclass: #ROVerticalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROVerticalNarrowTreeLayout methodsFor: 'private' stamp: 'JurajKubelka 4/2/2013 10:17'!
shapeTree: aRoot position: xOffset
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeWidth := self currentTreeSize.
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerWidth := layer width: self horizontalGap.
		horizontalPosition := treeWidth / 2.0 + xOffset - (layerWidth / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			horizontalPosition := horizontalPosition + aFigure width + self horizontalGap].
		verticalPosition := verticalPosition + layer height + self verticalGap].
	^treeWidth! !

ROAbstractGraphLayout subclass: #ROSugiyamaLayout
	instanceVariableNames: 'sortBlock labels layers layerNrs connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSugiyamaLayout class methodsFor: 'utils' stamp: ''!
sortBlock
	
	^ ROSortBlock new! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:38'!
addDummyNodes
	
	| layer layerNr |
	connections := ROIdentityMatrix new.
	self edgesDo:
			[:edge | 
			| a b span fromNode toNode |
			"edge hints removeAll."
			a := layerNrs at: edge source.
			b := layerNrs at: edge target.
			span := (a - b) abs.
			span = 1
				ifTrue:
					[connections
						at: edge source
						at: edge target
						put: true].	"Normal case where nodes are in adjacent layers"
			fromNode := edge source.
			[span > 1]
				whileTrue:
					[span := span - 1.
					layerNr := b + span.
					layer := layers at: layerNr.
					toNode := RODummyNode
						on: edge
						slot: a - span.
					layer add: toNode.
					layerNrs at: toNode put: layerNr.
					connections at: fromNode at: toNode put: true.
					fromNode := toNode].
			(a - b) abs > 1
				ifTrue:
					[connections
						at: fromNode
						at: edge target
						put: true]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
assignLabels: aNodeCollection 
	"Initialize label dictionary"
	| label vertices parentLabels |
	labels := IdentityDictionary new.
	label := 1.	"Assign labels to the roots"
	(self rootNodesFor: aNodeCollection) do: 
		[ :node | 
		labels 
			at: node
			put: label.
		label := label + 1 ].	"Assign labels to the rest"
	[ labels keys size < aNodeCollection size ] whileTrue: 
		[ vertices := SortedCollection sortBlock: self sortBlock.
		aNodeCollection do: 
			[ :node | 
			(labels includesKey: node) ifFalse: 
				[ parentLabels := ((self parentsFor: node) collect: 
					[ :pn | 
					labels 
						at: pn
						ifAbsent: [ self maxFloat ] ]) asSortedCollection.
				parentLabels last ~= self maxFloat ifTrue: [ vertices add: node -> parentLabels ] ] ].
		labels 
			at: vertices first key
			put: label.
		label := label + 1 ]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
buildLayers: g
	
	| w layerNr u vertices vertex layer done |
	w := self maxFloat.
	u := OrderedCollection new.
	layers := IdentityDictionary new.
	layerNrs := IdentityDictionary new.	"Assign all nodes to layers"
	[g isEmpty]
		whileFalse:
			[vertices := g
				select:
					[:e | (self childrenFor: e) allSatisfy: [:node | u includes: node]].
			vertex := vertices detectMax: [:e | labels at: e].
			done := false.
			layerNr := 1.
			[done]
				whileFalse:
					[layer := layers
						at: layerNr
						ifAbsentPut: [OrderedCollection new].
					(layer size >= w
						or:
							[(self childrenFor: vertex) anySatisfy: [:n | (layerNrs at: n) >= layerNr]])
						ifTrue: [layerNr := layerNr + 1]
						ifFalse: [done := true]].
			layer add: vertex.
			layerNrs at: vertex put: layerNr.
			u add: vertex.
			g remove: vertex]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
cl: layer u: u v: v
	"Calculates cuv. Di Battista, chapter 9.2.2, page 283"
	
	| partnersOfU partnersOfV c partnersOfUIndex partnersOfVIndex layerNr |
	layerNr := layerNrs at: u.	":= layerNrs at: v"
	partnersOfU := (connections at: u)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	partnersOfV := (connections at: v)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	c := 0.
	partnersOfUIndex := partnersOfU collect: [:node | layer indexOf: node].
	partnersOfVIndex := partnersOfV collect: [:node | layer indexOf: node].
	partnersOfUIndex
		do:
			[:uIndex | partnersOfVIndex do: [:vIndex | vIndex < uIndex ifTrue: [c := c + 1]]].
	^c! !

!ROSugiyamaLayout methodsFor: 'hook' stamp: ''!
doExecute: aNodeCollection 
	"Coffman-Graham-Layering. Di Battista Book, page 275, chapter, 9.2.1"
	self assignLabels: aNodeCollection.
	self buildLayers: aNodeCollection copy.
	self addDummyNodes.
	self reduceCrossing.
	self layoutAt: self verticalGap @ self horizontalGap! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:15'!
layoutAt: aPoint
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition layerHeight |
	treeWidth := layers values
		inject: self maxFloat negated
		into:
			[:max :e | max max: (e sum: #width) + ((e size - 1) * self horizontalGap)].
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection reverse.
	layerKeys
		do:
			[:aKey | 
			layer := layers at: aKey.
			layerWidth := (layer sum: #width)
				+ ((layer size - 1) * self horizontalGap).
			layerHeight := (layer detectMax: #height) height.
			horizontalPosition := treeWidth / 2.0 + aPoint x - (layerWidth / 2.0).
			layer
				do:
					[:node | 
					translator translate: node to:  horizontalPosition @ verticalPosition.
					
					horizontalPosition := horizontalPosition + node width
						+ self horizontalGap].
			verticalPosition := verticalPosition + layerHeight + self verticalGap]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:44'!
maxFloat
	^ 1e10! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:16'!
reduceCrossing
	"Crossing reduction"
	
	| layer2 u v c1 c2 layer1 done |
	2
		to: layers keys size
		do:
			[:index | 
			layer1 := layers at: index - 1.
			layer2 := layers at: index.
			done := false.
			[done]
				whileFalse:
					[done := true.
					2
						to: layer2 size
						do:
							[:i | 
							u := layer2 at: i - 1.
							v := layer2 at: i.
							c1 := self cl: layer1 u: u v: v.
							c2 := self cl: layer1 u: v v: u.
							c1 > c2
								ifTrue:
									[layer2 roSwapElement: u withElement: v.
									done := false]]]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
sortBlock
	
	sortBlock isNil ifTrue: [ sortBlock := self class sortBlock ].
	^sortBlock! !

!ROEdgeDrivenLayout class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/15/2012 13:25'!
isAbstract
	^ self name = #ROEdgeDrivenLayout! !

!ROEdgeDrivenLayout class methodsFor: 'instance creation' stamp: ''!
withEdges: aCollection
	
	^self new initialize userDefinedEdges: aCollection! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes
	
	^affectedNodes! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes: anObject
	
	affectedNodes := anObject! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodesOf:  aNode 
	^ affectedNodes ifNil: [ aNode nodes ]! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	^ #()
	! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	^ #()
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doExecute: aGraphElement
	
	self subclassResponsibility! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doExecute: anElementNode! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
edges
	
	^edges! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
edges: aCollection
	
	edges := aCollection! !

!ROEdgeDrivenLayout methodsFor: 'iterator' stamp: ''!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 16:03'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"

	self userDefinedEdges isNil 
		ifTrue: [ self setEdgesFromElements: elements ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each isCollection 
					ifTrue: [ flat addAll: each ]
					ifFalse: [ flat add: each ] ].
			self edges: flat ].
		
	super executeOnElements: elements! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
fromPositions
	
	^fromPositions ifNil: [fromPositions := self defaultFromPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
fromPositions: anArray
	
	fromPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialization"
	super initialize.
	edges := nil! !

!ROEdgeDrivenLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ false! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 7/20/2012 18:17'!
setEdgesFromElements: elements 
	| view |
	elements isEmpty ifTrue: [ ^ self ].
	self assert: [ (elements collect: #view) asSet size = 1 ].
	
	elements isEmpty ifTrue: [ ^ self ].
	
	view := elements anyOne view.
	self edges: (view elementsSuchThat: [ :el | ((el isKindOf: ROEdge) and: [ elements includes: el from ]) and: [ elements includes: el to ] ]).
	! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
toPositions
	
	^toPositions ifNil: [toPositions := self defaultToPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
toPositions: anArray
	
	toPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
userDefinedEdges
	
	^userDefinedEdges! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/9/2012 20:03'!
userDefinedEdges: aCollectionOfEdges
	"useful to tell to the layout which edges have to be used for the layout"

	userDefinedEdges := aCollectionOfEdges.
	! !

ROEdgeDrivenLayout subclass: #ROForceBasedLayout
	instanceVariableNames: 'iterations repellingForce attractingForce layoutInitial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
attractingForce: aBlock
	"Attracting force between edges."
	
	attractingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
attractingForceFor: aFigure
	
	^attractingForce roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'DennisSchenk 3/20/2013 17:39'!
doExecute: nodeElements
    | nodes nodeCenterA nodeCenterB deltaX deltaY distance xForces yForces xForce yForce force random edgesIndices nodeCenter nodeRadius nodeRadiusA nodeRadiusB nodeOrigin minX minY delta |
 
    "Start by placing the nodes at random"
    self initialPositionOfNodes: nodeElements.
    
    random := ROPlatform current randomClass new.   
        
    "Create array with the node center and radius. Like this we don't need to move the actual nodes"
    nodes := nodeElements asArray.
    nodeCenter := Array new: nodes size.
    nodeRadius := Array new: nodes size.
    1 to: nodes size do: [ :index | 
        nodeCenter at: index put: (nodes at: index) center.
        nodeRadius at: index put: (nodes at: index) radius ].   
        
    "Create array with the indices of the edge nodes"
    edgesIndices := Array new: self edges size.
    1 to: self edges size do: [ :index | 
        | edge |
        edge := self edges at: index.
        edgesIndices at: index put: (Array with: (nodes indexOf: edge source) with: (nodes indexOf: edge target)) ].
    
    1 to: (self iterationsFor: nodeElements) do: [ :iteration | 
        xForces := (Array new: nodes size) atAllPut: 0.
        yForces := (Array new: nodes size) atAllPut: 0. 
            
        "Node forces"
        1 to: nodes size do: [ :i | 
            i + 1 to: nodes size do: [ :j | 
                nodeCenterA := nodeCenter at: i.
                nodeCenterB := nodeCenter at: j.
                deltaX := nodeCenterB x - nodeCenterA x.
                deltaY := nodeCenterB y - nodeCenterA y.
                nodeRadiusA := nodeRadius at: i.
                nodeRadiusB := nodeRadius at: j.
                distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt - nodeRadiusA - nodeRadiusB.
                distance < 0.01
                    ifTrue: [ 
                        deltaX := random next + 5.
                        deltaY := random next + 5.
                        distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt - nodeRadiusA - nodeRadiusB].
                distance < (100 + nodeRadiusA + nodeRadiusB)
                    ifTrue: [ 
                        force := (self repellingForceFor: nodeElements) * nodeRadiusA * nodeRadiusB / distance / distance.
                        xForce := force * deltaX / distance.
                        yForce := force * deltaY / distance.
                        xForces at: i put: (xForces at: i) - xForce.
                        yForces at: i put: (yForces at: i) - yForce.
                        xForces at: j put: (xForces at: j) + xForce.
                        yForces at: j put: (yForces at: j) + yForce ] ].
            self step ].    
            
        "Edge forces"
        edgesIndices
            do: [ :indices | 
                nodeCenterA := nodeCenter at: indices first.
                nodeCenterB := nodeCenter at: indices last.
                deltaX := nodeCenterB x - nodeCenterA x.
                deltaY := nodeCenterB y - nodeCenterA y.
                distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt - nodeRadiusA - nodeRadiusB.
                distance < 0.01
                    ifTrue: [ 
                        deltaX := random next + 5.
                        deltaY := random next + 5.
                        distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt - nodeRadiusA - nodeRadiusB].
                distance := distance min: 15.
                force := (self attractingForceFor: nodeElements) * distance.
                xForce := force * deltaX / distance.
                yForce := force * deltaY / distance.
                xForces at: indices first put: (xForces at: indices first) + xForce.
                yForces at: indices first put: (yForces at: indices first) + yForce.
                xForces at: indices last put: (xForces at: indices last) - xForce.
                yForces at: indices last put: (yForces at: indices last) - yForce ].
            
        "Move centers"
        1 to: nodes size do: [ :index | 
            deltaX := xForces at: index.
            deltaY := yForces at: index.
            deltaX := deltaX min: 30.
            deltaX := deltaX max: -30.
            deltaY := deltaY min: 30.
            deltaY := deltaY max: -30.
            nodeCenter at: index put: ((nodeCenter at: index) + (deltaX @ deltaY)) ].
         ]. 
    
    "Node origins"
    nodeOrigin := Array new: nodes size.
    minX := 10000000.   "minX := Unlimited positive."
    minY := 10000000.   "minY := Unlimited positive."
    1 to: nodes size do: [ :index | 
        | origin node |
        node := nodes at: index.
        origin := (nodeCenter at: index) - ((node width / 2.0) @ (node height / 2.0)).
        nodeOrigin at: index put: origin.
        minX := minX min: origin x.
        minY := minY min: origin y ].   
        
    "Move nodes"
    minX := -1 * minX.
    minY := -1 * minY.
    delta := minX @ minY + (5 @ 5).
    1 to: nodes size do: [ :index | translator translate: (nodes at: index) to: (nodeOrigin at: index) + delta ]! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 6/11/2012 23:01'!
initialPositionOfNodes: nodeElements

	layoutInitial new executeOnElements: nodeElements! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2013 09:01'!
initialize
	
	super initialize.
	iterations := 300.
	repellingForce := 1.
	attractingForce := 0.02.
	layoutInitial := RONarrowRadialTreeLayout.	! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
iterations: aBlock
	
	iterations := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
iterationsFor: aFigure
	
	^iterations roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 6/11/2012 23:00'!
layoutInitial: aLayoutClass
	layoutInitial := aLayoutClass! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
repellingForce: aBlock
	"Repelling force between nodes."
	
	repellingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
repellingForceFor: aFigure
	
	^repellingForce roValue: aFigure! !

ROLayout subclass: #ROGridLayout
	instanceVariableNames: 'gapSize lineItemsCountBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROGridLayout commentStamp: '<historical>' prior: 0!
A ROGridLayout places elements as a grid.

Instance Variables
	gapSize:		<SmallInteger>
	lineItemsCountBlock:		<BlockContext>

gapSize
	- number of pixels between each elements, horizontally and vertically

lineItemsCountBlock
	- tells the amount of item per line should be used
!

!ROGridLayout class methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 01:16'!
defaultGap
	^ 5! !

!ROGridLayout class methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 01:16'!
new
	^ self withGap: self defaultGap! !

!ROGridLayout class methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 14:29'!
on: aCollectionOfElements withLineItemsCount: aBlock
	"place the elements in a grid with (aBlock roValue: aCollectionOfElements) as the amount of elements horizontally

	For example:
	self on: (ROElement forCollection: (1 to: 20)) withLineItemsCount: 5
	=> place the 20 elements on a grid 5 x 4
	
	self on: (ROElement forCollection: (1 to: 20)) withLineItemsCount: [ :elements | elements size // 3 ]
	=> place the 20 elements on a grid 3 x 7
	"
	
	
	| myLayout |
	myLayout := self new gapSize: self defaultGap;  lineItemsCount: aBlock.
	myLayout applyOn: aCollectionOfElements.
	^ aCollectionOfElements! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger 
	^ self 
		withGap: anInteger
		withLineItemsCount: 
			[ :graph | 
			| height width |
			(graph size < 3 
				ifTrue: [ (graph size max: 1) @ 1 ]
				ifFalse: 
					[ height := (graph size * 0.618034) sqrt ceiling truncated.
					width := (graph size / height) ceiling truncated.
					width @ height ]) x ]! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger withLineItemsCount: aBlock
	
	^(super new)
		gapSize: anInteger;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withLineItemsCount: aBlock
	
	^(super new)
		gapSize: 2;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/23/2013 15:33'!
defaultGapSize
	^ 5! !

!ROGridLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/24/2013 09:22'!
doExecute: elements
	| pointer lineItemCount lineItemSize maxLastLineHeight originalGapLeft originalGapTop |
	originalGapLeft := self paddingLeftFor: elements.
	originalGapTop := self paddingTopFor: elements.
	
	pointer := originalGapLeft @ originalGapTop.
	lineItemSize := self lineItemsCountBlock roValue: elements.
	lineItemCount := 0.
	maxLastLineHeight := 0.
	elements
		do: [ :element | 
			translator translate: element to: pointer.
			pointer := (pointer x + element width + (self gapSize * 2)) @ pointer y.
			lineItemCount := lineItemCount + 1.
			maxLastLineHeight := maxLastLineHeight max: element height.
			lineItemCount >= lineItemSize
				ifTrue: [ 
					pointer := originalGapLeft @ (pointer y + (self gapSize * 2) + maxLastLineHeight).
					
					maxLastLineHeight := 0.
					lineItemCount := 0 ].
			self step ]! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROGridLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 4/23/2013 15:33'!
gapSize: anInteger
	gapSize := anInteger! !

!ROGridLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/23/2013 15:33'!
initialize
	super initialize.
	gapSize := self defaultGapSize! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCount: aBlock
	
	lineItemsCountBlock := aBlock! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCountBlock
	
	^ lineItemsCountBlock! !

!ROLayout class methodsFor: 'public' stamp: 'AlexandreBergel 11/15/2012 13:29'!
isAbstract
	^ self name =  #ROLayout! !

!ROLayout class methodsFor: 'public' stamp: 'AlexandreBergel 11/15/2012 13:24'!
isNotAbstract
	^ self isAbstract not! !

!ROLayout class methodsFor: 'public' stamp: 'AlexandreBergel 4/23/2013 15:08'!
on: aCollection
	"main entry point of the class"
	
	"If aCollection is empty, then there is not much to do"
	aCollection isEmpty ifTrue: [ ^ aCollection ].
	self new applyOn: aCollection.
	^ aCollection! !

!ROLayout class methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"To make all the layout polymorphic"
	
	^ self on: elements ! !

!ROLayout methodsFor: 'events' stamp: 'AlexandreBergel 11/15/2012 13:11'!
announce: anEvent
	"trigger an event. Objects who registered to me will get notified"

	| eventToBeSent |
	eventToBeSent := anEvent isBehavior 
						ifTrue: [ anEvent new ]
						ifFalse: [ anEvent ]. 
	
	eventToBeSent layout: self.
	eventHandler announce: eventToBeSent! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/23/2013 15:41'!
applyOn: elements
	"Return quickly if there is nothing to do"
	elements isEmpty ifTrue: [ ^ self ].
	self executeOnElements: elements! !

!ROLayout methodsFor: 'configuration' stamp: 'AlexandreBergel 4/30/2013 18:25'!
defaultIterationsToSendEvent
	"Every 100 steps an event ROLayoutStep is sent"

	^ 100! !

!ROLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/22/2013 15:11'!
doExecute: elements
	"Performs the layout"

	self subclassResponsibility! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 3/11/2013 09:26'!
doInitialize: elements
	"Method executed before beginning the layout. Useful when the graph to be ordered need to be prepared"
	self announce: (ROLayoutBegin new elements: elements).! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 3/11/2013 09:23'!
doPost: elements
	"Method executed after performing the layout"
	self announce: (ROLayoutEnd new elements: elements).! !

!ROLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 3/11/2013 09:20'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"
		
	maxInterations := elements size.
	self doInitialize: elements.
	self doExecute: elements asOrderedCollection.
	self doPost: elements.
! !

!ROLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/30/2013 18:26'!
initialize
	translator := ROLayoutTranslator default.
	eventHandler := ROAnnouncer new.
	currentIteraction := 0.
	maxInterations := 0.
	iterationsToSendEvent := self defaultIterationsToSendEvent ! !

!ROLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2013 18:24'!
iterationsToSendEvent
	"This method return the amount of iterations before sending ROLayoutStep"
	^ iterationsToSendEvent! !

!ROLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2013 18:26'!
iterationsToSendEvent: anInteger
	iterationsToSendEvent := anInteger! !

!ROLayout methodsFor: 'hook' stamp: ''!
on: elements
	self applyOn: elements! !

!ROLayout methodsFor: 'events' stamp: 'AlexandreBergel 11/15/2012 13:11'!
on: eventClass do: aBlock
	"Register a block as an handler for eventClass"
	
	eventHandler when: eventClass do: aBlock.! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 11:38'!
on: elements edges: edges
	self applyOn: elements! !

!ROLayout methodsFor: 'padding' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingFor: elements
	^ (self resizeStrategyFor: elements) padding! !

!ROLayout methodsFor: 'padding' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingLeftFor: elements
	^ (self resizeStrategyFor: elements) paddingLeft! !

!ROLayout methodsFor: 'padding' stamp: 'AlexandreBergel 4/24/2013 09:20'!
paddingTopFor: elements
	^ (self resizeStrategyFor: elements) paddingTop! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/23/2013 15:32'!
resizeStrategyFor: elements
	"Return the resize strategy of these elements. This method assumes that all the elements have the same parent."
	^ elements anyOne parent resizeStrategy! !

!ROLayout methodsFor: 'events' stamp: 'AlexandreBergel 11/16/2012 09:09'!
step
	currentIteraction := currentIteraction + 1.
	(currentIteraction \\ self iterationsToSendEvent) = 0 
		ifTrue: [ self announce: (ROLayoutStep new 
											currentIteration: currentIteraction;
											maxInterations: maxInterations) ].
	! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator
	^ translator! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator: t
	translator := t! !

ROLayout subclass: #RONullLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RONullLayout commentStamp: '<historical>' prior: 0!
A RONullLayout does not relocate nodes!

!RONullLayout methodsFor: 'hook' stamp: 'AlexandreBergel 7/14/2012 15:52'!
doExecute: elements
	"do nothing"! !

ROLayout subclass: #ROScatterplotLayout
	instanceVariableNames: 'horizontalPadding verticalPadding xBlock yBlock xOffset yOffset upSideDown scaleFactorX scaleFactorY scaledToWidth scaledToHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROScatterplotLayout commentStamp: '<historical>' prior: 0!
A ROScatterplotLayout plots each element along a X-Y plan

Instance Variables
	horizontalPadding:		<Object>
	scaleFactorX:		<Object>
	scaleFactorY:		<Object>
	scaledToHeight:		<Object>
	scaledToWidth:		<Object>
	upSideDown:		<Object>
	verticalPadding:		<Object>
	xBlock:		<Object>
	xOffset:		<Object>
	yBlock:		<Object>
	yOffset:		<Object>

horizontalPadding
	- xxxxx

scaleFactorX
	- xxxxx

scaleFactorY
	- xxxxx

scaledToHeight
	- xxxxx

scaledToWidth
	- xxxxx

upSideDown
	- xxxxx

verticalPadding
	- xxxxx

xBlock
	- xxxxx

xOffset
	- xxxxx

yBlock
	- xxxxx

yOffset
	- xxxxx
!

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + deltaY + self yOutGap! !

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + deltaX + self xOutGap! !

!ROScatterplotLayout methodsFor: 'hook' stamp: 'AlexandreBergel 3/20/2013 09:14'!
doExecute: elements

	| maxWidth maxHeight nodesToLayout x y origin newX newY |
	maxWidth := 0.
	maxHeight := 0.
	nodesToLayout := affectedNodes isNil ifTrue: [ elements ] ifFalse: [ affectedNodes ].

	nodesToLayout
		do: [ :node | 
			| m |
			m := node model isNil ifTrue: [ 0 ] ifFalse: [ node model ].
			x := (xBlock value: m) * scaleFactorX.
			y := (yBlock value: m) * scaleFactorY.
			maxWidth := maxWidth max: x.
			maxHeight := maxHeight max: y.	"x = #centered ifTrue: [ x := 0 ]."
			x := x + xOffset.
			y := upSideDown
				ifTrue: [ y - yOffset ]
				ifFalse: [ y + yOffset ].
			translator translate: node to: x @ y ].	"We scale them to the width and height"
	elements
		do: [ :node | 
			origin := node bounds origin.
			newX := origin x.
			newY := origin y.
			scaledToWidth isNil ifFalse: [ newX := (origin x / maxWidth * scaledToWidth) asInteger ].
			scaledToHeight isNil ifFalse: [ newY := (origin y / maxHeight * scaledToHeight) asInteger ].
			translator translate: node to:  newX @ newY.
			self step ].
	scaledToHeight isNil ifFalse: [ maxHeight := scaledToHeight ].
	upSideDown
		ifFalse: [ ^ self ].	"We need to inverse the plots"
	nodesToLayout
		do: [ :node | 
			y := node bounds origin y.
			node translateBy: 0 @ (maxHeight - (2 * y)) ]! !

!ROScatterplotLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.

	horizontalPadding := 5.
	verticalPadding := 5.
	xOffset := 0.
	yOffset := 0.
	scaleFactorX := 1.
	scaleFactorY := 1.
	upSideDown := false.
	xBlock := yBlock := [:aNode | aNode ]! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
offset: anInt

	xOffset := anInt.
	yOffset := anInt.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap
	
	^ self xOutGap @ self yOutGap! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap: anObject
	
	self xOutGap: anObject.
	self yOutGap: anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactor: aValue
	scaleFactorX := aValue.
	scaleFactorY := aValue! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorX: aValue
	scaleFactorX := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorY: aValue
	scaleFactorY := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight
	^ scaledToHeight! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight: anObject
	scaledToHeight := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth
	^ scaledToWidth! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth: anObject
	scaledToWidth := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
upSideDown
	upSideDown := upSideDown not! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
x: aBlock
	xBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap
	
	^horizontalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap: anObject
	
	horizontalPadding := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
y: aBlock
	yBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap
	
	^verticalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap: anObject
	
	verticalPadding := anObject! !

ROLayout subclass: #ROTreeMapLayout
	instanceVariableNames: 'rootNodes weightBlock interactionBlock leafBlock canvas view inset minInset minAreaPerNode nodeBlock baseZIndex splitPercentages weightsCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeMapLayout commentStamp: '<historical>' prior: 0!
A ROTreeMapLayout locates the element as a tree

Instance Variables
	baseZIndex:		<Object>
	canvas:		<Object>
	inset:		<Object>
	interactionBlock:		<Object>
	leafBlock:		<Object>
	minAreaPerNode:		<Object>
	minInset:		<Object>
	nodeBlock:		<Object>
	rootNodes:		<Object>
	splitPercentages:		<Object>
	view:		<Object>
	weightBlock:		<Object>
	weightsCache:		<Object>

baseZIndex
	- xxxxx

canvas
	- xxxxx

inset
	- xxxxx

interactionBlock
	- xxxxx

leafBlock
	- xxxxx

minAreaPerNode
	- xxxxx

minInset
	- xxxxx

nodeBlock
	- xxxxx

rootNodes
	- xxxxx

splitPercentages
	- xxxxx

view
	- xxxxx

weightBlock
	- xxxxx

weightsCache
	- xxxxx
!

!ROTreeMapLayout class methodsFor: 'instance creation' stamp: 'AlexandreBergel 8/21/2012 10:12'!
withWeightBlock: aWeightBlock
	| layout |
	layout := self new.
	layout weightBlock: aWeightBlock.
	^ layout.! !

!ROTreeMapLayout methodsFor: 'interaction' stamp: 'DennisSchenk 5/23/2012 09:48'!
addInteraction: aNode
	"Adds interactions defined in interactionBlock to given node."
	interactionBlock notNil ifTrue: [
		interactionBlock value: aNode.
	].! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 7/3/2012 11:00'!
addLeafBlock: aNode
	"Applies leaf block to given node."
	leafBlock notNil ifTrue: [
		leafBlock value: aNode.
	].! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 10/24/2012 16:33'!
addNodeBlock: aNode
	"Applies node block to given node."
	nodeBlock notNil ifTrue: [
		nodeBlock value: aNode.
	].! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 2/12/2013 13:15'!
baseZIndex
	^ baseZIndex! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 2/12/2013 13:15'!
baseZIndex: anObject
	baseZIndex := anObject! !

!ROTreeMapLayout methodsFor: 'utility' stamp: 'DennisSchenk 3/4/2013 12:07'!
calculateWeight: firstHalf secondHalf: secondHalf
	| weight sumFirstHalf sumSecondHalf sum |
	
	"Initializing values"
	sumFirstHalf := 0.
	sumSecondHalf := 0.
	sum := 0.
	
	firstHalf do: [ :e |
		sumFirstHalf := sumFirstHalf + (self weightBlock value: e)
	].
	secondHalf do: [ :e |
		sumSecondHalf := sumSecondHalf + (self weightBlock value: e)
	].
	
	"Make sure its always at least one."
	sumFirstHalf < 1 ifTrue: [
		sumFirstHalf := 1.
	].
	sumSecondHalf < 1 ifTrue: [
		sumSecondHalf := 1.
	].
	
	sum := sumFirstHalf + sumSecondHalf.
	
	weight := sumFirstHalf / sum.
	
	"Should never be less or more than specified split percentages, 
	so it looks okay graphically and nodes are not disapearing."
	weight > splitPercentages y ifTrue: [
		weight := splitPercentages y.
	].
	weight < splitPercentages x ifTrue: [
		weight := splitPercentages x.
	].
	
	 ^ weight asFloat.
! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 6/5/2012 10:17'!
childrenFor: aNode
	^ aNode elements.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 3/5/2013 12:35'!
childrenSortedFor: aNode
	"Returns all children of given node sorted by weight block."
	| children |

	"Sort children by layouts weight block."
	children isNil ifTrue: [
		children := SortedCollection sortBlock: [ :e1 :e2 | 
			| w1 w2 |
			w1 := self weights at: e1 ifAbsentPut: [self weightBlock value: e1].
			w2 := self weights at: e2 ifAbsentPut: [self weightBlock value: e2].
			w1 <= w2
		].

		children addAll: (self childrenFor: aNode).
	].

 	^ children.! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 6/12/2012 11:18'!
defaultBounds
	^ Rectangle origin: 5@5 corner: 225@225.! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/11/2012 10:01'!
defaultInset
	"This is the default value for insets we use for intetendation inside containment nodes to their children."
	^ 5! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 6/13/2012 12:54'!
defaultMinArea 
	"We assume we need a 20x20 rectangle for a treemap at least."
	^ 400! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/11/2012 10:16'!
defaultMinAreaPerNode
	"The smallest node we want to draw has a size of roughly 5x5."
	^ 25! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/12/2012 10:38'!
defaultMinInset
	"This is the default minimal value for insets in containment nodes we use."
	^ 3! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 3/4/2013 12:15'!
defaultSplitPercentages
	"These percentage say what the min (x) and max (y) percentage value are when splitting available drawing space.
	E.g A node has weight 0 and another weight 100, the visual weight gets capped to 0.01 and 0.99, 
	so the small node is still visible."
	^ 0.01@0.99! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 6/12/2012 09:43'!
defineNodeShape: node rectangle: rectangle level: level
	"Sets a nodes shape and does other necessary stuff."

	node setBounds: rectangle.

	"Add specific interaction to node, if interactionBlock is set"
	self addInteraction: node.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'DennisSchenk 9/4/2012 15:13'!
doExecute: nodeCollection

	"Create the treemap layout."
	self layout: rootNodes rectangle: canvas level: 0.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/29/2013 16:39'!
doInitialize: nodeCollection
	"Let's make sure that everything is set up correctly to draw a treemap layout."
	| givenBounds |

	"If there is nothing to draw, then we simply exit"
	(nodeCollection isEmpty) ifTrue: [ ^ self ]. 

	"We remove the margin of nodeCollection to"
	self removeMarginFor: nodeCollection.

	"Can't draw a treemap without a weight definition."
	self assert: weightBlock notNil description: 'weightBlock has to be set!!'.
	
	super doInitialize: nodeCollection.
	
	"Getting the view we are in."
	view := nodeCollection first view.

	"Before we do anything else, we tell the nodes that they have a fixed size in a treemap."
	nodeCollection do: [ :node | 
		node resizeStrategy: ROPermissiveParent instance.
	].
	
	"Setting up canvas we draw the treemap in based on given nodes."
	givenBounds := self prepareGraph: nodeCollection.
	self setupCanvas: givenBounds.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'DennisSchenk 3/29/2013 08:40'!
doPost: aNodeCollection
	"Doing things after the layout has been generated."
	
	aNodeCollection notEmpty ifTrue: [
		"The treemap has to be draggable as a whole, 
		so we forward drag events from all nodes except the rootNodes."
		rootNodes size > 1 ifTrue: [
			aNodeCollection do: [ :node | node forward: ROMouseDragging ].
		]
		ifFalse: [
			(aNodeCollection reject: [ :node | node = rootNodes first ]) 
				do: [ :node | node forward: ROMouseDragging ].
		].
	].

	"Releasing temporary vars"
	weightsCache := nil.
	
	super doPost: aNodeCollection.! !

!ROTreeMapLayout methodsFor: 'initialize-release' stamp: 'DennisSchenk 3/4/2013 12:05'!
initialize
	super initialize.
	
	"Canvas is the Rectangle where we draw the 	treemap in."
	canvas := Rectangle origin: (5@5) corner: (150@150).
	
	"Inset is the indentation we use for containment nodes (to their children)."
	inset := self defaultInset.
	
	"This inset will never get smaller than the minimum though."
	minInset := self defaultMinInset.
	
	"This is the minimum area a node should have to be drawn."
	minAreaPerNode := self defaultMinAreaPerNode.
	
	"Where to cap split percentages as a point (x is min, y is max)"
	splitPercentages := self defaultSplitPercentages.
	
	"Base z-index is 0."
	baseZIndex := 0.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 09:54'!
inset
	^ inset.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 09:54'!
inset: aNumber
	inset := aNumber.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
interactionBlock
	^ interactionBlock.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
interactionBlock: aBlock
	"Sets an interaction block which will be set to every individual node."
	interactionBlock := aBlock.! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 3/5/2013 09:47'!
layout: nodes rectangle: rectangle level: level
	"Main method that lays out given nodes in given rectangle"
	
	"Nothing to draw..."
	(nodes isNil) ifTrue: [ ^ self. ].

	"If we have only one node we can lay it out directly."
	nodes size == 1 ifTrue: [
		self layoutNode: (nodes first) rectangle: rectangle level: level.
	]

	"If we have more then one node, we need to split them up."
	ifFalse: [

		"Make sure nodes are sorted by weight block."
		| sortedNodes | 
		nodes class ~= SortedCollection ifTrue: [
			sortedNodes := SortedCollection sortBlock: [ :e1 :e2 | 
				(self weightBlock value: e1) <= (self weightBlock value: e2) ].
			sortedNodes addAll: nodes.
		]
		ifFalse: [ sortedNodes := nodes. ].
	
		"Layout multiple nodes."
		self layoutNodes: sortedNodes rectangle: rectangle level: level.
	].! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 3/26/2013 17:31'!
layoutNode: node rectangle: rectangle level: level
	"Lays out a single node"
	| children insetToUse innerRectangle |
	
	"Set bounds of the node."
	self defineNodeShape: node rectangle: rectangle level: level.
	
	"Set zIndex of node, depending on level."
	node zIndex: baseZIndex + level + 1.

	"Get children of given node."
	children := self childrenFor: node.
	
	"Layouting one node at a time..."
	self step.

	"Are we rendering a leaf node?"
	(children isNil or: children isEmpty) ifTrue: [
		self styleLeafNode: node level: level.
		self addLeafBlock: node.
	]

	"Else it is a containment node, style accordingly"
	 ifFalse: [
		
		"If a containment node gets too small, we don't draw its children, instead we just mark it in a special way."
		(rectangle area < (self minAreaNeededFor: children)) ifTrue: [

			"We need to remove the nodes we don't draw."
			self removeChildrenFromRendering: node elements. "Remove this nodes children from the elementsToRender collection of the view."
			node removeAllElements. "Remove this nodes children (elements) from the node itself."
			self styleContainmentNodeWithOmittedChildren: node level: level.
			
		]
		ifFalse: [

			"Style as containment node"
			self styleContainmentNode: node level: level.
			
			"Making insets a little bit thinner the more nested in the graph we are,
			but cap at min inset pixels."
			insetToUse := (inset - (level * 0.2)) ceiling .
			insetToUse < minInset  ifTrue: [
				insetToUse := minInset.	
			].
		
			"Creating a containment border for the children."
			innerRectangle := rectangle insetBy: insetToUse.
			
			"In Roassal nested nodes are defined with relative bounds."
			innerRectangle := Rectangle origin: (insetToUse@insetToUse) extent: innerRectangle extent.
			
			"Need the children sorted if we draw them."
			children := self childrenSortedFor: node.
			
			"Layout children"
			self layout: children rectangle: innerRectangle level: level + 1.
		].
	].

	"Apply node block last, to allow for overwriting of all standard stylings etc."
	self addNodeBlock: node.! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 1/8/2013 10:37'!
layoutNodes: nodes rectangle: rectangle level: level
	"Split up given nodes by weightBlock."
	| firstHalf secondHalf firstRectangle secondRectangle weight |
		
	"Split up nodes"
	firstHalf := self splitCollection: nodes.
	secondHalf := nodes copy reject: [ :element |	
		firstHalf includes: element.
	].
	
	"Calculate weights of the halves"
	weight := self calculateWeight: firstHalf secondHalf: secondHalf.
		
	"Prepare and split up rectangles for the children..."
	firstRectangle := Rectangle new.
	secondRectangle := Rectangle new.		

	"Either vertically or..."
	(rectangle width > rectangle height) ifTrue: [
		self splitRectangleVertically: rectangle first: firstRectangle second: secondRectangle weight: weight.
	]
	"....horizontally"
	ifFalse: [
		self splitRectangleHorizontally: rectangle first: firstRectangle second: secondRectangle weight: weight.
	].
	
	"Recurse to draw nodes."
	self layout: firstHalf rectangle: firstRectangle level: level.
	self layout: secondHalf rectangle: secondRectangle level: level.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
leafBlock
	^ leafBlock! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
leafBlock: aBlock
	"Sets the leaf block: it will be called on all leaf nodes, can be used to style them in a certain way."
	leafBlock := aBlock.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 9/11/2012 11:53'!
minAreaNeededFor: nodesChildren
	^ (((minAreaPerNode * (nodesChildren size)) sqrt) + (2 * inset)) squared.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 9/11/2012 11:52'!
minAreaNeededForNode: node
	^ (((minAreaPerNode * (node size)) sqrt) + (2 * inset)) squared.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:16'!
minAreaPerNode
	^ minAreaPerNode.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:16'!
minAreaPerNode: aNumber
	minAreaPerNode := aNumber.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/12/2012 10:33'!
minInset
	^ minInset.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/12/2012 10:33'!
minInset: aNumber
	minInset := aNumber.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 10/24/2012 16:33'!
nodeBlock
	^ nodeBlock! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 10/24/2012 16:33'!
nodeBlock: aBlock
	"Sets the node block: it will be called on all node nodes, can be used to style them in a certain way."
	nodeBlock := aBlock.! !

!ROTreeMapLayout methodsFor: 'initialize-release' stamp: 'DennisSchenk 3/26/2013 17:01'!
prepareGraph: nodeCollection
	"Checks if the given nodeColection and the (implicit contained) graph are in the expected format
	 and tries to transform it automatically if not. Returns bounds that were given from the outside.
	
	TODO: The automatic transformation of graphs needs to be much more generic, 
	so far we only capture single possible configurations..."

	| givenBounds |

	"In most cases we expect exactly one node, which is the root node."
	"Here we have more than one root node."
	nodeCollection size > 1 ifTrue: [
		| edges parent roots |

		parent := nodeCollection first parent.
		edges := parent elements select: [ :e | e isEdge ].
		
		"But if we have more than one node in the collection, maybe we got an edge driven definition of a graph. 
		Let's try to transform it to a node-nested graph."
		(edges notEmpty) ifTrue: [ 		

			roots := ROGraphTransformation new fromEdgesToNesting: nodeCollection edges: edges.

			(roots isKindOf: Collection) ifFalse: [
				roots := OrderedCollection with: roots.	
			].

			parent class = ROElement ifTrue: [
				parent removeAllElements.
				parent addAll: roots.
				
				"TODO: HACK HACK: this if-else is used to distinguish between setting size of shape
				 externally of the treemap layout or on the nodes inside of it via an heuristic."
				roots first extent = (5@5) ifTrue: [
					givenBounds :=  parent bounds insetBy: inset.
				] 
				ifFalse: [
					givenBounds := roots first bounds.
				]
				
			].
		
			parent class = ROView ifTrue: [
				"Dont need edges anymore, all nodes are now nested."
				edges do:  [ :edge | edge remove ].
				givenBounds := nodeCollection first bounds
			].

			rootNodes := OrderedCollection withAll: roots.
		]
	
		"If we have no edges, we have multiple root nodes (alone or with nested children)."
		ifFalse: [		
			rootNodes := nodeCollection.
			
			parent class = ROView ifTrue: [
				givenBounds := rootNodes first bounds.
			]
			ifFalse: [
				givenBounds := parent bounds insetBy: inset.
			]
		].
	]

	"...as expected: only one root node."
	ifFalse: [
		| edges nodes roots |
		rootNodes := nodeCollection.
		givenBounds := rootNodes first bounds.
		
		"TODO: HACK HACK: we have two seperate configurations here. 
		If givenBounds of first rootNode are only 5@5, we can assume, that the bounds given from the outside, were actually given to its parent."
		givenBounds extent = (5@5) ifTrue: [
			rootNodes first parent class ~= ROView ifTrue: [ 
				givenBounds := rootNodes first parent bounds insetBy: inset.	
			].
		].
		
		"Another possibility is that only the first level is nested, but then we have a graph driven defintion, 
		so lets try to transform it to a nested graph."
		nodes := nodeCollection first elements.
		edges := nodeCollection first elements select: [ :e | e isEdge ].
		(edges notEmpty) ifTrue: [ 		
			roots := (ROGraphTransformation new fromEdgesToNesting: nodes edges: edges) select: [ :e | e isNotEdge].
			rootNodes first removeAllElements.
			rootNodes first addAll: roots.
		].
	].

	^ givenBounds.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/23/2012 09:32'!
recursiveChildrenFor: aNode
	"Returns all children, childrens children etc. of given node in a Set"
	| allChildren myChildren |
     
	allChildren := Set new.
	myChildren := Set new.
	
	myChildren addAll: (self childrenFor: aNode).
	allChildren addAll: myChildren.
	myChildren do: [ :each | allChildren addAll: (self recursiveChildrenFor: each) ].

	^ allChildren.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:12'!
recursiveChildrenSortedFor: aNode
	"Returns all children, childrens children etc. of given node in a SortedCollection sorted by weight block."
	| allChildren myChildren |
     
	allChildren := SortedCollection sortBlock: [ :e1 :e2 | 
		(self weightBlock value: e1) <= (self weightBlock value: e2) ].
	
	myChildren := Set new.
	
	myChildren addAll: (self childrenFor: aNode).
	allChildren addAll: myChildren.
	myChildren do: [ :each | allChildren addAll: (self recursiveChildrenFor: each) ].

	^ allChildren.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 2/26/2013 16:22'!
removeChildrenFromRendering: children
	"Recursive method that removes given children (and if applicable their grand children) from the view to render."	

	(children notNil and: children notEmpty) ifTrue: [
		children do: [ :child |
			view removeElementToRender: child. 
			self removeChildrenFromRendering: child elements 
		].
	].

	
	! !

!ROTreeMapLayout methodsFor: 'utility' stamp: 'AlexandreBergel 4/29/2013 16:29'!
removeMarginFor: elements
	"Assume that elements is not nil, and that all the elements have the same parent"
	
	elements do: [ :e | e allElementsDo: [ :ee | ee resizeStrategy: (e resizeStrategy paddingGap: 0) ] ]
! !

!ROTreeMapLayout methodsFor: 'initialize-release' stamp: 'DennisSchenk 9/19/2012 11:43'!
setupCanvas: givenBounds
	"Setting up the dimensions and position of the canvas we draw the treemap on."
	
	"If bounds are specified from the outside (e.g. view shape width: 400; height: 400) we have to apply
	these bounds only to the canvas of the treemap, not all the nodes."

	"Leave some space to possible parent."
	canvas := Rectangle origin: (inset@inset) extent: givenBounds extent.   ! !

!ROTreeMapLayout methodsFor: 'utility' stamp: 'DennisSchenk 7/3/2012 11:01'!
splitCollection: aSortedCollection
	"Returns the first half of a SortedCollection"
	"TODO: this does not belong here and can surely be solved more elegant."
	| indexOfSplitElement n firstHalf |

	indexOfSplitElement := (aSortedCollection size / 2) floor.
	
	n := 1.
	
	firstHalf := SortedCollection sortBlock: aSortedCollection sortBlock.
	
	[ n <= indexOfSplitElement ] whileTrue: [ 
		| element |
		element := aSortedCollection at: n.
		firstHalf add: element.
		n := n+1.
	].
	
	^ firstHalf.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 3/4/2013 12:05'!
splitPercentages
	^ splitPercentages! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 3/4/2013 12:05'!
splitPercentages: aPoint
	splitPercentages := aPoint.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'AlexandreBergel 8/27/2012 09:57'!
splitRectangleHorizontally: rectangle first: firstRectangle second: secondRectangle weight: weight
	"Splits given rectangle to given rectangles by given weight on the y axis"
	| y |

	"This is where we are going to split on the y-axis"
	y := ((((rectangle bottomLeft y) - (rectangle topLeft y)) * weight) floor + rectangle topLeft y).

	"HACKY: Subtract 1 of the seconds rectangles origin y value, 
	so the borders between the rectangles are overlaying eachother, so we dont have thick borders"
	firstRectangle roOrigin: (rectangle origin); roCorner: (rectangle corner x)@y.
	secondRectangle roOrigin: (rectangle origin x)@(y-1); roCorner: (rectangle corner).
! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'AlexandreBergel 8/27/2012 09:58'!
splitRectangleVertically: rectangle first: firstRectangle second: secondRectangle weight: weight
	"Splits given rectangle to given rectangles by given weight on the x axis"
	| x |
	
	"This is where we are going to split on the x-axis"
	x := ((((rectangle topRight x) - (rectangle topLeft x)) * weight) floor + rectangle topLeft x).
	
	"HACKY: Subtract 1 of the seconds rectangles origin x value, 
	so the borders between the rectangles are overlaying eachother, so we dont have thick borders"
	firstRectangle roOrigin: (rectangle origin); roCorner: x@(rectangle corner y).
	secondRectangle roOrigin: (x-1)@(rectangle origin y); roCorner: (rectangle corner).
	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'DennisSchenk 9/12/2012 10:41'!
styleContainmentNode: node level: level
	| shape |
	shape := (node getShape: ROBox).
	shape color:  ((Color r: 0.934 g: 0.934 b: 0.934) adjustBrightness: -0.03 * level).
	shape borderColor: ((Color r: 0.2 g: 0.2 b: 0.2) adjustBrightness: -0.008 * level).
	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'DennisSchenk 9/12/2012 10:42'!
styleContainmentNodeWithOmittedChildren: node level: level
	| shape |
	shape := (node getShape: ROBox).
	shape color:  ((Color r: 0.884 g: 0.884 b: 0.884) adjustBrightness: -0.03 * level).
	shape borderColor: ((Color r: 0.2 g: 0.2 b: 0.2) adjustBrightness: -0.008 * level).

	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'DennisSchenk 4/9/2013 08:59'!
styleLeafNode: node level: level
	| shape |
	shape := node getShape: ROBox.
	
	shape color: Color white.
	shape borderColor: Color gray.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
weightBlock
	^ weightBlock ! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
weightBlock: aWeightBlock
	weightBlock := aWeightBlock.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 7/25/2012 11:12'!
weightFor: aNode
	"Returns weight for given node based on weightBlock"
	self assert: weightBlock notNil description: 'weightBlock has to be set!!'.
	^ weightBlock value: aNode.! !

!ROTreeMapLayout methodsFor: 'caching' stamp: 'DennisSchenk 3/5/2013 09:53'!
weights
	weightsCache isNil ifTrue: [
		weightsCache := Dictionary new.
	].

	^ weightsCache .! !

ROObject subclass: #ROLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

!ROLayoutTranslator commentStamp: 'AlexandreBergel 11/28/2011 10:48' prior: 0!
ROLayoutTranslator is used by the layout to translate object. Each layout can be parametrized with a translator to produce a visual effect.

I am an abstract class!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

ROLayoutTranslator subclass: #ROAbsorbLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbsorbLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	"Does not perform the translation. Used in testing essentially"! !

ROLayoutTranslator subclass: #RODirectLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODirectLayoutTranslator class methodsFor: 'testing' stamp: ''!
isDefault
	^ true! !

!RODirectLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	element translateTo: newPosition! !

!ROLayoutTranslator class methodsFor: 'accessing' stamp: ''!
default
	"Return the default translator, the one used in the layouts"

	defaultTranslator ifNotNil: [ ^ defaultTranslator ].
	^ defaultTranslator := self defaultClass new! !

!ROLayoutTranslator class methodsFor: 'accessing' stamp: ''!
defaultClass
	^ self withAllSubclasses detect: #isDefault! !

!ROLayoutTranslator class methodsFor: 'testing' stamp: ''!
isDefault
	^ false! !

!ROLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	self subclassResponsibility ! !

ROLayoutTranslator subclass: #ROSmoothLayoutTranslator
	instanceVariableNames: 'move nbCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSmoothLayoutTranslator methodsFor: 'testing' stamp: ''!
hasCompleted
	"Return true if all the translation has completed"
	^ move hasCompleted! !

!ROSmoothLayoutTranslator methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/13/2013 22:10'!
initialize 
	super initialize.
	
	"The amount of view refresh we need to complete the transition"
	nbCycles := 180! !

!ROSmoothLayoutTranslator methodsFor: 'accessing' stamp: 'AlexandreBergel 4/13/2013 22:10'!
nbCycles: anInteger
	"Set the number of cycle we need to complete the transition"
	nbCycles := anInteger ! !

!ROSmoothLayoutTranslator methodsFor: 'hook' stamp: 'AlexandreBergel 4/13/2013 22:10'!
translate: element to: newPosition
	move := ROLinearMove new
					nbCycles: nbCycles;
					for: element to: newPosition! !

ROObject subclass: #ROLineDecoration
	instanceVariableNames: 'color offset size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROLineDecoration subclass: #ROAbstractArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 11/1/2012 12:09'!
drawOn: aCanvas for: anEdge fromPoint: fromPoint toPoint: toPoint line: line
	"Draw the arrow on the canvas and return the begining and ending of the arrow"
	
	| vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	toPointWithOffset := toPoint - (offset * (vector r - size) * unit).
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  arrowMiddle- (u * size).
	arrowRight := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROAbstractArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 11/1/2012 12:09'!
drawOn: aCanvas for: anEdge line: line
	"Draw the arrow on the canvas and return the begining and ending of the arrow"

	^ self drawOn: aCanvas for: anEdge fromPoint: (line startingPointOf: anEdge) toPoint: (line endingPointOf: anEdge) line: line! !

ROAbstractArrow subclass: #ROArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROArrow commentStamp: '<historical>' prior: 0!
A ROArrow represent an arrow. A ROLine may receive arrows.

Instance Variables
	color:		<Object>
	offset:		<Object>
	size:		<Object>

color
	- Color of the arrow

offset
	- float that represent where to put the arrow on a line

size
	- size of the arrow
!

!ROArrow methodsFor: 'hooks' stamp: 'AlexandreBergel 7/29/2012 21:18'!
getDirectionVectorFrom: fromPoint to: toPoint
	^ toPoint - fromPoint! !

ROArrow subclass: #ROReversedArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 22:48'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	toPointWithOffset := toPoint - (offset * (vector r - size) * unit).
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  toPointWithOffset - (u * size).
	arrowRight := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: arrowMiddle width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

ROAbstractArrow subclass: #ROHorizontalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROHorizontalArrow methodsFor: 'drawing' stamp: 'BenComan 8/5/2012 20:33'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowTop arrowBottom w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
"	toPointWithOffset := toPoint - (offset * (vector r - size) * unit)."
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (size @ 0))  ].

	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowTop :=  arrowMiddle - (u * size).
	arrowBottom := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROHorizontalArrow methodsFor: 'hooks' stamp: 'BenComan 8/5/2012 14:52'!
getDirectionVectorFrom: fromPoint to: toPoint
	^ (toPoint - fromPoint) x @  0! !

ROHorizontalArrow subclass: #ROReversedHorizontalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedHorizontalArrow methodsFor: 'drawing' stamp: 'BenComan 8/5/2012 20:31'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowTop arrowBottom w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (size @ 0))  ].
	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowTop :=  toPointWithOffset - (u * size).
	arrowBottom := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: arrowMiddle width: w color: c.
	
	^ Array with: (fromPoint + (unit * (size @ 0))) with: (toPoint - (unit * (size @ 0)))! !

ROAbstractArrow subclass: #ROVerticalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROVerticalArrow subclass: #ROReversedVerticalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedVerticalArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 23:58'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (0 @ size))  ].
	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  toPointWithOffset - (u * size).
	arrowRight := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: arrowMiddle width: w color: c.
	
	^ Array with: (fromPoint + (unit * (0 @ size))) with: (toPoint - (unit * (0 @ size)))! !

!ROVerticalArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 23:47'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
"	toPointWithOffset := toPoint - (offset * (vector r - size) * unit)."
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (0 @ size))  ].

	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  arrowMiddle- (u * size).
	arrowRight := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROVerticalArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:19'!
getDirectionVectorFrom: fromPoint to: toPoint
	^  0 @ (toPoint - fromPoint) y! !

ROLineDecoration subclass: #RODiamond
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RODiamond methodsFor: 'drawing' stamp: 'BenComan 10/20/2012 21:32'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector normal unit endPoint leftPoint rightPoint w c toPointWithOffset r middlePoint |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	normal := vector normal.
	unit := vector / r.
	toPointWithOffset := toPoint - (offset * (vector r - size) * unit).
	endPoint := toPointWithOffset - (unit * size). 
	middlePoint := toPointWithOffset + (unit * size).
	leftPoint :=  toPointWithOffset - (normal * size * 0.7 ).
	rightPoint := toPointWithOffset + (normal * size * 0.7).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: endPoint to: leftPoint width: w color: c.
	aCanvas line: leftPoint to: middlePoint width: w color: c.
	aCanvas line: middlePoint to: rightPoint width: w color: c.	
	aCanvas line: rightPoint to: endPoint width: w color: c.
	
	^ Array with: middlePoint with: endPoint! !

!RODiamond methodsFor: 'hooks' stamp: 'AlexandreBergel 11/1/2012 12:06'!
getDirectionVectorFrom: fromPoint to: toPoint
	^ toPoint - fromPoint! !

!ROLineDecoration methodsFor: 'configuration' stamp: 'DennisSchenk 9/18/2012 10:20'!
defaultSize
	^ 10! !

!ROLineDecoration methodsFor: 'drawing' stamp: 'AlexandreBergel 11/1/2012 12:09'!
drawOn: aCanvas for: anEdge line: line
	"Draw the decorator on the canvas and return the begining and ending of the decoration"

	self subclassResponsibility.
	! !

!ROLineDecoration methodsFor: 'hooks' stamp: 'AlexandreBergel 7/29/2012 21:26'!
getDirectionVectorFrom: fromPoint to: toPoint
	self subclassResponsibility! !

!ROLineDecoration methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/29/2012 21:25'!
initialize
	super initialize.
	offset := 0.
	size := self defaultSize! !

!ROLineDecoration methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
offset
	^ offset! !

!ROLineDecoration methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
offset: aFloat 
	offset := aFloat! !

!ROLineDecoration methodsFor: 'accessing' stamp: 'AlexandreBergel 11/1/2012 12:10'!
size
	"Return the size of the decoration"
	
	^ size! !

!ROLineDecoration methodsFor: 'accessing' stamp: 'AlexandreBergel 11/1/2012 12:10'!
size: anInteger
	"Set the size of the decoration. DefaultSize return the default size"
	size := anInteger! !

ROObject subclass: #ROMondrianFrame
	instanceVariableNames: 'parent view shape interactions layout elements children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianFrame commentStamp: '<historical>' prior: 0!
The Mondrian specific language structures a visualization as a tree (using nodes:forEach:). 
A ROMondrianFrame is an element of this tree. A frame correspond to what has to be pushed and popup.
It also contains funcionalities to lookup nodes.

Instance Variables
	children:		<ROMondrianFrameS>
	elements:		<ROElementS>
	interactions:		<Object>
	layout:		<Object>
	parent:		<Object>
	shape:		<Object>
	view:		<Object>

children
	- the list of children frames

elements
	- elements (nodes and edges) that are defined in the frame
	
interactions
	- xxxxx

layout
	- xxxxx

parent
	- xxxxx

shape
	- xxxxx

view
	- xxxxx
!

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/24/2012 17:57'!
addChild: aFrame
	children add: aFrame! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:03'!
addEdge: edge

	"we need to add the edge in the frame that includes both the from and to"
	| frameTo frameFrom |
	frameTo := self frameOfElement: edge to.
	frameFrom := self frameOfElement: edge from.

	(frameTo == frameFrom)
		ifTrue: [ frameFrom addElement: edge ]
		ifFalse: [ 
			"This looks like to be a weir case"
			self addElement: edge ]! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:17'!
addElement: element
"self haltIf: [ element class == ROEdge ]."
	elements add: element! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:03'!
addElements: elementss
	elementss do: [:e | self addElement: e]
	! !

!ROMondrianFrame methodsFor: 'actions' stamp: 'VanessaPena 4/12/2013 10:42'!
applyLayout
	children do: [ :frameChild | frameChild applyLayout ].
	layout 
		on: self nodes edges: self edges.! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 09:46'!
children
	^ children copy! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'DR 3/27/2013 16:46'!
edges	
	^ (elements select: [ :el | el isEdge ]) asArray! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 09:48'!
elements
	^ elements copy asArray! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 11:16'!
frameOfElement: element
	"Return the frame that contains element.
	 In case several frames contains the same element, the result is unspecified"

	^ self frameOfElement: element ifFound: [ :foundFrame | ^ foundFrame ]! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 11:15'!
frameOfElement: element ifFound: aBlock
	"aBlock takes an argument, the frame just found"
	
	"Return the frame that contains element.
	 In case several frames contains the same element, the result is unspecified"

	(elements includes: element) 
		ifTrue: [ ^ aBlock value:  self ].
		
	children do: [ :childFrame |
		childFrame frameOfElement: element ifFound: aBlock.
	].

	! !

!ROMondrianFrame methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/24/2012 17:46'!
initialize 
	super initialize.
	elements := OrderedCollection new.
	children := OrderedCollection new.! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
interactions
	^ interactions ! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
interactions: ints
	interactions := ints! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
layout
	^ layout! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
layout: aLayoutClass
	layout := aLayoutClass ! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 09:59'!
nodes
	^ (elements select: [ :el | el class ~~ ROEdge ]) asArray ! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 09:45'!
numberOfChildren
	^ children size! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 17:33'!
numberOfElements
	^ elements size! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 17:47'!
numberOfFrames
	^  children inject: 1 into: [ :s :e | s + e numberOfFrames ]! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:43'!
parent
	^ parent! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:43'!
parent: aFrame
	parent := aFrame! !

!ROMondrianFrame methodsFor: 'printing' stamp: 'AlexandreBergel 7/25/2012 09:30'!
printOn: stream
	super printOn: stream.
	self parent == self 
		ifTrue: [ stream nextPutAll: '<root>' ]
	  ! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 11:45'!
removeChild: aFrame
	children remove: aFrame ifAbsent: [  ]! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 12:27'!
removeEdge: edge 
	
	self removeEdges: (Array with: edge)! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 12:29'!
removeEdges: objects 
	
	elements removeAllFoundIn: objects! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 11:45'!
removeElement: element

	|frame|
	element elements do:[:el |
			frame := (self frameOfElement: el). 
			frame removeElement: el.
			frame removeFromParent.
		].
	elements remove: element ifAbsent: [  ]! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 12:29'!
removeElements: objects

	objects do:[:ob |
		self removeElement: ob			
		].
! !

!ROMondrianFrame methodsFor: 'removing' stamp: 'VanessaPena 4/12/2013 11:44'!
removeFromParent
	parent removeChild: self.! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
shape
	^ shape
	! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
shape: aShape
	shape := aShape! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:04'!
view
	^ view! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:04'!
view: aView
	view := aView! !

ROObject subclass: #ROMondrianShapeBuilder
	instanceVariableNames: 'shape color viewBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianShapeBuilder commentStamp: '<historical>' prior: 0!
A ROMondrianShapeBuilder is a convenient way to build shapes.

Instance Variables
	color:		<Object>
	shape:		<Object>
	viewBuilder:		<Object>

color
	- xxxxx

shape
	- xxxxx

viewBuilder
	- xxxxx
!

!ROMondrianShapeBuilder class methodsFor: 'createInstance' stamp: 'AlejandroInfante 4/15/2013 15:17'!
initializeOn: aViewBuilder
	^self new viewBuilder: aViewBuilder.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:21'!
arrowedLine
	^ self arrowedLineWithOffset: 0! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:21'!
arrowedLineReversed
	^ self arrowedLineReversedWithOffset: 1.0! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:21'!
arrowedLineReversedWithOffset: aFloat
	self setShape: ROLine new.
	self getShape add: (ROReversedArrow new offset: aFloat).
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:21'!
arrowedLineWithOffset: aFloat
	self setShape: ROLine new.
	self getShape add: (ROArrow new offset: aFloat).
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:24'!
bezierLine
	self setShape: RORadialBezierCurve new.
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
borderColor
	^ self getShape borderColor! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
borderColor: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	self getShape borderColor: [ :element | aBlockOrSymbol roValue: element model ]
	
	! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
borderWidth: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	self getShape borderWidth: [ :element | aBlockOrSymbol roValue: element model ]
	! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'JurajKubelka 4/26/2013 10:50'!
centeredLabel
	self setShape: self newCenteredLabel.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
circle
	self setShape: ROEllipse new.
	self color: self defaultNodeColor.
	self getShape borderWidth: 1.
	! !

!ROMondrianShapeBuilder methodsFor: 'accessors' stamp: 'AlejandroInfante 4/15/2013 14:37'!
color

	^color.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
color: aBlockOrSymbol
	color := aBlockOrSymbol.
	self getShape color: [ :element | aBlockOrSymbol roValue: element model ]
	
	! !

!ROMondrianShapeBuilder methodsFor: 'configuration' stamp: 'AlejandroInfante 4/15/2013 14:26'!
defaultColor
	^ Color veryLightGray.! !

!ROMondrianShapeBuilder methodsFor: 'configuration' stamp: 'AlejandroInfante 4/15/2013 14:26'!
defaultLineColor
	^ Color veryLightGray.! !

!ROMondrianShapeBuilder methodsFor: 'configuration' stamp: 'AlejandroInfante 4/15/2013 14:25'!
defaultNodeColor
	^ Color white! !

!ROMondrianShapeBuilder methodsFor: 'configuration' stamp: 'AlejandroInfante 4/15/2013 14:26'!
defaultTextColor
	^ Color black.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'JurajKubelka 4/30/2013 20:53'!
ellipse
	^ self circle! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
fillColor
	^ self getShape color! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
fillColor: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	self getShape color: [ :element | aBlockOrSymbol roValue: element model ]! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 15:21'!
fixedSize
	self viewBuilder fixedSize.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'JurajKubelka 4/26/2013 10:51'!
fontColor: aBlockOrASymbolAnOrObject

	(self getShape shapeDetect: [ :s | s isKindOf: ROAbstractLabel]) color: aBlockOrASymbolAnOrObject
! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:18'!
fontSize: aBlockOrASymbolOrAnObject

	(self getShape shapeDetect: [ :s | s class == ROLabel]) fontSize: [:element | aBlockOrASymbolOrAnObject roValue: element model]! !

!ROMondrianShapeBuilder methodsFor: 'accessors' stamp: 'AlejandroInfante 4/15/2013 13:50'!
getShape
	^shape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
height: aHeightBlock
	self getShape height: [ :elem | aHeightBlock roValue: elem model ] ! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
if: conditionBlock borderColor: colorBlock
	"If conditionBlock is evaluated at true, then colorBlock is used to pick the color to use. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self borderColor ifNil: [ self defaultBorderColor ].
	^ self borderColor: [ :aModel | (conditionBlock roValue: aModel)
									ifTrue: [ colorBlock roValue: aModel ] 
									ifFalse: [ 
										"Having to create a new element is rather ugly. 
										Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
										oldBlockOrValue roValue: (ROElement on: aModel) ]].! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
if: conditionBlock fillColor: colorBlock
	"If conditionBlock is evaluated at true, then colorBlock is used to set the color of the node. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
	^self fillColor: [ :aModel | (conditionBlock roValue: aModel)
									ifTrue: [ colorBlock roValue: aModel ] 
									ifFalse: [ 
										"Having to create a new element is rather ugly. 
										Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
										oldBlockOrValue roValue: (ROElement on: aModel) ]].
							
						
! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:16'!
label
	self setShape: self newLabel.
	! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:13'!
line
	self setShape: ROLine new.
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
linearFillColor: block within: groupOfObjects
	"Set the linear fill color for the nodes. The gradient goes from white to black. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."
	
	| max |
	"If the collection is empty, then we return an arbitrary color. 
	 If the script is properly done, the color should not be used"
	groupOfObjects isEmpty ifTrue: [ ^ Color red ].
	
	max := groupOfObjects maxValue: block.
	self getShape color: [ :v | Color gray256: 256 - ((block roValue: v model) max: max in: (1 to: 256)) ]! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/19/2013 16:17'!
linearFontSize: anObject within: aCollection
	"Set the linear font size for the nodes. The gradient goes from 0 to the maximum, obtained from aCollection. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."
	
	self fontSize: (RONFontLinearNormalizer inContext: aCollection withCommand: anObject)! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
logHeight: aBlock
	self height: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
logWidth: aBlock
	self width: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/23/2013 15:50'!
newCenteredLabel
	^ ROCenteredLabel new color: self defaultTextColor; yourself! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
newLabel
	^ ROLabel new color: self defaultTextColor; yourself! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'JurajKubelka 4/22/2013 17:37'!
orthoHorizontalLine

	self setShape: ROOrthoHorizontalLineShape new.
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'JurajKubelka 4/22/2013 17:38'!
orthoVerticalLine

	self setShape: ROOrthoVerticalLineShape new.
	self color: self defaultLineColor.
	^ self getShape! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
rectangle
	self setShape: ROBox new.
	self color: self defaultNodeColor.
	self getShape borderWidth: 1.
	! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:22'!
rectangleWithoutBorder
	self setShape: ROBox new.
	self color: self defaultNodeColor! !

!ROMondrianShapeBuilder methodsFor: 'accessors' stamp: 'AlejandroInfante 4/15/2013 13:51'!
setShape: aShape
	shape := aShape.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
size: aSizeBlock
	self width: aSizeBlock.
	self height: aSizeBlock.	! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
text: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a unary symbol or a one-arg block"

	self getShape text: [ :element | aBlockOrSymbol roValue: element model ]! !

!ROMondrianShapeBuilder methodsFor: 'accessors' stamp: 'AlejandroInfante 4/15/2013 15:19'!
viewBuilder

	^viewBuilder! !

!ROMondrianShapeBuilder methodsFor: 'accessors' stamp: 'AlejandroInfante 4/15/2013 15:19'!
viewBuilder: aViewBuilder

	viewBuilder := aViewBuilder.! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
width: aWidthBlock
	self getShape width: [ :elem | aWidthBlock roValue: elem model ] ! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
withCenteredText
	^ self withCenteredText: [ :element | element model ]! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
withCenteredText: aBlockOrASymbolAnOrObject
	| label |
	self getShape next: (label := self newCenteredLabel text: aBlockOrASymbolAnOrObject).
"	width := [ :v | label widthOfString: v printString ].
	height := [ :v | label heightOfString: v printString ]."! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
withText
	^ self withText: #yourself! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
withText: aBlockOrASymbolAnOrObject
	| label |
	label := self newLabel text: [ :anElement | aBlockOrASymbolAnOrObject roValue: anElement model ].
	self getShape next: label.
"	width := [ :v | label widthOfString: v printString ].
	height := [ :v | label heightOfString: v printString ]."! !

!ROMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:23'!
withoutBorder
	"We assume we want to have a rectangle"
	
	self rectangleWithoutBorder! !

ROObject subclass: #ROMondrianViewBuilder
	instanceVariableNames: 'shape selfDefinedInteraction title shouldHavePopup menu parentBehavior viewStack rawView structureTree currentFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianViewBuilder commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilder models the Mondrian Domain Specific Language. It is mostly compatible with the original Mondrian language (cf., Mondrian paper and website).

Instance Variables
	color:		<Object>
	container:		<Object>
	height:		<Object>
	isLayouted:		<Object>
	selfDefinedInteraction:		<Object>
	shape:		<Object>
	title:		<Object>
	width:		<Object>

color
	- xxxxx

container
	- xxxxx

height
	- xxxxx

isLayouted
	- xxxxx

selfDefinedInteraction
	- xxxxx

shape
	- xxxxx

title
	- xxxxx

width
	- xxxxx
!

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:29'!
initializedView: aView
	
	^ self basicNew
		initializeWithRoassalView: aView; 
		yourself! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 9/26/2012 11:17'!
nonDraggable
	"Create a builder with a non draggable roView in it"
	
	^ self initializedView: ROView new! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: ''!
titled: aTitleAsString
	^ self basicNew
		initializeWithTitle: aTitleAsString; 
		yourself! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:30'!
titled: aTitleAsString view: aView
	"Take a string and an instance of ROView as parameter"

	aView @ RODraggable @ RODraggableWithVelocity.

	^ self basicNew
		initializeWithTitle: aTitleAsString roassalView: aView; 
		yourself! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:29'!
view: aView
	"Take an instance of ROView as parameter"
	
	aView @ RODraggable @ RODraggableWithVelocity.
	
	^ self initializedView: aView! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:38'!
action: aBlockOrSymbol
	^ self item: aBlockOrSymbol printString action: aBlockOrSymbol! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:04'!
addEdge: edge
	"private"
	| commonParentNode frameOfCommonNode |
	commonParentNode := (edge from mostSpecificParentCommonWith: edge to).
	commonParentNode add: edge.
	
	frameOfCommonNode := structureTree frameOfElement: commonParentNode.
	frameOfCommonNode addEdge: edge! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:29'!
addEdges: edges
	"private"
	edges do: [ :e | self addEdge: e ]! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 5/18/2012 09:19'!
addMenu: name callBack: aCallBack
	"aCallback has to be one-arg block that accepts a view stack. It is convenient to receive the stack and not directly the view to add menu for example"
	
	menu add: name -> aCallBack! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
addUserCommand: anArray 
	"TODO"! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'VanessaPena 4/11/2013 19:19'!
applyLayout

	structureTree applyLayout.
! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
bottomFlowLayout
	^ self layout: ROBottomFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlejandroInfante 4/15/2013 13:57'!
buildEdgeFrom: fromNode to: toNode for: anObject
	"Shape is not initialized here"
	
	| edge |
	edge := (ROEdge on: anObject from: fromNode to: toNode) + self getShape.
	selfDefinedInteraction do: [:int | int value: (Array with: edge) ].
	^ edge! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
circleLayout
	^ self layout: ROCircleLayout new! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:35'!
createMondrianView
	"Creating the view that will contain all the nodes and edges"
	
	| v |
	v := ROView titled: title.
	v @RODraggable @ RODraggableWithVelocity.
	^ v! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:35'!
currentFrame
	^ currentFrame! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:34'!
defaultHeight
	"Default height of a node"
	
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:35'!
defaultWidth
	"Default width of a node"
	
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'TudorGirba 10/1/2012 14:00'!
dominanceTreeLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^self layout: RODominanceTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'dynamic edges' stamp: 'AlexandreBergel 4/7/2013 07:23'!
dynamicEdge: aBlockOrSymbol using: aShape

	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :n | 
			
			n @ (RODynamicEdge 
					toAll: [ :element | (self elementsFromModels: (aBlockOrSymbol roValue: element model)) ]
					using: aShape) ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:43'!
edge: object from: fromBlock to: toBlock
	"Add an edge going from (fromBlock roValue: object) to (toBlock roValue: object)"
	
	^ self edgeFromAssociation: ((fromBlock roValue: object) -> (toBlock roValue: object))
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 4/7/2013 00:42'!
edge: object toAll: toAllBlock
	"- object is the object from which the edges are defined from.
	- toAllBlock will be called similarly to return a collection of destination correpsonding to each source."

	^ self edges: (Array with: object) from: #yourself toAll: toAllBlock! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:01'!
edgeFromAssociation: assoc
	"Create an edge from an association
	e.g.,
	
	view nodes: #(1 2).
	view edgeFromAssociation: 1 -> 2.
	"
 	| edge |
	(assoc key isNil or: [ assoc value isNil ]) ifTrue: [ ^ nil ].
	(assoc key == assoc value) ifTrue: [ ^ nil ].
	
	self prepareForNewEdge.
	edge := self rawEdgeFromAssociation: assoc.
	edge notNil ifTrue: [ self addEdge: edge ].
	self unsetShape.
	^ edge! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 12/5/2012 18:03'!
edgeFromModel: aModelObject
	^ self raw edgeFromModel: aModelObject! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:19'!
edges
	^ self raw elementsSuchThat: [ :v | v class == ROEdge ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:03'!
edges: objects from: fromBlock to: toBlock
	"-  aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	- aToBlock will be called on each element of the collection and return the destination node.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"

	| edges |
	edges :=  self rawEdges: objects from: fromBlock to: toBlock.
	self addEdges: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:52'!
edges: objects from: fromBlock toAll: toAllBlock
	"- objects is the collection of from which the edges are defined from.
	- fromBlock will be called on each entity of the collection and return one edge source each time.
	- toAllBlock will be called similarly to return a collection of destination correpsonding to each source.
	Note that there is no restriction on the entities of aCollection, as long as aFromBlock returns a node and aToBlock returns a collection of nodes.
	For example:
	  aView edges: someFamixInvocations from: #sender toAll: #candidates

	Or:
	
	| collection |
	collection := #(1 2 3 4 5 6 7 8 9 10).
	view shape label.
	view nodes: collection.
	view edges: collection from: #yourself toAll: (collection select: #odd).
	view circleLayout
		
	aToBlock should return a collection, edges will be drawn from the entity returned by aFromBlock to this collection"
	
	| associations |
	associations := OrderedCollection new.
	objects do: [ :obj |
		| from |
		from := fromBlock roValue: obj.
		(toAllBlock roValue: obj) do: [:to | 
			associations add: (from -> to)
		]
	].
	^ self edgesFromAssociations: associations! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 11/29/2012 13:31'!
edges: objects fromAll: fromAllBlock to: toBlock
	
	| associations |
	associations := OrderedCollection new.
	objects do: [ :obj |
		| to |
		to := toBlock roValue: obj.
		(fromAllBlock roValue: obj) do: [:from | 
			associations add: (from -> to)
		]
	].
	^ self edgesFromAssociations: associations! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:29'!
edgesFrom: symbolOrBlock
	"The message edgesFrom: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."

	| edges |
	edges := self rawEdgesFrom: symbolOrBlock.
	self addEdges: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 11/28/2012 23:03'!
edgesFrom: fromBlock to: toBlock
	"-  aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	- aToBlock will be called on each element of the collection and return the destination node.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"

	^ self edges: ((rawView elementsSuchThat: #isNotEdge) collect: #model) from: fromBlock to: toBlock! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:02'!
edgesFromAssociations: associations
	| answer edge interestingEdges |
	
	self prepareForNewEdge.

	interestingEdges := associations select: [ :assoc | 
						assoc key notNil and: [ assoc value notNil ] ].
	interestingEdges := interestingEdges select: [ :assoc |
						assoc key ~~ assoc value ].
					
	answer := interestingEdges collect: [ :assoc | 
		edge := self rawEdgeFromAssociation: assoc.
		edge notNil ifTrue: [ self addEdge: edge ].
		
		edge ].
	self unsetShape.
	^ answer! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:02'!
edgesToAll: symbolOrBlock
	| edges |
	edges := self rawEdgesToAll: symbolOrBlock.
	edges do: [ :e | self addEdge: e ].
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 12/5/2012 17:59'!
elementFromModel: aModelObject
	^ self raw elementFromModel: aModelObject! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 4/7/2013 07:04'!
elementsFromModels: objects
	^ self raw elementsFromModels: objects! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'JurajKubelka 4/23/2013 14:09'!
extensibleSize
	parentBehavior := ROExtensibleParent instance! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'JurajKubelka 4/24/2013 10:26'!
extensibleSizeWithPaddingGap: aNumber
	parentBehavior := ROExtensibleParent new paddingGap: aNumber; yourself! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlejandroInfante 4/15/2013 15:20'!
fixedSize
	parentBehavior := ROFixedSizedParent instance! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
flowLayout
	^ self layout: ROFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
forceBasedLayout
	
	^ self layout: ROForceBasedLayout new! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward
	self forwarder! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward: event

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward: event ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forwarder

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward ] ]! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
fromPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlejandroInfante 4/15/2013 14:15'!
getShape
	^ self shape getShape.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
gridLayout
	
	^ self layout: (ROGridLayout new gapSize: 2)
		! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol
	self highlightNodesWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element) . 
		ROHighlightElements 
			on: nodes 
			color: (aColorAsBlockOrSymbol roValue: n element model).
		n element signalUpdate  ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element).
		ROUnhighlightElements  
			on: nodes.
		n element signalUpdate  ].! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/3/2012 17:09'!
highlightWhenOver: aBlockOrSymbol
	"(aBlockOrSymbol roValue: element) should return a collection of the models that should be highlighted"

	self highlightWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/6/2012 13:07'!
highlightWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	"We use 'nodes asSet' to make sure that we do not go twice over the same node, else it behaves strangely'"
	
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := self raw elementsFromModels: (aBlockOrSymbol roValue: n element model) . 
		ROHighlightElements 
			on: nodes asSet
			color: (aColorAsBlockOrSymbol roValue: n element model) ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := self raw elementsFromModels:  (aBlockOrSymbol roValue: n element model).
		ROUnhighlightElements  
			on: nodes asSet ].! !

!ROMondrianViewBuilder methodsFor: '*Roassal-Algorithm' stamp: 'MathieuDehouck 4/11/2013 10:24'!
horizontalCompactTree

	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^ self layout: ROVerticalCompactTree new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'TudorGirba 9/27/2012 23:08'!
horizontalDominanceTreeLayout
	self setEdgesAttachPoint: ROHorizontalAttachPoint.
	^self layout: ROHorizontalDominanceTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
horizontalLineLayout
	^ self layout: ROHorizontalLineLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'JurajKubelka 4/2/2013 10:20'!
horizontalNarrowTreeLayout

	^ self layout: ROHorizontalNarrowTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:04'!
horizontalTreeLayout
	self setEdgesAttachPoint: ROHorizontalAttachPoint.
	^self layout: ROHorizontalTreeLayout new.! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/9/2012 08:25'!
if: conditionBlock popupText: popupTextBlock
	"If conditionBlock is evaluated at true, then popupTextBlock is used to for the popup"

	^ self  popupView: [ :entity :myView | 
		(conditionBlock roValue: entity) 
			ifTrue:  
		[ myView shape rectangle.
	  	 myView node: entity forIt: [ 
			myView shape label.
			myView node: (popupTextBlock roValue: entity)
		] ] ] 

"	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			| oldBlockOrValue |
			oldBlockOrValue := 
				(node is: ROPopupView)
					ifTrue: [ node getInteraction: ROPopupView ] 
					ifFalse: [ #printString ].
			self popupText: [ :each |
				(conditionBlock roValue: each)
					ifTrue: [ popupTextBlock roValue: each ]
					ifFalse: [ oldBlockOrValue roValue: each ] ] ] ] 
			"! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlejandroInfante 4/15/2013 13:58'!
initFrame
	
	structureTree := ROMondrianFrame new.
	structureTree view: rawView.
	structureTree shape: self getShape.
	structureTree interactions: selfDefinedInteraction.
	
	structureTree parent: structureTree.
	currentFrame :=  structureTree! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlejandroInfante 4/15/2013 14:31'!
initialize
	self initializeWithTitle: ROView defaultWindowTitle.! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:23'!
initializeWithRoassalView: aView
	self initializeWithTitle: ROView defaultWindowTitle roassalView: aView! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:14'!
initializeWithTitle: aTitleAsString
	self initializeWithTitle: aTitleAsString roassalView: self createMondrianView.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlejandroInfante 4/15/2013 15:22'!
initializeWithTitle: aTitleAsString roassalView: aView
	super initialize.

	shape := ROMondrianShapeBuilder initializeOn: self.
	title := aTitleAsString.
	rawView := aView.
	aView title: title.

	"Not strictly necessary apparently"
	aView zOrdering: self zOrdering.
		
	shouldHavePopup := true.
	menu := OrderedCollection new.

	self initFrame.
	
	viewStack := ROViewStack new addView: rawView; title: rawView title.
	self setNodeShapeIfNecessary.
	self setUpSize.
	self setUpInteraction.
	self horizontalLineLayout.
	self popupText
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 10/2/2012 20:15'!
interaction
	"For compatibility with Mondrian"! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 12/17/2012 21:31'!
item: titleAsString action: aBlockOrSymbol
	"aBlockOrSymbol accepts an object model, and not the element
	"
	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :n | n @ (ROMenuActivable new item: titleAsString action: [ :element | aBlockOrSymbol roValue: element model ]) ] ]! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 16:54'!
lastFrame
	^ structureTree last! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 7/25/2012 10:05'!
layout: aLayout
	currentFrame layout: aLayout.
	^ aLayout ! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'TudorGirba 7/29/2012 23:22'!
lookup: anObject
	"Return the node that has the object as model"
	
	| ans |
	ans := self raw elementsSuchThat: [ :n | n isEdge not and: [n model = anObject ] ].
	ans isEmpty ifTrue: [ ^ self nestedLookup: anObject ].
	ans size ~= 1 ifTrue: [ self error: 'Several candidates' ].
	^ ans first! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'JurajKubelka 4/2/2013 10:20'!
narrowTreeLayout

	^ self layout: ROVerticalNarrowTreeLayout new.! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlejandroInfante 4/15/2013 13:59'!
needToSetup
	^ self getShape isNil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:19'!
nestedLookup: anObject
	"Return the node that has the object as model, it goes "
	
	self raw elementsDo: [ :el | 
		| t |
		t := self nestedLookup: anObject in: el.
		t ifNotNil: [ ^ t ] ].
	^ nil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
nestedLookup: anObject in: aNode
	"Return the node that has the object as model, it goes "
	
	| ans |
	(aNode model = anObject)
		ifTrue: [ ^ aNode ].
		
	aNode elementsDo: [ :n | 
		| t |
		t := self nestedLookup: anObject in: n.
		t ifNotNil: [ ^ t ] ].
	
	^ nil. 
		! !

!ROMondrianViewBuilder methodsFor: 'util' stamp: 'AlexandreBergel 9/20/2012 12:08'!
newCenteredLabel
	^ ROCenteredLabel new color: self defaultTextColor; yourself! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 7/14/2012 15:51'!
noLayout
	^ self layout: RONullLayout
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 8/20/2012 09:12'!
noPopup 

	selfDefinedInteraction add: [ :listOfElements | 
		listOfElements do: [ :element | element removeInteraction: ROAbstractPopup ] ].! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 4/7/2013 00:16'!
node: object
	"Add a new node to the view"
	^ (self nodes: (Array with: object)) first! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
node: object forIt: aBlock
	^ (self nodes: (Array with: object) forEach: [ :v | aBlock value ]) first! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:18'!
nodes
	^ self raw elementsSuchThat: [ :v | v class == ROElement ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'JurajKubelka 4/25/2013 17:22'!
nodes: objects
	| els |
	self assert: [ objects isCollection] description: 'Should provide a collection as parameter'.
		
	self prepareForNewNode.
	
	els := ROElement forCollection: objects.

	els do: [ :el | 
		el + self getShape chainedCopy @ RODraggable. 
		el resizeStrategy: parentBehavior ].
	
	selfDefinedInteraction do: [:int | int value: els ].
	
	
	self assert: [ els allSatisfy: [ :e | e model notNil ] ].
	rawView addAll: els.
	self unsetShape.
	
	selfDefinedInteraction := OrderedCollection new.
	self popupText. "Make sure the next nodes have a popup"

	currentFrame addElements: els.
	
	^ els! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 4/29/2013 16:39'!
nodes: objects forEach: aBlock
	"Create a set of nodes, each representing an element of objects. Each node then acts as a view on its own."

	| nodes oldResizeStrategy |
	nodes := self nodes: objects.
		
	nodes do: [ :n | 
		self push.
		self horizontalLineLayout.
		
		rawView := n.
		selfDefinedInteraction := OrderedCollection new.
		self popupText.
		
		oldResizeStrategy := n resizeStrategy.
		n resizeStrategy: (ROPermissiveParent new padding: oldResizeStrategy padding).
		aBlock roValue: n model.
		n resizeStrategy: oldResizeStrategy.
		
		n adjustSizeIfNecessary.
		self pop.
		 ].
	self unsetShape.
	^ nodes! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
nodesAndEdges
	^ rawView elementsSuchThat: [ :v | true ]! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: 'AlexandreBergel 4/30/2012 19:53'!
nodraggable
	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | node removeInteraction: RODraggable ] ]! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/9/2012 07:33'!
numberOfDefinedInteractions
	"Used essentially for debugging purpose"

	^ selfDefinedInteraction size! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 18:05'!
numberOfFrames
	"number of children of the root node"

	^ structureTree numberOfFrames! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
on: event do: block
	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node on: event do: block ] ]! !

!ROMondrianViewBuilder methodsFor: 'opening' stamp: 'VanessaPena 1/5/2013 12:50'!
open
	"Open the view. Return the system window opened"

	| whiteBox realView win |
	win := viewStack open.
	self applyLayout.
	
	self populateMenuOn: viewStack.
	^ win
	! !

!ROMondrianViewBuilder methodsFor: 'opening' stamp: 'VanessaPena 1/5/2013 12:50'!
openInWindowSized: extent
	"Open the view. Return the system window opened"

	| whiteBox realView win |
	win := viewStack openInWindowSized: extent.
	self applyLayout.

	self populateMenuOn: viewStack.
	^ win
	! !

!ROMondrianViewBuilder methodsFor: '*Roassal-Algorithm' stamp: 'MathieuDehouck 4/10/2013 09:43'!
orthoHorizontalLine

	shape := ROOrthoHorizontalLineShape new.
	self color: self defaultLineColor.
	^ shape! !

!ROMondrianViewBuilder methodsFor: '*Roassal-Algorithm' stamp: 'MathieuDehouck 4/10/2013 09:43'!
orthoVerticalLine

	shape := ROOrthoVerticalLineShape new.
	self color: self defaultLineColor.
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlejandroInfante 4/15/2013 14:00'!
pop

	rawView := currentFrame view.
	self setShape: currentFrame shape.
	selfDefinedInteraction := OrderedCollection new.

	currentFrame := currentFrame parent! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 9/29/2012 15:26'!
populateMenuOn: aStackView
	| labels |
	labels := OrderedCollection new. 
	menu do: [ :assoc |
		| label |
		label := ROElement labelOn: assoc key.
		label @ ROLightlyHighlightable lightGray + ROBorder gray + ROBox white. 
		label on: ROMouseLeftClick do: [ :event | 
			ROUnhighlightElement on: label.
			label view signalUpdate.
			
			assoc value roValue: aStackView ].
		aStackView add: label.
		labels add: label ].
	
	ROHorizontalLineLayout on: labels.! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:40'!
popupText
	^ self popupText: [ :v | (v class == 'ab' class) ifTrue: [ v ] ifFalse: [ v printString ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/9/2012 08:24'!
popupText: aBlockOrSelector

	^ self  popupView: [ :entity :myView | 
		myView shape rectangle.
		myView node: entity forIt: [ 
			myView shape label.
			myView node: (aBlockOrSelector roValue: entity)
		] 
	]
"	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			| int |
			int := ROPopup text: aBlockOrSelector.
			int receivingView: stack.
			int textColor: Color black.
			node changeInteraction: ROAbstractPopup for: int.
			 ] ]
		
	"
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/6/2012 13:36'!
popupView: aTwoArgsBlock
	"aTwoArgsBlock is in the form [ :entity :myView |  ... ]"
	
	^ self popupView: aTwoArgsBlock delay: 100
! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 9/20/2012 15:58'!
popupView: aTwoArgsBlock delay: delayAsInteger
	"aTwoArgsBlock is in the form [ :entity :myView |  ... ]"

	selfDefinedInteraction add: [ :listOfElements | 
		listOfElements do: [ :element | 
			element changeInteraction: ROAbstractPopup for: 
				(ROPopupView new 
					 receivingView: viewStack;
					view: [ :entity | 
						| v |
						v := self class new.
						aTwoArgsBlock value: entity model value: v.
						v applyLayout.
						v ] ) ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 8/20/2012 09:09'!
prepareForNewEdge

	self needToSetup ifTrue: 
		[self setUpSize.
		self setLineShapeIfNecessary ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 5/21/2012 23:59'!
prepareForNewNode

	self needToSetup ifTrue: 
		[ self setUpSize.
		  self setNodeShapeIfNecessary ].
	parentBehavior ifNil: [ parentBehavior := ROExtensibleParent instance ]
! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 17:32'!
prepareStack
	structureTree isEmpty ifTrue: [ self push ]! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlejandroInfante 4/15/2013 14:00'!
push
	
	| newFrame |
	newFrame := ROMondrianFrame new.
	newFrame  view: rawView.
	newFrame shape: self getShape.
	newFrame interactions: selfDefinedInteraction.
	
	currentFrame addChild: newFrame.
	newFrame parent: currentFrame.
	
	currentFrame := newFrame.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 4/18/2013 09:11'!
radialNarrowTreeLayout
	
	^ self layout: RONarrowRadialTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 4/18/2013 09:11'!
radialTreeLayout
	
	^ self layout: RORadialTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
raw
	^ rawView! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 22:48'!
rawEdgeFromAssociation: assoc
	| from to |
	from := self lookup: assoc key.
	to := self lookup: assoc value.
	(from isNil or: [ to isNil ])
		ifTrue: [ ^ nil ].
	^ self buildEdgeFrom: from to: to for: assoc! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 12/1/2012 17:39'!
rawEdges: objects from: symbolOrBlockFrom to: symbolOrBlockTo
	| edges alreadyCreatedEdges |
	edges := OrderedCollection new.
	alreadyCreatedEdges := IdentityDictionary new.
	self prepareForNewEdge.

	objects 
		do: [ :obj | 
			| from to |
			from := self lookup: (symbolOrBlockFrom roValue: obj).
			to := self lookup: (symbolOrBlockTo roValue: obj).
			((from notNil and: [ to notNil ]) and: [ from ~~ to ])
				ifTrue: [ 
					alreadyCreatedEdges at: from model ifAbsentPut: [ IdentitySet new ].
					
					((alreadyCreatedEdges at: from model) includes: to model) not
						ifTrue: [ 
							(alreadyCreatedEdges at: from model) add: to model.
							edges add: (self buildEdgeFrom: from to: to for: obj) ] ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgesFrom: symbolOrBlockFrom
	^ self rawEdgesFrom: symbolOrBlockFrom to: #yourself! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 4/24/2013 09:37'!
rawEdgesFrom: symbolOrBlockFrom to: symbolOrBlockTo
       | edges |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	rawView
		elementsNotEdge do: [ :el |
			rawView
				elementsNotEdge do: [ :el2 |
					self assert: [ el model notNil ].
					self assert: [ el2 model notNil ].
					(symbolOrBlockFrom roValue: el model) = (symbolOrBlockTo roValue:
el2 model)
						ifTrue: [
							el ~~ el2
								ifTrue: [ edges add: (self buildEdgeFrom: el2 to: el for: el2
model) ] ] ] ].
	self unsetShape.
	^ edges
! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'JurajKubelka 5/3/2013 12:54'!
rawEdgesToAll: symbolOrBlock
	| edges values v |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	rawView
		elementsDo: [ :el | 
			values := symbolOrBlock roValue: el model.
			rawView
				elementsDo: [ :el2 | 
					v := values detect: [ :n | n == el2 model ] ifNone: [ nil ].
					v ifNotNil: [ edges add: (self buildEdgeFrom: el to: el2 for: el2) ] ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:33'!
removeAllEdgesFrom: anObject

	|edges|
	edges := (self elementFromModel: anObject) allEdgesFrom.
	edges do: [ :ed |
		(currentFrame frameOfElement: ed) removeElement: ed.
		ed remove.
		 ].
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:35'!
removeAllEdgesFromNodes: objects

	objects do:[:ob |
			self removeAllEdgesFrom: ob 
		].
! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:33'!
removeAllEdgesTo: anObject

	|edges|
	edges := (self elementFromModel: anObject) allEdgesTo.
	edges do: [ :ed |
		(currentFrame frameOfElement: ed) removeElement: ed.
		ed remove.
		 ].
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'VanessaPena 4/12/2013 12:35'!
removeAllEdgesToNodes: objects

	objects do:[:ob |
			self removeAllEdgesTo: ob 
		].
! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 11:42'!
removeNode: anObject

	self removeNodes: (Array with: anObject)
! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 11:43'!
removeNodes: objects

	|elements|
	self assert: [ objects isCollection] description: 'Should provide a collection as parameter'.
	elements := self raw elementsFromModels: objects.
	currentFrame removeElements: elements.
	elements do: [:el | 
		el remove ].
	! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'VanessaPena 4/12/2013 13:22'!
removeNodesAndEdgesOf: objects

	self removeAllEdgesFromNodes: (2 to: 4). 
	self removeAllEdgesToNodes: (2 to: 4).
	self removeNodes: (2 to: 4).! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
root
	^ self ! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 09:04'!
scatterPlotLayout
	
	^ self layout: ROScatterplotLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlejandroInfante 4/15/2013 14:37'!
setEdgesAttachPoint: attachPointClass
	
	self edges do: [ :ed | 
		(ed isShapedAs: ROShape) 
			ifTrue: [
				(ed getShape: ROShape) attachPoint: attachPointClass instance ]
			ifFalse: [ ROLine new color: self shape color; attachPoint: attachPointClass instance ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlejandroInfante 4/15/2013 14:01'!
setLineShapeIfNecessary
	"If no shape for edge is defined, then we set up a default one"

	self getShape ifNil: [ self shape line ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlejandroInfante 4/15/2013 14:01'!
setNodeShapeIfNecessary
	"If no shape for node is defined, then we set up a default one"

	self getShape ifNil: [ self shape rectangle ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:15'!
setShape: aShape
	self shape setShape: aShape.! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 4/30/2012 17:22'!
setUpInteraction
	selfDefinedInteraction := OrderedCollection new.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 14:09'!
setUpSize
"	width := self defaultWidth.
	height := self defaultHeight"! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:14'!
shape
	^shape.! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:02'!
shape: aShape
	self setShape: aShape! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 11:38'!
stack
	^ viewStack! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 11:38'!
stack: aStack
	"This method is essentially used in the VW Easel. It should not be existing actually"
	viewStack := aStack! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 16:36'!
structureTree
	^ structureTree! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:00'!
sugiyamaLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^ self layout: ROSugiyamaLayout new
	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title
	"Return a string"
	
	^ title! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title: aString
	"Define the title of the view"

	title := aString! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
toPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:10'!
treeLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^ self layout: ROTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlejandroInfante 4/15/2013 14:02'!
unsetShape
	self setShape: nil.
	self setUpSize.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
verticalLineLayout
	^ self layout: ROVerticalLineLayout new.
	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 18:38'!
view
	"This method is made to have the builder, roelement and roview polymorphic. Useful in the class ROPopupView"

	^ self raw! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
view: aView
	rawView := aView! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/30/2012 17:23'!
withPopup 
	shouldHavePopup := true! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: 'AlexandreBergel 11/3/2012 20:32'!
withoutBackground! !

!ROMondrianViewBuilder methodsFor: 'zOrdering' stamp: 'AlexandreBergel 12/13/2012 18:13'!
zOrdering

	^ (ROZOrdering new
			setZIndex: [:edge | ((edge source depth * 2) max: (edge target depth * 2)) - 1 ] if: #isEdge;
			setZIndex: [ :element | element depth * 2 ] if: #isNotEdge).! !

ROObject subclass: #RONAbstractNormalizer
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONAbstractNormalizer subclass: #ROMultipleColorLinearNormalizer
	instanceVariableNames: 'normalizers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!ROMultipleColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors

	^ self new valueRange: anArrayOfNumbers colorRange: anArrayOfColors! !

!ROMultipleColorLinearNormalizer methodsFor: 'private-accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
detectNormalizerFor: aValue

	normalizers keysAndValuesDo: [:range :norm |
		(range rangeIncludes: aValue)
			ifTrue: [^ norm] ].
	self error: aValue asString, ' not in declared ranges'! !

!ROMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:05'!
initialize

	command := #yourself! !

!ROMultipleColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 18:35'!
roValue: anEntity

	| value |
	value := self command value: anEntity.
	"detect range for the value, retrieve and call corresponding normalizers"
	^ (self detectNormalizerFor: value) roValue: value! !

!ROMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/4/2012 01:06'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors
	" {1. 2. 3} {Color red. Color yellow. Color green}"
	
	| size start end |
	normalizers := Dictionary new.
	self assert: anArrayOfNumbers size = anArrayOfColors size.
	size := anArrayOfNumbers size.
	1 to: size - 1 do: [ :i |
		start := anArrayOfNumbers at: i.
		end :=  anArrayOfNumbers at: i + 1.
		normalizers
			at: (start to: end)
			put: (RONColorLinearNormalizer
						inContext: (Array with: start with: end)
						lowColor: (anArrayOfColors at: i)
						highColor: (anArrayOfColors at: i + 1))
	].
! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
command
	
	^command! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
command: aBlock
	
	command := aBlock! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:13'!
roValue: anEntity
	
	self subclassResponsibility! !

RONAbstractNormalizer subclass: #RONIdentityNormalizer
	instanceVariableNames: 'dictionary colorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONIdentityNormalizer subclass: #RONExplicitIdentityNormalizer
	instanceVariableNames: 'colors defaultColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONExplicitIdentityNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
withCommand: aBlock withColors: aCollection withDefaultColor: aColor
	
	^(self withCommand: aBlock)
		colors: aCollection;
		defaultColor: aColor;
		yourself! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
colors
	
	^colors! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
colors: anObject
	
	colors := anObject! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
defaultColor
	
	^defaultColor! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
defaultColor: anObject
	
	defaultColor := anObject! !

!RONExplicitIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/4/2012 00:21'!
nextColor
	
	colorIndex := colorIndex + 1.
	^colorIndex > self colors size
		ifTrue: [ self defaultColor ]
		ifFalse: [ self colors at: colorIndex ]! !

!RONIdentityNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/14/2012 10:43'!
beginingAtBlue
	^ self new
			setIndexTo: #blue;
			yourself! !

!RONIdentityNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/14/2012 10:40'!
beginingAtRed
	^ self new
			setIndexTo: #red;
			yourself! !

!RONIdentityNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
withCommand: aBlock
	
	^(self new)
		command: aBlock;
		yourself! !

!RONIdentityNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:05'!
initialize
	
	super initialize.
	colorIndex := 0.
	dictionary := IdentityDictionary new.
	command := #yourself! !

!RONIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 16:05'!
nextColor
	
	colorIndex := colorIndex \\ Color colorNames size + 1.
	^Color perform: (Color colorNames at: colorIndex)! !

!RONIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:12'!
roValue: anEntity
	
	^dictionary
		at: (command roValue: anEntity)
		ifAbsentPut: [ self nextColor ]! !

!RONIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/14/2012 10:42'!
setIndexTo: colorAsSymbol
	"colorAsSymbol has to be one of Color colorNames. 
	The method set the current index to the color given in parameter"
	
	colorIndex := (Color colorNames indexOf: colorAsSymbol) - 1! !

RONAbstractNormalizer subclass: #RONLinearNormalizer
	instanceVariableNames: 'maximumValue context minimumValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONLinearNormalizer subclass: #RONColorLinearNormalizer
	instanceVariableNames: 'minBrightness maxBrightness lowColor highColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!RONColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!RONColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!RONColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!RONColorLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 16:06'!
blend: aColor with: aColorValue weight: wt
	"Answer a new ColorValue which is a weighted blend of the receiver and the
	supplied ColorValue."
	"Simply interpolates in RGB space."

	| rv gv bv invWt |
	
	invWt := 1-wt.
	rv := ((aColor red * invWt) + ((aColorValue red)*wt)) "rounded".
	gv := ((aColor green  * invWt) + ((aColorValue green)*wt)) "rounded".
	bv := ((aColor blue *invWt)+ ((aColorValue blue)*wt)) "rounded".
	^Color r: rv g: gv b: bv! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
highColor: aBlock
	
	highColor := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
highColorFor: anEntity
	
	^highColor roValue: anEntity! !

!RONColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:06'!
initialize
	
	super initialize.
	lowColor := Color white.
	highColor := Color black! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
lowColor: aBlock
	
	lowColor := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
lowColorFor: anEntity
	
	^lowColor roValue: anEntity! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
maxBrightness: aBlock
	
	maxBrightness := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
maxBrightnessFor: anEntity
	
	^maxBrightness isNil
		ifTrue: [1.0]
		ifFalse: [maxBrightness roValue: anEntity]! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
minBrightness: aBlock
	
	minBrightness := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
minBrightnessFor: anEntity
	
	^minBrightness isNil
		ifTrue: [0.0]
		ifFalse: [minBrightness roValue: anEntity]! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:14'!
roValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| myValue myHighColor myLowColor myMinBrightness myMaxBrightness weight minValue maxValue |
	"Get color specific data"
	minValue :=  self minimumValue: anEntity.
	maxValue :=  self maximumValue: anEntity.
	myMinBrightness := self minBrightnessFor: anEntity.
	myMaxBrightness := self maxBrightnessFor: anEntity.
	myHighColor := self highColorFor: anEntity.
	myLowColor := self lowColorFor: anEntity.	"Get data"
	weight := minValue = maxValue 
		ifTrue: [(myMinBrightness + myMaxBrightness) / 2]
		ifFalse: [	
			myValue := (self command value: anEntity) - (self minimumValue: anEntity).
			myMinBrightness + (myValue abs / (maxValue - minValue) * (myMaxBrightness - myMinBrightness)) ].
	^self blend: myLowColor with: myHighColor weight: weight! !

RONLinearNormalizer subclass: #RONFontLinearNormalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONFontLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:12'!
roValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| value |
	value := self command roValue: anEntity.
	^5 + (38 * (value abs / (self maximumValue: anEntity))) asInteger! !

!RONLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection
	
	^self inContext: aCollection withCommand: #yourself! !

!RONLinearNormalizer class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock
	
	^(self new)
		context: aCollection;
		command: aBlock;
		yourself! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
command: aBlock
	
	super command: aBlock.
	self flushCache! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
context
	
	^context! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
context: aContext
	
	context := aContext.
	self flushCache! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
flushCache
	
	maximumValue := nil! !

!RONLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:06'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	maximumValue := nil! !

!RONLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/3/2012 00:12'!
maximumValue: anEntity
	"Returns the largest value that the color metric provides"
	
	maximumValue isNil
		ifTrue:
			[maximumValue := (self context roValue: anEntity)
				inject: 1
				into:
					[:maximum :entity | maximum max: (self command roValue: entity)]].
	^maximumValue! !

!RONLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/4/2012 00:15'!
minimumValue: anEntity
	"Returns the smallest value that the color metric provides"
	
	minimumValue isNil
		ifTrue:
			[minimumValue := (self context roValue: anEntity)
				inject: 100000000000 
				into:
					[:minimum :entity | minimum min: (self command roValue: entity)]].
	^minimumValue! !

RONLinearNormalizer subclass: #RONumberLinearNormalizer
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONumberLinearNormalizer methodsFor: 'initialization' stamp: 'AlexandreBergel 7/2/2012 16:07'!
initialize
	super initialize.
	scale := 1! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:13'!
roValue: anEntity
	"Normalize value based on maximum value."
	
	| value |
	value := self command roValue: anEntity.
	^ ((value abs / (self maximumValue: anEntity)) asFloat * self scale) asInteger! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:07'!
scale
	^ scale! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:07'!
scale: anObject
	scale := anObject! !

RONLinearNormalizer subclass: #ROValueLinearNormalizer
	instanceVariableNames: 'minScale maxScale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:19'!
initialize

	super initialize.
	minScale := 0.
	maxScale := 1.! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:19'!
maxScale

	^maxScale.! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:20'!
maxScale: aValue

	^maxScale := aValue.! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:20'!
minScale

	^minScale.! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:20'!
minScale: aValue

	minScale := aValue.! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:20'!
roValue: anEntity
	
	"Normalize value based on minimum and maximum value."
	| value slope |
	value := self command roValue: anEntity.
	slope := self slope: anEntity.
	^ ((value abs * slope) + self maxScale - ((self maximumValue: anEntity) asFloat * slope)) asInteger! !

!ROValueLinearNormalizer methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 15:20'!
slope: anEntity
	
	^ (maxScale - minScale) / ((self maximumValue: anEntity) asFloat - (self minimumValue: anEntity )asFloat).! !

ROObject subclass: #RONativeExampleUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:48'!
current
	^self allSubclasses first ! !

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:50'!
getMethodsForClass: aClass
	^self subclassResponsibility ! !

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:51'!
substringsFor: aString
	^self subclassResponsibility ! !

ROObject subclass: #RONativeWidgetFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeWidgetFactory commentStamp: 'AlexandreBergel 4/23/2012 17:31' prior: 0!
RONativeWidgetFactory is useful to create a ROMorph or ROVWVisual, depending on where the platform is running!

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/23/2012 17:34'!
current
	^ self subclasses first! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 18:38'!
forView: aView
	"Return an instance of ROMorph of ROVWVisual without opening the window. "
	
	self subclassResponsibility! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:07'!
forView: aView windowSized: aPoint
	"Return an instance of ROMorph of ROVWVisual and open the window. This depends on which platform it is run"
	
	self subclassResponsibility! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:09'!
menuForAssociations: associations on: element
	"associations is a list of association following: #aSymbol -> [ :model | ... ]
	The block contains in the association is evaluated with the model provided by the element."
	
	self subclassResponsibility! !

!ROObject class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/24/2012 17:52'!
new
	^ self basicNew initialize! !

!ROObject methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/17/2012 20:19'!
initialize! !

ROObject subclass: #ROPlatform
	instanceVariableNames: 'name canvasClass timeOrganizerClass fontOrganizerClass widgetFactory hostVisualElement svgExporterClass imageExporterClass htmlExporterClass serializerClass randomClass newLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-PlatformIndependent'!

ROPlatform class
	instanceVariableNames: 'current platforms'!

!ROPlatform commentStamp: '<historical>' prior: 0!
A ROPlatform enable to have different canvas rending. For example having athens, morphic or cairo.
!

ROPlatform class
	instanceVariableNames: 'current platforms'!

!ROPlatform class methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 15:38'!
add: aPlatform
	aPlatform check.
	
	self platforms at: aPlatform name put: aPlatform ! !

!ROPlatform class methodsFor: 'public' stamp: 'DR 1/16/2013 18:58'!
current
	current ifNil: [current := self subclasses first new].
	^ current! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 7/25/2012 15:17'!
names
	^ nil! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 7/25/2012 15:36'!
numberOfPlatforms
	^ self  platforms size ! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 7/25/2012 15:18'!
platforms
	^ platforms ifNil: [ platforms := Dictionary new ]! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 7/25/2012 15:42'!
removeNamed: aName
	self platforms removeKey: aName! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 7/25/2012 15:44'!
removeNamed: aName ifAbsent: aBlock
	self platforms removeKey: aName ifAbsent: aBlock! !

!ROPlatform class methodsFor: 'public' stamp: 'AlexandreBergel 5/6/2013 19:02'!
setCurrent: aPlatformName
	"aPlatformName is a string. Evaluate to get the possible value of aPlatformName: 
		ROPlatform platforms keys"
	current := self platforms at: aPlatformName! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:32'!
canvasClass
	^ canvasClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 15:28'!
canvasClass: aClass
	canvasClass := aClass ! !

!ROPlatform methodsFor: 'util' stamp: 'VanessaPena 12/2/2012 19:09'!
check
	self assert: [ self name class == 'abc' class ] description: 'A platform name should be a string'.
	self assert: [ self canvasClass superclass ==  ROAbstractCanvas ] description: 'A platform canvas should be a subclass of ROAbstractCanvas'.
	self assert: [ self fontOrganizerClass superclass ==  ROFontOrganizer ] description: 'A platform font organizer should be a subclass of ROFontOrganizerMorphic'.
	self assert: [ self widgetFactory superclass ==  RONativeWidgetFactory  ] description: 'A platform widget organizer should be a subclass of ROFontOrganizerMorphic'.
	self assert: [ self timeOrganizerClass superclass ==  ROTimeOrganizer  ] description: 'A platform time organizer should be a subclass of ROTimeOrganizer'.
	self assert: [ self hostVisualElement notNil ] description: 'You need to provide a host visual element (a Morph or a Visual)'.
! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:50'!
fontOrganizerClass
	^ fontOrganizerClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 16:05'!
fontOrganizerClass: aClass
	^ fontOrganizerClass := aClass! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 17:55'!
hostVisualElement
	^ hostVisualElement! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 17:58'!
hostVisualElement: visualElement
	"Typically a morph (Pharo) or a visual (VW)"
	
	hostVisualElement := visualElement! !

!ROPlatform methodsFor: 'configuration' stamp: 'VanessaPena 11/25/2012 14:52'!
htmlExporterClass 

	^ htmlExporterClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'VanessaPena 11/25/2012 14:53'!
htmlExporterClass: aClass

	htmlExporterClass := aClass ! !

!ROPlatform methodsFor: 'configuration' stamp: 'VanessaPena 11/19/2012 21:43'!
imageExporterClass 

	^ imageExporterClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'VanessaPena 11/19/2012 21:44'!
imageExporterClass: aClass
	
	imageExporterClass := aClass ! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:43'!
name
	^ name! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 15:35'!
name: aString
	name := aString! !

!ROPlatform methodsFor: 'configuration' stamp: 'DR 1/22/2013 17:08'!
newLine
	^newLine
	! !

!ROPlatform methodsFor: 'mutators' stamp: 'DR 1/22/2013 17:08'!
newLine: aString
	newLine := aString! !

!ROPlatform methodsFor: 'configuration' stamp: 'DR 1/16/2013 17:01'!
randomClass
	^ randomClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'DR 1/16/2013 17:00'!
randomClass: aClass
	^ randomClass := aClass! !

!ROPlatform methodsFor: 'util' stamp: 'AlexandreBergel 7/25/2012 15:44'!
remove
	ROPlatform removeNamed: self name ifAbsent: []! !

!ROPlatform methodsFor: 'configuration' stamp: 'VanessaPena 12/5/2012 16:21'!
serializerClass

	^serializerClass ! !

!ROPlatform methodsFor: 'mutators' stamp: 'VanessaPena 12/5/2012 16:21'!
serializerClass: aClass
	
	serializerClass := aClass ! !

!ROPlatform methodsFor: 'configuration' stamp: 'VanessaPena 11/19/2012 21:37'!
svgExporterClass 

	^ svgExporterClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'VanessaPena 11/19/2012 21:37'!
svgExporterClass: aClass
	
	svgExporterClass := aClass ! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:50'!
timeOrganizerClass
	^ timeOrganizerClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 17:10'!
timeOrganizerClass: aClass
	^ timeOrganizerClass := aClass! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:52'!
widgetFactory
	^ widgetFactory! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 16:05'!
widgetFactory: aClass
	^ widgetFactory := aClass! !

ROObject subclass: #ROSVGCanvas
	instanceVariableNames: 'stream view camera bounds stringOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROSVGCanvas class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 11/20/2012 09:31'!
onCamera: camera

		^ self new camera: camera! !

!ROSVGCanvas class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 12/2/2012 15:24'!
onCamera: camera onStream: aStream

		^ self new camera: camera; stream: aStream ! !

!ROSVGCanvas methodsFor: 'svg' stamp: 'VanessaPena 11/19/2012 21:02'!
addEnd
	
	stream
		nextPutAll: '</svg>'.! !

!ROSVGCanvas methodsFor: 'svg' stamp: 'AlexandreBergel 4/19/2013 15:50'!
addStart
	
	stream 
		nextPutAll: '<svg  xmlns="http://www.w3.org/2000/svg" ';
		nextPutAll:  ('width="<1p>px" height="<2p>px" ' expandMacrosWith: (bounds bottomRight x + 2) with: (bounds bottomRight y + 2));
		nextPutAll: ROPlatform current newLine;
		nextPut: Character tab;
		nextPutAll: 'xmlns:xlink="http://www.w3.org/1999/xlink">';
		nextPutAll: ROPlatform current newLine! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 1/31/2013 13:01'!
camera
	
	^camera! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 11/16/2012 18:17'!
camera: aCamera 

	camera := aCamera ! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:16'!
drawString: aByteString at: aPoint 
	"Render a string at a given position. No specification about the font is given. Use the default then"
	|p|
	p := camera virtualToRealPoint: aPoint + self stringOffset .
	
	stream 
		nextPutAll: '<text ';
		nextPutAll: ('x="<1p>" y="<2p>" ' expandMacrosWith: p x floor  with:  p y floor);
		nextPutAll: 'fill="black">';
		nextPutAll: aByteString ;
		nextPutAll: '</text>';
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:16'!
drawString: aByteString at: aPoint color: color
	"Render a colored string at a given position. No specification about the font is given. Use the default then"

	|p|
	p := camera virtualToRealPoint: aPoint + self stringOffset  .

	stream 
		nextPutAll: '<text ';
		nextPutAll: ('x="<1p>" y="<2p>" ' expandMacrosWith: p x floor  with:  p y floor);
		nextPutAll: ('fill="rgb(<1p>,<2p>,<3p>)">' expandMacrosWith: (color red * 256) rounded  with: (color green * 256) rounded with: (color blue * 256) rounded);
		nextPutAll: aByteString ;
		nextPutAll: '</text>';
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:17'!
drawString: aByteString at:  aPoint font: f color: color
	"Render a colored string at a given position using a particular font."
	
	|p|
	p := camera virtualToRealPoint: aPoint + self stringOffset  .

	stream 
		nextPutAll: '<text ';
		nextPutAll: ('x="<1p>" y="<2p>" ' expandMacrosWith: p x floor  with:  p y floor);
		nextPutAll: ('fill="rgb(<1p>,<2p>,<3p>)">' expandMacrosWith: (color red * 256) rounded  with: (color green * 256) rounded with: (color blue * 256) rounded);
		nextPutAll: aByteString;
		nextPutAll: '</text>';
		nextPutAll: ROPlatform current newLine.
! !

!ROSVGCanvas methodsFor: 'svg' stamp: 'DR 1/22/2013 17:17'!
endGroup

	stream 
		nextPutAll: '</g>';
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:17'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"Render an oval"
	|center w h extent r2 b|

	b := camera virtualToRealRectangle: aRectangle.
	center := b center.
	w := b width.
	h := b height.
	
	stream 
		nextPutAll: '<ellipse ';
		nextPutAll: ('cx= "<1p>" cy="<2p>" ' expandMacrosWith: center x floor  with: center y floor);
		nextPutAll: ('rx="<1p>" ry="<2p>" ' expandMacrosWith: (w/ 2) floor with: (h /2) floor);
		nextPutAll: ('style="fill:rgb(<1p>,<2p>,<3p>);' expandMacrosWith: (aColor red *256) rounded with: (aColor green * 256) rounded with: (aColor blue * 256) rounded );
		nextPutAll: ('stroke: rgb(<1p>,<2p>,<3p>);' expandMacrosWith: (aColor4 red *256) rounded with: (aColor4 green * 256) rounded with: (aColor4 blue * 256) rounded ); 
		nextPutAll: ('stroke-width: <1p>"/>' expandMacrosWith: aSmallInteger);		
		nextPutAll: ROPlatform current newLine.
! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:17'!
fillRectangle: aRectangle color: fillColor 
	"Render a rectangle"
	|b|
	
	b := camera virtualToRealRectangle: aRectangle.
	
	stream
		nextPutAll: '<rect ';
		nextPutAll: ('x="<1p>" y="<2p>"' expandMacrosWith: (b topLeft x floor) with: (b topLeft y floor) );
		nextPutAll: (' height="<1p>" width="<2p>" ' expandMacrosWith: b height with: b width);
		nextPutAll: 'style="'.
	stream
		nextPutAll: ('fill:rgb(<1p>,<2p>,<3p>)"/>' expandMacrosWith: (fillColor red * 256) rounded with: (fillColor green * 256) rounded with: (fillColor blue * 256) rounded);
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:17'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	"Render a framed rectangle. Implementation example:
	"
	
	|b|
	
	b := camera virtualToRealRectangle: aRectangle.
	
	stream
		nextPutAll: '<rect ';
		nextPutAll: ('x="<1p>" y="<2p>"' expandMacrosWith: (b topLeft x floor) with: (b topLeft y floor) );
		nextPutAll: (' height="<1p>" width="<2p>" ' expandMacrosWith: b height with: b width);
		nextPutAll: 'style="';
		nextPutAll: ('fill:rgb(<1p>,<2p>,<3p>)' expandMacrosWith: (fillColor red * 256) rounded with: (fillColor green * 256) rounded with: (fillColor blue * 256) rounded).
		aSmallInteger > 0 
			ifTrue: [
				stream 
					nextPutAll: (';stroke:rgb(<1p>,<2p>,<3p>);' expandMacrosWith: (aColor red * 256) rounded with: (aColor green * 256) rounded with: (aColor blue * 256) rounded);
					nextPutAll: ('stroke-width:<1p>" ' expandMacrosWith: aSmallInteger)
			]
			ifFalse: [stream nextPutAll: '"'].
		stream 
			nextPutAll: '/>';
			nextPutAll: ROPlatform current newLine.
	
! !

!ROSVGCanvas methodsFor: 'initialize-release' stamp: 'VanessaPena 1/31/2013 18:43'!
initialize 

	stream := WriteStream on: String new.
	stringOffset := 0@10! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'DR 1/22/2013 17:18'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	"Draw a line between two points"
	"Implementation example
		canvas line: (self virtualToRealPoint: aPoint) to: (self virtualToRealPoint: aPoint2) width: aSmallInteger color: aColor.

	"
	|p1 p2|
	
	p1 := camera virtualToRealPoint: aPoint.
	p2 := camera virtualToRealPoint: aPoint2.
	
	stream 
		nextPutAll: '<line ';
		nextPutAll: ('x1="<1p>" y1="<2p>" ' expandMacrosWith: p1 x floor  with:  p1 y floor);
		nextPutAll: ('x2="<1p>" y2="<2p>" ' expandMacrosWith: p2 x floor with: p2 y floor );
		nextPutAll: ('style="stroke:rgb(<1p>,<2p>,<3p>);' expandMacrosWith: (aColor red * 256) rounded with: (aColor green * 256) rounded with: (aColor blue * 256) rounded );
		nextPutAll: ('stroke-width:<1p>"/>' expandMacrosWith: aSmallInteger );
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'VanessaPena 11/20/2012 23:54'!
paintBackground: aColor

	self fillRectangle: view encompassingRectangle color: aColor ! !

!ROSVGCanvas methodsFor: 'hooks' stamp: 'VanessaPena 11/20/2012 17:32'!
paintImage: aForm at: aPoint
	"Render a bitmap on screen"
	"TODO"

! !

!ROSVGCanvas methodsFor: 'svg' stamp: 'DR 1/22/2013 17:18'!
startGroup

	stream 
		nextPutAll: '<g>';
		nextPutAll: ROPlatform current newLine.! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 11/16/2012 17:43'!
stream

	^stream ! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 12/2/2012 15:24'!
stream: aStream 

	stream := aStream ! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 11/20/2012 22:59'!
stringOffset

	^stringOffset! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 11/13/2012 19:18'!
view

	^view! !

!ROSVGCanvas methodsFor: 'accesing' stamp: 'VanessaPena 4/3/2013 22:04'!
view: aROView 

	view := aROView.
	bounds := view encompassingRectangle " camera virtualToRealPoint: view camera extent".! !

ROObject subclass: #ROShape
	instanceVariableNames: 'color width height colorCache widthCache heightCache next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROShape commentStamp: 'AlexandreBergel 10/15/2012 13:21' prior: 0!
A ROShape represents the graphical representation of an element.
Decorator has a color, and they are link together.

All the accessors in Mondrian's builder operates on the model.
However, outside the builder, shapes accepts roassal elements.

For example:
-=-=-=-=-=-=-=-=-=-=-=-=
testIfFillColor

        | nodes |
        view shape rectangle
                if: #odd fillColor: [ :model | model + 1];
                if: #even fillColor: [ :model | model + 10].
        nodes := view nodes: #(2 3 4 5 6).

        self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(12 4 14 6 16)
-=-=-=-=-=-=-=-=-=-=-=-=

This piece of code works only in the test since a number is not a color. But it illustrates the point.

Then fillColor: is defined as:
-=-=-=-=-=-=-=-=-=-=-=-=
ROMondrianBuilder>>fillColor: aBlockOrSymbol
        "aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

        shape color: [ :element | aBlockOrSymbol roValue: element model ]
-=-=-=-=-=-=-=-=-=-=-=-=

Something is left ugly, that I cannot easily remove:


-=-=-=-=-=-=-=-=-=-=-=-=
ROMondrianBuilder>>if: conditionBlock fillColor: colorBlock
        "If conditionBlock is evaluated at true, then colorBlock is used to set the color of the node. Both conditionBlock and colorBlock are evaluated with the model value of the node."

        | oldBlockOrValue |
        oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
        ^self fillColor: [ :aModel | (conditionBlock roValue: aModel)
                                                                        ifTrue: [ colorBlock roValue: aModel ]
                                                                        ifFalse: [
                                                                                "Having to create a new element is rather ugly.
                                                                                Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
                                                                                oldBlockOrValue roValue: (ROElement on: aModel) ]].
-=-=-=-=-=-=-=-=-=-=-=-=

Instance Variables
	color:		<Object>
	colorCache:		<Object>
	next:		<Object>

color
	- xxxxx

colorCache
	- xxxxx

next
	- xxxxx
!

ROShape subclass: #ROAbstractLabel
	instanceVariableNames: 'text textVerticalPadding textHorizontalPadding extentCache fontSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractLabel class methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/19/2013 14:01'!
isAbstract

	^ self name = #ROAbstractLabel ! !

!ROAbstractLabel methodsFor: 'visitor' stamp: 'VanessaPena 12/27/2012 13:18'!
accept: visitor

	visitor visitAbstractLabel: self! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
drawOn: aCanvas for: aROElement
	self subclassResponsibility ! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'VanessaPena 12/5/2012 13:14'!
extentFor: element

"	extentCache isNil ifTrue: [
		extentCache := (super extentFor: element) max: (self preferedExtentFor: element)].
	^extentCache"
	
	 ^(super extentFor: element) max: (self preferedExtentFor: element)! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'JurajKubelka 4/30/2013 15:16'!
fontFor: anElement

	^ self fontFor: anElement with: anElement view camera! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'JurajKubelka 4/30/2013 15:17'!
fontFor: anElement with: aCamera

	|fo|
	fo := ROPlatform current fontOrganizerClass.

	^fontSize isNil 
		ifTrue:  [ fo defaultFontForSize: fo defaultFontSize * (aCamera scale x) ]
		ifFalse: [ fo defaultFontForSize: ((self fontSizeFor: anElement) * (aCamera scale x)) ]
		! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'VanessaPena 12/23/2012 13:14'!
fontSize: aBlockOrASymbolOrAnObject

	fontSize := aBlockOrASymbolOrAnObject.! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'JurajKubelka 4/2/2013 16:14'!
fontSizeFor: anElement

	^fontSize roValue: anElement! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:33'!
heightFor: aROElement
	"Return the height for the element"
	
	^ self heightOfString: (self textFor: aROElement) for: aROElement.
	! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:32'!
heightOfString: string for: aROElement
	"Return the height of a string"
	
	^ self heightOfString: string for: aROElement with: aROElement view! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:28'!
heightOfString: string for: anElement with: aCanvas
	"Return the height of a string"
	
	| lineCount h |
	lineCount := string lineCount.
	h := (self fontFor: anElement with: aCanvas camera) height.
	^ (( h asInteger + self interlineSpace) * lineCount) + (2 * textVerticalPadding) ! !

!ROAbstractLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 9/20/2012 12:04'!
initialize 
	super initialize.
	text := #model.
	textHorizontalPadding := textVerticalPadding := 0 ! !

!ROAbstractLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 9/20/2012 12:04'!
interlineSpace
	"Space between lines in a multi-line text"

	^ 3! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'DR 1/15/2013 21:01'!
linesOf: aString
	"Return a collection of strings got from aString."
	
	| ans |
	ans := OrderedCollection new.
	aString lineIndicesDo: [:start :endWithoutDelimiters :end |
		ans add: (aString copyFrom: start to: endWithoutDelimiters)].
	^ ans asArray! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:04'!
longestTextLineFor: aROElement
	"Return the longest line for the textFor: of the element. This is use to compute the right width of the label"
	
	| lines |
	lines := self linesOf: (self textAdaptedFor: aROElement).
	lines size = 0 ifTrue: [ ^ '' ].
	^ lines inject: lines first into: [ :longest :line | 
		line size > longest size 
			ifTrue: [ line ] ifFalse: [ longest ] ]! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 3/6/2013 15:36'!
offsetWhenDrawing
	^ ROPlatform current fontOrganizerClass offsetWhenDrawing! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:04'!
preferedExtentFor: aROElement
	^ (self widthFor: aROElement) @ (self heightFor: aROElement)! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:05'!
text
	^ text! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:05'!
text: anObject
	text := anObject! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 10/15/2012 20:16'!
textAdaptedFor: anElement
	"Return the text from anElement. All the tabulation are replaced"
	
	^ (self textFor: anElement) copyReplaceAll: '	' with: '      '! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
textFor: aROElement
	 | v |
	v := (text roValue: aROElement).
	^ (v class == 'abc' class)
			ifTrue: [ v ]
			ifFalse: [ v printString ]
! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:10'!
widthFor: aROElement
	"Return the width for the element"
	
	^ self widthOfString: (self textAdaptedFor: aROElement) for: aROElement.! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 16:26'!
widthOfString: string for: anElement
	"Return the length of a string"
	
	^ self widthOfString: string for: anElement with: anElement view! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 5/6/2013 18:23'!
widthOfString: string for: anElement with: aCanvas
	"Return the length of a string"
	
	| font cols |
	font := self fontFor: anElement with: aCanvas camera.
	cols := (self linesOf: string) collect: [ :line | ROFontOrganizer current widthOfString: line font: font ].
	^ cols notEmpty
		ifTrue: [ cols inject: cols anyOne into: [ :s :e | s max: e ] ]
		ifFalse: [ 0 ]! !

ROAbstractLabel subclass: #ROCenteredLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCenteredLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:30'!
drawOn: aCanvas for: aROElement
	| str runner|
	str := self textAdaptedFor: aROElement.
	runner := 
		aROElement absolutePosition + self offsetWhenDrawing 
		+ (0 @ (aROElement height - (self heightOfString: str for: aROElement with: aCanvas) /2) ).
			
	runner := runner asIntegerPoint.
	str linesDo: [ :line | 
		| lineOffset |
		lineOffset := ( (aROElement width - (self widthOfString: line for: aROElement with: aCanvas)) / 2 ) @ 0.
		aCanvas drawString: line at: (runner + lineOffset) font: (self fontFor: aROElement with: aCanvas camera ) color: (self colorFor: aROElement ).
		runner := runner + (0 @ (self heightOfString: line for: aROElement with: aCanvas))
	]! !

ROAbstractLabel subclass: #ROLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLabel class methodsFor: 'public' stamp: 'AlexandreBergel 6/5/2012 20:22'!
defaultColor
	^ Color black! !

!ROLabel class methodsFor: 'public' stamp: ''!
text: aBlock
	^ self new text: aBlock! !

!ROLabel class methodsFor: 'public' stamp: 'JurajKubelka 4/22/2013 17:29'!
verticalText: aBlock

	^ self text: [:object | 
		String streamContents: [ :stream |
			(aBlock roValue: object) do: [ :e | stream nextPut: e ] separatedBy: [ stream nextPut: Character cr ] ] ]! !

!ROLabel methodsFor: 'rendering' stamp: 'JurajKubelka 4/30/2013 17:31'!
drawOn: aCanvas for: aROElement
	| str runner |
	str := self textAdaptedFor: aROElement.
	runner := aROElement absolutePosition + self offsetWhenDrawing.
	str
		linesDo: [ :line | 
			aCanvas
				drawString: line
				at: runner
				font: (self fontFor: aROElement with: aCanvas camera)
				color: (self colorFor: aROElement).
			runner := runner + (0 @ (self heightOfString: line for: aROElement with: aCanvas)) ]! !

ROShape subclass: #ROAbstractLine
	instanceVariableNames: 'attachPoint arrows strokeWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROAbstractLine subclass: #ROAbstractBezierCurve
	instanceVariableNames: ''
	classVariableNames: 'Recursion'
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractBezierCurve class methodsFor: 'maths' stamp: 'MathieuDehouck 4/16/2013 10:54'!
approximate: anArray in: anInteger

	| bary rightPart leftPart col |

	( anInteger <= 0 ) ifTrue: [ ^ anArray ].
	
	bary := self barycentersFor: anArray.
	col := (Array with: anArray) , bary.
	
	rightPart :=  col collect: [ :e | e first ].
	leftPart := (col collect: [ :e | e last ]) reverse .
	
	^ (self approximate: rightPart in: anInteger-1 ),(self approximate: leftPart in: anInteger-1)! !

!ROAbstractBezierCurve class methodsFor: 'maths' stamp: 'MathieuDehouck 4/12/2013 10:50'!
barycentersFor: anArray

	| barycenters bary new |
	
	barycenters := OrderedCollection new.
	bary := OrderedCollection new.
	
	(1 to: anArray size - 1) do: [ :i | bary add: ((anArray at: i) + (anArray at: i+1) /2)].
	barycenters add: bary.
	
	[ bary size > 1 ] whileTrue: [ new := OrderedCollection new.
									1 to: bary size - 1 do: [ :i | new add: ((bary at: i) + (bary at: i+1) /2) ].
									 barycenters add: new.
									bary := new].
								
	^ barycenters! !

!ROAbstractBezierCurve class methodsFor: 'testing' stamp: 'JurajKubelka 4/19/2013 14:02'!
isAbstract

	^ self name = #ROAbstractBezierCurve ! !

!ROAbstractBezierCurve methodsFor: 'rendering' stamp: 'AlexandreBergel 4/18/2013 09:21'!
drawOn: aCanvas for: anEdge

	| rawStartingPoint rawEndingPoint approx |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
		approx := self lineSegmentsFor: anEdge.
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		 ].
	
	"We draw a line after the arrow"

	1 to: approx size -1 do: [ :i | aCanvas line: (approx at: i) to: (approx at: i+1) width: (strokeWidth roValue: anEdge) color: (color roValue: anEdge) ]! !

!ROAbstractBezierCurve methodsFor: 'initialize' stamp: 'MathieuDehouck 4/16/2013 10:55'!
initialize 

	super initialize.
	
	Recursion := 4! !

!ROAbstractBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/12/2013 10:24'!
lineSegmentsFor: anEdge

	self subclassResponsibility ! !

ROAbstractBezierCurve subclass: #RORadialBezierCurve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RORadialBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/16/2013 11:01'!
lineSegmentsFor: anEdge 

	| startingPoint endingPoint firstControl secondControl gap |
	
	startingPoint := anEdge from position.
	(startingPoint = (0@0)) ifTrue: [ ^ ROLine new lineSegmentsFor: anEdge ].
	
	startingPoint := attachPoint startingPointOf: anEdge.
	endingPoint := attachPoint endingPointOf: anEdge.
	
	gap := endingPoint r - startingPoint r.
	
	(startingPoint r = 0) ifTrue: [ firstControl := Point radius: 0 + (gap/2) theta: endingPoint theta. ] 
						ifFalse: [ firstControl := Point radius: startingPoint r + (gap/2) theta: startingPoint theta. ].
	
	secondControl := Point radius: endingPoint r - (gap/2) theta: endingPoint theta.
	
	^ self class approximate: (Array with: startingPoint with: firstControl with: secondControl with: endingPoint ) in: Recursion! !

!ROAbstractLine class methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2013 12:50'!
elementFrom: fromElement to: toElement
	^ self new elementFrom: fromElement to: toElement! !

!ROAbstractLine class methodsFor: 'testing' stamp: 'JurajKubelka 4/19/2013 14:01'!
isAbstract

	^ self name = #ROAbstractLine ! !

!ROAbstractLine class methodsFor: 'testing' stamp: 'JurajKubelka 4/19/2013 14:53'!
isEdgeShape

	^ true! !

!ROAbstractLine methodsFor: 'visitor' stamp: 'VanessaPena 1/31/2013 17:59'!
accept: visitor

	visitor visitAbstractLine: self
! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
add: aROArrow 
	arrows add: aROArrow! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
add: aROArrow offset: aNumber 
	aROArrow offset: aNumber.
	self add: aROArrow! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
addBegining: aROArrow 
	self add: aROArrow offset: 0! !

!ROAbstractLine methodsFor: 'accessing' stamp: ''!
attachPoint
	
	^ attachPoint! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 05:56'!
attachPoint: attach
	
	attachPoint := attach! !

!ROAbstractLine methodsFor: 'testing' stamp: 'miltonmamani 4/17/2013 15:22'!
contains: aPoint for: anEdge
	"Return true if aPoint is contained in at least one of the line segments"

	| segments index | 
	segments := self lineSegmentsFor: anEdge.
	segments isEmpty ifTrue: [ ^ false ].
	index := segments first.
	segments allButFirst do: [ :p |
		(aPoint onLineFrom: index to: p within: 2) 
			ifTrue: [ ^ true].
		index := p.
	 ].	
	^ false! !

!ROAbstractLine methodsFor: 'hooks' stamp: 'AlexandreBergel 9/4/2012 12:53'!
defaultShape 
	^ RONullShape new! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'TudorGirba 7/29/2012 21:58'!
defaultWidth
	^ 1! !

!ROAbstractLine methodsFor: 'rendering' stamp: 'AlexandreBergel 11/28/2012 22:25'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint |		
			
	rawEndingPoint  := (self startingPointOf: anEdge).
	rawStartingPoint := (self endingPointOf: anEdge).
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		aCanvas 
			line: rawStartingPoint 
			to: arr first 
			width: (self widthFor: anEdge) 
			color: (self colorFor: anEdge).
		rawStartingPoint := arr second.
		 ].
	
	"We draw a line after the arrow"
	aCanvas line: rawStartingPoint to: rawEndingPoint width: (self widthFor: anEdge) color: (self colorFor: anEdge).
! !

!ROAbstractLine methodsFor: 'public' stamp: 'miltonmamani 4/16/2013 17:55'!
elementFrom: fromElement to: toElement
	"Easy way to create element from a shape"
	
	^ (ROEdge from: fromElement to: toElement) + self! !

!ROAbstractLine methodsFor: 'public' stamp: 'AlexandreBergel 4/7/2013 01:02'!
elementOn: object
	"Easy way to create element from a shape"
	
	^ (ROEdge on: object) + self! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 12/11/2012 05:20'!
endingPointOf: anEdge
	 ^ attachPoint endingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'testing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
hasArrow
	"True if some arrows have been added"
	
	^ arrows isNil or: [ arrows notEmpty ]! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:40'!
initialize
	super initialize.
	attachPoint := ROShorterDistanceAttachPoint instance.
	strokeWidth := self defaultWidth.
	arrows := OrderedCollection new! !

!ROAbstractLine methodsFor: 'hooks' stamp: 'AlexandreBergel 8/23/2012 22:41'!
lineSegmentsFor: anEdge
	self subclassResponsibility ! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
numberOfArrows
	"Answer the number of arrows the edge contains"
	
	^ arrows size ! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 12/11/2012 05:17'!
startingPointOf: anEdge
	^ attachPoint startingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:40'!
width
	^ strokeWidth! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:40'!
width: aNumber
	strokeWidth := aNumber! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2012 19:09'!
widthFor: anEdge
	^ self width roValue: anEdge! !

ROAbstractLine subclass: #ROBezierCurve
	instanceVariableNames: ''
	classVariableNames: 'Recursion'
	poolDictionaries: ''
	category: 'Roassal-Algorithm'!

ROBezierCurve class
	instanceVariableNames: 'strategy'!

ROBezierCurve class
	instanceVariableNames: 'strategy'!

!ROBezierCurve class methodsFor: 'maths' stamp: 'MathieuDehouck 4/16/2013 10:54'!
approximate: anArray in: anInteger

	| bary rightPart leftPart col |

	( anInteger <= 0 ) ifTrue: [ ^ anArray ].
	
	bary := self barycentersFor: anArray.
	col := (Array with: anArray) , bary.
	
	rightPart :=  col collect: [ :e | e first ].
	leftPart := (col collect: [ :e | e last ]) reverse .
	
	^ (self approximate: rightPart in: anInteger-1 ),(self approximate: leftPart in: anInteger-1)! !

!ROBezierCurve class methodsFor: 'maths' stamp: 'MathieuDehouck 4/12/2013 10:50'!
barycentersFor: anArray

	| barycenters bary new |
	
	barycenters := OrderedCollection new.
	bary := OrderedCollection new.
	
	(1 to: anArray size - 1) do: [ :i | bary add: ((anArray at: i) + (anArray at: i+1) /2)].
	barycenters add: bary.
	
	[ bary size > 1 ] whileTrue: [ new := OrderedCollection new.
									1 to: bary size - 1 do: [ :i | new add: ((bary at: i) + (bary at: i+1) /2) ].
									 barycenters add: new.
									bary := new].
								
	^ barycenters! !

!ROBezierCurve class methodsFor: 'testing' stamp: 'MathieuDehouck 4/29/2013 11:07'!
isAbstract

	^ self name = #ROBezierCurve ! !

!ROBezierCurve class methodsFor: 'testing' stamp: 'MathieuDehouck 4/29/2013 10:46'!
orthoHorizontal
"set the strategy to orthoHorizontal"

	strategy := 'orthoHorizontal'! !

!ROBezierCurve class methodsFor: 'testing' stamp: 'MathieuDehouck 4/29/2013 10:45'!
orthoVertical
"set the strategy to orthoVertical"

	strategy := 'orthoVertical'! !

!ROBezierCurve class methodsFor: 'testing' stamp: 'MathieuDehouck 4/29/2013 10:45'!
radial
"set the strategy to radial"

	strategy := 'radial'! !

!ROBezierCurve class methodsFor: 'testing' stamp: 'MathieuDehouck 4/29/2013 10:51'!
strategy

	^ strategy! !

!ROBezierCurve methodsFor: 'rendering' stamp: 'AlexandreBergel 4/18/2013 09:21'!
drawOn: aCanvas for: anEdge

	| rawStartingPoint rawEndingPoint approx |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
		approx := self lineSegmentsFor: anEdge.
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		 ].
	
	"We draw a line after the arrow"

	1 to: approx size -1 do: [ :i | aCanvas line: (approx at: i) to: (approx at: i+1) width: (strokeWidth roValue: anEdge) color: (color roValue: anEdge) ]! !

!ROBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/29/2013 11:04'!
horizontalSegmentsFor: anEdge

	| startingPoint endingPoint firstControl secondControl midx |
	
	startingPoint := attachPoint startingPointOf: anEdge.
	endingPoint := attachPoint endingPointOf: anEdge.
	
	midx := startingPoint x + endingPoint x / 2.
	
	firstControl := midx @ startingPoint y.
	secondControl := midx @ endingPoint y.
	
	^ self class approximate: (Array with: startingPoint with: firstControl with: secondControl with: endingPoint ) in: Recursion! !

!ROBezierCurve methodsFor: 'initialize' stamp: 'MathieuDehouck 4/16/2013 10:55'!
initialize 

	super initialize.
	
	Recursion := 4! !

!ROBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/29/2013 10:53'!
lineSegmentsFor: anEdge

	self class strategy = 'radial' ifTrue: [ ^ self radialSegmentsFor: anEdge ].
	
	self class strategy = 'orthoHorizontal' ifTrue: [ ^ self horizontalSegmentsFor: anEdge ].
	
	self class strategy = 'orthoVertical' ifTrue: [ ^ self verticalSegmentsFor: anEdge ]! !

!ROBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/29/2013 10:48'!
radialSegmentsFor: anEdge

	| startingPoint endingPoint firstControl secondControl gap |
	
	startingPoint := anEdge from position.
	(startingPoint = (0@0)) ifTrue: [ ^ ROLine new lineSegmentsFor: anEdge ].
	
	startingPoint := attachPoint startingPointOf: anEdge.
	endingPoint := attachPoint endingPointOf: anEdge.
	
	gap := endingPoint r - startingPoint r.
	
	(startingPoint r = 0) ifTrue: [ firstControl := Point radius: 0 + (gap/2) theta: endingPoint theta. ] 
						ifFalse: [ firstControl := Point radius: startingPoint r + (gap/2) theta: startingPoint theta. ].
	
	secondControl := Point radius: endingPoint r - (gap/2) theta: endingPoint theta.
	
	^ self class approximate: (Array with: startingPoint with: firstControl with: secondControl with: endingPoint ) in: Recursion! !

!ROBezierCurve methodsFor: 'hooks' stamp: 'MathieuDehouck 4/29/2013 11:07'!
verticalSegmentsFor: anEdge

	| startingPoint endingPoint firstControl secondControl midy |
	
	startingPoint := attachPoint startingPointOf: anEdge.
	endingPoint := attachPoint endingPointOf: anEdge.
	
	midy := startingPoint y + endingPoint y / 2.
	
	firstControl := startingPoint x @ midy.
	secondControl := endingPoint x @ midy.
	
	^ self class approximate: (Array with: startingPoint with: firstControl with: secondControl with: endingPoint ) in: Recursion! !

ROAbstractLine subclass: #ROLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLine class methodsFor: 'public' stamp: 'AlexandreBergel 4/7/2013 01:21'!
arrowed
	"Return an arrowed line"
	^ ROLine new add: (ROArrow new offset: 0)! !

!ROLine methodsFor: 'rendering' stamp: 'AlexandreBergel 8/20/2012 11:08'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		aCanvas 
			line: rawStartingPoint 
			to: arr first 
			width: (self widthFor: anEdge) 
			color: (self colorFor: anEdge).
		rawStartingPoint := arr second.
		 ].
	
	"We draw a line after the arrow"
	aCanvas line: rawStartingPoint to: rawEndingPoint width: (self widthFor: anEdge) color: (self colorFor: anEdge).
! !

!ROLine methodsFor: 'utility' stamp: 'AlexandreBergel 8/19/2012 21:01'!
lineSegmentsFor: anEdge
	| rawStartingPoint rawEndingPoint |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.

	^ Array with: rawStartingPoint with: rawEndingPoint! !

!ROLine methodsFor: 'enumerating' stamp: 'AlexandreBergel 8/20/2012 10:42'!
lineSegmentsFor: anEdge do: aTwoArgBlock

	| segments p |
	segments := self lineSegmentsFor: anEdge.
	p := segments first.
	segments allButFirst do: [ :point| 
		aTwoArgBlock value: p value: point.
		p := point
	]! !

!ROLine methodsFor: 'utility' stamp: 'AlexandreBergel 6/12/2012 15:24'!
unitFor: anEdge

	| vector toPoint fromPoint u unit |
	fromPoint := self startingPointOf: anEdge.
	toPoint := self endingPointOf: anEdge.

	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	^ unit! !

ROAbstractLine subclass: #ROOrthoHorizontalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROOrthoHorizontalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:40'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint edgeBound midx w c rawEndingPointOriginal rawStartingPointOriginal |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPointOriginal := rawEndingPoint.
	
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	rawStartingPointOriginal := rawStartingPoint.
	
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		"aCanvas line: rawStartingPoint to: arr first width: (width roValue: anEdge) color: color."
		(arrow offset = 0) 
			ifTrue: [ rawStartingPoint := arr second ] 
			ifFalse: [ rawEndingPoint := arr first ].
		 ].
	"-------- "

	edgeBound := rawStartingPointOriginal corner: rawEndingPointOriginal.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.
	w := strokeWidth roValue: anEdge.
	c := color.

	aCanvas line: rawStartingPoint to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: rawEndingPoint width: w color: c.! !

!ROOrthoHorizontalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 19:06'!
lineSegmentsFor: anEdge 		
	| rawEndingPoint rawStartingPoint edgeBound midx |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ #() ].
	
	edgeBound := rawStartingPoint corner: rawEndingPoint.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.

	^ Array 
		with: rawStartingPoint 
		with: (midx @ edgeBound origin y) 
		with: (midx @ edgeBound corner y) 
		with: rawEndingPoint ! !

ROAbstractLine subclass: #ROOrthoVerticalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROOrthoVerticalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:40'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint edgeBound midy w c rawEndingPointOriginal rawStartingPointOriginal |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPointOriginal := rawEndingPoint.
	
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	rawStartingPointOriginal := rawStartingPoint.
	
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		"aCanvas line: rawStartingPoint to: arr first width: (width roValue: anEdge) color: color."
		(arrow offset = 0) 
			ifTrue: [ rawStartingPoint := arr second ] 
			ifFalse: [ rawEndingPoint := arr first ].
		 ].
	
	"We draw a line after the arrow"
"	aCanvas line: rawStartingPoint  to:  rawEndingPoint width: (width roValue: anEdge) color: (color roValue: anEdge).
"	"-------- "

	edgeBound := rawStartingPointOriginal corner: rawEndingPointOriginal.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := strokeWidth roValue: anEdge.
	c := color.

	aCanvas line: rawStartingPoint to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: rawEndingPoint width: w color: c.! !

!ROOrthoVerticalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 19:14'!
lineSegmentsFor: anEdge 		
	| rawEndingPoint rawStartingPoint edgeBound midy |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ #() ].
	
	edgeBound := rawStartingPoint corner: rawEndingPoint.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.

	^ Array 
		with: rawStartingPoint 
		with: (edgeBound origin x @ midy) 
		with: (edgeBound corner x @ midy) 
		with: rawEndingPoint ! !

ROShape subclass: #ROBorder
	instanceVariableNames: 'strokeWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBorder commentStamp: '<historical>' prior: 0!
A ROBorder defines a border to be added to an element.

Instance Variables
	width:		Number

width
	- Width of the border!

!ROBorder class methodsFor: 'public' stamp: ''!
defaultColor
	^ Color black! !

!ROBorder methodsFor: 'visitor' stamp: 'VanessaPena 12/27/2012 13:19'!
accept: visitor

	visitor visitBorder: self! !

!ROBorder methodsFor: 'rendering' stamp: 'AlexandreBergel 12/11/2012 05:25'!
drawOn: aCanvas for: aROElement
	| topLeft extent c |
	topLeft := aROElement absolutePosition.
	extent := aROElement extent.

	c := color roValue: aROElement model.
	aCanvas 
		line: topLeft to: topLeft + (extent x @ 0) width: strokeWidth color: c.
	aCanvas 
		line: topLeft + (extent x @ 0) to: topLeft + extent width: strokeWidth color: c.
	aCanvas 
		line: topLeft + extent to: topLeft + (0 @ extent y) width: strokeWidth color: c.
	aCanvas 
		line: topLeft + (0 @ extent y) to: topLeft width: strokeWidth color: c.
! !

!ROBorder methodsFor: 'initialization' stamp: 'AlexandreBergel 10/17/2012 08:41'!
initialize 
	super initialize.
	strokeWidth := 1.
	color := self class defaultColor! !

ROShape subclass: #ROBox
	instanceVariableNames: 'borderColorCache borderColor borderWidthCache borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBox commentStamp: '<historical>' prior: 0!
A ROBox draws a box

Instance Variables
	borderColor:		<Color | BlockContext | Normalizer>
	borderColorCache:		<Color>
	borderWidth:		<Number | Block>
	borderWidthCache:		<Number>

borderColor
	- could be a block, a color or a normalizer. Used to determine the color of the element being painted
	
borderColorCache
	- used as a cache

borderWidth
	- a block or a number that represent the border width.

borderWidthCache
	- cache of the width
!

!ROBox class methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROBox methodsFor: 'visitor' stamp: 'VanessaPena 12/27/2012 13:19'!
accept: visitor

	visitor visitBox: self! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderColor
	^ borderColor! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderColor: aBlockOrSymbolOrObject
	borderColor := aBlockOrSymbolOrObject.
	! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderColorFor: element
	^ borderColor roValue: element! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderWidth
	^ borderWidth! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderWidth: aBlockOrSymbolOrObject
	borderWidth := aBlockOrSymbolOrObject.! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderWidthFor: element
	^ borderWidth roValue: element! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 12:07'!
drawOn: aCanvas for: aROElement

	aCanvas
		frameAndFillRectangle: (self absoluteBoundsFor: aROElement)
		fillColor: (self colorFor: aROElement)
		borderWidth: (self borderWidthFor: aROElement)
		borderColor: (self borderColorFor: aROElement)! !

!ROBox methodsFor: 'initialize' stamp: ''!
initialize 
	super initialize.
	borderColor := Color black.
	borderWidth := 0.! !

ROShape subclass: #ROEllipse
	instanceVariableNames: 'borderColor borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROEllipse commentStamp: '<historical>' prior: 0!
A ROCircle draws a circle!

!ROEllipse class methodsFor: 'public' stamp: ''!
color: aColor
	^ self new color: aColor! !

!ROEllipse class methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROEllipse methodsFor: 'visitor' stamp: 'VanessaPena 12/27/2012 13:20'!
accept: visitor

	visitor visitCircle: self! !

!ROEllipse methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 11:55'!
borderColor
	^ borderColor ! !

!ROEllipse methodsFor: 'rendering' stamp: 'AlexandreBergel 10/15/2012 13:12'!
borderColor: aBlockOrSymbolOrObject
	borderColor := aBlockOrSymbolOrObject.! !

!ROEllipse methodsFor: 'rendering' stamp: 'BenComan 9/16/2012 20:38'!
borderOnly
		self borderWidth: 1. 
		self borderColor: Color black.
		self color: Color transparent.
		! !

!ROEllipse methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:08'!
borderWidth
	^borderWidth 
! !

!ROEllipse methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:06'!
borderWidth: anInteger
	borderWidth := anInteger. 
! !

!ROEllipse methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 12:07'!
drawOn: aCanvas for: aROElement
	aCanvas
		fillOval: (self absoluteBoundsFor: aROElement)
		color: (color roValue: aROElement) 
		borderWidth: (borderWidth roValue: aROElement) 
		borderColor: (borderColor roValue: aROElement)! !

!ROEllipse methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:05'!
initialize
		super initialize.
		borderWidth := 0. 
		borderColor := Color black.! !

ROShape subclass: #ROImage
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROImage methodsFor: 'rendering' stamp: 'AlexandreBergel 12/13/2012 15:47'!
drawOn: aCanvas for: aROElement
	aCanvas
		paintImage: (form roValue: aROElement) at: aROElement absolutePosition 
! !

!ROImage methodsFor: 'accessing' stamp: ''!
form
	^ form! !

!ROImage methodsFor: 'accessing' stamp: ''!
form: aFormBlockOrObject
	form := aFormBlockOrObject! !

!ROImage methodsFor: 'hooks' stamp: ''!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	| p | 
	super installedOn: element.
	p := (form roValue: element) extent.
	element extent < p
		ifTrue: [ element extent: p ].
	! !

!ROImage methodsFor: 'accessing' stamp: 'AlexandreBergel 5/29/2012 10:22'!
preferedExtentFor: element
	^ (form roValue: element) extent! !

ROShape subclass: #RONullShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RONullShape commentStamp: '<historical>' prior: 0!
A RONullShape is the terminator of the shape chain. A new element will have an instance of null shape in it.!

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:02'!
addLast: aShape
	^ aShape! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:03'!
addLast: aShape in: elementToAdd

	elementToAdd next: aShape! !

!RONullShape methodsFor: 'rendering' stamp: 'AlexandreBergel 9/14/2012 19:03'!
chainedDrawOn: aCanvas for: aROElement 
	self drawOn: aCanvas for: aROElement ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:45'!
change: aShapeClass for: aShape
	^ self ! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 8/20/2012 10:03'!
contains: aPoint for: aROEdge 
	^ false! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/4/2012 12:50'!
defaultShape 
	^ RONullShape new! !

!RONullShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/24/2012 18:53'!
element: aROElement containsPoint: aPoint
	"Return true if aPoint is contained in the bounds defined by myself for the element"
	
	^ self boundsFor: aROElement containsPoint: aPoint
		! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 10/17/2012 08:45'!
extent: anExtentPoint
	width := anExtentPoint x.
	height := anExtentPoint y.! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 10/17/2012 08:45'!
extentFor: element
	^ (width roValue: element) @ (height roValue: element)! !

!RONullShape methodsFor: 'util' stamp: 'AlexandreBergel 8/19/2012 13:06'!
hasNext
	^ false! !

!RONullShape methodsFor: 'accessing' stamp: 'VanessaPena 1/28/2013 15:44'!
height: anObject
	
	height := anObject! !

!RONullShape methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:46'!
initialize
	color := self class defaultColor.
	self extent: self defaultExtent.
! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ false! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 1/26/2013 19:13'!
lineSegmentsFor: element
	^ Array with: 0 @ 0! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:23'!
removeShape: aShapeClass
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:55'!
removeShape: aShapeClass previousShape: aShape
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:46'!
shapeDetect: aBlock
	(aBlock value: self) ifTrue: [ ^ self ].
	self error: 'Not found'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 7/23/2012 14:53'!
shapesDetect: aBlock
	self error: 'Not found'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:55'!
shapesDo: aBlock
	aBlock value: self! !

!RONullShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/25/2012 09:59'!
subElementsAt: aPoint forElement: aROElement
	"Return one of the direct children element of aROElement pointed by aPoint. Return null if none"

	^ nil! !

!RONullShape methodsFor: 'accessing' stamp: 'VanessaPena 1/28/2013 15:45'!
width: anObject

	width := anObject! !

!ROShape class methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:47'!
+ aShape

	^ self compose: aShape! !

!ROShape class methodsFor: 'public' stamp: 'JurajKubelka 4/19/2013 12:38'!
black
	^ self new color: Color black! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 6/4/2012 00:53'!
blue
	^ self new color: Color blue! !

!ROShape class methodsFor: 'copying' stamp: 'JurajKubelka 4/9/2013 17:13'!
chainedCopy
	
	^ self! !

!ROShape class methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:38'!
compose: aShape 

	^ self new compose: aShape; yourself! !

!ROShape class methodsFor: 'public' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
element
	^ self elementOn: nil! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 4/11/2013 14:27'!
elementOn: object
	"Easy way to create element from a shape"
	
	^ (ROElement on: object) + self! !

!ROShape class methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:38'!
ensureInstance
	
	^ self new! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:12'!
gray
	^ self new color: Color gray! !

!ROShape class methodsFor: 'public' stamp: ''!
green
	^ self new color: Color green! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 4/11/2013 14:27'!
installedOn: element
	^ self new installedOn: element; yourself! !

!ROShape class methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/19/2013 14:00'!
isAbstract

	^ self name = #ROShape! !

!ROShape class methodsFor: 'testing' stamp: 'JurajKubelka 4/19/2013 14:52'!
isEdgeShape

	^ false! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:12'!
lightGray
	^ self new color: Color lightGray! !

!ROShape class methodsFor: 'public' stamp: ''!
red
	^ self new color: Color red! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 4/7/2013 01:15'!
size: aSize
	^ self new size: aSize! !

!ROShape class methodsFor: 'public' stamp: ''!
white
	^ self new color: Color white! !

!ROShape class methodsFor: 'public' stamp: ''!
yellow
	^ self new color: Color yellow! !

!ROShape methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:46'!
+ aShape

	self compose: aShape! !

!ROShape methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 12:10'!
absoluteBoundsFor: aROElement
	^ (self boundsFor: aROElement) translateBy: aROElement absolutePosition! !

!ROShape methodsFor: 'visitor' stamp: 'VanessaPena 12/27/2012 13:20'!
accept: visitor

	! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/19/2012 11:25'!
addLast: aShape
	"Instance variable 'next' must be a RONullShape to provide the exit condition of this recursive call.  This is ensured by instance initialization. The Null Object design pattern is here applied"

	self addLast: aShape in: self! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:43'!
addLast: aShape in: elementToAdd
	next addLast: aShape in: self! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/28/2012 08:21'!
boundsFor: aROElement
	^ 0 @ 0 extent: aROElement extent! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/25/2012 09:49'!
boundsFor: aROElement containsPoint: aPoint
	"Return true if aPoint is contained in one of the chain of shape"
	
	^ (self boundsFor: aROElement) containsPoint: aPoint! !

!ROShape methodsFor: 'copying' stamp: 'AlexandreBergel 12/11/2012 19:13'!
chainedCopy

	| s current |
	s := self copy.
	current := s.
	self next shapesDo: [:shape | 
			| shapeCopy |
			shapeCopy := shape copy .
			 current next: shapeCopy.
			current := shapeCopy ].
	^s
	! !

!ROShape methodsFor: 'rendering' stamp: 'AlexandreBergel 4/11/2013 15:54'!
chainedDrawOn: aCanvas for: aROElement
"
	The following code remove all the optimization.
	
	true ifTrue: [ 
		self drawOn: aCanvas for: aROElement.
				next chainedDrawOn: aCanvas for: aROElement.
				^ true]."
			
	((aCanvas camera windowSize = (0 @ 0)) or: 
		[ (self isElementVisible: aROElement inCanvas: aCanvas) ])
			ifTrue: [ 
				(aROElement attributes includesKey: #childrenAreShadowed)
					ifTrue: [  
						aROElement attributes removeKey: #childrenAreShadowed.
						aROElement allElementsDo: #setAsRendered ].
					
				"If the window size is more than (0@0), meaning we are not in a test, or, if the element is actually visible, then we render it"
				self drawOn: aCanvas for: aROElement.
				next chainedDrawOn: aCanvas for: aROElement ]
			ifFalse: [
				"Else, we simply remove from the elementToRenders list in the view"
				aROElement isRendered
					ifTrue: [ aROElement allElementsDo: #setAsNotRendered.
							 aROElement attributes at: #childrenAreShadowed put: true ] ]! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/27/2012 17:05'!
change: aShapeClass for: aShape
	"Replace a shape per another shape"

	^ (self isKindOf: aShapeClass) 
		ifTrue: [ aShape next: self next; yourself ]
		ifFalse: [ self next: (self next change: aShapeClass for: aShape) ]! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 9/27/2012 17:05'!
color
	"Color associated to the shape"
	
	^ color! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2012 11:35'!
color: anObject
	"Set a color. For practical reason, the color is cached and the cache needs to be reset"
	
	color := anObject.
	colorCache := nil.! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2012 11:35'!
colorFor: element
	"Compute the color of the element"

	"We use a cache mechanism since computing the cache can be quite slow"
	colorCache notNil ifTrue: [ ^ colorCache ].
	^ colorCache := color roValue: element.
! !

!ROShape methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:35'!
compose: aShape 

	self addLast: (aShape ensureInstance)! !

!ROShape methodsFor: 'initialize' stamp: 'AlexandreBergel 9/4/2012 12:18'!
defaultExtent
	"Each shape has a minimum size of 5@5"

	^ 5 @ 5! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/25/2012 20:21'!
defaultShape 
	^ RONullShape new! !

!ROShape methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement 
	! !

!ROShape methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
element
	"Easy way to create element from a shape"

	^ self elementOn: nil! !

!ROShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/27/2012 17:25'!
elementAt: aPoint forElement: aROElement
	"Return the element pointed by aPoint for a given element.
	 The coordinate aPoint is local to the element aROElement. This means that aPoint = 0@0 refers to the topLeft of aROElement"

	"If the point does not refer to myself, then we simply return the view"
	| subElement |
	 
	(((0 @ 0) corner: (self extentFor: aROElement)) containsPoint: aPoint)
		ifFalse: [ ^ aROElement view ].
		
	"The point refers to myself. We now have to check whether a subelement is pointed"
	subElement := self subElementsAt: aPoint forElement: aROElement.
	^ subElement notNil
		ifTrue: [ subElement elementAt: (aPoint - subElement position)  ]
		ifFalse: [ aROElement ]
	! !

!ROShape methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
elementOn: object
	"Easy way to create element from a shape"
	
	^ (ROElement on: object) + self! !

!ROShape methodsFor: 'linking' stamp: 'JurajKubelka 4/19/2013 12:36'!
ensureInstance

	^ self! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:43'!
extent
	"Return the extent of the shape. Note that the width and height may be block and not immediate value.
	  Use extentFor: to get immediate value"
	^ width @ height! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 19:16'!
extent: anExtentPoint

	self resetCache.
	width := anExtentPoint x.
	height := anExtentPoint y.
	next extent: anExtentPoint! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 19:16'!
extentFor: element
	"Return the extent of element"
	
	| res |
	(widthCache notNil and: [ heightCache notNil ]) ifTrue: [ ^ widthCache @ heightCache ].
	
	res := ((width roValue: element) @ (height roValue: element)) max: (next extentFor: element).
	widthCache := res x.
	heightCache := res y.
	^ res! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 13:05'!
hasNext
	^ true! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:58'!
height
	^ height! !

!ROShape methodsFor: 'accessing' stamp: 'VanessaPena 1/28/2013 15:44'!
height: anObject
	
	self resetCache.
	height := anObject.
	next height: anObject.! !

!ROShape methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:44'!
initialize 
	super initialize.
	color := self class defaultColor.
	next := self defaultShape.
	
	self extent: self defaultExtent.
! !

!ROShape methodsFor: 'hooks' stamp: 'JurajKubelka 4/19/2013 12:37'!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	"self extent: (self preferedExtentFor: element)."
	"element extent: (element extent max: extent)."
	
	self hasNext ifTrue: [self next installedOn: element]! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/11/2013 14:34'!
isElementVisible: aROElement inCanvas: aROCanvas
	^ (aROCanvas camera virtualToRealRectangle: (self absoluteBoundsFor: aROElement))
		intersects: (0 @ 0 extent: aROCanvas camera windowSize)! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ (self isKindOf: aShapeClass) or: [ self next isShapedAs: aShapeClass ]! !

!ROShape methodsFor: 'accessing' stamp: ''!
next
	^ next! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 12/11/2012 19:17'!
next: aShape
	next := aShape.
	! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/28/2012 11:15'!
preferedExtentFor: element
	"Override this method is you want the element to have a particular shape"

	^ self extentFor: element! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:55'!
removeShape: aShapeClass
	"Remove a shape of the element"

	^ (self isKindOf: aShapeClass)
		ifTrue: [ next ]
		ifFalse: [ next removeShape: aShapeClass previousShape: self ]
! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:56'!
removeShape: aShapeClass previousShape: aShape
	"Remove a shape of the element. Return the element that has been removed"

	^ (self isKindOf: aShapeClass)
		ifTrue: [ aShape next: next. self ]
		ifFalse: [ next removeShape: aShapeClass previousShape: next next ]! !

!ROShape methodsFor: 'cache' stamp: 'AlexandreBergel 12/11/2012 19:13'!
resetCache

	colorCache := nil.
	widthCache := nil.
	heightCache := nil! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:44'!
shapeDetect: aBlock

	(aBlock value: self) ifTrue: [ ^ self ].
	^ self next shapeDetect: aBlock! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:55'!
shapesDo: aBlock

	aBlock value: self.
	^ self next shapesDo: aBlock! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 1/25/2013 08:26'!
size: aNumber
	"Set the size of the shape as a square"

	self extent: aNumber @ aNumber ! !

!ROShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/25/2012 10:03'!
subElementsAt: aPoint forElement: aROElement
	"Return one of the direct children element of aROElement pointed by aPoint. Return null if none"
	"Note that we are here interested only in direct children. The recursion is done later on"

	"For a shape that is not an abstractchildren one, there is nothing to do."
	^ next subElementsAt: aPoint forElement: aROElement! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:59'!
width
	^ width! !

!ROShape methodsFor: 'accessing' stamp: 'VanessaPena 1/28/2013 15:45'!
width: anObject

	self resetCache.
	width := anObject.
	next width: anObject.
! !

ROShape subclass: #ROViewDisplayer
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewDisplayer commentStamp: 'AlexandreBergel 8/2/2012 18:07' prior: 0!
ROViewDisplayer is a shape that is used to display a view. It simply wraps a view into a shape.

Instance Variables:
	view	<ROView>!

ROViewDisplayer subclass: #ROMiniMapDisplayer
	instanceVariableNames: 'camera factor canvasWrapper originalCameraRealExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROMiniMapDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 22:19'!
camera
	^ camera! !

!ROMiniMapDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 12/20/2012 22:19'!
camera: anObject
	camera := anObject! !

!ROMiniMapDisplayer methodsFor: 'initialize' stamp: 'VanessaPena 1/2/2013 17:34'!
defaultFactor

	^0.2! !

!ROMiniMapDisplayer methodsFor: 'rendering' stamp: 'VanessaPena 1/4/2013 10:44'!
drawOn: aCanvas for: aROElement
	| previousOffset previousCamera rect|
		
	previousOffset := aCanvas offset.
	previousCamera := aCanvas camera.
	aCanvas offset: (aROElement position).
	aCanvas camera: camera.
	canvasWrapper canvas: aCanvas.
	view drawWithoutSettingCameraElementsOn: canvasWrapper.
	aCanvas offset: previousOffset.
	aCanvas camera: previousCamera.! !

!ROMiniMapDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 1/2/2013 17:34'!
factor

	^factor! !

!ROMiniMapDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 1/2/2013 17:34'!
factor: aNumber

	factor := aNumber! !

!ROMiniMapDisplayer methodsFor: 'initialize' stamp: 'VanessaPena 1/4/2013 10:44'!
initialize
	
	super initialize.
	factor := self defaultFactor.
	canvasWrapper := RONoTextCanvasWrapper new.! !

!ROMiniMapDisplayer methodsFor: 'initialize' stamp: 'VanessaPena 1/5/2013 14:19'!
installedOn: element

	|rect max1 max2 e|
	super installedOn: element.
	self setCameraRealExtentFor: element.
	self setViewAnnouncementsFor: element.! !

!ROMiniMapDisplayer methodsFor: 'initialize' stamp: 'AlexandreBergel 3/11/2013 10:42'!
setCameraRealExtentFor: element

	| rect max1 max2 e |
	rect := view encompassingRectangle.
	e := element extent.
	max1 := e x max: e y.
	max2 :=  rect extent x max: rect extent y.
	camera realExtent: originalCameraRealExtent * (max1/max2).
! !

!ROMiniMapDisplayer methodsFor: 'events' stamp: 'VanessaPena 1/5/2013 13:10'!
setViewAnnouncementsFor: element
	
	view 
		on: ROWindowResized 
		do: [:event |
			element extent: view camera windowSize.
			element signalUpdate.
		].! !

!ROMiniMapDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 1/5/2013 13:13'!
view: aView
	"Take a roassal view as argument"
	
	view := aView.
	camera := aView camera copy.
"	camera scale: (1@1) * self factor."
	originalCameraRealExtent := camera realExtent.

! !

!ROViewDisplayer methodsFor: 'rendering' stamp: 'VanessaPena 12/20/2012 22:15'!
drawOn: aCanvas for: aROElement

	| previousOffset|
	previousOffset := aCanvas offset.
	aCanvas offset: (aROElement position).
	view drawElementsOn: aCanvas.
	aCanvas offset: previousOffset.! !

!ROViewDisplayer methodsFor: 'accessing' stamp: 'VanessaPena 1/4/2013 10:11'!
view: aView
	"Take a roassal view as argument"
	
	view := aView.
	"camera := aView camera copy."

! !

ROObject subclass: #ROTimeOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROTimeOrganizer commentStamp: '<historical>' prior: 0!
Abstract class for the time passing.!

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
current
	^ self subclasses first! !

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:44'!
milliseconds
	"Return the elapsed amount of milliseconds"
	
	self subclassResponsibility ! !

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
now
	^ Time now! !

ROObject subclass: #ROTreeLayerWrapper
	instanceVariableNames: 'cachedHeight cachedWidth elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeLayerWrapper commentStamp: '<historical>' prior: 0!
This class holds all figures that belong to the same layer. The class also contains auxiliary information
like width and height of the layer.

Instance Variables:
	cachedHeight	<ArithmeticValue>	The height of the layer
	cachedWidth	<ArithmeticValue>	The widht of the layer
	figures	<Collection of: AtlantisFigure>	All figures that belong to this layer

!

!ROTreeLayerWrapper methodsFor: 'accessing' stamp: 'miltonmamani 4/17/2013 15:34'!
add: aFigure
	
	elements add: aFigure! !

!ROTreeLayerWrapper methodsFor: 'accessing' stamp: 'miltonmamani 4/17/2013 15:34'!
do: aBlock
	
	elements do: aBlock! !

!ROTreeLayerWrapper methodsFor: 'accessing' stamp: 'miltonmamani 4/17/2013 15:34'!
height
	
	cachedHeight isNil
		ifTrue:
			[cachedHeight := 0.
			elements do: [:aFigure | cachedHeight := cachedHeight max: aFigure height]].
	^cachedHeight! !

!ROTreeLayerWrapper methodsFor: 'initialize-release' stamp: 'miltonmamani 4/17/2013 15:34'!
initialize
	elements := OrderedCollection new.
	cachedWidth := nil.
	cachedHeight := nil! !

!ROTreeLayerWrapper methodsFor: 'accessing' stamp: 'miltonmamani 4/17/2013 15:34'!
width: gapSize	
	^ cachedWidth ifNil: [
		cachedWidth := 0.
		elements do: [ :aFigure | cachedWidth := cachedWidth + aFigure width].
		cachedWidth := cachedWidth + ((elements size - 1) * gapSize) ].! !

ROObject subclass: #ROViewExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

ROViewExporter subclass: #ROHTMLExporter
	instanceVariableNames: 'view visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROHTMLExporter class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 11/20/2012 09:54'!
exportViewAsHTML: view

	self subclassResponsibility ! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:10'!
addDataSet: fileStream

	visitor :=ROHTMLVisitor new runOn: view.

	fileStream 
		nextPutAll: 'var dataset = {
		';
		nextPutAll: visitor nodesStream contents ;
		nextPutAll: visitor linksStream contents ;
		nextPutAll: '	};';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'declarations' stamp: 'DR 3/25/2013 21:48'!
addEllipseDeclaration: fileStream

	fileStream 
		nextPutAll: '	var nodes = roElements.selectAll("ellipse")
         .data(function(d) { return getChildrenNodesByParentIDAndShape(d.nodeID, "ROEllipse")})
       .enter().append("svg:ellipse")
         .attr("id", function(d) { return d.nodeID; } )
         .attr("stroke", function(d) { return d.nodeBorderColor; } )
         .attr("stroke-width", function(d) { return d.nodeBorderWidth; } )
         .attr("fill", function(d) { return d.nodeFillColor; } )
         .attr("draggable", function(d) { return d.draggable; } )
         .attr("cx", function(d) { return d.x + d.nodeWidth/2; })
         .attr("cy", function(d) { return d.y + d.nodeHeight/2; })
		 .attr("rx", function(d) { return d.nodeWidth/2; } )
         .attr("ry", function(d) { return d.nodeHeight/2; } )
         .attr("nodeParentID", function(d) { return d.nodeParentID } )
		.call(drag);';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:10'!
addEndBody: fileStream

	fileStream 
		nextPutAll: '    </script>
  </body>';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'VanessaPena 11/30/2012 17:27'!
addEndHTML: fileStream

	fileStream 
		nextPutAll: '</html>'! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:10'!
addHeader: fileStream

	fileStream 
		nextPutAll: '  <head>
    <script type="text/javascript" src="d3.v2.js"></script>
    <script type="text/javascript" src="jquery-1.4.2.min.js"></script> 
    <script type="text/javascript" src="jquery.tipsy.js"></script>
    <script type="text/javascript" src="RODraggingAndUtil.js"></script>
    <link href="tipsy.css" rel="stylesheet" type="text/css" />
  </head>';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'declarations' stamp: 'DR 3/25/2013 21:48'!
addROElementDeclaration: fileStream

	fileStream 
		nextPutAll: '	var roElements = vis.selectAll("g").data(dataROElement);
	roElements.enter().append("g")
		 .attr("id", function(d) { return d.nodeID; } )
		 .attr("draggable", function(d) { return d.draggable; } )
		 .attr("x", function(d) { return d.x; })
         .attr("y", function(d) { return d.y; })
		 .attr("width", function(d) { return d.nodeWidth; } )
         .attr("height", function(d) { return d.nodeHeight; } )
		 .attr("nodeParentID", function(d) { return d.nodeParentID } );';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'declarations' stamp: 'DR 3/25/2013 21:47'!
addRectangleDeclaration: fileStream

	fileStream 
		nextPutAll: '	var roBorders = roElements.selectAll("rect")
         .data(function(d) { return (getChildrenNodesByParentIDAndShape(d.nodeID, "ROBorder")).concat(getChildrenNodesByParentIDAndShape(d.nodeID, "ROBox")) })
       .enter().append("svg:rect")
		 .attr("id", function(d) { return d.nodeID; } )
         .attr("stroke", function(d) { return d.nodeBorderColor; } )
         .attr("stroke-width", function(d) { return d.nodeBorderWidth; } )
	   .attr("fill", function(d) { return d.nodeFillColor; } )
         .attr("draggable", function(d) { return d.draggable; } )
         .attr("x", function(d) { return d.x; })
         .attr("y", function(d) { return d.y; })
		 .attr("width", function(d) { return d.nodeWidth; } )
         .attr("height", function(d) { return d.nodeHeight; } )
         .attr("nodeParentID", function(d) { return d.nodeParentID } )
		.call(drag);';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:15'!
addRenderingEdges: fileStream

	fileStream 
		nextPutAll: '/***** RENDERING LINKS*****/
	var links = dataset.links;
	var path = vis.selectAll("path")
		  .data(links);
	path.enter().append("path")
		.attr("d", elbow)
		.attr("stroke", function(d) {return d.edgeColor});';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 3/25/2013 21:47'!
addRenderingNodes: fileStream

	self addSelectNodesDeclaration: fileStream.
	self addROElementDeclaration: fileStream.
	self addRectangleDeclaration: fileStream.
	self addEllipseDeclaration: fileStream.
	self addTextDeclaration: fileStream.
	fileStream
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:15'!
addRenderingPopup: fileStream

	fileStream 
		nextPutAll: '/*****POPUP*****/
    $("svg g").tipsy({ 
        gravity: "w", 
        html: true, 
        title: function() {
          var d = this.__data__;
          return d.nodeModel + "</span>"; 
        }
	});';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:15'!
addSVGInitialization: fileStream

	|extent|
	extent := view encompassingRectangle extent + view camera extent .

	fileStream 
		nextPutAll: '/*****INITIALIZATION*****/	
	var drag = d3.behavior.drag()
		.origin(Object)
		.on("dragstart", dragstart)
        .on("drag", dragmove)
        .on("dragend", dragend);';
		nextPutAll: ('var w = <1p>, h = <2p>;' expandMacrosWith: extent x with: extent y); 
 	     nextPutAll: 'var vis = d3.select("#chart").append("svg:svg")
          .attr("width", w)
          .attr("height", h);';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'declarations' stamp: 'DR 3/25/2013 21:47'!
addSelectNodesDeclaration: fileStream


	fileStream 
		nextPutAll: '/***** RENDERING NODES*****/
	var dataROBox = getNodesByShape("ROBorder");
	var dataROCircle = getNodesByShape("ROCircle");
	var dataROLabel = getNodesByShape("ROLabel");
	var dataROElement = getNodesByShape("ROElement");';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:14'!
addStartBody: fileStream

	fileStream 
		nextPutAll: '    <body>
    <div id="chart"></div>
    <script type="text/javascript">';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'DR 1/22/2013 17:14'!
addStartHTML: fileStream

	fileStream 
		nextPutAll: '  <!!DOCTYPE html>
<html>';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLExporter methodsFor: 'declarations' stamp: 'VanessaPena 1/31/2013 15:52'!
addTextDeclaration: fileStream

	fileStream 
		nextPutAll: '	var roLabel = roElements.selectAll("text")
         .data(function(d) { return getChildrenNodesByParentIDAndShape(d.nodeID, "ROLabel")})
       .enter().append("svg:text")
         .attr("stroke", "black")
         .attr("draggable", function(d) { return d.draggable; } )
         .attr("id", function(d) { return d.nodeID; } )
         .attr("x", function(d, id) { return d.x; })
         .attr("y", function(d, id) { return d.y; })
         .text(function(d) { return d.nodeModel; })
         .attr("nodeParentID", function(d) { return d.nodeParentID } )
	   .attr("font-size", 10)
		.call(drag);'.! !

!ROHTMLExporter methodsFor: 'html file' stamp: 'AlexandreBergel 4/8/2013 11:38'!
exportOnStream: stream

	|  rect oldPosition|
	rect := view encompassingRectangle.
	oldPosition := view camera position.
	view translateTo: rect origin negated.	

	self addStartHTML: stream.
	self addHeader: stream.
	self addStartBody: stream.
	self addDataSet: stream.
	self addSVGInitialization: stream.
	self addRenderingNodes: stream.
	self addRenderingEdges: stream.
	self addRenderingPopup: stream.
	self addEndBody: stream.
	self addEndHTML: stream.
	
	view translateTo: oldPosition negated .! !

!ROHTMLExporter methodsFor: 'accessing' stamp: 'VanessaPena 11/25/2012 14:57'!
view: aROView

	view := aROView 

	! !

ROViewExporter subclass: #ROImageExporter
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROImageExporter class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 11/19/2012 18:56'!
exportViewAsPNG: aROView 

	self subclassResponsibility ! !

!ROImageExporter methodsFor: 'accessing' stamp: 'VanessaPena 11/19/2012 18:55'!
view: aROView

	view := aROView ! !

ROViewExporter subclass: #ROSVGExporter
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROSVGExporter class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 11/19/2012 19:01'!
exportViewAsSVG: aROView 

	self subclassResponsibility ! !

!ROSVGExporter methodsFor: 'html file' stamp: 'VanessaPena 1/31/2013 18:25'!
exportOnStream: fileStream

	|canvas|
	canvas := ROSVGCanvas onCamera: view camera onStream: fileStream.
	canvas view: view.
	canvas addStart.
	view drawOn: canvas.
	canvas addEnd.! !

ROViewExporter subclass: #ROSerializerExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Exporter'!

!ROSerializerExporter methodsFor: 'exporting' stamp: 'VanessaPena 11/20/2012 17:48'!
exportView: view

	self subclassResponsibility ! !

!ROSerializerExporter methodsFor: 'exporting' stamp: 'VanessaPena 12/5/2012 15:50'!
exportView: view onFileNamed: filename

	self subclassResponsibility ! !

!ROSerializerExporter methodsFor: 'importing' stamp: 'VanessaPena 12/5/2012 15:50'!
importView: fileName

	self subclassResponsibility ! !

!ROSerializerExporter methodsFor: 'exporting' stamp: 'VanessaPena 12/5/2012 15:50'!
interactiveExportView: aROView

	self subclassResponsibility ! !

!ROSerializerExporter methodsFor: 'importing' stamp: 'VanessaPena 12/5/2012 15:50'!
interactiveImportView

	self subclassResponsibility ! !

ROObject subclass: #ROVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

ROVisitor subclass: #ROCollectingVisitor
	instanceVariableNames: 'edges nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROCollectingVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 12/6/2012 15:37'!
initialize
	super initialize.
	edges := OrderedCollection new.
	nodes := OrderedCollection new! !

!ROCollectingVisitor methodsFor: 'visit' stamp: 'AlexandreBergel 12/6/2012 15:41'!
visitEdge: anEdge
	edges add: anEdge.
	anEdge elementsDo: [ :el | el accept: self ]! !

!ROCollectingVisitor methodsFor: 'visit' stamp: 'AlexandreBergel 12/6/2012 15:41'!
visitElement: aNode
	nodes add: aNode.
	aNode elementsDo: [ :el | el accept: self ] ! !

ROVisitor subclass: #ROCountingVisitor
	instanceVariableNames: 'nbOfNodes nbOfEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROCountingVisitor methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	nbOfEdges := 0.
	nbOfNodes := 0! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfEdges
	^ nbOfEdges! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfNodes
	^ nbOfNodes! !

!ROCountingVisitor methodsFor: 'visiting' stamp: ''!
visitEdge: anEdge
	nbOfEdges := nbOfEdges + 1! !

!ROCountingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 11/27/2012 19:36'!
visitElement: aNode
	nbOfNodes := nbOfNodes + 1! !

ROVisitor subclass: #ROHTMLVisitor
	instanceVariableNames: 'idsDic idCount nodesStream linksStream shapeVisitor edgeVisitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROHTMLVisitor methodsFor: 'private-element' stamp: 'VanessaPena 1/31/2013 17:50'!
addChildrenElementsFor: aNode

	aNode view camera 
		translateBy: aNode topLeft negated.
	aNode elementsDo: [:el | el accept: self.].
	aNode view camera 
		translateBy: aNode topLeft.! !

!ROHTMLVisitor methodsFor: 'private-element' stamp: 'DR 3/27/2013 17:14'!
addElementToStream: aNode
	
	| position bounds nodeModel nodeParentID |
	position := aNode view camera virtualToRealPoint: aNode topLeft.
	bounds :=  aNode view camera virtualToRealRectangle: aNode bounds.
 	nodeModel :=  self getModelAsString: aNode.
	nodeParentID := self getParentIdFor: aNode.	
	nodesStream 
		nextPutAll: '{ ';
		nextPutAll: ('nodeID: <1p>' expandMacrosWith: (self getIdFor: aNode )); 
		nextPutAll: ', ';
		nextPutAll: ('nodeShape: "<1s>"' expandMacrosWith: (ROElement name asString)); 
		nextPutAll: ', ';
		nextPutAll: ('nodeModel: "<1s>"' expandMacrosWith: nodeModel); 
		nextPutAll: ', ';
		nextPutAll: ('nodeWidth: <1p>' expandMacrosWith: bounds width); 
		nextPutAll: ', ';
		nextPutAll: ('nodeHeight: <1p>' expandMacrosWith: bounds height); 
		nextPutAll: ', ';
		nextPutAll: ('x: <1p>' expandMacrosWith: position x); 
		nextPutAll: ', ';
		nextPutAll: ('y: <1p>' expandMacrosWith: position y); 
		nextPutAll: ', ';
		nextPutAll: ('nodeParentID: <1s>' expandMacrosWith: nodeParentID); 
		nextPutAll: ', ';
		nextPutAll: ('draggable: "<1p>"' expandMacrosWith: (aNode is: RODraggable));
		nextPutAll: '},';
		nextPutAll: ROPlatform current newLine.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 1/31/2013 17:42'!
afterRun

	self endNodesStream.
	self endLinksStream.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 1/31/2013 17:51'!
beforeRun

	self initializeIdDependences.
	self initializeNodesStream.
	self initializeLinksStream.
	self initializeElementShapeVisitor.
	self initializeEdgeShapeVisitor.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 11/25/2012 15:10'!
endLinksStream 

	linksStream nextPutAll: ' ] '.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 11/24/2012 21:34'!
endNodesStream 

	nodesStream nextPutAll: ' ], '.! !

!ROHTMLVisitor methodsFor: 'private' stamp: 'VanessaPena 11/26/2012 16:13'!
getIdFor: anObject

	|id|
	idsDic at: anObject ifAbsentPut: [id := idCount. idCount := idCount + 1. id].
	^idsDic at: anObject ! !

!ROHTMLVisitor methodsFor: 'private' stamp: 'VanessaPena 1/31/2013 17:07'!
getModelAsString: aNode

	|ret|
	aNode model isNil 
		ifTrue: [ret := 'Node'] 
		ifFalse: [ "Ugly but compatible with VW"
				((aNode model) isKindOf: String) 
					ifTrue: [ret := aNode model] 
					ifFalse:  [ret := aNode model printString ]].
		
	^ (ret replaceAll: '"' first with: ' ' first)! !

!ROHTMLVisitor methodsFor: 'private' stamp: 'VanessaPena 1/31/2013 17:06'!
getParentIdFor: aNode

	^(aNode parent isNil) 
		ifTrue: ['"null"'] 
		ifFalse: [(self getIdFor: aNode parent) printString ] ! !

!ROHTMLVisitor methodsFor: 'private-edge' stamp: 'VanessaPena 1/31/2013 17:54'!
getShapesForEdge: anEdge

	edgeVisitor edge: anEdge.	
	anEdge 
		shapesDo: [:aShape | 	| idFrom idTo |
								idFrom := self getIdFor: anEdge from.
								idTo := self getIdFor: anEdge to.
								edgeVisitor edge: anEdge.
								edgeVisitor idNodeFrom: idFrom. 
								edgeVisitor idNodeTo: idTo. 
								aShape accept: edgeVisitor.]
	! !

!ROHTMLVisitor methodsFor: 'private-element' stamp: 'VanessaPena 1/31/2013 17:49'!
getShapesForElement: aNode 

	| nodeID nodeParentID |
	
	shapeVisitor node: aNode.	
	aNode 
		shapesDo: [:aShape | 	nodeID := self getIdFor: aShape.
								nodeParentID := (self getIdFor: aNode) printString.
								shapeVisitor nodeParentID: nodeParentID.
								shapeVisitor nodeID: nodeID.
								aShape accept: shapeVisitor.]! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 1/31/2013 17:51'!
initializeEdgeShapeVisitor

	edgeVisitor := ROHTMLEdgeShapeVisitor new.
	edgeVisitor stream: linksStream.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 1/31/2013 17:51'!
initializeElementShapeVisitor

	shapeVisitor := ROHTMLElementShapeVisitor new.
	shapeVisitor stream: nodesStream.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 1/31/2013 17:41'!
initializeIdDependences

	idsDic := IdentityDictionary new.
	idCount := 0.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 11/24/2012 21:36'!
initializeLinksStream 

	linksStream := WriteStream on: String new.
	linksStream nextPutAll: ' links:[ '.! !

!ROHTMLVisitor methodsFor: 'start-end' stamp: 'VanessaPena 11/24/2012 21:35'!
initializeNodesStream 

	nodesStream := WriteStream on: String new.
	nodesStream nextPutAll: ' nodes:[ '.! !

!ROHTMLVisitor methodsFor: 'accesing' stamp: 'VanessaPena 11/25/2012 14:59'!
linksStream

	^linksStream ! !

!ROHTMLVisitor methodsFor: 'accesing' stamp: 'VanessaPena 11/25/2012 14:59'!
nodesStream 

	^nodesStream ! !

!ROHTMLVisitor methodsFor: 'public' stamp: 'VanessaPena 1/31/2013 17:42'!
runOn: aROView

	self beforeRun.
	aROView elementsDo: [ :el | el accept: self ].
	self afterRun.! !

!ROHTMLVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 17:55'!
visitEdge: anEdge

	self getShapesForEdge: anEdge.

	! !

!ROHTMLVisitor methodsFor: 'visit' stamp: 'VanessaPena 1/31/2013 17:50'!
visitElement: aNode

	self addElementToStream: aNode.		
	self getShapesForElement: aNode.
	self addChildrenElementsFor: aNode.! !

!ROVisitor methodsFor: 'public' stamp: ''!
runOn: aROView 
	aROView elementsDo: [ :el | el accept: self ] ! !

!ROVisitor methodsFor: 'visit' stamp: ''!
visitEdge: anEdge! !

!ROVisitor methodsFor: 'visit' stamp: 'AlexandreBergel 11/27/2012 19:36'!
visitElement: aNode! !

Object subclass: #ROSortBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSortBlock commentStamp: '<historical>' prior: 0!
A ROSortBlock is used by the Sugiyama layout!

!ROSortBlock methodsFor: 'accessing' stamp: ''!
fixTemps! !

!ROSortBlock methodsFor: 'accessing' stamp: ''!
value: assocA value: assocB
	"Return false if assocA is bigger than assocB.
	Return true if assocA is smaller than assocB.
	-> Inverted list with biggest elements first"
	
	| a b offset |
	offset := 0.
	a := assocA value.
	b := assocB value.
	[(a size > offset)
		and: [(b size > offset) and: [(a at: a size - offset) = (b at: b size - offset)]]]
		whileTrue: [offset := offset + 1].	"Corner cases"
	(a size = b size and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3], [3, 3]"
	(a size > offset and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3, 6], [3, 3]"
	(b size > offset and: [a size = offset]) ifTrue: [ ^ false ].	"[3, 3], [3, 3, 6]"	"Normal case"
	^(a at: a size - offset) >= (b at: b size - offset)! !

!Symbol methodsFor: '*roassal-core' stamp: ''!
roValue: anObject 
	^ anObject perform: self! !

!Color class methodsFor: '*roassal-core' stamp: ''!
gray256: intensity
	"between 0 and 256"
	| i |
	i := intensity asFloat / 256.
	^ self r:  i g: i b: i ! !

!Color class methodsFor: '*roassal-core' stamp: ''!
wheel: s alpha: a
	^ (Color wheel: 6) collect: [:c | c alpha: a ].! !
ROView initialize!
